/* pthread_testcancel
   Separate from cancel.c to avoid pulling in other cancel functions
   for a non threaded program
   Copyright (c) 2002-2007 UnixLib Developers
   Written by Alex Waugh */

#include <pthread.h>
#include <unixlib/os.h>
#include <unixlib/unix.h>

/* Introduce a cancellation point into the current thread.  */
void
pthread_testcancel (void)
{
  struct ul_global *gbl = &__ul_global;

  if (__pthread_running_thread->cancelpending
      && gbl->pthread_worksemaphore == 0)
    {
      if (__pthread_running_thread->cancelstate == PTHREAD_CANCEL_ENABLE
          && __pthread_running_thread->state == STATE_RUNNING)
        {
#ifdef PTHREAD_DEBUG
          __os_print("-- pthread_testcancel: thread cancelled\r\n");
#endif
          pthread_exit(PTHREAD_CANCELED);
        }
    }

#ifdef PTHREAD_DEBUG
  __os_print("-- pthread_testcancel: thread not cancelled\r\n");
#endif
}
