/*
 * IBM Accurate Mathematical Library
 * Written by International Business Machines Corp.
 * Copyright (C) 2001 Free Software Foundation, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/****************************************************************/
/* TABLES FOR THE upow() FUNCTION                               */
/****************************************************************/



#ifdef BIG_ENDI
static const union {int4 i[5800]; double x[2900];} ui = { .i = {
/**/                   0x3FF6A000, 0x00000000,
/**/                   0x3F33CD15, 0x3729043E,
/**/                   0xBFD63003, 0x0B3AB000,
/**/                   0x3D2DB623, 0xE731AE00,
/**/                   0x3FF69800, 0x00000000,
/**/                   0x3F33F349, 0xCC7267D0,
/**/                   0xBFD61965, 0xCDB03000,
/**/                   0x3D2F08AD, 0x603C488E,
/**/                   0x3FF69000, 0x00000000,
/**/                   0x3F3473A8, 0x8D0BFD2E,
/**/                   0xBFD602D0, 0x8AF09000,
/**/                   0xBD1EBE91, 0x76DF3F65,
/**/                   0x3FF68800, 0x00000000,
/**/                   0x3F354DD2, 0x390B9ED0,
/**/                   0xBFD5EC43, 0x3D5C3000,
/**/                   0xBD36B71A, 0x1229D17F,
/**/                   0x3FF68000, 0x00000000,
/**/                   0x3F368168, 0x16816817,
/**/                   0xBFD5D5BD, 0xDF596000,
/**/                   0x3D0A0B2A, 0x08A465DC,
/**/                   0x3FF67800, 0x00000000,
/**/                   0x3F380E0B, 0xF08C7765,
/**/                   0xBFD5BF40, 0x6B544000,
/**/                   0x3D227023, 0xEB68981C,
/**/                   0x3FF67000, 0x00000000,
/**/                   0x3F39F360, 0x16719F36,
/**/                   0xBFD5A8CA, 0xDBBEE000,
/**/                   0x3CF7C79B, 0x0AF7ECF8,
/**/                   0x3FF66800, 0x00000000,
/**/                   0x3F3C3107, 0x5AB40167,
/**/                   0xBFD5925D, 0x2B113000,
/**/                   0x3D369BF5, 0xA7A56F34,
/**/                   0x3FF66000, 0x00000000,
/**/                   0x3F3EC6A5, 0x122F9016,
/**/                   0xBFD57BF7, 0x53C8D000,
/**/                   0xBD1FADED, 0xEE5D40EF,
/**/                   0x3FF65C00, 0x00000000,
/**/                   0xBF3E4C22, 0xECCA9097,
/**/                   0xBFD56599, 0x50695000,
/**/                   0xBD14C5FD, 0x2BADC774,
/**/                   0x3FF65400, 0x00000000,
/**/                   0xBF3B07AC, 0x4B55CC62,
/**/                   0xBFD54F43, 0x1B7BE000,
/**/                   0xBD1A8954, 0xC0910952,
/**/                   0x3FF64C00, 0x00000000,
/**/                   0xBF376C52, 0x32DA090E,
/**/                   0xBFD538F4, 0xAF8F7000,
/**/                   0xBD27EC02, 0xE45547CE,
/**/                   0x3FF64400, 0x00000000,
/**/                   0xBF337A6F, 0x4DE9BD38,
/**/                   0xBFD522AE, 0x0738A000,
/**/                   0xBD2EBE70, 0x8164C759,
/**/                   0x3FF63C00, 0x00000000,
/**/                   0xBF2E64BB, 0x923C708B,
/**/                   0xBFD50C6F, 0x1D11C000,
/**/                   0x3D3A0E6B, 0x7E827C2C,
/**/                   0x3FF63400, 0x00000000,
/**/                   0xBF2528EE, 0xA7E43FD4,
/**/                   0xBFD4F637, 0xEBBAA000,
/**/                   0x3D3FC158, 0xCB3124B9,
/**/                   0x3FF62C00, 0x00000000,
/**/                   0xBF168454, 0x86689DF7,
/**/                   0xBFD4E008, 0x6DD8C000,
/**/                   0x3D34D692, 0xA1E44788,
/**/                   0x3FF62400, 0x00000000,
/**/                   0xBED623FA, 0x77016240,
/**/                   0xBFD4C9E0, 0x9E173000,
/**/                   0x3D2E2089, 0x1B0AD8A4,
/**/                   0x3FF61C00, 0x00000000,
/**/                   0x3F151300, 0x58715130,
/**/                   0xBFD4B3C0, 0x77268000,
/**/                   0x3D165B46, 0x81052B9F,
/**/                   0x3FF61400, 0x00000000,
/**/                   0x3F266D06, 0x35D2754E,
/**/                   0xBFD49DA7, 0xF3BCC000,
/**/                   0xBD307B33, 0x4DAF4B9A,
/**/                   0x3FF60C00, 0x00000000,
/**/                   0x3F317C61, 0xDA197F23,
/**/                   0xBFD48797, 0x0E958000,
/**/                   0xBD3DC1B8, 0x465CF25F,
/**/                   0x3FF60400, 0x00000000,
/**/                   0x3F381605, 0x81605816,
/**/                   0xBFD4718D, 0xC271C000,
/**/                   0xBD306C18, 0xFB4C14C5,
/**/                   0x3FF5FC00, 0x00000000,
/**/                   0x3F3F0317, 0xB5C6F559,
/**/                   0xBFD45B8C, 0x0A17E000,
/**/                   0x3D0D9120, 0xE7D0A853,
/**/                   0x3FF5F800, 0x00000000,
/**/                   0xBF39BCBD, 0x6D2041E3,
/**/                   0xBFD44591, 0xE053A000,
/**/                   0x3D06E958, 0x92923D88,
/**/                   0x3FF5F000, 0x00000000,
/**/                   0xBF3229CF, 0x5604CC40,
/**/                   0xBFD42F9F, 0x3FF62000,
/**/                   0xBD390644, 0x0F7D3354,
/**/                   0x3FF5E800, 0x00000000,
/**/                   0xBF2488E5, 0xFD431489,
/**/                   0xBFD419B4, 0x23D5F000,
/**/                   0x3D3CE379, 0x226DE3EC,
/**/                   0x3FF5E000, 0x00000000,
/**/                   0xBF0067E7, 0x6424E9C9,
/**/                   0xBFD403D0, 0x86CEA000,
/**/                   0xBD3E6EF5, 0x74487308,
/**/                   0x3FF5D800, 0x00000000,
/**/                   0x3F19F0FB, 0x38A94D24,
/**/                   0xBFD3EDF4, 0x63C17000,
/**/                   0x3D3F067C, 0x297F2C3F,
/**/                   0x3FF5D000, 0x00000000,
/**/                   0x3F2EADD9, 0x23CAD2AA,
/**/                   0xBFD3D81F, 0xB5947000,
/**/                   0x3D222C7C, 0x2A9D37A4,
/**/                   0x3FF5C800, 0x00000000,
/**/                   0x3F3882B9, 0x31057262,
/**/                   0xBFD3C252, 0x77333000,
/**/                   0xBD183B54, 0xB606BD5C,
/**/                   0x3FF5C400, 0x00000000,
/**/                   0xBF3E00AE, 0x10FFA8F8,
/**/                   0xBFD3AC8C, 0xA38E6000,
/**/                   0x3D2D0BEF, 0xBC02BE4A,
/**/                   0x3FF5BC00, 0x00000000,
/**/                   0xBF34339B, 0x8056EAF3,
/**/                   0xBFD396CE, 0x359BC000,
/**/                   0x3D05839C, 0x5663663D,
/**/                   0x3FF5B400, 0x00000000,
/**/                   0xBF242CC1, 0xF31D7FD5,
/**/                   0xBFD38117, 0x28565000,
/**/                   0x3D2A71E4, 0x93A0702B,
/**/                   0x3FF5AC00, 0x00000000,
/**/                   0x3ED5AC05, 0x6B015AC0,
/**/                   0xBFD36B67, 0x76BE1000,
/**/                   0xBD116ECD, 0xB0F177C8,
/**/                   0x3FF5A400, 0x00000000,
/**/                   0x3F26268D, 0x5BA55E5A,
/**/                   0xBFD355BF, 0x1BD83000,
/**/                   0x3D2BA99B, 0x8964F0E8,
/**/                   0x3FF59C00, 0x00000000,
/**/                   0x3F361F12, 0x3CCAA376,
/**/                   0xBFD3401E, 0x12AED000,
/**/                   0x3D317C73, 0x556E291D,
/**/                   0x3FF59800, 0x00000000,
/**/                   0xBF3E863D, 0x62D32417,
/**/                   0xBFD32A84, 0x56512000,
/**/                   0xBD04F928, 0x139AF5D6,
/**/                   0x3FF59000, 0x00000000,
/**/                   0xBF32DCF7, 0xEA712DCF,
/**/                   0xBFD314F1, 0xE1D36000,
/**/                   0x3D28E27A, 0xD3213CB8,
/**/                   0x3FF58800, 0x00000000,
/**/                   0xBF1B95B2, 0xA0CC87E8,
/**/                   0xBFD2FF66, 0xB04EB000,
/**/                   0x3D38AED2, 0x541E6E2E,
/**/                   0x3FF58000, 0x00000000,
/**/                   0x3F158056, 0x01580560,
/**/                   0xBFD2E9E2, 0xBCE12000,
/**/                   0xBD24300C, 0x128D1DC2,
/**/                   0x3FF57800, 0x00000000,
/**/                   0x3F31F340, 0x15791F34,
/**/                   0xBFD2D466, 0x02ADD000,
/**/                   0x3D288D0D, 0xDCD54196,
/**/                   0x3FF57000, 0x00000000,
/**/                   0x3F3ED3C5, 0x06B39A23,
/**/                   0xBFD2BEF0, 0x7CDC9000,
/**/                   0xBD2A9CFA, 0x4A5004F4,
/**/                   0x3FF56C00, 0x00000000,
/**/                   0xBF33FEA9, 0x53FEA954,
/**/                   0xBFD2A982, 0x269A4000,
/**/                   0x3D22058E, 0x557285CF,
/**/                   0x3FF56400, 0x00000000,
/**/                   0xBF1A1160, 0xEB478503,
/**/                   0xBFD2941A, 0xFB187000,
/**/                   0x3D3210C2, 0xB730E28B,
/**/                   0x3FF55C00, 0x00000000,
/**/                   0x3F1D09AD, 0xE4A18B2E,
/**/                   0xBFD27EBA, 0xF58D9000,
/**/                   0x3D2B1988, 0x00B4BDA7,
/**/                   0x3FF55400, 0x00000000,
/**/                   0x3F355555, 0x55555555,
/**/                   0xBFD26962, 0x1134E000,
/**/                   0x3D31B61F, 0x10522625,
/**/                   0x3FF55000, 0x00000000,
/**/                   0xBF3C4BE6, 0xB319A21F,
/**/                   0xBFD25410, 0x494E5000,
/**/                   0xBD3B1D7A, 0xC0EF77F2,
/**/                   0x3FF54800, 0x00000000,
/**/                   0xBF2B4328, 0x8FA03FD5,
/**/                   0xBFD23EC5, 0x991EC000,
/**/                   0x3D36DBE4, 0x48A2E522,
/**/                   0x3FF54000, 0x00000000,
/**/                   0x3EF54015, 0x40154015,
/**/                   0xBFD22981, 0xFBEF8000,
/**/                   0x3D3A1421, 0x609580DA,
/**/                   0x3FF53800, 0x00000000,
/**/                   0x3F30948F, 0x40FEAC6F,
/**/                   0xBFD21445, 0x6D0EC000,
/**/                   0x3D3CAF04, 0x28B728A3,
/**/                   0x3FF53400, 0x00000000,
/**/                   0xBF3FE034, 0xFD04F7B8,
/**/                   0xBFD1FF0F, 0xE7CF4000,
/**/                   0xBD3E9D5B, 0x513FF0C1,
/**/                   0x3FF52C00, 0x00000000,
/**/                   0xBF300A95, 0x7FAB5403,
/**/                   0xBFD1E9E1, 0x6788A000,
/**/                   0x3D382EAE, 0xD3C8B65E,
/**/                   0x3FF52400, 0x00000000,
/**/                   0x3EB52401, 0x52401524,
/**/                   0xBFD1D4B9, 0xE796C000,
/**/                   0xBD222A66, 0x7C42E56D,
/**/                   0x3FF51C00, 0x00000000,
/**/                   0x3F307EAE, 0x2F8151D0,
/**/                   0xBFD1BF99, 0x635A7000,
/**/                   0x3D31AC89, 0x575C2125,
/**/                   0x3FF51800, 0x00000000,
/**/                   0xBF3ECE3F, 0xEAE9ECE4,
/**/                   0xBFD1AA7F, 0xD638D000,
/**/                   0xBD29F60A, 0x9616F7A0,
/**/                   0x3FF51000, 0x00000000,
/**/                   0xBF2BA3DD, 0xC7675243,
/**/                   0xBFD1956D, 0x3B9BC000,
/**/                   0xBD27D2F7, 0x3AD1AA14,
/**/                   0x3FF50800, 0x00000000,
/**/                   0x3F0B9AC8, 0x764E368D,
/**/                   0xBFD18061, 0x8EF19000,
/**/                   0x3D3482FF, 0xC86D38E5,
/**/                   0x3FF50000, 0x00000000,
/**/                   0x3F350150, 0x15015015,
/**/                   0xBFD16B5C, 0xCBAD0000,
/**/                   0x3D323299, 0x042D74BF,
/**/                   0x3FF4FC00, 0x00000000,
/**/                   0xBF392851, 0x4A683C50,
/**/                   0xBFD1565E, 0xED456000,
/**/                   0x3CEE75AD, 0xFB6ABA25,
/**/                   0x3FF4F400, 0x00000000,
/**/                   0xBF1C2748, 0xACD95EF0,
/**/                   0xBFD14167, 0xEF367000,
/**/                   0xBD3E0C07, 0x824DAAF5,
/**/                   0x3FF4EC00, 0x00000000,
/**/                   0x3F26B90D, 0x67A47465,
/**/                   0xBFD12C77, 0xCD007000,
/**/                   0xBD13B294, 0x8A11F797,
/**/                   0x3FF4E400, 0x00000000,
/**/                   0x3F3E0A72, 0xF0539783,
/**/                   0xBFD1178E, 0x8227E000,
/**/                   0xBD31EF78, 0xCE2D07F2,
/**/                   0x3FF4E000, 0x00000000,
/**/                   0xBF2E00A6, 0xF87FD642,
/**/                   0xBFD102AC, 0x0A35D000,
/**/                   0x3D2F1FBD, 0xDFDFD686,
/**/                   0x3FF4D800, 0x00000000,
/**/                   0x3F10EFB7, 0x0B12E3FD,
/**/                   0xBFD0EDD0, 0x60B78000,
/**/                   0xBD0019B5, 0x2D8435F5,
/**/                   0x3FF4D000, 0x00000000,
/**/                   0x3F37BEF1, 0x5CB4DBE5,
/**/                   0xBFD0D8FB, 0x813EB000,
/**/                   0xBD1EE8C8, 0x8753FA35,
/**/                   0x3FF4CC00, 0x00000000,
/**/                   0xBF34778D, 0xA50918B1,
/**/                   0xBFD0C42D, 0x67616000,
/**/                   0xBD27188B, 0x163CEAE9,
/**/                   0x3FF4C400, 0x00000000,
/**/                   0xBED9F4F7, 0xE37288EC,
/**/                   0xBFD0AF66, 0x0EB9E000,
/**/                   0xBD23C7C3, 0xF528D80A,
/**/                   0x3FF4BC00, 0x00000000,
/**/                   0x3F33EDDA, 0x68FE0E42,
/**/                   0xBFD09AA5, 0x72E6C000,
/**/                   0xBD3B50A1, 0xE1734342,
/**/                   0x3FF4B800, 0x00000000,
/**/                   0xBF3776C6, 0xB72E47D9,
/**/                   0xBFD085EB, 0x8F8AE000,
/**/                   0xBD3E5D51, 0x3F45FE7B,
/**/                   0x3FF4B000, 0x00000000,
/**/                   0xBF04AFD6, 0xA052BF5B,
/**/                   0xBFD07138, 0x604D6000,
/**/                   0x3D3E7632, 0x4E912B17,
/**/                   0x3FF4A800, 0x00000000,
/**/                   0x3F328FFA, 0xD5B5C015,
/**/                   0xBFD05C8B, 0xE0D96000,
/**/                   0xBD2AD0F1, 0xC77CCB58,
/**/                   0x3FF4A400, 0x00000000,
/**/                   0xBF380528, 0x9FEB5D80,
/**/                   0xBFD047E6, 0x0CDE8000,
/**/                   0xBD2DBDF1, 0x0D397F3C,
/**/                   0x3FF49C00, 0x00000000,
/**/                   0xBF02AD3E, 0x25FF5B21,
/**/                   0xBFD03346, 0xE0106000,
/**/                   0xBCF89FF8, 0xA966395C,
/**/                   0x3FF49400, 0x00000000,
/**/                   0x3F339E3B, 0x2D066EA2,
/**/                   0xBFD01EAE, 0x5626C000,
/**/                   0xBD3A43DC, 0xFADE85AE,
/**/                   0x3FF49000, 0x00000000,
/**/                   0xBF3629C1, 0xAFB2E932,
/**/                   0xBFD00A1C, 0x6ADDA000,
/**/                   0xBD31CD8D, 0x688B9E18,
/**/                   0x3FF48800, 0x00000000,
/**/                   0x3ED48805, 0x22014880,
/**/                   0xBFCFEB22, 0x33EA0000,
/**/                   0xBD2F3418, 0xDE00938B,
/**/                   0x3FF48000, 0x00000000,
/**/                   0x3F37119F, 0x3D324D89,
/**/                   0xBFCFC218, 0xBE620000,
/**/                   0xBD34BBA4, 0x6F1CF6A0,
/**/                   0x3FF47C00, 0x00000000,
/**/                   0xBF31EB85, 0x1EB851EC,
/**/                   0xBFCF991C, 0x6CB3C000,
/**/                   0x3D390D04, 0xCD7CC834,
/**/                   0x3FF47400, 0x00000000,
/**/                   0x3F1569C9, 0xAAFC7C01,
/**/                   0xBFCF702D, 0x36778000,
/**/                   0x3D108195, 0x16673E23,
/**/                   0x3FF46C00, 0x00000000,
/**/                   0x3F3CE345, 0x96066250,
/**/                   0xBFCF474B, 0x134E0000,
/**/                   0x3D3BAE49, 0xF1DF7B5E,
/**/                   0x3FF46800, 0x00000000,
/**/                   0xBF26A297, 0x1D02DE87,
/**/                   0xBFCF1E75, 0xFADFA000,
/**/                   0x3D20862B, 0x25D83F6D,
/**/                   0x3FF46000, 0x00000000,
/**/                   0x3F2978FE, 0xB9F34381,
/**/                   0xBFCEF5AD, 0xE4DD0000,
/**/                   0x3CCA2115, 0x65BB8E11,
/**/                   0x3FF45C00, 0x00000000,
/**/                   0xBF3AF398, 0xF6C71366,
/**/                   0xBFCECCF2, 0xC8FEA000,
/**/                   0x3D3BEC63, 0xA3E75640,
/**/                   0x3FF45400, 0x00000000,
/**/                   0xBF030E9C, 0x449AFF5D,
/**/                   0xBFCEA444, 0x9F04A000,
/**/                   0xBD35E916, 0x63732A36,
/**/                   0x3FF44C00, 0x00000000,
/**/                   0x3F367190, 0xF8B42EF3,
/**/                   0xBFCE7BA3, 0x5EB78000,
/**/                   0x3D0D5EEE, 0x23793649,
/**/                   0x3FF44800, 0x00000000,
/**/                   0xBF3079A9, 0xD260511C,
/**/                   0xBFCE530E, 0xFFE72000,
/**/                   0x3D3FDBDB, 0xB13F7C18,
/**/                   0x3FF44000, 0x00000000,
/**/                   0x3F21B87C, 0x0B644FBE,
/**/                   0xBFCE2A87, 0x7A6B2000,
/**/                   0xBD382381, 0x7787081A,
/**/                   0x3FF43C00, 0x00000000,
/**/                   0xBF3D8CF5, 0x411B2E25,
/**/                   0xBFCE020C, 0xC6236000,
/**/                   0x3D252B00, 0xADB91424,
/**/                   0x3FF43400, 0x00000000,
/**/                   0xBF0DAC08, 0xD6A60978,
/**/                   0xBFCDD99E, 0xDAF6E000,
/**/                   0x3D302EC6, 0x69C756EB,
/**/                   0x3FF42C00, 0x00000000,
/**/                   0x3F36625D, 0x51F86EFA,
/**/                   0xBFCDB13D, 0xB0D48000,
/**/                   0xBD32806A, 0x847527E6,
/**/                   0x3FF42800, 0x00000000,
/**/                   0xBF2E8B2D, 0xA8766564,
/**/                   0xBFCD88E9, 0x3FB30000,
/**/                   0x3D375F28, 0x0234BF51,
/**/                   0x3FF42000, 0x00000000,
/**/                   0x3F26A4CB, 0xCB2A247B,
/**/                   0xBFCD60A1, 0x7F904000,
/**/                   0x3D35D6E0, 0x6FC20D39,
/**/                   0x3FF41C00, 0x00000000,
/**/                   0xBF39D5E8, 0xC17DF552,
/**/                   0xBFCD3866, 0x68720000,
/**/                   0x3D373650, 0xB38932BC,
/**/                   0x3FF41400, 0x00000000,
/**/                   0x3EF41414, 0x14141414,
/**/                   0xBFCD1037, 0xF2656000,
/**/                   0x3D084A7E, 0x75B6F6E4,
/**/                   0x3FF40C00, 0x00000000,
/**/                   0x3F3C97A8, 0x43AE87FD,
/**/                   0xBFCCE816, 0x157F2000,
/**/                   0x3D29E0AB, 0xA2099515,
/**/                   0x3FF40800, 0x00000000,
/**/                   0xBF1F4BBC, 0x66A67E6F,
/**/                   0xBFCCC000, 0xC9DB4000,
/**/                   0x3D1D6D58, 0x5D57AFF9,
/**/                   0x3FF40000, 0x00000000,
/**/                   0x3F340140, 0x14014014,
/**/                   0xBFCC97F8, 0x079D4000,
/**/                   0xBD23B161, 0xA8C6E6C5,
/**/                   0x3FF3FC00, 0x00000000,
/**/                   0xBF2FD809, 0xFD809FD8,
/**/                   0xBFCC6FFB, 0xC6F00000,
/**/                   0xBD3EE138, 0xD3A69D43,
/**/                   0x3FF3F400, 0x00000000,
/**/                   0x3F28CA0E, 0x57EE89D2,
/**/                   0xBFCC480C, 0x0005C000,
/**/                   0xBD39A294, 0xD5E44E76,
/**/                   0x3FF3F000, 0x00000000,
/**/                   0xBF370BD5, 0xA50F9260,
/**/                   0xBFCC2028, 0xAB180000,
/**/                   0x3D292E0E, 0xE55C7AC6,
/**/                   0x3FF3E800, 0x00000000,
/**/                   0x3F1704AA, 0x75945FCE,
/**/                   0xBFCBF851, 0xC0676000,
/**/                   0x3D35420E, 0x4C0854AD,
/**/                   0x3FF3E400, 0x00000000,
/**/                   0xBF3D3431, 0xB56FD83C,
/**/                   0xBFCBD087, 0x383BE000,
/**/                   0x3D2D4BC4, 0x595412B6,
/**/                   0x3FF3DC00, 0x00000000,
/**/                   0x3EB3DC01, 0x3DC013DC,
/**/                   0xBFCBA8C9, 0x0AE4A000,
/**/                   0xBD3A32E7, 0xF44432DA,
/**/                   0x3FF3D400, 0x00000000,
/**/                   0x3F3D991A, 0xA75C5BBD,
/**/                   0xBFCB8117, 0x30B82000,
/**/                   0xBD1E9068, 0x3B9CD768,
/**/                   0x3FF3D000, 0x00000000,
/**/                   0xBF1292BA, 0x59C52F5D,
/**/                   0xBFCB5971, 0xA213A000,
/**/                   0xBD39B50E, 0x83AA91DF,
/**/                   0x3FF3C800, 0x00000000,
/**/                   0x3F395A47, 0xBABE7440,
/**/                   0xBFCB31D8, 0x575BC000,
/**/                   0xBD3C794E, 0x562A63CB,
/**/                   0x3FF3C400, 0x00000000,
/**/                   0xBF20D475, 0x58A0943A,
/**/                   0xBFCB0A4B, 0x48FC2000,
/**/                   0x3D22E72D, 0x5C3998ED,
/**/                   0x3FF3BC00, 0x00000000,
/**/                   0x3F360D92, 0x3295482C,
/**/                   0xBFCAE2CA, 0x6F672000,
/**/                   0xBD37A8D5, 0xAE54F550,
/**/                   0x3FF3B800, 0x00000000,
/**/                   0xBF267D12, 0xCAB48651,
/**/                   0xBFCABB55, 0xC316A000,
/**/                   0x3D38A65A, 0xCAF14CD8,
/**/                   0x3FF3B000, 0x00000000,
/**/                   0x3F33B13B, 0x13B13B14,
/**/                   0xBFCA93ED, 0x3C8AE000,
/**/                   0x3D287243, 0x50562169,
/**/                   0x3FF3AC00, 0x00000000,
/**/                   0xBF2A46AF, 0x2C8FD3BF,
/**/                   0xBFCA6C90, 0xD44B8000,
/**/                   0x3D3F63B7, 0xF037B0C6,
/**/                   0x3FF3A400, 0x00000000,
/**/                   0x3F324387, 0xAC822610,
/**/                   0xBFCA4540, 0x82E6A000,
/**/                   0xBD360A77, 0xC81F7171,
/**/                   0x3FF3A000, 0x00000000,
/**/                   0xBF2C34BB, 0xA1923DEE,
/**/                   0xBFCA1DFC, 0x40F1C000,
/**/                   0x3D301E0F, 0x004F3781,
/**/                   0x3FF39800, 0x00000000,
/**/                   0x3F31C2C1, 0x87F63372,
/**/                   0xBFC9F6C4, 0x0708A000,
/**/                   0x3D3337D9, 0x4BCD3F43,
/**/                   0x3FF39400, 0x00000000,
/**/                   0xBF2C4AA0, 0xE11BD52E,
/**/                   0xBFC9CF97, 0xCDCE0000,
/**/                   0xBD3D862F, 0x10C414E3,
/**/                   0x3FF38C00, 0x00000000,
/**/                   0x3F322D36, 0x6088DBF4,
/**/                   0xBFC9A877, 0x8DEBA000,
/**/                   0xBD3470FA, 0x3EFEC390,
/**/                   0x3FF38800, 0x00000000,
/**/                   0xBF2A8BBF, 0x503F774E,
/**/                   0xBFC98163, 0x4011A000,
/**/                   0xBD34EADD, 0x9E9045E2,
/**/                   0x3FF38000, 0x00000000,
/**/                   0x3F338138, 0x13813814,
/**/                   0xBFC95A5A, 0xDCF70000,
/**/                   0xBD07F228, 0x58A0FF6F,
/**/                   0x3FF37C00, 0x00000000,
/**/                   0xBF26FB6F, 0x1B177053,
/**/                   0xBFC9335E, 0x5D594000,
/**/                   0xBD33115C, 0x3ABD47DA,
/**/                   0x3FF37400, 0x00000000,
/**/                   0x3F35BD1C, 0x945EDC20,
/**/                   0xBFC90C6D, 0xB9FCC000,
/**/                   0x3D1935F5, 0x7718D7CA,
/**/                   0x3FF37000, 0x00000000,
/**/                   0xBF219D00, 0x4DBDCC60,
/**/                   0xBFC8E588, 0xEBAC2000,
/**/                   0xBD3B7D5C, 0xAB2D1140,
/**/                   0x3FF36800, 0x00000000,
/**/                   0x3F38DF3D, 0xE0747954,
/**/                   0xBFC8BEAF, 0xEB390000,
/**/                   0x3D073D54, 0xAAE92CD1,
/**/                   0x3FF36400, 0x00000000,
/**/                   0xBF14E775, 0xD9D3C49F,
/**/                   0xBFC897E2, 0xB17B2000,
/**/                   0x3D296B37, 0x380CBE9E,
/**/                   0x3FF35C00, 0x00000000,
/**/                   0x3F3CE5F9, 0xF2AF821E,
/**/                   0xBFC87121, 0x3750E000,
/**/                   0xBD3328EB, 0x42F9AF75,
/**/                   0x3FF35800, 0x00000000,
/**/                   0xBEE82DF0, 0xE34971F2,
/**/                   0xBFC84A6B, 0x759F6000,
/**/                   0x3D3DA280, 0x2ADF8609,
/**/                   0x3FF35400, 0x00000000,
/**/                   0xBF3E304D, 0x4873ECAE,
/**/                   0xBFC823C1, 0x6551A000,
/**/                   0xBD1E0DDB, 0x9A631E83,
/**/                   0x3FF34C00, 0x00000000,
/**/                   0x3F1264B6, 0x1FF659DB,
/**/                   0xBFC7FD22, 0xFF59A000,
/**/                   0x3D158BEB, 0xF457B7D2,
/**/                   0x3FF34800, 0x00000000,
/**/                   0xBF386531, 0xFECB9865,
/**/                   0xBFC7D690, 0x3CAF6000,
/**/                   0x3D24C06B, 0x17C301D7,
/**/                   0x3FF34000, 0x00000000,
/**/                   0x3F25A8C2, 0xEEDA65AE,
/**/                   0xBFC7B009, 0x16516000,
/**/                   0x3D3AE75F, 0xCB067E57,
/**/                   0x3FF33C00, 0x00000000,
/**/                   0xBF31BA4A, 0x8434E1F4,
/**/                   0xBFC7898D, 0x85444000,
/**/                   0xBD38E67B, 0xE3DBAF3F,
/**/                   0x3FF33400, 0x00000000,
/**/                   0x3F31EE97, 0xDBFC660A,
/**/                   0xBFC7631D, 0x82936000,
/**/                   0x3D25E77D, 0xC7C5F3E1,
/**/                   0x3FF33000, 0x00000000,
/**/                   0xBF246252, 0xBC40BFDA,
/**/                   0xBFC73CB9, 0x074FE000,
/**/                   0x3D3D66A9, 0x0D0005A6,
/**/                   0x3FF32800, 0x00000000,
/**/                   0x3F39E640, 0x13299E64,
/**/                   0xBFC71660, 0x0C914000,
/**/                   0xBCE51B15, 0x7CEC3838,
/**/                   0x3FF32400, 0x00000000,
/**/                   0xBEFCB5D4, 0xEF40991F,
/**/                   0xBFC6F012, 0x8B756000,
/**/                   0xBD357739, 0x0D31EF0F,
/**/                   0x3FF32000, 0x00000000,
/**/                   0xBF3D4632, 0xC823D892,
/**/                   0xBFC6C9D0, 0x7D204000,
/**/                   0x3CDC73FA, 0xFD9B2DCA,
/**/                   0x3FF31800, 0x00000000,
/**/                   0x3F1DD63A, 0x7AED804C,
/**/                   0xBFC6A399, 0xDABBE000,
/**/                   0x3D38F934, 0xE66A15A6,
/**/                   0x3FF31400, 0x00000000,
/**/                   0xBF339849, 0xE8C11E1A,
/**/                   0xBFC67D6E, 0x9D786000,
/**/                   0x3D311E88, 0x30A706D3,
/**/                   0x3FF30C00, 0x00000000,
/**/                   0x3F319013, 0x0D190131,
/**/                   0xBFC6574E, 0xBE8C2000,
/**/                   0x3D398C1D, 0x34F0F462,
/**/                   0x3FF30800, 0x00000000,
/**/                   0xBF222315, 0xB47A7FDA,
/**/                   0xBFC6313A, 0x37336000,
/**/                   0x3D144DF5, 0x4F21EA6D,
/**/                   0x3FF30000, 0x00000000,
/**/                   0x3F3C82AC, 0x40260390,
/**/                   0xBFC60B31, 0x00B0A000,
/**/                   0x3D371456, 0xC988F814,
/**/                   0x3FF2FC00, 0x00000000,
/**/                   0x3F026443, 0xA2430A62,
/**/                   0xBFC5E533, 0x144C2000,
/**/                   0x3D31CE0B, 0xF3B290EA,
/**/                   0x3FF2F800, 0x00000000,
/**/                   0xBF37B425, 0xED097B42,
/**/                   0xBFC5BF40, 0x6B544000,
/**/                   0x3D127023, 0xEB68981C,
/**/                   0x3FF2F000, 0x00000000,
/**/                   0x3F2D00E3, 0x4AE0553C,
/**/                   0xBFC59958, 0xFF1D6000,
/**/                   0x3D3A1D05, 0x9769CA05,
/**/                   0x3FF2EC00, 0x00000000,
/**/                   0xBF262BC0, 0x25D69D44,
/**/                   0xBFC5737C, 0xC9018000,
/**/                   0xBD39BAA7, 0xA6B887F6,
/**/                   0x3FF2E400, 0x00000000,
/**/                   0x3F3B88B5, 0xE3103D6B,
/**/                   0xBFC54DAB, 0xC2610000,
/**/                   0xBD2746FE, 0xE5C8D0D8,
/**/                   0x3FF2E000, 0x00000000,
/**/                   0x3F02E025, 0xC04B8097,
/**/                   0xBFC527E5, 0xE4A1C000,
/**/                   0x3D34E60B, 0x8D4B411D,
/**/                   0x3FF2DC00, 0x00000000,
/**/                   0xBF369C22, 0x2C305021,
/**/                   0xBFC5022B, 0x292F6000,
/**/                   0xBD348A05, 0xFF36A25B,
/**/                   0x3FF2D400, 0x00000000,
/**/                   0x3F30A012, 0xD50A012D,
/**/                   0xBFC4DC7B, 0x897BC000,
/**/                   0xBD0C79B6, 0x0AE1FF0F,
/**/                   0x3FF2D000, 0x00000000,
/**/                   0xBF1FBE29, 0xBC66484E,
/**/                   0xBFC4B6D6, 0xFEFE2000,
/**/                   0xBD1522EC, 0xF56E7952,
/**/                   0x3FF2C800, 0x00000000,
/**/                   0x3F3FB4D8, 0x12C9FB4E,
/**/                   0xBFC4913D, 0x8333C000,
/**/                   0x3D353E43, 0x558124C4,
/**/                   0x3FF2C400, 0x00000000,
/**/                   0x3F1E3432, 0x7004B11E,
/**/                   0xBFC46BAF, 0x0F9F6000,
/**/                   0x3D1249CD, 0x0790841A,
/**/                   0x3FF2C000, 0x00000000,
/**/                   0xBF30671A, 0x5C8EF02F,
/**/                   0xBFC4462B, 0x9DC9C000,
/**/                   0x3D384858, 0xA711B062,
/**/                   0x3FF2B800, 0x00000000,
/**/                   0x3F37D835, 0xD548D9AC,
/**/                   0xBFC420B3, 0x27410000,
/**/                   0x3D116282, 0xC85A0884,
/**/                   0x3FF2B400, 0x00000000,
/**/                   0x3ED2B404, 0xAD012B40,
/**/                   0xBFC3FB45, 0xA5992000,
/**/                   0xBD319713, 0xC0CAE559,
/**/                   0x3FF2B000, 0x00000000,
/**/                   0xBF370F78, 0x8E7302A1,
/**/                   0xBFC3D5E3, 0x126BC000,
/**/                   0xBD13FB2F, 0x85096C4B,
/**/                   0x3FF2A800, 0x00000000,
/**/                   0x3F31C92F, 0x3C1053F9,
/**/                   0xBFC3B08B, 0x67580000,
/**/                   0x3D3AADE8, 0xF29320FB,
/**/                   0x3FF2A400, 0x00000000,
/**/                   0xBF14AD94, 0x3DBE2E04,
/**/                   0xBFC38B3E, 0x9E028000,
/**/                   0x3D370EF0, 0x545C17F9,
/**/                   0x3FF2A000, 0x00000000,
/**/                   0xBF3BED61, 0xBED61BED,
/**/                   0xBFC365FC, 0xB015A000,
/**/                   0x3D3FD3A0, 0xAFB9691B,
/**/                   0x3FF29800, 0x00000000,
/**/                   0x3F2B061A, 0x26F004A6,
/**/                   0xBFC340C5, 0x97412000,
/**/                   0x3D37A3DC, 0xF7D9D386,
/**/                   0x3FF29400, 0x00000000,
/**/                   0xBF21B488, 0xFF6B646D,
/**/                   0xBFC31B99, 0x4D3A4000,
/**/                   0xBD3F098E, 0xE3A50810,
/**/                   0x3FF29000, 0x00000000,
/**/                   0xBF3F0582, 0x2CA5D5AC,
/**/                   0xBFC2F677, 0xCBBC0000,
/**/                   0xBD352B30, 0x2160F40D,
/**/                   0x3FF28800, 0x00000000,
/**/                   0x3F260251, 0x16025116,
/**/                   0xBFC2D161, 0x0C868000,
/**/                   0xBD039D6C, 0xCB81B4A1,
/**/                   0x3FF28400, 0x00000000,
/**/                   0xBF258CDF, 0x502065D2,
/**/                   0xBFC2AC55, 0x095F6000,
/**/                   0x3D1D3466, 0xD0C6C8A8,
/**/                   0x3FF27C00, 0x00000000,
/**/                   0x3F3FA38A, 0x1CE4D6F8,
/**/                   0xBFC28753, 0xBC11A000,
/**/                   0xBD37494E, 0x359302E6,
/**/                   0x3FF27800, 0x00000000,
/**/                   0x3F247DD5, 0xDCCA0781,
/**/                   0xBFC2625D, 0x1E6DE000,
/**/                   0x3CF52962, 0xF09E3D82,
/**/                   0x3FF27400, 0x00000000,
/**/                   0xBF25E8EF, 0xDB195E8F,
/**/                   0xBFC23D71, 0x2A49C000,
/**/                   0xBD100D23, 0x8FD3DF5C,
/**/                   0x3FF27000, 0x00000000,
/**/                   0xBF3FF6C8, 0xFFB647FE,
/**/                   0xBFC2188F, 0xD9808000,
/**/                   0x3D3B3A1E, 0x7F50C701,
/**/                   0x3FF26800, 0x00000000,
/**/                   0x3F266F9A, 0xC024D167,
/**/                   0xBFC1F3B9, 0x25F26000,
/**/                   0x3D15F74E, 0x9B083633,
/**/                   0x3FF26400, 0x00000000,
/**/                   0xBF22D1BD, 0xEABD0E14,
/**/                   0xBFC1CEED, 0x09854000,
/**/                   0x3D315C1C, 0x39192AF9,
/**/                   0x3FF26000, 0x00000000,
/**/                   0xBF3DD8F7, 0xF6D0EEC8,
/**/                   0xBFC1AA2B, 0x7E240000,
/**/                   0x3D31AC38, 0xDDE3B366,
/**/                   0x3FF25800, 0x00000000,
/**/                   0x3F2BCEB1, 0x2A241EF6,
/**/                   0xBFC18574, 0x7DBEC000,
/**/                   0xBD3E6744, 0x45BD9B49,
/**/                   0x3FF25400, 0x00000000,
/**/                   0xBF18A05B, 0xA21378D7,
/**/                   0xBFC160C8, 0x024B2000,
/**/                   0xBD2EC2D2, 0xA9009E3D,
/**/                   0x3FF25000, 0x00000000,
/**/                   0xBF3A076F, 0xD6CFA90C,
/**/                   0xBFC13C26, 0x05C3A000,
/**/                   0x3D2CF5FD, 0xD94F6509,
/**/                   0x3FF24800, 0x00000000,
/**/                   0x3F324924, 0x92492492,
/**/                   0xBFC1178E, 0x8227E000,
/**/                   0xBD21EF78, 0xCE2D07F2,
/**/                   0x3FF24400, 0x00000000,
/**/                   0xBEF3682B, 0x6151E899,
/**/                   0xBFC0F301, 0x717D0000,
/**/                   0x3D3E09B4, 0x41AE86C5,
/**/                   0x3FF24000, 0x00000000,
/**/                   0xBF34868E, 0x89FA4C67,
/**/                   0xBFC0CE7E, 0xCDCCC000,
/**/                   0xBD14652D, 0xABFF5447,
/**/                   0x3FF23800, 0x00000000,
/**/                   0x3F3858D8, 0x6B11F09F,
/**/                   0xBFC0AA06, 0x91268000,
/**/                   0x3D345519, 0xD7032129,
/**/                   0x3FF23400, 0x00000000,
/**/                   0x3F159E26, 0xAF37C049,
/**/                   0xBFC08598, 0xB59E4000,
/**/                   0x3D27E5DD, 0x7009902C,
/**/                   0x3FF23000, 0x00000000,
/**/                   0xBF2AB546, 0x2E076329,
/**/                   0xBFC06135, 0x354D4000,
/**/                   0xBD363046, 0x28340EE9,
/**/                   0x3FF22C00, 0x00000000,
/**/                   0xBF3FEDD5, 0xFEDD5FEE,
/**/                   0xBFC03CDC, 0x0A51E000,
/**/                   0xBD381A9C, 0xF169FC5C,
/**/                   0x3FF22400, 0x00000000,
/**/                   0x3F2B5B92, 0x009126D7,
/**/                   0xBFC0188D, 0x2ECF6000,
/**/                   0xBD03F965, 0x1CFF9DFE,
/**/                   0x3FF22000, 0x00000000,
/**/                   0xBF121FB7, 0x8121FB78,
/**/                   0xBFBFE891, 0x39DBC000,
/**/                   0xBD356594, 0xD82F7A82,
/**/                   0x3FF21C00, 0x00000000,
/**/                   0xBF368F22, 0x3A459635,
/**/                   0xBFBFA01C, 0x9DB58000,
/**/                   0x3D08F351, 0xFA48A730,
/**/                   0x3FF21400, 0x00000000,
/**/                   0x3F379804, 0x855E6012,
/**/                   0xBFBF57BC, 0x7D900000,
/**/                   0xBD176A6C, 0x9EA8B04E,
/**/                   0x3FF21000, 0x00000000,
/**/                   0x3F17B57C, 0x78CD7A37,
/**/                   0xBFBF0F70, 0xCDD98000,
/**/                   0xBD32E31F, 0x6C272C1E,
/**/                   0x3FF20C00, 0x00000000,
/**/                   0xBF271E73, 0x07E4EF15,
/**/                   0xBFBEC739, 0x830A0000,
/**/                   0xBD311FCB, 0xA80CDD10,
/**/                   0x3FF20800, 0x00000000,
/**/                   0xBF3CDDEC, 0x49392BA7,
/**/                   0xBFBE7F16, 0x91A34000,
/**/                   0x3D32C1C5, 0x9BC77BFA,
/**/                   0x3FF20000, 0x00000000,
/**/                   0x3F320120, 0x12012012,
/**/                   0xBFBE3707, 0xEE304000,
/**/                   0xBD20F684, 0xE6766ABD,
/**/                   0x3FF1FC00, 0x00000000,
/**/                   0x3EF0DC4F, 0xCE8AD1A2,
/**/                   0xBFBDEF0D, 0x8D468000,
/**/                   0x3D324750, 0x412E9A74,
/**/                   0x3FF1F800, 0x00000000,
/**/                   0xBF2F7047, 0xDC11F704,
/**/                   0xBFBDA727, 0x63844000,
/**/                   0xBD1A8940, 0x1FA71733,
/**/                   0x3FF1F000, 0x00000000,
/**/                   0x3F3FAF3F, 0x16B6419D,
/**/                   0xBFBD5F55, 0x65920000,
/**/                   0xBD30E239, 0xCC185469,
/**/                   0x3FF1EC00, 0x00000000,
/**/                   0x3F2E878F, 0xF70985E2,
/**/                   0xBFBD1797, 0x88218000,
/**/                   0xBD336433, 0xB5EFBEED,
/**/                   0x3FF1E800, 0x00000000,
/**/                   0xBEEF55E4, 0x94D7FDC3,
/**/                   0xBFBCCFED, 0xBFEE0000,
/**/                   0xBD33A823, 0x2FE71256,
/**/                   0x3FF1E400, 0x00000000,
/**/                   0xBF310C4C, 0x0478BBCF,
/**/                   0xBFBC8858, 0x01BC4000,
/**/                   0xBD2646D1, 0xC65AACD3,
/**/                   0x3FF1DC00, 0x00000000,
/**/                   0x3F3F0ECB, 0xCB840C49,
/**/                   0xBFBC40D6, 0x425A4000,
/**/                   0xBD3CB112, 0x1D1930DD,
/**/                   0x3FF1D800, 0x00000000,
/**/                   0x3F2EACE5, 0xC9579074,
/**/                   0xBFBBF968, 0x769FC000,
/**/                   0xBD24218C, 0x8D824283,
/**/                   0x3FF1D400, 0x00000000,
/**/                   0xBECABDFA, 0xFC60F0AE,
/**/                   0xBFBBB20E, 0x936D8000,
/**/                   0x3D368BA8, 0x35459B8E,
/**/                   0x3FF1D000, 0x00000000,
/**/                   0xBF2F2A4B, 0xAFDC61F3,
/**/                   0xBFBB6AC8, 0x8DAD4000,
/**/                   0xBD3B1BDF, 0xF50225C7,
/**/                   0x3FF1CC00, 0x00000000,
/**/                   0xBF3EC8AF, 0xAB802394,
/**/                   0xBFBB2396, 0x5A530000,
/**/                   0x3CEFF64E, 0xEA137079,
/**/                   0x3FF1C400, 0x00000000,
/**/                   0x3F322FC1, 0xCE058D9B,
/**/                   0xBFBADC77, 0xEE5B0000,
/**/                   0x3D3573B2, 0x09C31904,
/**/                   0x3FF1C000, 0x00000000,
/**/                   0x3F0AA04F, 0xE0EFA2CF,
/**/                   0xBFBA956D, 0x3ECAC000,
/**/                   0xBD3E6379, 0x4C02C4AF,
/**/                   0x3FF1BC00, 0x00000000,
/**/                   0xBF26B7F7, 0x225ADFDD,
/**/                   0xBFBA4E76, 0x40B1C000,
/**/                   0x3D0E42B6, 0xB94407C8,
/**/                   0x3FF1B800, 0x00000000,
/**/                   0xBF39E073, 0x217CD13A,
/**/                   0xBFBA0792, 0xE9278000,
/**/                   0x3D0A9CE6, 0xC9AD51BF,
/**/                   0x3FF1B000, 0x00000000,
/**/                   0x3F37C67F, 0x2BAE2B21,
/**/                   0xBFB9C0C3, 0x2D4D4000,
/**/                   0x3D3AB7C0, 0x9E838668,
/**/                   0x3FF1AC00, 0x00000000,
/**/                   0x3F23316E, 0xBD720DCF,
/**/                   0xBFB97A07, 0x024CC000,
/**/                   0x3CF8BCC1, 0x732093CE,
/**/                   0x3FF1A800, 0x00000000,
/**/                   0xBF11A7B9, 0x611A7B96,
/**/                   0xBFB9335E, 0x5D594000,
/**/                   0xBD23115C, 0x3ABD47DA,
/**/                   0x3FF1A400, 0x00000000,
/**/                   0xBF324195, 0xA1C1B8E7,
/**/                   0xBFB8ECC9, 0x33AEC000,
/**/                   0x3D222F39, 0xBE67F7AA,
/**/                   0x3FF1A000, 0x00000000,
/**/                   0xBF3FEE61, 0xFEE61FEE,
/**/                   0xBFB8A647, 0x7A91C000,
/**/                   0xBD3C28C0, 0xAF9BD6DF,
/**/                   0x3FF19800, 0x00000000,
/**/                   0x3F328F89, 0x362B721D,
/**/                   0xBFB85FD9, 0x27508000,
/**/                   0x3D35B818, 0x19970C1C,
/**/                   0x3FF19400, 0x00000000,
/**/                   0x3F14E023, 0x28A70119,
/**/                   0xBFB8197E, 0x2F410000,
/**/                   0x3D3C0FE4, 0x60D20041,
/**/                   0x3FF19000, 0x00000000,
/**/                   0xBF1FD419, 0x3E48FC6F,
/**/                   0xBFB7D336, 0x87C28000,
/**/                   0xBD33C88C, 0x3E706706,
/**/                   0x3FF18C00, 0x00000000,
/**/                   0xBF34F7C6, 0xFD42546B,
/**/                   0xBFB78D02, 0x263D8000,
/**/                   0xBD069B57, 0x94B69FB7,
/**/                   0x3FF18400, 0x00000000,
/**/                   0x3F3E2FA4, 0x01185E30,
/**/                   0xBFB746E1, 0x00228000,
/**/                   0x3D3126D1, 0x6E1E21D2,
/**/                   0x3FF18000, 0x00000000,
/**/                   0x3F318118, 0x11811812,
/**/                   0xBFB700D3, 0x0AEAC000,
/**/                   0xBCEC1E8D, 0xA99DED32,
/**/                   0x3FF17C00, 0x00000000,
/**/                   0x3F13F1CA, 0xFF2E2C43,
/**/                   0xBFB6BAD8, 0x3C188000,
/**/                   0xBD0DAF3C, 0xC08926AE,
/**/                   0x3FF17800, 0x00000000,
/**/                   0xBF1D79B9, 0x0A5EF9FF,
/**/                   0xBFB674F0, 0x89364000,
/**/                   0xBD3A7999, 0x4C9D3302,
/**/                   0x3FF17400, 0x00000000,
/**/                   0xBF338FAD, 0x1ECEA765,
/**/                   0xBFB62F1B, 0xE7D78000,
/**/                   0x3D217995, 0x7ED63C4E,
/**/                   0x3FF17000, 0x00000000,
/**/                   0xBF3F976B, 0xD8C8714B,
/**/                   0xBFB5E95A, 0x4D978000,
/**/                   0xBD31CB7C, 0xE1D17171,
/**/                   0x3FF16800, 0x00000000,
/**/                   0x3F348A33, 0xB08FA497,
/**/                   0xBFB5A3AB, 0xB01AC000,
/**/                   0xBD3E2574, 0x9E6AFA18,
/**/                   0x3FF16400, 0x00000000,
/**/                   0x3F21AA1F, 0x864022C9,
/**/                   0xBFB55E10, 0x050E0000,
/**/                   0xBD0C1D74, 0x0C53C72E,
/**/                   0x3FF16000, 0x00000000,
/**/                   0xBF05B7C9, 0xB487BCAD,
/**/                   0xBFB51887, 0x42260000,
/**/                   0xBD330A1D, 0x96258B3E,
/**/                   0x3FF15C00, 0x00000000,
/**/                   0xBF2C3411, 0x5B1E5F75,
/**/                   0xBFB4D311, 0x5D208000,
/**/                   0x3CF53A25, 0x82F4E1EF,
/**/                   0x3FF15800, 0x00000000,
/**/                   0xBF39543F, 0xEEA99544,
/**/                   0xBFB48DAE, 0x4BC30000,
/**/                   0xBD30185B, 0x208C200C,
/**/                   0x3FF15000, 0x00000000,
/**/                   0x3F3B9A3F, 0xDD5C8CB8,
/**/                   0xBFB4485E, 0x03DBC000,
/**/                   0xBD3FAD46, 0xE8D26AB7,
/**/                   0x3FF14C00, 0x00000000,
/**/                   0x3F30B155, 0xB19AE5C7,
/**/                   0xBFB40320, 0x7B414000,
/**/                   0xBD26FD84, 0xAA8157C0,
/**/                   0x3FF14800, 0x00000000,
/**/                   0x3F17C382, 0xB34EDA32,
/**/                   0xBFB3BDF5, 0xA7D20000,
/**/                   0x3D319BD0, 0xAD125895,
/**/                   0x3FF14400, 0x00000000,
/**/                   0xBF129CFF, 0xBAF129D0,
/**/                   0xBFB378DD, 0x7F748000,
/**/                   0xBD371411, 0x28F1FACA,
/**/                   0x3FF14000, 0x00000000,
/**/                   0xBF2E2E59, 0x771B7C7F,
/**/                   0xBFB333D7, 0xF8184000,
/**/                   0x3CE692B6, 0xA81B8848,
/**/                   0x3FF13C00, 0x00000000,
/**/                   0xBF395F06, 0x30FE1D9C,
/**/                   0xBFB2EEE5, 0x07B40000,
/**/                   0xBD08081E, 0xDD77C860,
/**/                   0x3FF13400, 0x00000000,
/**/                   0x3F3C8113, 0x5C81135D,
/**/                   0xBFB2AA04, 0xA4470000,
/**/                   0xBD37A48B, 0xA8B1CB41,
/**/                   0x3FF13000, 0x00000000,
/**/                   0x3F3288FF, 0xBB3B5DC0,
/**/                   0xBFB26536, 0xC3D8C000,
/**/                   0xBD0B4BAC, 0x097C5BA3,
/**/                   0x3FF12C00, 0x00000000,
/**/                   0x3F21713D, 0xB81577AE,
/**/                   0xBFB2207B, 0x5C784000,
/**/                   0xBD349D8C, 0xFC10C7BF,
/**/                   0x3FF12800, 0x00000000,
/**/                   0xBEEE05E5, 0xBAD6FC84,
/**/                   0xBFB1DBD2, 0x643D0000,
/**/                   0xBD390B24, 0xD977C494,
/**/                   0x3FF12400, 0x00000000,
/**/                   0xBF24E314, 0x59F992BF,
/**/                   0xBFB1973B, 0xD1464000,
/**/                   0xBD3566D1, 0x54F930B3,
/**/                   0x3FF12000, 0x00000000,
/**/                   0xBF33CB91, 0xC9F6E7A8,
/**/                   0xBFB152B7, 0x99BB4000,
/**/                   0x3D09BB29, 0x07030829,
/**/                   0x3FF11C00, 0x00000000,
/**/                   0xBF3CFE65, 0x8B7D9851,
/**/                   0xBFB10E45, 0xB3CB0000,
/**/                   0x3D37CF69, 0x284A3465,
/**/                   0x3FF11400, 0x00000000,
/**/                   0x3F39F5DB, 0x29605DF7,
/**/                   0xBFB0C9E6, 0x15AC4000,
/**/                   0xBD2C2DA8, 0x0974D976,
/**/                   0x3FF11000, 0x00000000,
/**/                   0x3F311111, 0x11111111,
/**/                   0xBFB08598, 0xB59E4000,
/**/                   0x3D17E5DD, 0x7009902C,
/**/                   0x3FF10C00, 0x00000000,
/**/                   0x3F20A63A, 0x12A5B1AE,
/**/                   0xBFB0415D, 0x89E74000,
/**/                   0xBD1111C0, 0x5CF1D753,
/**/                   0x3FF10800, 0x00000000,
/**/                   0xBED107FB, 0xBE011080,
/**/                   0xBFAFFA69, 0x11AB8000,
/**/                   0xBD23008C, 0x98381A8F,
/**/                   0x3FF10400, 0x00000000,
/**/                   0xBF216989, 0x6FEABBAE,
/**/                   0xBFAF723B, 0x51800000,
/**/                   0x3D3D6EB0, 0xDD5610D3,
/**/                   0x3FF10000, 0x00000000,
/**/                   0xBF30FEF0, 0x10FEF011,
/**/                   0xBFAEEA31, 0xC0068000,
/**/                   0xBD3C3DD8, 0x3606D891,
/**/                   0x3FF0FC00, 0x00000000,
/**/                   0xBF3922C0, 0x98CDDC74,
/**/                   0xBFAE624C, 0x4A0B8000,
/**/                   0x3D30F25C, 0x74676689,
/**/                   0x3FF0F400, 0x00000000,
/**/                   0x3F3EDFAB, 0x325A1A80,
/**/                   0xBFADDA8A, 0xDC680000,
/**/                   0x3D21B1AC, 0x64D9E42F,
/**/                   0x3FF0F000, 0x00000000,
/**/                   0x3F370834, 0xF27F9A57,
/**/                   0xBFAD52ED, 0x64060000,
/**/                   0x3D33C85D, 0x2A29BBD6,
/**/                   0x3FF0EC00, 0x00000000,
/**/                   0x3F2EAD7C, 0xD391FBC5,
/**/                   0xBFACCB73, 0xCDDD8000,
/**/                   0xBD3965C3, 0x6E09F5FE,
/**/                   0x3FF0E800, 0x00000000,
/**/                   0x3F1F2CA5, 0xE9479870,
/**/                   0xBFAC441E, 0x06F70000,
/**/                   0xBD354F1F, 0x49850D15,
/**/                   0x3FF0E400, 0x00000000,
/**/                   0x3ED95609, 0x80439019,
/**/                   0xBFABBCEB, 0xFC690000,
/**/                   0x3D17BF86, 0x8C317C2A,
/**/                   0x3FF0E000, 0x00000000,
/**/                   0xBF1B6B4D, 0xC6867596,
/**/                   0xBFAB35DD, 0x9B588000,
/**/                   0xBD3D5674, 0xD6CF558E,
/**/                   0x3FF0DC00, 0x00000000,
/**/                   0xBF2BEAEE, 0x172D4CE8,
/**/                   0xBFAAAEF2, 0xD0FB0000,
/**/                   0xBD20FC1A, 0x353BB42E,
/**/                   0x3FF0D800, 0x00000000,
/**/                   0xBF34EAB0, 0x479071A9,
/**/                   0xBFAA282B, 0x8A938000,
/**/                   0x3D2E8F59, 0x80EFC8E3,
/**/                   0x3FF0D400, 0x00000000,
/**/                   0xBF3BBA9C, 0xA61C62D3,
/**/                   0xBFA9A187, 0xB5740000,
/**/                   0x3D30C22E, 0x4EC4D90D,
/**/                   0x3FF0CC00, 0x00000000,
/**/                   0x3F3D9AA6, 0x77344011,
/**/                   0xBFA91B07, 0x3EFD8000,
/**/                   0x3D19D7C5, 0x3F76CA96,
/**/                   0x3FF0C800, 0x00000000,
/**/                   0x3F3714FB, 0xCDA3AC11,
/**/                   0xBFA894AA, 0x149F8000,
/**/                   0xBD39A19A, 0x8BE97661,
/**/                   0x3FF0C400, 0x00000000,
/**/                   0x3F30B446, 0x391F2E61,
/**/                   0xBFA80E70, 0x23D90000,
/**/                   0x3D399DC1, 0x6F28BF45,
/**/                   0x3FF0C000, 0x00000000,
/**/                   0x3F24F0D1, 0x682E11CD,
/**/                   0xBFA78859, 0x5A358000,
/**/                   0x3D108B0D, 0x083B3A4C,
/**/                   0x3FF0BC00, 0x00000000,
/**/                   0x3F118519, 0x5D5A36EA,
/**/                   0xBFA70265, 0xA5510000,
/**/                   0x3D2888DF, 0x11FD5CE7,
/**/                   0x3FF0B800, 0x00000000,
/**/                   0xBEF913DA, 0x62386CAB,
/**/                   0xBFA67C94, 0xF2D48000,
/**/                   0xBD3DAC20, 0x827CCA0C,
/**/                   0x3FF0B400, 0x00000000,
/**/                   0xBF1D7CFF, 0xBD31D7D0,
/**/                   0xBFA5F6E7, 0x30790000,
/**/                   0x3D20485A, 0x8012494C,
/**/                   0x3FF0B000, 0x00000000,
/**/                   0xBF2A11BA, 0x226951DC,
/**/                   0xBFA5715C, 0x4C040000,
/**/                   0x3D38888D, 0xDFC47628,
/**/                   0x3FF0AC00, 0x00000000,
/**/                   0xBF328E31, 0x7B2E9DD2,
/**/                   0xBFA4EBF4, 0x334A0000,
/**/                   0x3D2D9150, 0xF73BE773,
/**/                   0x3FF0A800, 0x00000000,
/**/                   0xBF37EF59, 0x7EF597EF,
/**/                   0xBFA466AE, 0xD42E0000,
/**/                   0x3D2C1673, 0x75BDFD28,
/**/                   0x3FF0A400, 0x00000000,
/**/                   0xBF3D2C71, 0x50D413C1,
/**/                   0xBFA3E18C, 0x1CA08000,
/**/                   0xBD3748ED, 0x3F6E378E,
/**/                   0x3FF09C00, 0x00000000,
/**/                   0x3F3DBA6A, 0xF836010A,
/**/                   0xBFA35C8B, 0xFAA10000,
/**/                   0xBD38357D, 0x5EF9EB35,
/**/                   0x3FF09800, 0x00000000,
/**/                   0x3F38C51F, 0x624D4AF5,
/**/                   0xBFA2D7AE, 0x5C3C8000,
/**/                   0x3D322939, 0x459DA66D,
/**/                   0x3FF09400, 0x00000000,
/**/                   0x3F33F390, 0x10953F39,
/**/                   0xBFA252F3, 0x2F8D0000,
/**/                   0xBD283E9A, 0xE021B67B,
/**/                   0x3FF09000, 0x00000000,
/**/                   0x3F2E8B42, 0x861539B9,
/**/                   0xBFA1CE5A, 0x62BC0000,
/**/                   0xBD3A9CC7, 0x8D8DF999,
/**/                   0x3FF08C00, 0x00000000,
/**/                   0x3F25766E, 0xACBC4021,
/**/                   0xBFA149E3, 0xE4008000,
/**/                   0x3D32B98A, 0x9A4168FD,
/**/                   0x3FF08800, 0x00000000,
/**/                   0x3F1950DB, 0x0F3DBD5A,
/**/                   0xBFA0C58F, 0xA19E0000,
/**/                   0x3D0559D1, 0x58B17913,
/**/                   0x3FF08400, 0x00000000,
/**/                   0x3F008421, 0x08421084,
/**/                   0xBFA0415D, 0x89E78000,
/**/                   0x3D3DDDC7, 0xF461C516,
/**/                   0x3FF08000, 0x00000000,
/**/                   0xBF007FDF, 0x0041FF7C,
/**/                   0xBF9F7A9B, 0x16780000,
/**/                   0xBD242AD9, 0x271BE7D7,
/**/                   0x3FF07C00, 0x00000000,
/**/                   0xBF183591, 0xC54798FB,
/**/                   0xBF9E72BF, 0x28140000,
/**/                   0x3D28D751, 0x49774D47,
/**/                   0x3FF07800, 0x00000000,
/**/                   0xBF23CFA1, 0x518F4EFD,
/**/                   0xBF9D6B27, 0x25980000,
/**/                   0x3D39FF7B, 0x50D1B838,
/**/                   0x3FF07400, 0x00000000,
/**/                   0xBF2B3EB7, 0x01073261,
/**/                   0xBF9C63D2, 0xEC150000,
/**/                   0x3D35439C, 0xE030A687,
/**/                   0x3FF07000, 0x00000000,
/**/                   0xBF31341F, 0xD6EAB025,
/**/                   0xBF9B5CC2, 0x58B70000,
/**/                   0xBD18E611, 0xB8AFBFE8,
/**/                   0x3FF06C00, 0x00000000,
/**/                   0xBF34A638, 0x6ED049E0,
/**/                   0xBF9A55F5, 0x48C60000,
/**/                   0x3D2DE070, 0x9F2D03C9,
/**/                   0x3FF06800, 0x00000000,
/**/                   0xBF37F5BF, 0xEF997F5C,
/**/                   0xBF994F6B, 0x99A20000,
/**/                   0xBD311D5E, 0xF96CF7F5,
/**/                   0x3FF06400, 0x00000000,
/**/                   0xBF3B22D0, 0xE5604189,
/**/                   0xBF984925, 0x28C90000,
/**/                   0x3D2AA0BA, 0x325A0C34,
/**/                   0x3FF06000, 0x00000000,
/**/                   0xBF3E2D85, 0xC1163FF0,
/**/                   0xBF974321, 0xD3D00000,
/**/                   0xBCFB4A69, 0x0FE94778,
/**/                   0x3FF05800, 0x00000000,
/**/                   0x3F3EEA07, 0x27586632,
/**/                   0xBF963D61, 0x78690000,
/**/                   0xBD07ABF3, 0x89596542,
/**/                   0x3FF05400, 0x00000000,
/**/                   0x3F3C23BB, 0x98E2A5E7,
/**/                   0xBF9537E3, 0xF45F0000,
/**/                   0xBD2AB259, 0xD2D7F253,
/**/                   0x3FF05000, 0x00000000,
/**/                   0x3F397F7D, 0x73404146,
/**/                   0xBF9432A9, 0x25980000,
/**/                   0xBD098139, 0x928637FE,
/**/                   0x3FF04C00, 0x00000000,
/**/                   0x3F36FD32, 0xB0C7B49A,
/**/                   0xBF932DB0, 0xEA130000,
/**/                   0xBD2710CB, 0x130895FC,
/**/                   0x3FF04800, 0x00000000,
/**/                   0x3F349CC1, 0x664C578A,
/**/                   0xBF9228FB, 0x1FEA0000,
/**/                   0xBD2713E3, 0x284991FE,
/**/                   0x3FF04400, 0x00000000,
/**/                   0x3F325E0F, 0xC2FCB1F4,
/**/                   0xBF912487, 0xA5500000,
/**/                   0xBD3FDBE5, 0xFED4B393,
/**/                   0x3FF04000, 0x00000000,
/**/                   0x3F304104, 0x10410410,
/**/                   0xBF902056, 0x58930000,
/**/                   0xBD3611D2, 0x7C8E8417,
/**/                   0x3FF03C00, 0x00000000,
/**/                   0x3F2C8B09, 0x6334030B,
/**/                   0xBF8E38CE, 0x30340000,
/**/                   0x3D39DE88, 0xA3DA281A,
/**/                   0x3FF03800, 0x00000000,
/**/                   0x3F28D6F0, 0x48FF7E3A,
/**/                   0xBF8C3173, 0x84C80000,
/**/                   0x3D341F33, 0xFCEFB9FE,
/**/                   0x3FF03400, 0x00000000,
/**/                   0x3F25658A, 0x0081A559,
/**/                   0xBF8A2A9C, 0x6C180000,
/**/                   0x3D3F73BC, 0x4D6D3472,
/**/                   0x3FF03000, 0x00000000,
/**/                   0x3F2236A3, 0xEBC349DE,
/**/                   0xBF882448, 0xA3880000,
/**/                   0xBD345544, 0x12C584E0,
/**/                   0x3FF02C00, 0x00000000,
/**/                   0x3F1E9417, 0x3FEFD386,
/**/                   0xBF861E77, 0xE8B60000,
/**/                   0x3D38073E, 0xEAF8EAF3,
/**/                   0x3FF02800, 0x00000000,
/**/                   0x3F193F1D, 0xCA7A317C,
/**/                   0xBF841929, 0xF9680000,
/**/                   0xBD1977C7, 0x55D01368,
/**/                   0x3FF02400, 0x00000000,
/**/                   0x3F146DF7, 0x6CB49652,
/**/                   0xBF82145E, 0x939E0000,
/**/                   0xBD3E3D12, 0x38C4EA00,
/**/                   0x3FF02000, 0x00000000,
/**/                   0x3F102040, 0x81020408,
/**/                   0xBF801015, 0x75880000,
/**/                   0xBD3BCE25, 0x1998B506,
/**/                   0x3FF01C00, 0x00000000,
/**/                   0x3F08AB2B, 0x8C355D63,
/**/                   0xBF7C189C, 0xBB100000,
/**/                   0x3D3D8055, 0x12588560,
/**/                   0x3FF01800, 0x00000000,
/**/                   0x3F021B28, 0xBD1BA97E,
/**/                   0xBF781212, 0x14580000,
/**/                   0xBD1AD503, 0x82973F27,
/**/                   0x3FF01400, 0x00000000,
/**/                   0x3EF91F67, 0x411155AB,
/**/                   0xBF740C8A, 0x74780000,
/**/                   0xBD1E3871, 0xDF070002,
/**/                   0x3FF01000, 0x00000000,
/**/                   0x3EF01010, 0x10101010,
/**/                   0xBF700805, 0x59580000,
/**/                   0xBD2166AF, 0xCB31C67B,
/**/                   0x3FF00C00, 0x00000000,
/**/                   0x3EE20D8A, 0x279DB649,
/**/                   0xBF680904, 0x82880000,
/**/                   0xBD285C06, 0x96A70C0C,
/**/                   0x3FF00800, 0x00000000,
/**/                   0x3ED00804, 0x02010080,
/**/                   0xBF600401, 0x55D80000,
/**/                   0x3D33BB10, 0xC7CC7089,
/**/                   0x3FF00400, 0x00000000,
/**/                   0x3EB00401, 0x00401004,
/**/                   0xBF500200, 0x55600000,
/**/                   0xBD356224, 0xCD5F35F8,
/**/                   0x3FF00000, 0x00000000,
/**/                   0x00000000, 0x00000000,
/**/                   0x00000000, 0x00000000,
/**/                   0x00000000, 0x00000000,
/**/                   0x3FEFF800, 0x00000000,
/**/                   0x3EAFF801, 0xFF801FF8,
/**/                   0x3F4FFC00, 0xAA800000,
/**/                   0x3D35621F, 0x7809A0A3,
/**/                   0x3FEFF000, 0x00000000,
/**/                   0x3ECFF007, 0xFC01FF00,
/**/                   0x3F5FF802, 0xA9B00000,
/**/                   0xBD33BC66, 0x1D61C5EB,
/**/                   0x3FEFE800, 0x00000000,
/**/                   0x3EE1F28A, 0x186DADBE,
/**/                   0x3F67F704, 0x7D780000,
/**/                   0x3D283DA6, 0x89D68648,
/**/                   0x3FEFE000, 0x00000000,
/**/                   0x3EEFE01F, 0xE01FE020,
/**/                   0x3F6FF00A, 0xA2B00000,
/**/                   0x3D20BC04, 0xA086B56A,
/**/                   0x3FEFD800, 0x00000000,
/**/                   0x3EF8E0E6, 0xDF68BD14,
/**/                   0x3F73F38A, 0x60F00000,
/**/                   0x3D192256, 0x93C93749,
/**/                   0x3FEFD000, 0x00000000,
/**/                   0x3F01E528, 0x439A981C,
/**/                   0x3F77EE11, 0xEBD80000,
/**/                   0x3D0749D3, 0xC2D23A07,
/**/                   0x3FEFC800, 0x00000000,
/**/                   0x3F08556A, 0x8596391C,
/**/                   0x3F7BE79C, 0x70040000,
/**/                   0x3D38EC8F, 0x9A6C0404,
/**/                   0x3FEFC000, 0x00000000,
/**/                   0x3F0FC07F, 0x01FC07F0,
/**/                   0x3F7FE02A, 0x6B100000,
/**/                   0x3D19E23F, 0x0DDA40E4,
/**/                   0x3FEFB800, 0x00000000,
/**/                   0x3F1412D5, 0x9F5976B5,
/**/                   0x3F81EBDE, 0x2D1A0000,
/**/                   0xBD2A0683, 0xFF48DC36,
/**/                   0x3FEFB000, 0x00000000,
/**/                   0x3F18C21A, 0xBD271E34,
/**/                   0x3F83E729, 0x5D260000,
/**/                   0xBD2609C1, 0xFF29A114,
/**/                   0x3FEFA800, 0x00000000,
/**/                   0x3F1DEDB2, 0x5594A734,
/**/                   0x3F85E1F7, 0x03EC0000,
/**/                   0x3D37CA09, 0xF585DA1B,
/**/                   0x3FEFA000, 0x00000000,
/**/                   0x3F21CAA0, 0x1FA11CAA,
/**/                   0x3F87DC47, 0x5F820000,
/**/                   0xBD3EB124, 0x5B5DA1F5,
/**/                   0x3FEF9800, 0x00000000,
/**/                   0x3F24DC34, 0x55E8CB6B,
/**/                   0x3F89D61A, 0xADC60000,
/**/                   0x3D37B196, 0x327B4257,
/**/                   0x3FEF9000, 0x00000000,
/**/                   0x3F282B68, 0x13BAF1B2,
/**/                   0x3F8BCF71, 0x2C740000,
/**/                   0x3D1C25E0, 0x97BD9771,
/**/                   0x3FEF8800, 0x00000000,
/**/                   0x3F2BB80D, 0xCC420861,
/**/                   0x3F8DC84B, 0x19120000,
/**/                   0x3D1C0A54, 0x1E3A5B30,
/**/                   0x3FEF8000, 0x00000000,
/**/                   0x3F2F81F8, 0x1F81F820,
/**/                   0x3F8FC0A8, 0xB0FC0000,
/**/                   0x3CDF1E7C, 0xF6D3A69C,
/**/                   0x3FEF7800, 0x00000000,
/**/                   0x3F31C47C, 0xED1079FA,
/**/                   0x3F90DC45, 0x18B00000,
/**/                   0xBD29BC2F, 0x380313FC,
/**/                   0x3FEF7000, 0x00000000,
/**/                   0x3F33E672, 0xFA98528D,
/**/                   0x3F91D7F7, 0xEB9F0000,
/**/                   0xBD14193A, 0x83FCC7A6,
/**/                   0x3FEF6800, 0x00000000,
/**/                   0x3F3626C7, 0xCAFBD3D2,
/**/                   0x3F92D36C, 0xEFB50000,
/**/                   0x3D35F0BB, 0x341706C3,
/**/                   0x3FEF6000, 0x00000000,
/**/                   0x3F388565, 0x06DDABA6,
/**/                   0x3F93CEA4, 0x43470000,
/**/                   0xBD36A2C4, 0x32D6A40B,
/**/                   0x3FEF5800, 0x00000000,
/**/                   0x3F3B0234, 0x6CC4F5F5,
/**/                   0x3F94C99E, 0x04900000,
/**/                   0x3D1DECC6, 0x5DF5F4A5,
/**/                   0x3FEF5000, 0x00000000,
/**/                   0x3F3D9D1F, 0xD102728A,
/**/                   0x3F95C45A, 0x51B90000,
/**/                   0xBD263BB6, 0x216D87D8,
/**/                   0x3FEF5000, 0x00000000,
/**/                   0xBF3FA9EE, 0xE26A1DD4,
/**/                   0x3F96BED9, 0x48D20000,
/**/                   0xBD320BC4, 0x160A43F8,
/**/                   0x3FEF4800, 0x00000000,
/**/                   0xBF3CD30D, 0xADEC7540,
/**/                   0x3F97B91B, 0x07D60000,
/**/                   0xBD33B955, 0xB602ACE4,
/**/                   0x3FEF4000, 0x00000000,
/**/                   0xBF39DE52, 0x7C761DC6,
/**/                   0x3F98B31F, 0xACAA0000,
/**/                   0xBD33FC78, 0xA96E4964,
/**/                   0x3FEF3800, 0x00000000,
/**/                   0xBF36CBD3, 0x23989FF0,
/**/                   0x3F99ACE7, 0x551D0000,
/**/                   0xBD2D75D9, 0x7EC7C410,
/**/                   0x3FEF3000, 0x00000000,
/**/                   0xBF339BA5, 0x639F8B15,
/**/                   0x3F9AA672, 0x1EE80000,
/**/                   0x3D2AD4EB, 0x5C5AF494,
/**/                   0x3FEF2800, 0x00000000,
/**/                   0xBF304DDE, 0xE7AA579B,
/**/                   0x3F9B9FC0, 0x27B00000,
/**/                   0xBD3B9A01, 0x0AE6922A,
/**/                   0x3FEF2000, 0x00000000,
/**/                   0xBF29C52A, 0x8B8C46FD,
/**/                   0x3F9C98D1, 0x8D010000,
/**/                   0xBD2BF615, 0x0589DF0F,
/**/                   0x3FEF1800, 0x00000000,
/**/                   0xBF22B3BB, 0xFE0E92B4,
/**/                   0x3F9D91A6, 0x6C540000,
/**/                   0x3D2E61F1, 0x658CFB9A,
/**/                   0x3FEF1000, 0x00000000,
/**/                   0xBF16CF39, 0xFE8B488E,
/**/                   0x3F9E8A3E, 0xE30D0000,
/**/                   0xBD21A9FA, 0x3DE53900,
/**/                   0x3FEF0800, 0x00000000,
/**/                   0xBEFF07C1, 0xF07C1F08,
/**/                   0x3F9F829B, 0x0E780000,
/**/                   0x3D298026, 0x7C7E09E4,
/**/                   0x3FEF0000, 0x00000000,
/**/                   0x3EFF003E, 0x007C00F8,
/**/                   0x3FA03D5D, 0x85E70000,
/**/                   0x3D3F7789, 0x60ED29CF,
/**/                   0x3FEEF800, 0x00000000,
/**/                   0x3F17B671, 0x3D759870,
/**/                   0x3FA0B94F, 0x7C198000,
/**/                   0xBD2E8989, 0x6F022783,
/**/                   0x3FEEF000, 0x00000000,
/**/                   0x3F241070, 0x2A8BB96A,
/**/                   0x3FA13523, 0x78598000,
/**/                   0xBD1C1AC3, 0xB71FA59B,
/**/                   0x3FEEE800, 0x00000000,
/**/                   0x3F2C7F84, 0x58E01EEA,
/**/                   0x3FA1B0D9, 0x89240000,
/**/                   0xBD33401E, 0x9AE889BB,
/**/                   0x3FEEE000, 0x00000000,
/**/                   0x3F329425, 0xA3D491BC,
/**/                   0x3FA22C71, 0xBCEA8000,
/**/                   0x3CFD2818, 0xF87F888F,
/**/                   0x3FEED800, 0x00000000,
/**/                   0x3F37054D, 0x9E9D2AE8,
/**/                   0x3FA2A7EC, 0x22150000,
/**/                   0xBD278CE7, 0x7A9163FE,
/**/                   0x3FEED000, 0x00000000,
/**/                   0x3F3B9325, 0x540C85E6,
/**/                   0x3FA32348, 0xC7000000,
/**/                   0x3D2696DB, 0x90B1E49F,
/**/                   0x3FEED000, 0x00000000,
/**/                   0xBF3FC267, 0xF099FC26,
/**/                   0x3FA39E87, 0xB9FE8000,
/**/                   0x3D3EAFD4, 0x80AD9015,
/**/                   0x3FEEC800, 0x00000000,
/**/                   0xBF3AFB6E, 0xD02A4E5D,
/**/                   0x3FA419A9, 0x09590000,
/**/                   0x3D3B5CDC, 0x67D48EA7,
/**/                   0x3FEEC000, 0x00000000,
/**/                   0xBF361803, 0xD7A79FF1,
/**/                   0x3FA494AC, 0xC34D8000,
/**/                   0x3D211C78, 0xA56FD247,
/**/                   0x3FEEB800, 0x00000000,
/**/                   0xBF31183B, 0x805C2197,
/**/                   0x3FA50F92, 0xF60F8000,
/**/                   0x3D296CFB, 0x0A91FFE3,
/**/                   0x3FEEB000, 0x00000000,
/**/                   0xBF27F854, 0x5FE15180,
/**/                   0x3FA58A5B, 0xAFC90000,
/**/                   0xBD2B2B73, 0x9570AD39,
/**/                   0x3FEEA800, 0x00000000,
/**/                   0xBF1B0F90, 0xE210C36A,
/**/                   0x3FA60506, 0xFE990000,
/**/                   0xBD32BA40, 0x8194E036,
/**/                   0x3FEEA000, 0x00000000,
/**/                   0xBEF6F7DD, 0x8C33ADB2,
/**/                   0x3FA67F94, 0xF0948000,
/**/                   0x3D3ECC1F, 0x3E7E4ED7,
/**/                   0x3FEE9800, 0x00000000,
/**/                   0x3F1003D3, 0x1003D310,
/**/                   0x3FA6FA05, 0x93C78000,
/**/                   0x3D3B415E, 0x41D634A1,
/**/                   0x3FEE9000, 0x00000000,
/**/                   0x3F231ABF, 0x0B7672A0,
/**/                   0x3FA77458, 0xF6330000,
/**/                   0xBD3181DC, 0xE586AF09,
/**/                   0x3FEE8800, 0x00000000,
/**/                   0x3F2E6B5C, 0xCF172481,
/**/                   0x3FA7EE8F, 0x25CD8000,
/**/                   0xBD3F4216, 0x11A5C1E9,
/**/                   0x3FEE8000, 0x00000000,
/**/                   0x3F34F9CD, 0x77A84876,
/**/                   0x3FA868A8, 0x30840000,
/**/                   0xBD12623A, 0x134AC693,
/**/                   0x3FEE7800, 0x00000000,
/**/                   0x3F3AD9A8, 0xD7473427,
/**/                   0x3FA8E2A4, 0x243A0000,
/**/                   0x3D2B9EEB, 0x01426490,
/**/                   0x3FEE7800, 0x00000000,
/**/                   0xBF3F2AD3, 0x4578DCCA,
/**/                   0x3FA95C83, 0x0EC90000,
/**/                   0xBD2C1482, 0x97C5FEB8,
/**/                   0x3FEE7000, 0x00000000,
/**/                   0xBF3913BA, 0x97A6A035,
/**/                   0x3FA9D644, 0xFDFF8000,
/**/                   0x3D313C90, 0x539A473B,
/**/                   0x3FEE6800, 0x00000000,
/**/                   0xBF32E120, 0xC594A915,
/**/                   0x3FAA4FE9, 0xFFA40000,
/**/                   0xBD36E584, 0xA0402925,
/**/                   0x3FEE6000, 0x00000000,
/**/                   0xBF292632, 0xC5DF4232,
/**/                   0x3FAAC972, 0x21710000,
/**/                   0x3D2F8D3E, 0xF013222C,
/**/                   0x3FEE5800, 0x00000000,
/**/                   0xBF18A6DF, 0xC3518A6E,
/**/                   0x3FAB42DD, 0x71198000,
/**/                   0xBD1C827A, 0xE5D6704C,
/**/                   0x3FEE5000, 0x00000000,
/**/                   0x3ED6BC08, 0x86833271,
/**/                   0x3FABBC2B, 0xFC450000,
/**/                   0xBD17D186, 0x91417DAF,
/**/                   0x3FEE4800, 0x00000000,
/**/                   0x3F1BEB2D, 0xE672838D,
/**/                   0x3FAC355D, 0xD0920000,
/**/                   0x3D2F2CCC, 0x9ABF8388,
/**/                   0x3FEE4000, 0x00000000,
/**/                   0x3F2B6B8D, 0x9785150A,
/**/                   0x3FACAE72, 0xFB960000,
/**/                   0xBD3EFABF, 0x2025B1BE,
/**/                   0x3FEE3800, 0x00000000,
/**/                   0x3F348BCE, 0xE0D399FA,
/**/                   0x3FAD276B, 0x8ADB0000,
/**/                   0x3D16A423, 0xC78A64B0,
/**/                   0x3FEE3000, 0x00000000,
/**/                   0x3F3B7CD0, 0x933AC00F,
/**/                   0x3FADA047, 0x8BE38000,
/**/                   0x3D2252C7, 0xB1F6FE05,
/**/                   0x3FEE3000, 0x00000000,
/**/                   0xBF3D7747, 0x308F5281,
/**/                   0x3FAE1907, 0x0C278000,
/**/                   0xBD2FEA46, 0x64629E86,
/**/                   0x3FEE2800, 0x00000000,
/**/                   0xBF36508B, 0x6C196F66,
/**/                   0x3FAE91AA, 0x19150000,
/**/                   0xBD0E82A0, 0x1DCC6A76,
/**/                   0x3FEE2000, 0x00000000,
/**/                   0xBF2E1E1E, 0x1E1E1E1E,
/**/                   0x3FAF0A30, 0xC0118000,
/**/                   0xBD2D599E, 0x83368E91,
/**/                   0x3FEE1800, 0x00000000,
/**/                   0xBF1ECB93, 0xDD355CDB,
/**/                   0x3FAF829B, 0x0E780000,
/**/                   0x3D398026, 0x7C7E09E4,
/**/                   0x3FEE1000, 0x00000000,
/**/                   0xBECE0FF8, 0x7C01E100,
/**/                   0x3FAFFAE9, 0x119B8000,
/**/                   0x3D230337, 0x4262C554,
/**/                   0x3FEE0800, 0x00000000,
/**/                   0x3F1D54B5, 0x25C73724,
/**/                   0x3FB0398D, 0x6B624000,
/**/                   0xBD3AB14D, 0xFCBFCD00,
/**/                   0x3FEE0000, 0x00000000,
/**/                   0x3F2E01E0, 0x1E01E01E,
/**/                   0x3FB07598, 0x35990000,
/**/                   0xBD3B8ECF, 0xE4B59987,
/**/                   0x3FEDF800, 0x00000000,
/**/                   0x3F36C715, 0xC84194BA,
/**/                   0x3FB0B194, 0xEE0D0000,
/**/                   0x3D3666EA, 0x4F69EDCC,
/**/                   0x3FEDF000, 0x00000000,
/**/                   0x3F3EA78B, 0xEF26D838,
/**/                   0x3FB0ED83, 0x9B554000,
/**/                   0xBD3901F4, 0x6D48ABB4,
/**/                   0x3FEDF000, 0x00000000,
/**/                   0xBF395DBF, 0xF10995DC,
/**/                   0x3FB12964, 0x44030000,
/**/                   0xBD3D53BB, 0x751AA773,
/**/                   0x3FEDE800, 0x00000000,
/**/                   0xBF3148E0, 0x3BCBADC8,
/**/                   0x3FB16536, 0xEEA38000,
/**/                   0xBD147C5E, 0x768FA309,
/**/                   0x3FEDE000, 0x00000000,
/**/                   0xBF2233CE, 0x86E25CE1,
/**/                   0x3FB1A0FB, 0xA1BF8000,
/**/                   0x3D24A3FC, 0xC319D6DC,
/**/                   0x3FEDD800, 0x00000000,
/**/                   0xBEEA1CE9, 0x26B3FE23,
/**/                   0x3FB1DCB2, 0x63DB0000,
/**/                   0x3D39444F, 0x5E9E8981,
/**/                   0x3FEDD000, 0x00000000,
/**/                   0x3F1E4836, 0x0AB71710,
/**/                   0x3FB2185B, 0x3B75C000,
/**/                   0xBD3E3189, 0xF8F32304,
/**/                   0x3FEDC800, 0x00000000,
/**/                   0x3F300EE5, 0x00EE500F,
/**/                   0x3FB253F6, 0x2F0A0000,
/**/                   0x3D3416F8, 0xFB69A701,
/**/                   0x3FEDC000, 0x00000000,
/**/                   0x3F38A58D, 0x231C226A,
/**/                   0x3FB28F83, 0x450EC000,
/**/                   0x3D3A8D75, 0xAA119769,
/**/                   0x3FEDC000, 0x00000000,
/**/                   0xBF3EAA0C, 0x14715D63,
/**/                   0x3FB2CB02, 0x83F5C000,
/**/                   0x3D3E1EE2, 0xCA657021,
/**/                   0x3FEDB800, 0x00000000,
/**/                   0xBF35DFF8, 0x92AEFFC5,
/**/                   0x3FB30673, 0xF22C8000,
/**/                   0x3D24C9E2, 0x9DCF0BA5,
/**/                   0x3FEDB000, 0x00000000,
/**/                   0xBF29F894, 0x67E251A0,
/**/                   0x3FB341D7, 0x961BC000,
/**/                   0x3D31D092, 0x99837610,
/**/                   0x3FEDA800, 0x00000000,
/**/                   0xBF0FF896, 0x1FF89620,
/**/                   0x3FB37D2D, 0x76284000,
/**/                   0xBD2C60AA, 0x9B7FF15C,
/**/                   0x3FEDA000, 0x00000000,
/**/                   0x3F145E70, 0x076828BD,
/**/                   0x3FB3B875, 0x98B1C000,
/**/                   0xBD222415, 0x94ACA313,
/**/                   0x3FED9800, 0x00000000,
/**/                   0x3F2C8F60, 0xE567D573,
/**/                   0x3FB3F3B0, 0x04140000,
/**/                   0x3CEE2474, 0xACDFCEC5,
/**/                   0x3FED9000, 0x00000000,
/**/                   0x3F379118, 0xF3FC4DA2,
/**/                   0x3FB42EDC, 0xBEA64000,
/**/                   0x3D1BC0EE, 0xEA7C9ACD,
/**/                   0x3FED9000, 0x00000000,
/**/                   0xBF3F0C3C, 0x049DE4C3,
/**/                   0x3FB469FB, 0xCEBB4000,
/**/                   0x3D3B663C, 0x4F257194,
/**/                   0x3FED8800, 0x00000000,
/**/                   0xBF35905F, 0xF13D5906,
/**/                   0x3FB4A50D, 0x3AA1C000,
/**/                   0xBD2F7FE1, 0x308973E2,
/**/                   0x3FED8000, 0x00000000,
/**/                   0xBF27F6C8, 0x77D1EA57,
/**/                   0x3FB4E011, 0x08A34000,
/**/                   0x3D3AE5CF, 0xDF2C5AE5,
/**/                   0x3FED7800, 0x00000000,
/**/                   0xBF026AD1, 0xF4F31BA0,
/**/                   0x3FB51B07, 0x3F060000,
/**/                   0x3D383F69, 0x278E686A,
/**/                   0x3FED7000, 0x00000000,
/**/                   0x3F1DE6B2, 0xF26DF1BD,
/**/                   0x3FB555EF, 0xE40B4000,
/**/                   0x3D30B497, 0x8C868E23,
/**/                   0x3FED6800, 0x00000000,
/**/                   0x3F31599F, 0x7BA23D96,
/**/                   0x3FB590CA, 0xFDF00000,
/**/                   0x3D3C284F, 0x5722ABAA,
/**/                   0x3FED6000, 0x00000000,
/**/                   0x3F3B526C, 0xD425A760,
/**/                   0x3FB5CB98, 0x92ED4000,
/**/                   0x3D17BE44, 0xA64FC52F,
/**/                   0x3FED6000, 0x00000000,
/**/                   0xBF3A9BFC, 0x546A6FF1,
/**/                   0x3FB60658, 0xA9374000,
/**/                   0x3D30C3B1, 0xDEE9C4F8,
/**/                   0x3FED5800, 0x00000000,
/**/                   0xBF3071AD, 0x08F02FAC,
/**/                   0x3FB6410B, 0x46FE8000,
/**/                   0xBD153F8F, 0x3CBD8D14,
/**/                   0x3FED5000, 0x00000000,
/**/                   0xBF18BAD9, 0x12C6C142,
/**/                   0x3FB67BB0, 0x726EC000,
/**/                   0x3CEF724B, 0x69EF5912,
/**/                   0x3FED4800, 0x00000000,
/**/                   0x3F10B35C, 0x3254A5A2,
/**/                   0x3FB6B648, 0x31B00000,
/**/                   0xBD3BF30A, 0x1377DE92,
/**/                   0x3FED4000, 0x00000000,
/**/                   0x3F2D41D4, 0x1D41D41D,
/**/                   0x3FB6F0D2, 0x8AE58000,
/**/                   0xBD34B464, 0x1B664613,
/**/                   0x3FED3800, 0x00000000,
/**/                   0x3F392D71, 0xF494E548,
/**/                   0x3FB72B4F, 0x842EC000,
/**/                   0xBD3704CC, 0xC00C9DD3,
/**/                   0x3FED3800, 0x00000000,
/**/                   0xBF3C2DA1, 0xFF165C2E,
/**/                   0x3FB765BF, 0x23A6C000,
/**/                   0xBCFECBC0, 0x35C4256A,
/**/                   0x3FED3000, 0x00000000,
/**/                   0xBF317062, 0x7AA49674,
/**/                   0x3FB7A021, 0x6F648000,
/**/                   0x3D3E124C, 0xA18418FF,
/**/                   0x3FED2800, 0x00000000,
/**/                   0xBF1A6B80, 0x749CB290,
/**/                   0x3FB7DA76, 0x6D7B0000,
/**/                   0x3D32CC84, 0x4480C89B,
/**/                   0x3FED2000, 0x00000000,
/**/                   0x3F114B52, 0x25C6336D,
/**/                   0x3FB814BE, 0x23F8C000,
/**/                   0x3CCB2381, 0xDA82FDFD,
/**/                   0x3FED1800, 0x00000000,
/**/                   0x3F2EB155, 0xF08A3B1D,
/**/                   0x3FB84EF8, 0x98E84000,
/**/                   0xBD37D5CD, 0x246977C9,
/**/                   0x3FED1000, 0x00000000,
/**/                   0x3F3A7692, 0xBD71CD93,
/**/                   0x3FB88925, 0xD24FC000,
/**/                   0xBD31D505, 0x44FBB806,
/**/                   0x3FED1000, 0x00000000,
/**/                   0xBF3A5384, 0x89FC5E69,
/**/                   0x3FB8C345, 0xD6318000,
/**/                   0x3D3B20F5, 0xACB42A66,
/**/                   0x3FED0800, 0x00000000,
/**/                   0xBF2E0B56, 0x6439240E,
/**/                   0x3FB8FD58, 0xAA8C4000,
/**/                   0xBD3EEC90, 0x1BCB725B,
/**/                   0x3FED0000, 0x00000000,
/**/                   0xBF0CFF8C, 0x01CFF8C0,
/**/                   0x3FB9375E, 0x55594000,
/**/                   0x3D3EDDC3, 0x7380C364,
/**/                   0x3FECF800, 0x00000000,
/**/                   0x3F1F7661, 0x546D8D78,
/**/                   0x3FB97156, 0xDC8F8000,
/**/                   0xBD3C1FC1, 0x9AFDB97B,
/**/                   0x3FECF000, 0x00000000,
/**/                   0x3F3372E2, 0x25FE30D9,
/**/                   0x3FB9AB42, 0x46204000,
/**/                   0xBD28A648, 0x26787061,
/**/                   0x3FECE800, 0x00000000,
/**/                   0x3F3F1FDB, 0xD92305A6,
/**/                   0x3FB9E520, 0x97F9C000,
/**/                   0x3D235FAC, 0xB52DD050,
/**/                   0x3FECE800, 0x00000000,
/**/                   0xBF351B8A, 0x9C37FC63,
/**/                   0x3FBA1EF1, 0xD8060000,
/**/                   0x3D3CD417, 0x6DF97BCB,
/**/                   0x3FECE000, 0x00000000,
/**/                   0xBF227EC2, 0x6CB725AB,
/**/                   0x3FBA58B6, 0x0C2B4000,
/**/                   0xBD3CDC73, 0x5C5C9F2A,
/**/                   0x3FECD800, 0x00000000,
/**/                   0x3F05A240, 0xE6C2B448,
/**/                   0x3FBA926D, 0x3A4AC000,
/**/                   0x3D356365, 0x0BD22A9C,
/**/                   0x3FECD000, 0x00000000,
/**/                   0x3F2D7EC2, 0xFBB8D9F3,
/**/                   0x3FBACC17, 0x68434000,
/**/                   0xBD2AA783, 0xA0B7FA4C,
/**/                   0x3FECC800, 0x00000000,
/**/                   0x3F3AE1DB, 0x1B71D3E9,
/**/                   0x3FBB05B4, 0x9BEE4000,
/**/                   0x3D0FF22C, 0x18F84A5E,
/**/                   0x3FECC800, 0x00000000,
/**/                   0xBF38E45A, 0xCD6DE82D,
/**/                   0x3FBB3F44, 0xDB220000,
/**/                   0x3D3FD153, 0xD8DE09AF,
/**/                   0x3FECC000, 0x00000000,
/**/                   0xBF29269F, 0xE341926A,
/**/                   0x3FBB78C8, 0x2BB10000,
/**/                   0xBD325EF7, 0xBC3987E7,
/**/                   0x3FECB800, 0x00000000,
/**/                   0xBEC589FB, 0xF620C1DA,
/**/                   0x3FBBB23E, 0x93690000,
/**/                   0xBD368B18, 0x3559DB8B,
/**/                   0x3FECB000, 0x00000000,
/**/                   0x3F28A893, 0x0DE5FF1A,
/**/                   0x3FBBEBA8, 0x18148000,
/**/                   0xBD389B78, 0xB6DF1F57,
/**/                   0x3FECA800, 0x00000000,
/**/                   0x3F38EAB9, 0x0039563B,
/**/                   0x3FBC2504, 0xBF79C000,
/**/                   0x3D3717C4, 0xD0EF4ADC,
/**/                   0x3FECA800, 0x00000000,
/**/                   0xBF3A67D5, 0x08F377F2,
/**/                   0x3FBC5E54, 0x8F5BC000,
/**/                   0x3D1D0C57, 0x585FBE06,
/**/                   0x3FECA000, 0x00000000,
/**/                   0xBF2B46E0, 0x072792E4,
/**/                   0x3FBC9797, 0x8D790000,
/**/                   0xBD36E010, 0x977D1884,
/**/                   0x3FEC9800, 0x00000000,
/**/                   0xBEE904EA, 0x1BB327C3,
/**/                   0x3FBCD0CD, 0xBF8C0000,
/**/                   0x3D33E14D, 0xB50DD743,
/**/                   0x3FEC9000, 0x00000000,
/**/                   0x3F2853EB, 0x77683AEC,
/**/                   0x3FBD09F7, 0x2B4C4000,
/**/                   0x3D2048C0, 0x00354E33,
/**/                   0x3FEC8800, 0x00000000,
/**/                   0x3F3932D7, 0xDC52100E,
/**/                   0x3FBD4313, 0xD66CC000,
/**/                   0xBD294543, 0x79135713,
/**/                   0x3FEC8800, 0x00000000,
/**/                   0xBF39AD90, 0x2736962B,
/**/                   0x3FBD7C23, 0xC69CC000,
/**/                   0xBD297EE4, 0xDD328771,
/**/                   0x3FEC8000, 0x00000000,
/**/                   0xBF28EEA2, 0xF316B4C2,
/**/                   0x3FBDB527, 0x0187C000,
/**/                   0x3D392778, 0x56AE181F,
/**/                   0x3FEC7800, 0x00000000,
/**/                   0x3EEAB099, 0x058F7536,
/**/                   0x3FBDEE1D, 0x8CD60000,
/**/                   0xBD328DA0, 0x729EFF89,
/**/                   0x3FEC7000, 0x00000000,
/**/                   0x3F2C71C7, 0x1C71C71C,
/**/                   0x3FBE2707, 0x6E2B0000,
/**/                   0xBD2A342C, 0x2AF0003C,
/**/                   0x3FEC6800, 0x00000000,
/**/                   0x3F3BB2BB, 0xD6422A30,
/**/                   0x3FBE5FE4, 0xAB274000,
/**/                   0xBD35FAE9, 0xF74FFE4D,
/**/                   0x3FEC6800, 0x00000000,
/**/                   0xBF36BD01, 0x54BDE47E,
/**/                   0x3FBE98B5, 0x49670000,
/**/                   0x3D346774, 0x89C50E97,
/**/                   0x3FEC6000, 0x00000000,
/**/                   0xBF222CC5, 0xB5157FE4,
/**/                   0x3FBED179, 0x4E838000,
/**/                   0xBD1FD143, 0x749D0484,
/**/                   0x3FEC5800, 0x00000000,
/**/                   0x3F129A21, 0xA930B840,
/**/                   0x3FBF0A30, 0xC0118000,
/**/                   0xBD3D599E, 0x83368E91,
/**/                   0x3FEC5000, 0x00000000,
/**/                   0x3F3279B1, 0xAC5CEE14,
/**/                   0x3FBF42DB, 0xA3A24000,
/**/                   0xBD3312B7, 0x32DF6C0D,
/**/                   0x3FEC5000, 0x00000000,
/**/                   0xBF3F9CF5, 0xD4AB8D0B,
/**/                   0x3FBF7B79, 0xFEC38000,
/**/                   0xBD010987, 0xE897ED01,
/**/                   0x3FEC4800, 0x00000000,
/**/                   0xBF319D7C, 0xCC17DAE4,
/**/                   0x3FBFB40B, 0xD6FF4000,
/**/                   0x3D2C0BEC, 0xB7B53B5B,
/**/                   0x3FEC4000, 0x00000000,
/**/                   0xBF0C3F8F, 0x01C3F8F0,
/**/                   0x3FBFEC91, 0x31DC0000,
/**/                   0xBD354555, 0xD1AE6607,
/**/                   0x3FEC3800, 0x00000000,
/**/                   0x3F254738, 0xAB1B8FFC,
/**/                   0x3FC01285, 0x0A6E0000,
/**/                   0xBD1A8619, 0x4805BF94,
/**/                   0x3FEC3000, 0x00000000,
/**/                   0x3F38E51F, 0x48B3C5D7,
/**/                   0x3FC02EBB, 0x42BF4000,
/**/                   0xBD15A8FA, 0x5CE00E5D,
/**/                   0x3FEC3000, 0x00000000,
/**/                   0xBF38C377, 0x867E595E,
/**/                   0x3FC04AEB, 0x449F6000,
/**/                   0x3D2AFA90, 0x65CCD35C,
/**/                   0x3FEC2800, 0x00000000,
/**/                   0xBF24AC6D, 0x15FE3D95,
/**/                   0x3FC06715, 0x12CA6000,
/**/                   0xBD2A4757, 0x9CDC0A3D,
/**/                   0x3FEC2000, 0x00000000,
/**/                   0x3F10B34F, 0x53B8CDAE,
/**/                   0x3FC08338, 0xAFFA2000,
/**/                   0x3D30533C, 0xAC823E27,
/**/                   0x3FEC1800, 0x00000000,
/**/                   0x3F32C599, 0x3FABB0F6,
/**/                   0x3FC09F56, 0x1EE72000,
/**/                   0xBD28F305, 0x7157D1A8,
/**/                   0x3FEC1800, 0x00000000,
/**/                   0xBF3E8BF4, 0x97CD1B6C,
/**/                   0x3FC0BB6D, 0x6247A000,
/**/                   0x3D35464F, 0x3CCD04B3,
/**/                   0x3FEC1000, 0x00000000,
/**/                   0xBF2F8FC7, 0xE3F1F8FC,
/**/                   0x3FC0D77E, 0x7CD08000,
/**/                   0x3D3CB2CD, 0x2EE2F482,
/**/                   0x3FEC0800, 0x00000000,
/**/                   0xBEEDC860, 0x5B199F35,
/**/                   0x3FC0F389, 0x7134C000,
/**/                   0xBD3DA359, 0xE893D6C6,
/**/                   0x3FEC0000, 0x00000000,
/**/                   0x3F2C01C0, 0x1C01C01C,
/**/                   0x3FC10F8E, 0x42254000,
/**/                   0xBD293B38, 0x43396307,
/**/                   0x3FEBF800, 0x00000000,
/**/                   0x3F3D0577, 0x256228AA,
/**/                   0x3FC12B8C, 0xF2518000,
/**/                   0x3D348A4A, 0x13C0A0FC,
/**/                   0x3FEBF800, 0x00000000,
/**/                   0xBF33E08B, 0xCB93A8A1,
/**/                   0x3FC14785, 0x84674000,
/**/                   0x3D156345, 0x1027C750,
/**/                   0x3FEBF000, 0x00000000,
/**/                   0xBF12C4DB, 0x1DE63F4A,
/**/                   0x3FC16377, 0xFB124000,
/**/                   0x3D091E1A, 0xBF41763E,
/**/                   0x3FEBE800, 0x00000000,
/**/                   0x3F2526D0, 0x769F9E4F,
/**/                   0x3FC17F64, 0x58FCA000,
/**/                   0x3D2843FA, 0xD093C8DC,
/**/                   0x3FEBE000, 0x00000000,
/**/                   0x3F39ED43, 0x5292D891,
/**/                   0x3FC19B4A, 0xA0CEE000,
/**/                   0xBD3D8824, 0x9621338B,
/**/                   0x3FEBE000, 0x00000000,
/**/                   0xBF36A3B3, 0x5FC845A9,
/**/                   0x3FC1B72A, 0xD52F6000,
/**/                   0x3D2E80A4, 0x1811A396,
/**/                   0x3FEBD800, 0x00000000,
/**/                   0xBF1C7E26, 0xB7230491,
/**/                   0x3FC1D304, 0xF8C36000,
/**/                   0xBD3A6D44, 0xDF451042,
/**/                   0x3FEBD000, 0x00000000,
/**/                   0x3F20F365, 0x451B61CB,
/**/                   0x3FC1EED9, 0x0E2DC000,
/**/                   0x3D161563, 0x7097648F,
/**/                   0x3FEBC800, 0x00000000,
/**/                   0x3F3827F3, 0xD72DD0AA,
/**/                   0x3FC20AA7, 0x18102000,
/**/                   0x3D3F2C94, 0x348552FE,
/**/                   0x3FEBC800, 0x00000000,
/**/                   0xBF3814D3, 0xBE0C262F,
/**/                   0x3FC2266F, 0x190A6000,
/**/                   0xBD24D20A, 0xB840E7F6,
/**/                   0x3FEBC000, 0x00000000,
/**/                   0xBF207963, 0x7ECECB53,
/**/                   0x3FC24231, 0x13BA6000,
/**/                   0xBD3E3A00, 0x78EE9D9C,
/**/                   0x3FEBB800, 0x00000000,
/**/                   0x3F1EC130, 0xF29268D3,
/**/                   0x3FC25DED, 0x0ABC6000,
/**/                   0x3D35A385, 0x4F176449,
/**/                   0x3FEBB000, 0x00000000,
/**/                   0x3F37B218, 0xAB6353BF,
/**/                   0x3FC279A3, 0x00AB4000,
/**/                   0x3D3EF432, 0xB3235108,
/**/                   0x3FEBB000, 0x00000000,
/**/                   0xBF383759, 0xF2298376,
/**/                   0x3FC29552, 0xF8200000,
/**/                   0xBD35B967, 0xF4471DFC,
/**/                   0x3FEBA800, 0x00000000,
/**/                   0xBF201832, 0x1EAD4253,
/**/                   0x3FC2B0FC, 0xF3B1A000,
/**/                   0x3D177CA3, 0xE30A59EA,
/**/                   0x3FEBA000, 0x00000000,
/**/                   0x3F20679B, 0xD84886B1,
/**/                   0x3FC2CCA0, 0xF5F60000,
/**/                   0xBD3B5EF1, 0x91AFF120,
/**/                   0x3FEB9800, 0x00000000,
/**/                   0x3F38884D, 0xA41FEB4C,
/**/                   0x3FC2E83F, 0x0180E000,
/**/                   0xBD3F0C2A, 0xC284E1CE,
/**/                   0x3FEB9800, 0x00000000,
/**/                   0xBF370EA7, 0x3806E548,
/**/                   0x3FC303D7, 0x18E48000,
/**/                   0xBCD680B5, 0xCE3ECB05,
/**/                   0x3FEB9000, 0x00000000,
/**/                   0xBF1A4477, 0xB5EF34C0,
/**/                   0x3FC31F69, 0x3EB1A000,
/**/                   0xBD2A6726, 0xE5A396FB,
/**/                   0x3FEB8800, 0x00000000,
/**/                   0x3F2401B8, 0x9401B894,
/**/                   0x3FC33AF5, 0x75770000,
/**/                   0x3D3C9ECC, 0xA2FE72A5,
/**/                   0x3FEB8000, 0x00000000,
/**/                   0x3F3AA73A, 0x400DC1AA,
/**/                   0x3FC3567B, 0xBFC22000,
/**/                   0x3D3250D2, 0x53991A1F,
/**/                   0x3FEB8000, 0x00000000,
/**/                   0xBF349E11, 0x2E63A6A8,
/**/                   0x3FC371FC, 0x201E8000,
/**/                   0x3D3EE877, 0x9B2D8ABC,
/**/                   0x3FEB7800, 0x00000000,
/**/                   0xBF0E7898, 0xC8DA04B9,
/**/                   0x3FC38D76, 0x99164000,
/**/                   0x3D1844A5, 0x9E39BB70,
/**/                   0x3FEB7000, 0x00000000,
/**/                   0x3F2A284E, 0xE6B33E2D,
/**/                   0x3FC3A8EB, 0x2D31A000,
/**/                   0x3D1BAFB7, 0x7D5D503E,
/**/                   0x3FEB6800, 0x00000000,
/**/                   0x3F3E0B91, 0x759C2BB4,
/**/                   0x3FC3C459, 0xDEF76000,
/**/                   0x3D3EDC86, 0xF6B70D33,
/**/                   0x3FEB6800, 0x00000000,
/**/                   0xBF30E8E2, 0x088FD6E7,
/**/                   0x3FC3DFC2, 0xB0ECC000,
/**/                   0x3D28A72A, 0x62B8C13F,
/**/                   0x3FEB6000, 0x00000000,
/**/                   0x3ECB6006, 0xD801B600,
/**/                   0x3FC3FB25, 0xA5952000,
/**/                   0x3D3195BE, 0x6B358FF7,
/**/                   0x3FEB5800, 0x00000000,
/**/                   0x3F316A6A, 0xD840F62C,
/**/                   0x3FC41682, 0xBF728000,
/**/                   0xBD210047, 0x081F849D,
/**/                   0x3FEB5800, 0x00000000,
/**/                   0xBF3D4DEE, 0x7DF8BD99,
/**/                   0x3FC431DA, 0x01050000,
/**/                   0x3D304837, 0x836E0391,
/**/                   0x3FEB5000, 0x00000000,
/**/                   0xBF27E4B1, 0x7E4B17E5,
/**/                   0x3FC44D2B, 0x6CCB8000,
/**/                   0xBD170CC1, 0x6135783C,
/**/                   0x3FEB4800, 0x00000000,
/**/                   0x3F15F47D, 0x55E6D8FE,
/**/                   0x3FC46877, 0x05430000,
/**/                   0xBD3D8145, 0xF8D5087E,
/**/                   0x3FEB4000, 0x00000000,
/**/                   0x3F37006D, 0x0B803686,
/**/                   0x3FC483BC, 0xCCE6E000,
/**/                   0x3D1EEA52, 0x723F6369,
/**/                   0x3FEB4000, 0x00000000,
/**/                   0xBF37687C, 0x46A66920,
/**/                   0x3FC49EFC, 0xC6314000,
/**/                   0xBD090F59, 0x9F55572B,
/**/                   0x3FEB3800, 0x00000000,
/**/                   0xBF16F6A4, 0xFF2645BE,
/**/                   0x3FC4BA36, 0xF39A6000,
/**/                   0xBD34354B, 0xB3F219E5,
/**/                   0x3FEB3000, 0x00000000,
/**/                   0x3F2801B3, 0x1801B318,
/**/                   0x3FC4D56B, 0x5798E000,
/**/                   0x3D380580, 0x15A96555,
/**/                   0x3FEB2800, 0x00000000,
/**/                   0x3F3DD2FF, 0x93511680,
/**/                   0x3FC4F099, 0xF4A24000,
/**/                   0xBD3E9BF2, 0xFAFEAF27,
/**/                   0x3FEB2800, 0x00000000,
/**/                   0xBF304743, 0xA89DCCAC,
/**/                   0x3FC50BC2, 0xCD29C000,
/**/                   0x3D1ADA57, 0x28DB8D4F,
/**/                   0x3FEB2000, 0x00000000,
/**/                   0x3EFB2036, 0x406C80D9,
/**/                   0x3FC526E5, 0xE3A1C000,
/**/                   0xBD3790BA, 0x37FC5238,
/**/                   0x3FEB1800, 0x00000000,
/**/                   0x3F33BEC8, 0x4F9DC00E,
/**/                   0x3FC54203, 0x3A7A8000,
/**/                   0x3D268D68, 0xED855F0E,
/**/                   0x3FEB1800, 0x00000000,
/**/                   0xBF3A2101, 0x44F8CE7E,
/**/                   0x3FC55D1A, 0xD4232000,
/**/                   0x3D3ADD94, 0xDDA647E8,
/**/                   0x3FEB1000, 0x00000000,
/**/                   0xBF1FB596, 0xB99AF3F3,
/**/                   0x3FC5782C, 0xB3092000,
/**/                   0xBD33A463, 0x51794442,
/**/                   0x3FEB0800, 0x00000000,
/**/                   0x3F24B31D, 0x922A3E85,
/**/                   0x3FC59338, 0xD9982000,
/**/                   0x3CF0BA68, 0xB7555D4A,
/**/                   0x3FEB0000, 0x00000000,
/**/                   0x3F3CB3CF, 0xE19BF6B7,
/**/                   0x3FC5AE3F, 0x4A3AA000,
/**/                   0x3D21EA25, 0xF012A8B9,
/**/                   0x3FEB0000, 0x00000000,
/**/                   0xBF30DEAE, 0x9A5BF0D1,
/**/                   0x3FC5C940, 0x07598000,
/**/                   0xBD3A8D94, 0x8CD23322,
/**/                   0x3FEAF800, 0x00000000,
/**/                   0x3EFA2072, 0x9EDE13CE,
/**/                   0x3FC5E43B, 0x135BE000,
/**/                   0xBD343AB4, 0xCEED9C31,
/**/                   0x3FEAF000, 0x00000000,
/**/                   0x3F3435E5, 0x0D79435E,
/**/                   0x3FC5FF30, 0x70A7A000,
/**/                   0xBD38586F, 0x183BEBF2,
/**/                   0x3FEAF000, 0x00000000,
/**/                   0xBF392321, 0x06855D30,
/**/                   0x3FC61A20, 0x21A0E000,
/**/                   0x3D3DD9DD, 0x1BDF3CDD,
/**/                   0x3FEAE800, 0x00000000,
/**/                   0xBF19A45C, 0x7ABED811,
/**/                   0x3FC6350A, 0x28AAA000,
/**/                   0x3D2D5EC0, 0xAB8163AF,
/**/                   0x3FEAE000, 0x00000000,
/**/                   0x3F28C7ED, 0x84EF68CB,
/**/                   0x3FC64FEE, 0x88260000,
/**/                   0xBD1DA40D, 0x759DDED6,
/**/                   0x3FEAD800, 0x00000000,
/**/                   0x3F3F43FC, 0xA482F00D,
/**/                   0x3FC66ACD, 0x4272A000,
/**/                   0x3D3AA1BD, 0xBFC6C785,
/**/                   0x3FEAD800, 0x00000000,
/**/                   0xBF2B9222, 0xCDE3E7AE,
/**/                   0x3FC685A6, 0x59EF0000,
/**/                   0xBD21F2A9, 0x6C103214,
/**/                   0x3FEAD000, 0x00000000,
/**/                   0x3F14F302, 0xEED254A3,
/**/                   0x3FC6A079, 0xD0F7A000,
/**/                   0x3D35A3F8, 0x448D14F5,
/**/                   0x3FEAC800, 0x00000000,
/**/                   0x3F385567, 0x32071DEF,
/**/                   0x3FC6BB47, 0xA9E80000,
/**/                   0x3D19F64D, 0x23EA3296,
/**/                   0x3FEAC800, 0x00000000,
/**/                   0xBF347F29, 0xD47F29D4,
/**/                   0x3FC6D60F, 0xE719E000,
/**/                   0xBD3BC6E5, 0x57134767,
/**/                   0x3FEAC000, 0x00000000,
/**/                   0xBEF40FE1, 0xE82D23BC,
/**/                   0x3FC6F0D2, 0x8AE56000,
/**/                   0x3D369737, 0xC93373DA,
/**/                   0x3FEAB800, 0x00000000,
/**/                   0x3F320FDE, 0x972D8538,
/**/                   0x3FC70B8F, 0x97A1A000,
/**/                   0x3D34EA64, 0xF6A95BEF,
/**/                   0x3FEAB800, 0x00000000,
/**/                   0xBF3A8C9F, 0x66711513,
/**/                   0x3FC72647, 0x0FA40000,
/**/                   0xBD3774DF, 0x0E743A45,
/**/                   0x3FEAB000, 0x00000000,
/**/                   0xBF1C5A0F, 0x02806ABC,
/**/                   0x3FC740F8, 0xF5404000,
/**/                   0xBD30B66C, 0x99018AA1,
/**/                   0x3FEAA800, 0x00000000,
/**/                   0x3F28E44B, 0xD22C937A,
/**/                   0x3FC75BA5, 0x4AC8E000,
/**/                   0x3D3DDCA5, 0x8BC4A7C0,
/**/                   0x3FEAA800, 0x00000000,
/**/                   0xBF3FF2AD, 0xFF2ADFF3,
/**/                   0x3FC7764C, 0x128F2000,
/**/                   0x3D027490, 0x3479E3D1,
/**/                   0x3FEAA000, 0x00000000,
/**/                   0xBF288A16, 0x0B3ADA5C,
/**/                   0x3FC790ED, 0x4EE26000,
/**/                   0x3D199BBD, 0x4E7746F6,
/**/                   0x3FEA9800, 0x00000000,
/**/                   0x3F1DEC0D, 0x4C77B035,
/**/                   0x3FC7AB89, 0x0210E000,
/**/                   0xBD2BDB90, 0x72534A58,
/**/                   0x3FEA9000, 0x00000000,
/**/                   0x3F3B4D71, 0x91F59E6B,
/**/                   0x3FC7C61F, 0x2E674000,
/**/                   0xBD32392D, 0xB31BE8E0,
/**/                   0x3FEA9000, 0x00000000,
/**/                   0xBF30CDCB, 0xB8A2A522,
/**/                   0x3FC7E0AF, 0xD630C000,
/**/                   0x3D139E7C, 0x1D8F1034,
/**/                   0x3FEA8800, 0x00000000,
/**/                   0x3F094A00, 0x6A2194A0,
/**/                   0x3FC7FB3A, 0xFBB76000,
/**/                   0xBD37DBF5, 0x24609D57,
/**/                   0x3FEA8000, 0x00000000,
/**/                   0x3F373289, 0x870AC52E,
/**/                   0x3FC815C0, 0xA1436000,
/**/                   0xBD302A52, 0xF9201CE8,
/**/                   0x3FEA8000, 0x00000000,
/**/                   0xBF34B1FA, 0x9E8684DD,
/**/                   0x3FC83040, 0xC91BC000,
/**/                   0x3D3E5B71, 0xC6E66F32,
/**/                   0x3FEA7800, 0x00000000,
/**/                   0xBEE08AF5, 0xA9267648,
/**/                   0x3FC84ABB, 0x75866000,
/**/                   0xBD3D8DAA, 0xDF4E2BD2,
/**/                   0x3FEA7000, 0x00000000,
/**/                   0x3F33BB67, 0x1A3D927E,
/**/                   0x3FC86530, 0xA8C70000,
/**/                   0x3D398BB0, 0xCB4EA3E3,
/**/                   0x3FEA7000, 0x00000000,
/**/                   0xBF37F2C9, 0x7F2C97F3,
/**/                   0x3FC87FA0, 0x6520C000,
/**/                   0x3D322120, 0x401202FC,
/**/                   0x3FEA6800, 0x00000000,
/**/                   0xBF0C77A5, 0x3C076D20,
/**/                   0x3FC89A0A, 0xACD4E000,
/**/                   0x3D2C0BFB, 0xDA8F5A72,
/**/                   0x3FEA6000, 0x00000000,
/**/                   0x3F30E6DA, 0x7C7EF82B,
/**/                   0x3FC8B46F, 0x82236000,
/**/                   0x3D12D9F2, 0x102DD7C9,
/**/                   0x3FEA6000, 0x00000000,
/**/                   0xBF3A9167, 0x2EC05C44,
/**/                   0x3FC8CECE, 0xE74AE000,
/**/                   0xBD3A5BA0, 0xAA429BB5,
/**/                   0x3FEA5800, 0x00000000,
/**/                   0xBF17DF12, 0xEEB6BD53,
/**/                   0x3FC8E928, 0xDE886000,
/**/                   0x3D3A8154, 0xB13D72D5,
/**/                   0x3FEA5000, 0x00000000,
/**/                   0x3F2D676D, 0x98C70AE6,
/**/                   0x3FC9037D, 0x6A180000,
/**/                   0x3D230DEA, 0x57C1C8D9,
/**/                   0x3FEA5000, 0x00000000,
/**/                   0xBF3C8EFF, 0x96CE4780,
/**/                   0x3FC91DCC, 0x8C340000,
/**/                   0x3D37BC6A, 0xBDDEFF46,
/**/                   0x3FEA4800, 0x00000000,
/**/                   0xBF1EFFCB, 0x71EFFCB7,
/**/                   0x3FC93816, 0x4715A000,
/**/                   0xBD34C63D, 0x6A3A39D9,
/**/                   0x3FEA4000, 0x00000000,
/**/                   0x3F2A41A4, 0x1A41A41A,
/**/                   0x3FC9525A, 0x9CF46000,
/**/                   0xBD329713, 0x7D9F158F,
/**/                   0x3FEA4000, 0x00000000,
/**/                   0xBF3DECBB, 0xBF3B3C0E,
/**/                   0x3FC96C99, 0x9006A000,
/**/                   0x3D2A88D5, 0x9CBB452C,
/**/                   0x3FEA3800, 0x00000000,
/**/                   0xBF21D14E, 0x3BCD35A8,
/**/                   0x3FC986D3, 0x22818000,
/**/                   0x3CF93B56, 0x4DD44000,
/**/                   0x3FEA3000, 0x00000000,
/**/                   0x3F285A0A, 0x3B5832C0,
/**/                   0x3FC9A107, 0x56988000,
/**/                   0x3D264AA6, 0x242CD098,
/**/                   0x3FEA3000, 0x00000000,
/**/                   0xBF3EABC1, 0xD71AFD8C,
/**/                   0x3FC9BB36, 0x2E7E0000,
/**/                   0xBD21F2A8, 0xA1CE0FFC,
/**/                   0x3FEA2800, 0x00000000,
/**/                   0xBF22E60D, 0x7C041611,
/**/                   0x3FC9D55F, 0xAC62E000,
/**/                   0xBD3F4669, 0xFC3B5BC3,
/**/                   0x3FEA2000, 0x00000000,
/**/                   0x3F27AE57, 0x5FF2EF43,
/**/                   0x3FC9EF83, 0xD276A000,
/**/                   0xBD2730B7, 0xB3F9CE00,
/**/                   0x3FEA2000, 0x00000000,
/**/                   0xBF3ECD35, 0x3D66322E,
/**/                   0x3FCA09A2, 0xA2E7A000,
/**/                   0xBD2DD99D, 0xCD411233,
/**/                   0x3FEA1800, 0x00000000,
/**/                   0xBF22C068, 0x5B4FE5E9,
/**/                   0x3FCA23BC, 0x1FE2C000,
/**/                   0xBD3539CD, 0x91DC9F0B,
/**/                   0x3FEA1000, 0x00000000,
/**/                   0x3F283C48, 0x80B67A9A,
/**/                   0x3FCA3DD0, 0x4B938000,
/**/                   0x3D297DA1, 0x366E2C5A,
/**/                   0x3FEA1000, 0x00000000,
/**/                   0xBF3E5236, 0x89907BBA,
/**/                   0x3FCA57DF, 0x28244000,
/**/                   0x3D3B99C8, 0xCA1D9ABB,
/**/                   0x3FEA0800, 0x00000000,
/**/                   0xBF21629E, 0x32054967,
/**/                   0x3FCA71E8, 0xB7BE0000,
/**/                   0xBD210ACA, 0x6EF05323,
/**/                   0x3FEA0000, 0x00000000,
/**/                   0x3F2A01A0, 0x1A01A01A,
/**/                   0x3FCA8BEC, 0xFC882000,
/**/                   0x3D3E3185, 0xCF21B9CF,
/**/                   0x3FEA0000, 0x00000000,
/**/                   0xBF3D3BE3, 0x93FF301D,
/**/                   0x3FCAA5EB, 0xF8A94000,
/**/                   0xBD32A0A9, 0x36951A8F,
/**/                   0x3FE9F800, 0x00000000,
/**/                   0xBF1D9DD1, 0xBFE608ED,
/**/                   0x3FCABFE5, 0xAE462000,
/**/                   0xBD3B68F5, 0x395F139D,
/**/                   0x3FE9F000, 0x00000000,
/**/                   0x3F2CFC26, 0x1B29257F,
/**/                   0x3FCAD9DA, 0x1F828000,
/**/                   0xBD3882B7, 0xC803F050,
/**/                   0x3FE9F000, 0x00000000,
/**/                   0xBF3B8B57, 0x7E613717,
/**/                   0x3FCAF3C9, 0x4E80C000,
/**/                   0xBCBA4E63, 0x3FCD9066,
/**/                   0x3FE9E800, 0x00000000,
/**/                   0xBF160EF9, 0xB9FABD04,
/**/                   0x3FCB0DB3, 0x3D620000,
/**/                   0x3D3FEE14, 0x38EAB906,
/**/                   0x3FE9E000, 0x00000000,
/**/                   0x3F3094D3, 0xEAF850E2,
/**/                   0x3FCB2797, 0xEE464000,
/**/                   0xBD3BE88A, 0x906D00A9,
/**/                   0x3FE9E000, 0x00000000,
/**/                   0xBF3941AA, 0xBBE88FDC,
/**/                   0x3FCB4177, 0x634BA000,
/**/                   0x3D355D01, 0x5666069F,
/**/                   0x3FE9D800, 0x00000000,
/**/                   0xBF083A25, 0x25F4B1AA,
/**/                   0x3FCB5B51, 0x9E8FC000,
/**/                   0xBD34B722, 0xEC011F31,
/**/                   0x3FE9D000, 0x00000000,
/**/                   0x3F3343FB, 0xF71FAC14,
/**/                   0x3FCB7526, 0xA22E4000,
/**/                   0x3D2C0DBF, 0x2E785490,
/**/                   0x3FE9D000, 0x00000000,
/**/                   0xBF365FF3, 0x1965FF32,
/**/                   0x3FCB8EF6, 0x70420000,
/**/                   0x3D387533, 0x321788E0,
/**/                   0x3FE9C800, 0x00000000,
/**/                   0x3EA9C801, 0x9C8019C8,
/**/                   0x3FCBA8C1, 0x0AE46000,
/**/                   0x3D3A32E2, 0x9EEE9D85,
/**/                   0x3FE9C000, 0x00000000,
/**/                   0x3F368A77, 0x25080CE1,
/**/                   0x3FCBC286, 0x742D8000,
/**/                   0x3D39AC53, 0xF39D121C,
/**/                   0x3FE9C000, 0x00000000,
/**/                   0xBF32E743, 0xC54763F2,
/**/                   0x3FCBDC46, 0xAE344000,
/**/                   0x3D3625B4, 0x023D6505,
/**/                   0x3FE9B800, 0x00000000,
/**/                   0x3F0DBD49, 0x8B7424F9,
/**/                   0x3FCBF601, 0xBB0E4000,
/**/                   0x3D2386A9, 0x47C378B5,
/**/                   0x3FE9B000, 0x00000000,
/**/                   0x3F3A6734, 0x00CD9A67,
/**/                   0x3FCC0FB7, 0x9CCFE000,
/**/                   0xBD346FFF, 0x99E8A558,
/**/                   0x3FE9B000, 0x00000000,
/**/                   0xBF2DB15A, 0xAEF25B7C,
/**/                   0x3FCC2968, 0x558C2000,
/**/                   0xBD2CFD73, 0xDEE38A40,
/**/                   0x3FE9A800, 0x00000000,
/**/                   0x3F1FDFEC, 0xC140C073,
/**/                   0x3FCC4313, 0xE754E000,
/**/                   0x3D3279BE, 0x74CAD7D6,
/**/                   0x3FE9A000, 0x00000000,
/**/                   0x3F3ED923, 0xA7DCBEB3,
/**/                   0x3FCC5CBA, 0x543AE000,
/**/                   0x3D20929D, 0xECB454FC,
/**/                   0x3FE9A000, 0x00000000,
/**/                   0xBF246A7B, 0xB256DE2C,
/**/                   0x3FCC765B, 0x9E4D6000,
/**/                   0x3D31AB6B, 0x36976F6C,
/**/                   0x3FE99800, 0x00000000,
/**/                   0x3F299999, 0x9999999A,
/**/                   0x3FCC8FF7, 0xC79AA000,
/**/                   0xBD27794F, 0x689F8434,
/**/                   0x3FE99800, 0x00000000,
/**/                   0xBF3C20C6, 0x3EC03FF3,
/**/                   0x3FCCA98E, 0xD22F6000,
/**/                   0xBCF698C1, 0x8CA209C8,
/**/                   0x3FE99000, 0x00000000,
/**/                   0xBF13F803, 0x31EC07FD,
/**/                   0x3FCCC320, 0xC0176000,
/**/                   0x3D240903, 0x9A653794,
/**/                   0x3FE98800, 0x00000000,
/**/                   0x3F323513, 0x5AC98715,
/**/                   0x3FCCDCAD, 0x935D2000,
/**/                   0xBD0A0FF0, 0x34C9A447,
/**/                   0x3FE98800, 0x00000000,
/**/                   0xBF368793, 0x89F80661,
/**/                   0x3FCCF635, 0x4E09C000,
/**/                   0x3D277123, 0x9A07D55B,
/**/                   0x3FE98000, 0x00000000,
/**/                   0x3EE98019, 0x8019801A,
/**/                   0x3FCD0FB7, 0xF2256000,
/**/                   0xBD0AF52B, 0x20633B29,
/**/                   0x3FE97800, 0x00000000,
/**/                   0x3F382FC6, 0xAB329020,
/**/                   0x3FCD2935, 0x81B6C000,
/**/                   0xBD383270, 0x128AAA5F,
/**/                   0x3FE97800, 0x00000000,
/**/                   0xBF305C4B, 0x962DBFF3,
/**/                   0x3FCD42AD, 0xFEC36000,
/**/                   0xBD175C00, 0xFD804272,
/**/                   0x3FE97000, 0x00000000,
/**/                   0x3F1C9F01, 0x970E4F81,
/**/                   0x3FCD5C21, 0x6B4FC000,
/**/                   0xBD21BA91, 0xBBCA681B,
/**/                   0x3FE96800, 0x00000000,
/**/                   0x3F3EBBE1, 0x049160B8,
/**/                   0x3FCD758F, 0xC95F0000,
/**/                   0xBD15A10A, 0x8B4162AA,
/**/                   0x3FE96800, 0x00000000,
/**/                   0xBF233FE6, 0x9933FE6A,
/**/                   0x3FCD8EF9, 0x1AF32000,
/**/                   0xBD15105F, 0xC364C784,
/**/                   0x3FE96000, 0x00000000,
/**/                   0x3F2C2873, 0xCE078906,
/**/                   0x3FCDA85D, 0x620CE000,
/**/                   0x3D240194, 0xC16CC7EC,
/**/                   0x3FE96000, 0x00000000,
/**/                   0xBF3A27A0, 0xE442936B,
/**/                   0x3FCDC1BC, 0xA0ABE000,
/**/                   0x3D38FAC1, 0xA628CCC6,
/**/                   0x3FE95800, 0x00000000,
/**/                   0xBF029C69, 0x548A97A9,
/**/                   0x3FCDDB16, 0xD8CEA000,
/**/                   0xBD1EEF79, 0x7104B8BC,
/**/                   0x3FE95000, 0x00000000,
/**/                   0x3F35906B, 0x9F74B92D,
/**/                   0x3FCDF46C, 0x0C722000,
/**/                   0x3D3A5E82, 0xB0B79039,
/**/                   0x3FE95000, 0x00000000,
/**/                   0xBF327BBF, 0xF35927BC,
/**/                   0x3FCE0DBC, 0x3D92A000,
/**/                   0x3D359233, 0xF0529BF1,
/**/                   0x3FE94800, 0x00000000,
/**/                   0x3F161F9A, 0xDD3C0CA4,
/**/                   0x3FCE2707, 0x6E2B0000,
/**/                   0xBD3A342C, 0x2AF0003C,
/**/                   0x3FE94000, 0x00000000,
/**/                   0x3F3D9B56, 0x41228A8F,
/**/                   0x3FCE404D, 0xA034C000,
/**/                   0xBD3187EE, 0xE09A2799,
/**/                   0x3FE94000, 0x00000000,
/**/                   0xBF2482F5, 0x598A73F8,
/**/                   0x3FCE598E, 0xD5A88000,
/**/                   0xBD0D134B, 0xCF1E98A1,
/**/                   0x3FE93800, 0x00000000,
/**/                   0x3F2BE2D5, 0x3C1B9728,
/**/                   0x3FCE72CB, 0x107DA000,
/**/                   0x3D1DD48C, 0xCDF5471C,
/**/                   0x3FE93800, 0x00000000,
/**/                   0xBF39CC03, 0x2698CFF3,
/**/                   0x3FCE8C02, 0x52AA6000,
/**/                   0xBD26805B, 0x80E8E6FF,
/**/                   0x3FE93000, 0x00000000,
/**/                   0xBEF79CD3, 0xB9F30358,
/**/                   0x3FCEA534, 0x9E23A000,
/**/                   0x3D381B93, 0x4C73CCB5,
/**/                   0x3FE92800, 0x00000000,
/**/                   0x3F36E803, 0x255BA00D,
/**/                   0x3FCEBE61, 0xF4DD8000,
/**/                   0xBD23D453, 0x30FDCA4D,
/**/                   0x3FE92800, 0x00000000,
/**/                   0xBF30A69B, 0x36077742,
/**/                   0x3FCED78A, 0x58CA8000,
/**/                   0x3D16F1B5, 0x3793387E,
/**/                   0x3FE92000, 0x00000000,
/**/                   0x3F1F693A, 0x1C451AB3,
/**/                   0x3FCEF0AD, 0xCBDC6000,
/**/                   0xBD2B26B7, 0x9C86AF24,
/**/                   0x3FE92000, 0x00000000,
/**/                   0xBF3F9548, 0xC74EA9E2,
/**/                   0x3FCF09CC, 0x50036000,
/**/                   0x3D3DA094, 0x18D999DB,
/**/                   0x3FE91800, 0x00000000,
/**/                   0xBF1BD5A8, 0xF7C46911,
/**/                   0x3FCF22E5, 0xE72F2000,
/**/                   0xBD3F454F, 0x1417E41F,
/**/                   0x3FE91000, 0x00000000,
/**/                   0x3F31B9E1, 0x0D83D1C6,
/**/                   0x3FCF3BFA, 0x934D6000,
/**/                   0x3D2D9F2A, 0x937B903B,
/**/                   0x3FE91000, 0x00000000,
/**/                   0xBF35876F, 0xF3795877,
/**/                   0x3FCF550A, 0x564B8000,
/**/                   0xBD2323E3, 0xA09202FE,
/**/                   0x3FE90800, 0x00000000,
/**/                   0x3F0A34CD, 0xBD1D87EC,
/**/                   0x3FCF6E15, 0x32154000,
/**/                   0xBD3C9A97, 0x7AC4EC74,
/**/                   0x3FE90000, 0x00000000,
/**/                   0x3F3C23F5, 0x0E760899,
/**/                   0x3FCF871B, 0x28956000,
/**/                   0xBD3F75FD, 0x6A526EFE,
/**/                   0x3FE90000, 0x00000000,
/**/                   0xBF25DECD, 0xD0BE9594,
/**/                   0x3FCFA01C, 0x3BB58000,
/**/                   0xBD1A1F71, 0xFAE1D786,
/**/                   0x3FE8F800, 0x00000000,
/**/                   0x3F2C18F9, 0xC18F9C19,
/**/                   0x3FCFB918, 0x6D5E4000,
/**/                   0xBD0D572A, 0xAB993C87,
/**/                   0x3FE8F800, 0x00000000,
/**/                   0xBF38E868, 0x8176594C,
/**/                   0x3FCFD20F, 0xBF770000,
/**/                   0xBD11C55B, 0x72C6FE70,
/**/                   0x3FE8F000, 0x00000000,
/**/                   0x3EC8F006, 0x3C018F00,
/**/                   0x3FCFEB02, 0x33E60000,
/**/                   0x3D2F316E, 0x32D5E8C7,
/**/                   0x3FE8E800, 0x00000000,
/**/                   0x3F395B4D, 0xAD115384,
/**/                   0x3FD001F7, 0xE6484000,
/**/                   0x3D38A957, 0x40C9ABBC,
/**/                   0x3FE8E800, 0x00000000,
/**/                   0xBF2AD850, 0xEC8C0F90,
/**/                   0x3FD00E6C, 0x45AD5000,
/**/                   0x3CDCC68D, 0x52E01203,
/**/                   0x3FE8E000, 0x00000000,
/**/                   0x3F27B6E9, 0xA56B1AA1,
/**/                   0x3FD01ADE, 0x3913A000,
/**/                   0xBD108930, 0xCCDC1521,
/**/                   0x3FE8E000, 0x00000000,
/**/                   0xBF3ACDE3, 0x40DFC1D8,
/**/                   0x3FD0274D, 0xC16C2000,
/**/                   0x3D2979E8, 0x9CF835C2,
/**/                   0x3FE8D800, 0x00000000,
/**/                   0xBEF68397, 0x317DF64C,
/**/                   0x3FD033BA, 0xDFA74000,
/**/                   0x3D0C30BC, 0x1485BDFF,
/**/                   0x3FE8D000, 0x00000000,
/**/                   0x3F380C69, 0x80C6980C,
/**/                   0x3FD04025, 0x94B4D000,
/**/                   0x3CF036B8, 0x9EF42D7F,
/**/                   0x3FE8D000, 0x00000000,
/**/                   0xBF2CE006, 0x338C7FE7,
/**/                   0x3FD04C8D, 0xE1842000,
/**/                   0xBD1FE6BA, 0x512CEB86,
/**/                   0x3FE8C800, 0x00000000,
/**/                   0x3F2644F0, 0x1EFBBD63,
/**/                   0x3FD058F3, 0xC703F000,
/**/                   0xBD30E866, 0xBCD236AD,
/**/                   0x3FE8C800, 0x00000000,
/**/                   0xBF3B3C2D, 0xAA79217A,
/**/                   0x3FD06557, 0x46227000,
/**/                   0x3D0131DF, 0xB4868D6A,
/**/                   0x3FE8C000, 0x00000000,
/**/                   0xBEF8BFCE, 0x8062FF3A,
/**/                   0x3FD071B8, 0x5FCD6000,
/**/                   0xBD3BCB8B, 0xA3E01A11,
/**/                   0x3FE8B800, 0x00000000,
/**/                   0x3F383301, 0xBD2672C4,
/**/                   0x3FD07E17, 0x14F1D000,
/**/                   0xBD3EFCC6, 0x4F384BD5,
/**/                   0x3FE8B800, 0x00000000,
/**/                   0xBF2BFE74, 0x9BFE749C,
/**/                   0x3FD08A73, 0x667C5000,
/**/                   0x3D3EBC1D, 0x40C5A329,
/**/                   0x3FE8B000, 0x00000000,
/**/                   0x3F27BA8C, 0xD4353EB3,
/**/                   0x3FD096CD, 0x55591000,
/**/                   0x3D3F998D, 0x20550A31,
/**/                   0x3FE8B000, 0x00000000,
/**/                   0xBF3A3784, 0xA062B2E4,
/**/                   0x3FD0A324, 0xE2739000,
/**/                   0x3D0C6BEE, 0x7EF4030E,
/**/                   0x3FE8A800, 0x00000000,
/**/                   0xBECED1F6, 0x5E630281,
/**/                   0x3FD0AF7A, 0x0EB6C000,
/**/                   0x3D23CCF9, 0x4945ADAD,
/**/                   0x3FE8A000, 0x00000000,
/**/                   0x3F39CAE0, 0x0C519CAE,
/**/                   0x3FD0BBCC, 0xDB0D2000,
/**/                   0x3D32F32C, 0xCC5DCDFB,
/**/                   0x3FE8A000, 0x00000000,
/**/                   0xBF283C02, 0x4EDBA5FD,
/**/                   0x3FD0C81D, 0x4860B000,
/**/                   0xBD3E5BCF, 0x401D1731,
/**/                   0x3FE89800, 0x00000000,
/**/                   0x3F2C0F60, 0x1899C0F6,
/**/                   0x3FD0D46B, 0x579AB000,
/**/                   0x3D3D2C81, 0xF640E1E6,
/**/                   0x3FE89800, 0x00000000,
/**/                   0xBF37C414, 0xBDBE51D0,
/**/                   0x3FD0E0B7, 0x09A43000,
/**/                   0x3D32A038, 0xA7862F2A,
/**/                   0x3FE89000, 0x00000000,
/**/                   0x3F03F540, 0xDD12CE7D,
/**/                   0x3FD0ED00, 0x5F658000,
/**/                   0xBD22DC75, 0x285AA803,
/**/                   0x3FE88800, 0x00000000,
/**/                   0x3F3CCFDE, 0x400C45CD,
/**/                   0x3FD0F947, 0x59C67000,
/**/                   0xBD395261, 0x7F0818B6,
/**/                   0x3FE88800, 0x00000000,
/**/                   0xBF21A0F5, 0x44FB66B5,
/**/                   0x3FD1058B, 0xF9AE5000,
/**/                   0xBD34AB9D, 0x817D52CD,
/**/                   0x3FE88000, 0x00000000,
/**/                   0x3F319D95, 0x2866A138,
/**/                   0x3FD111CE, 0x4003F000,
/**/                   0xBD1B3237, 0x096B4B6B,
/**/                   0x3FE88000, 0x00000000,
/**/                   0xBF33E5FA, 0xA48B49DA,
/**/                   0x3FD11E0E, 0x2DADA000,
/**/                   0xBD2A47F8, 0x8FCCE5BA,
/**/                   0x3FE87800, 0x00000000,
/**/                   0x3F1A9336, 0xDEECB0A8,
/**/                   0x3FD12A4B, 0xC3912000,
/**/                   0xBD35A750, 0x61473259,
/**/                   0x3FE87800, 0x00000000,
/**/                   0xBF3EC219, 0xFB6A388D,
/**/                   0x3FD13687, 0x0293B000,
/**/                   0xBD3D3E84, 0x99D67123,
/**/                   0x3FE87000, 0x00000000,
/**/                   0xBF106AE7, 0xC1625090,
/**/                   0x3FD142BF, 0xEB9A0000,
/**/                   0x3D31CE61, 0x85B58A9E,
/**/                   0x3FE86800, 0x00000000,
/**/                   0x3F369AE5, 0xACD4200C,
/**/                   0x3FD14EF6, 0x7F887000,
/**/                   0xBD3E97A6, 0x5DFC9794,
/**/                   0x3FE86800, 0x00000000,
/**/                   0xBF2D4286, 0x9389D11C,
/**/                   0x3FD15B2A, 0xBF429000,
/**/                   0xBD2D8E3B, 0x49B629B2,
/**/                   0x3FE86000, 0x00000000,
/**/                   0x3F286186, 0x18618618,
/**/                   0x3FD1675C, 0xABABA000,
/**/                   0x3D38380E, 0x731F55C4,
/**/                   0x3FE86000, 0x00000000,
/**/                   0xBF38EF0F, 0x6AC71708,
/**/                   0x3FD1738C, 0x45A67000,
/**/                   0xBD39C6E9, 0x0032C176,
/**/                   0x3FE85800, 0x00000000,
/**/                   0x3EFFF3D3, 0xE00C2C20,
/**/                   0x3FD17FB9, 0x8E151000,
/**/                   0xBD3A8A8B, 0xA74A2684,
/**/                   0x3FE85000, 0x00000000,
/**/                   0x3F3CFBA0, 0xF9592266,
/**/                   0x3FD18BE4, 0x85D93000,
/**/                   0x3D3C167F, 0x6F3604AB,
/**/                   0x3FE85000, 0x00000000,
/**/                   0xBF1FE7B0, 0xFF3D87FA,
/**/                   0x3FD1980D, 0x2DD42000,
/**/                   0x3D2B7B3A, 0x7A361C9A,
/**/                   0x3FE84800, 0x00000000,
/**/                   0x3F331E8D, 0x918DC223,
/**/                   0x3FD1A433, 0x86E68000,
/**/                   0xBD07A850, 0x634E0AAC,
/**/                   0x3FE84800, 0x00000000,
/**/                   0xBF31BAF9, 0x8D76B549,
/**/                   0x3FD1B057, 0x91F08000,
/**/                   0xBD32DD46, 0x6DC55E2D,
/**/                   0x3FE84000, 0x00000000,
/**/                   0x3F22F2EC, 0xDC90C512,
/**/                   0x3FD1BC79, 0x4FD1D000,
/**/                   0xBD3CCF0C, 0x747BA7BE,
/**/                   0x3FE84000, 0x00000000,
/**/                   0xBF3B442A, 0x6A0916B9,
/**/                   0x3FD1C898, 0xC169A000,
/**/                   0xBD381410, 0xE5C62AFF,
/**/                   0x3FE83800, 0x00000000,
/**/                   0x3EA83801, 0x83801838,
/**/                   0x3FD1D4B5, 0xE796A000,
/**/                   0x3D222A5B, 0xD197BAC2,
/**/                   0x3FE83000, 0x00000000,
/**/                   0x3F3B6A41, 0xCBD11C5C,
/**/                   0x3FD1E0D0, 0xC3371000,
/**/                   0x3D3AF8F2, 0xA9B0D4A0,
/**/                   0x3FE83000, 0x00000000,
/**/                   0xBF225381, 0xCB7A3CD6,
/**/                   0x3FD1ECE9, 0x5528B000,
/**/                   0xBD184E7B, 0x09B4A3B8,
/**/                   0x3FE82800, 0x00000000,
/**/                   0x3F32500C, 0x152500C1,
/**/                   0x3FD1F8FF, 0x9E48A000,
/**/                   0x3D27946C, 0x040CBE77,
/**/                   0x3FE82800, 0x00000000,
/**/                   0xBF32285F, 0x14902134,
/**/                   0x3FD20513, 0x9F73B000,
/**/                   0x3CF6E15E, 0x1609E0A4,
/**/                   0x3FE82000, 0x00000000,
/**/                   0x3F22D9EB, 0xA4018213,
/**/                   0x3FD21125, 0x59861000,
/**/                   0x3D382E78, 0xBA2950C4,
/**/                   0x3FE82000, 0x00000000,
/**/                   0xBF3AEFFC, 0xFC6BBFF4,
/**/                   0x3FD21D34, 0xCD5B9000,
/**/                   0x3D3B552F, 0xB28BADAA,
/**/                   0x3FE81800, 0x00000000,
/**/                   0x3EE81818, 0x18181818,
/**/                   0x3FD22941, 0xFBCF8000,
/**/                   0xBD3A6976, 0xF5EB0963,
/**/                   0x3FE81000, 0x00000000,
/**/                   0x3F3C7F27, 0x4FF0F3C6,
/**/                   0x3FD2354C, 0xE5BC9000,
/**/                   0xBD3D78ED, 0x0602A663,
/**/                   0x3FE81000, 0x00000000,
/**/                   0xBF1ED344, 0x0A86941D,
/**/                   0x3FD24155, 0x8BFD1000,
/**/                   0x3D300FFF, 0x3228FCAD,
/**/                   0x3FE80800, 0x00000000,
/**/                   0x3F3424D0, 0x1B0BD52D,
/**/                   0x3FD24D5B, 0xEF6AF000,
/**/                   0xBCBDD780, 0xFC9FABDD,
/**/                   0x3FE80800, 0x00000000,
/**/                   0xBF2FE7F9, 0xFE7F9FE8,
/**/                   0x3FD25960, 0x10DF7000,
/**/                   0x3D38E7BC, 0x224EA3E3,
/**/                   0x3FE80000, 0x00000000,
/**/                   0x3F280180, 0x18018018,
/**/                   0x3FD26561, 0xF1338000,
/**/                   0x3D38B488, 0x66FAA45F,
/**/                   0x3FE80000, 0x00000000,
/**/                   0xBF37FD00, 0x5FF40180,
/**/                   0x3FD27161, 0x913F8000,
/**/                   0x3D34F4F1, 0xF61564B4,
/**/                   0x3FE7F800, 0x00000000,
/**/                   0x3F104AE8, 0x9750B6C7,
/**/                   0x3FD27D5E, 0xF1DB6000,
/**/                   0xBD092374, 0x78CAC9F4,
/**/                   0x3FE7F800, 0x00000000,
/**/                   0xBF3FD017, 0xF405FD01,
/**/                   0x3FD2895A, 0x13DE8000,
/**/                   0x3D3A8D7A, 0xD24C13F0,
/**/                   0x3FE7F000, 0x00000000,
/**/                   0xBF0D2BF1, 0xC9C5485E,
/**/                   0x3FD29552, 0xF81FF000,
/**/                   0x3D348D30, 0x1771C408,
/**/                   0x3FE7E800, 0x00000000,
/**/                   0x3F38927F, 0xD029DB60,
/**/                   0x3FD2A149, 0x9F763000,
/**/                   0xBD30DBBF, 0x51F3AADC,
/**/                   0x3FE7E800, 0x00000000,
/**/                   0xBF26504A, 0xB0A45169,
/**/                   0x3FD2AD3E, 0x0AB73000,
/**/                   0x3D2B972E, 0x488C359F,
/**/                   0x3FE7E000, 0x00000000,
/**/                   0x3F312A8A, 0xD278E8DD,
/**/                   0x3FD2B930, 0x3AB8A000,
/**/                   0xBD26DB12, 0xD6BFB0A5,
/**/                   0x3FE7E000, 0x00000000,
/**/                   0xBF327577, 0x24BB32E7,
/**/                   0x3FD2C520, 0x304F8000,
/**/                   0x3D230852, 0x8C342F39,
/**/                   0x3FE7D800, 0x00000000,
/**/                   0x3F23EF9A, 0xA4B45AEC,
/**/                   0x3FD2D10D, 0xEC508000,
/**/                   0x3D360C61, 0xF7088353,
/**/                   0x3FE7D800, 0x00000000,
/**/                   0xBF398DAF, 0x32748CC1,
/**/                   0x3FD2DCF9, 0x6F8FD000,
/**/                   0x3D20B4A2, 0x8E33C9CE,
/**/                   0x3FE7D000, 0x00000000,
/**/                   0x3F07D05F, 0x417D05F4,
/**/                   0x3FD2E8E2, 0xBAE12000,
/**/                   0xBD267B1E, 0x99B72BD8,
/**/                   0x3FE7C800, 0x00000000,
/**/                   0x3F3F8EF7, 0x431D3027,
/**/                   0x3FD2F4C9, 0xCF17A000,
/**/                   0x3D371F04, 0x9374B87B,
/**/                   0x3FE7C800, 0x00000000,
/**/                   0xBF0E77A3, 0xDAD83E6C,
/**/                   0x3FD300AE, 0xAD063000,
/**/                   0x3D342F56, 0x8B75FCAC,
/**/                   0x3FE7C000, 0x00000000,
/**/                   0x3F38E041, 0x588D1676,
/**/                   0x3FD30C91, 0x557F2000,
/**/                   0xBD142958, 0xA1451755,
/**/                   0x3FE7C000, 0x00000000,
/**/                   0xBF24C6DD, 0x1FE8414C,
/**/                   0x3FD31871, 0xC9544000,
/**/                   0x3D184FAB, 0x94CECFD9,
/**/                   0x3FE7B800, 0x00000000,
/**/                   0x3F3265F4, 0x81C2D3B2,
/**/                   0x3FD32450, 0x09570000,
/**/                   0x3D3D271B, 0x9BDAE59D,
/**/                   0x3FE7B800, 0x00000000,
/**/                   0xBF30C39C, 0xB6466407,
/**/                   0x3FD3302C, 0x16586000,
/**/                   0x3D36217D, 0xC2A3E08B,
/**/                   0x3FE7B000, 0x00000000,
/**/                   0x3F283FAD, 0x12B21224,
/**/                   0x3FD33C05, 0xF128E000,
/**/                   0xBD22B906, 0x380E1A7D,
/**/                   0x3FE7B000, 0x00000000,
/**/                   0xBF36EFB8, 0xF899E55D,
/**/                   0x3FD347DD, 0x9A988000,
/**/                   0xBD25594D, 0xD4C58092,
/**/                   0x3FE7A800, 0x00000000,
/**/                   0x3F1836B6, 0x3FF42B9F,
/**/                   0x3FD353B3, 0x1376E000,
/**/                   0xBD1331AF, 0xE6C26D9B,
/**/                   0x3FE7A800, 0x00000000,
/**/                   0xBF3CE7FD, 0x0B739FF4,
/**/                   0x3FD35F86, 0x5C933000,
/**/                   0xBD3B07DE, 0x4EA1A54A,
/**/                   0x3FE7A000, 0x00000000,
/**/                   0x3EC7A005, 0xE8017A00,
/**/                   0x3FD36B57, 0x76BC1000,
/**/                   0x3D116978, 0x5A9C223F,
/**/                   0x3FE79800, 0x00000000,
/**/                   0x3F3D535D, 0xB1CC5B7B,
/**/                   0x3FD37726, 0x62BFE000,
/**/                   0xBD3E9436, 0xAC53B023,
/**/                   0x3FE79800, 0x00000000,
/**/                   0xBF15EEAC, 0xE0DA37A9,
/**/                   0x3FD382F3, 0x216C5000,
/**/                   0xBD1061D2, 0x1D1A7F6D,
/**/                   0x3FE79000, 0x00000000,
/**/                   0x3F37C21E, 0x344E16D6,
/**/                   0x3FD38EBD, 0xB38ED000,
/**/                   0x3D290582, 0xE67D4CA0,
/**/                   0x3FE79000, 0x00000000,
/**/                   0xBF25E69A, 0x39C9E465,
/**/                   0x3FD39A86, 0x19F45000,
/**/                   0x3D18EE51, 0x937354F5,
/**/                   0x3FE78800, 0x00000000,
/**/                   0x3F32640B, 0xC52640BC,
/**/                   0x3FD3A64C, 0x55694000,
/**/                   0x3D37A71C, 0xBCD735D0,
/**/                   0x3FE78800, 0x00000000,
/**/                   0xBF3037DE, 0x2F6A09ED,
/**/                   0x3FD3B210, 0x66B9C000,
/**/                   0xBD33C1ED, 0x9811560E,
/**/                   0x3FE78000, 0x00000000,
/**/                   0x3F2A71DC, 0x01781A72,
/**/                   0x3FD3BDD2, 0x4EB15000,
/**/                   0xBD3257B4, 0x970E6ED9,
/**/                   0x3FE78000, 0x00000000,
/**/                   0xBF354996, 0xA9EEBFF4,
/**/                   0x3FD3C992, 0x0E1B2000,
/**/                   0x3D141C28, 0xAA680B76,
/**/                   0x3FE77800, 0x00000000,
/**/                   0x3F208119, 0xAC60D341,
/**/                   0x3FD3D54F, 0xA5C1F000,
/**/                   0x3D3C3E1C, 0xD9A395E3,
/**/                   0x3FE77800, 0x00000000,
/**/                   0xBF3A28AE, 0x742E2DD0,
/**/                   0x3FD3E10B, 0x16701000,
/**/                   0x3D3F3BCF, 0x145429C7,
/**/                   0x3FE77000, 0x00000000,
/**/                   0x3F0BD584, 0x36340177,
/**/                   0x3FD3ECC4, 0x60EF6000,
/**/                   0xBD060286, 0x27C1300F,
/**/                   0x3FE77000, 0x00000000,
/**/                   0xBF3ED55D, 0x240C7174,
/**/                   0x3FD3F87B, 0x86094000,
/**/                   0xBD35DFD7, 0x54589889,
/**/                   0x3FE76800, 0x00000000,
/**/                   0xBEF18DE5, 0xAB277F45,
/**/                   0x3FD40430, 0x8686A000,
/**/                   0x3D3F8EF4, 0x3049F7D3,
/**/                   0x3FE76000, 0x00000000,
/**/                   0x3F3CB026, 0x01D3C7B8,
/**/                   0x3FD40FE3, 0x63303000,
/**/                   0x3D3E5C5F, 0xE79F05C6,
/**/                   0x3FE76000, 0x00000000,
/**/                   0xBF15E95B, 0xA9D08664,
/**/                   0x3FD41B94, 0x1CCE1000,
/**/                   0xBD304690, 0x13E43FC9,
/**/                   0x3FE75800, 0x00000000,
/**/                   0x3F3867A4, 0x097CFD43,
/**/                   0x3FD42742, 0xB427E000,
/**/                   0xBD398727, 0x02B82675,
/**/                   0x3FE75800, 0x00000000,
/**/                   0xBF2353DF, 0xE8A9353E,
/**/                   0x3FD432EF, 0x2A04F000,
/**/                   0xBD3FB129, 0x931715AD,
/**/                   0x3FE75000, 0x00000000,
/**/                   0x3F3450E6, 0x4F13DC4A,
/**/                   0x3FD43E99, 0x7F2C1000,
/**/                   0x3D1C3F72, 0x40C41A04,
/**/                   0x3FE75000, 0x00000000,
/**/                   0xBF2B4FBF, 0xE8B1B4FC,
/**/                   0x3FD44A41, 0xB463C000,
/**/                   0x3D31EE28, 0xF37CF612,
/**/                   0x3FE74800, 0x00000000,
/**/                   0x3F306BB6, 0x7E458100,
/**/                   0x3FD455E7, 0xCA720000,
/**/                   0x3D1AD8C6, 0x36629AED,
/**/                   0x3FE74800, 0x00000000,
/**/                   0xBF31745D, 0x1745D174,
/**/                   0x3FD4618B, 0xC21C6000,
/**/                   0xBD13D82F, 0x484C84CC,
/**/                   0x3FE74000, 0x00000000,
/**/                   0x3F296FBD, 0x236DEC04,
/**/                   0x3FD46D2D, 0x9C280000,
/**/                   0x3D359B27, 0x5F67F75A,
/**/                   0x3FE74000, 0x00000000,
/**/                   0xBF350F9D, 0x3B304B87,
/**/                   0x3FD478CD, 0x5959B000,
/**/                   0x3D2EC89B, 0xF0C8D098,
/**/                   0x3FE73800, 0x00000000,
/**/                   0x3F226A51, 0xA4EBDC70,
/**/                   0x3FD4846A, 0xFA75C000,
/**/                   0xBD263EA2, 0xE3798DCE,
/**/                   0x3FE73800, 0x00000000,
/**/                   0xBF3879D5, 0xF00B9A78,
/**/                   0x3FD49006, 0x80401000,
/**/                   0xBD38BCCF, 0xFE1A0F8C,
/**/                   0x3FE73000, 0x00000000,
/**/                   0x3F178D7F, 0x5DAAD90C,
/**/                   0x3FD49B9F, 0xEB7C1000,
/**/                   0x3D3DAC1C, 0x58AB60D7,
/**/                   0x3FE73000, 0x00000000,
/**/                   0xBF3BB33C, 0x783709C7,
/**/                   0x3FD4A737, 0x3CED0000,
/**/                   0xBD39A234, 0xEBF35449,
/**/                   0x3FE72800, 0x00000000,
/**/                   0x3F061274, 0x265AD23A,
/**/                   0x3FD4B2CC, 0x75556000,
/**/                   0xBD380FCB, 0xC78BFA4B,
/**/                   0x3FE72800, 0x00000000,
/**/                   0xBF3EBC05, 0xC90A1FD2,
/**/                   0x3FD4BE5F, 0x95778000,
/**/                   0xBD3D7C92, 0xCD9AD824,
/**/                   0x3FE72000, 0x00000000,
/**/                   0xBEC71FFA, 0x38017200,
/**/                   0x3FD4C9F0, 0x9E153000,
/**/                   0xBD2E1DDE, 0x70E02DE0,
/**/                   0x3FE71800, 0x00000000,
/**/                   0x3F3E6B99, 0x74A050E1,
/**/                   0x3FD4D57F, 0x8FEFE000,
/**/                   0x3D23F926, 0x7FD06868,
/**/                   0x3FE71800, 0x00000000,
/**/                   0xBF077400, 0xB8BD1180,
/**/                   0x3FD4E10C, 0x6BC8A000,
/**/                   0x3CF8283F, 0x1636F061,
/**/                   0x3FE71000, 0x00000000,
/**/                   0x3F3BC36C, 0xE3E0453A,
/**/                   0x3FD4EC97, 0x32600000,
/**/                   0x3D234D7A, 0xAF04D104,
/**/                   0x3FE71000, 0x00000000,
/**/                   0xBF15FA98, 0x6935DDC5,
/**/                   0x3FD4F81F, 0xE4764000,
/**/                   0xBD27FCF6, 0x434FF08D,
/**/                   0x3FE70800, 0x00000000,
/**/                   0x3F394B40, 0x7337CF08,
/**/                   0x3FD503A6, 0x82CB2000,
/**/                   0xBD2A68C8, 0xF16F9B5D,
/**/                   0x3FE70800, 0x00000000,
/**/                   0xBF1F7B97, 0xA835403A,
/**/                   0x3FD50F2B, 0x0E1E0000,
/**/                   0x3D3A0940, 0x8C47B8D8,
/**/                   0x3FE70000, 0x00000000,
/**/                   0x3F3702E0, 0x5C0B8170,
/**/                   0x3FD51AAD, 0x872E0000,
/**/                   0xBD3F4BD8, 0xDB0A7CC1,
/**/                   0x3FE70000, 0x00000000,
/**/                   0xBF241EE6, 0x4F67A855,
/**/                   0x3FD5262D, 0xEEB99000,
/**/                   0xBD3E1B9F, 0x70894A01,
/**/                   0x3FE6F800, 0x00000000,
/**/                   0x3F34EA19, 0x221C0170,
/**/                   0x3FD531AC, 0x457EE000,
/**/                   0x3D3DF83B, 0x7D931501,
/**/                   0x3FE6F800, 0x00000000,
/**/                   0xBF282102, 0x5508CA5C,
/**/                   0x3FD53D28, 0x8C3BE000,
/**/                   0xBD111397, 0xEB6DFAC5,
/**/                   0x3FE6F000, 0x00000000,
/**/                   0x3F3300B7, 0x9300B793,
/**/                   0x3FD548A2, 0xC3ADD000,
/**/                   0x3D23167E, 0x63081CF7,
/**/                   0x3FE6F000, 0x00000000,
/**/                   0xBF2BC486, 0x005BB90F,
/**/                   0x3FD5541A, 0xEC91C000,
/**/                   0xBCF816AA, 0xDC72EEBA,
/**/                   0x3FE6E800, 0x00000000,
/**/                   0x3F314688, 0xC5A3A00B,
/**/                   0x3FD55F91, 0x07A44000,
/**/                   0xBD11E647, 0x78DF4A62,
/**/                   0x3FE6E800, 0x00000000,
/**/                   0xBF2F09D6, 0xDA9C5AE1,
/**/                   0x3FD56B05, 0x15A18000,
/**/                   0x3D29247B, 0xBC4A23FC,
/**/                   0x3FE6E000, 0x00000000,
/**/                   0x3F2F76B4, 0x337C6CB1,
/**/                   0x3FD57677, 0x17456000,
/**/                   0xBD364EAD, 0x9524D7CA,
/**/                   0x3FE6E000, 0x00000000,
/**/                   0xBF30F8AC, 0xEDF4EC87,
/**/                   0x3FD581E7, 0x0D4B3000,
/**/                   0xBD1F31E1, 0xB12D8F1D,
/**/                   0x3FE6D800, 0x00000000,
/**/                   0x3F2CBDF2, 0x6EAEF381,
/**/                   0x3FD58D54, 0xF86E0000,
/**/                   0x3D2791F3, 0x0A795215,
/**/                   0x3FE6D800, 0x00000000,
/**/                   0xBF323DB9, 0xB624BFF5,
/**/                   0x3FD598C0, 0xD9688000,
/**/                   0xBD385F49, 0x70D96DA4,
/**/                   0x3FE6D000, 0x00000000,
/**/                   0x3F2A6268, 0x1C860FB0,
/**/                   0x3FD5A42A, 0xB0F4D000,
/**/                   0xBCDE63AF, 0x2DF7BA69,
/**/                   0x3FE6D000, 0x00000000,
/**/                   0xBF335443, 0xB253BAE1,
/**/                   0x3FD5AF92, 0x7FCCE000,
/**/                   0xBD1C032F, 0xF5FFC77A,
/**/                   0x3FE6C800, 0x00000000,
/**/                   0x3F2863B1, 0xAB4294D4,
/**/                   0x3FD5BAF8, 0x46AA2000,
/**/                   0xBD339AE8, 0xF873FA41,
/**/                   0x3FE6C800, 0x00000000,
/**/                   0xBF343C7C, 0x87EAA6DF,
/**/                   0x3FD5C65C, 0x0645A000,
/**/                   0xBD39FE06, 0x0180EE65,
/**/                   0x3FE6C000, 0x00000000,
/**/                   0x3F26C16C, 0x16C16C17,
/**/                   0x3FD5D1BD, 0xBF581000,
/**/                   0xBD38D6BD, 0xC9C7C238,
/**/                   0x3FE6C000, 0x00000000,
/**/                   0xBF34F695, 0x95C33E00,
/**/                   0x3FD5DD1D, 0x7299C000,
/**/                   0xBD38AF61, 0x8815CE17,
/**/                   0x3FE6B800, 0x00000000,
/**/                   0x3F257B34, 0xE7802D73,
/**/                   0x3FD5E87B, 0x20C29000,
/**/                   0x3D3527D1, 0x8F7738FA,
/**/                   0x3FE6B800, 0x00000000,
/**/                   0xBF3582BF, 0xF4A5582C,
/**/                   0x3FD5F3D6, 0xCA8A2000,
/**/                   0x3D37AF84, 0x8E19CC75,
/**/                   0x3FE6B000, 0x00000000,
/**/                   0x3F2490AA, 0x31A3CFC7,
/**/                   0x3FD5FF30, 0x70A79000,
/**/                   0x3D2E9E43, 0x9F105039,
/**/                   0x3FE6B000, 0x00000000,
/**/                   0xBF35E12C, 0x77C30E5A,
/**/                   0x3FD60A88, 0x13D1A000,
/**/                   0x3D36E9B9, 0xC879AF55,
/**/                   0x3FE6A800, 0x00000000,
/**/                   0x3F24016A, 0x94016A94,
/**/                   0x3FD615DD, 0xB4BEC000,
/**/                   0x3D13C7CA, 0x90BC04B2,
/**/                   0x3FE6A800, 0x00000000,
/**/                   0xBF36120B, 0xAD33D63F,
/**/                   0x3FD62131, 0x5424F000,
/**/                   0xBD3382FC, 0x4AA68669,
/**/                   0x3FE6A000, 0x00000000,
/**/                   0x3F23CD15, 0x3729043E,
/**/                   0x3FD62C82, 0xF2B9C000,
/**/                   0x3D3E54BD, 0xBD7C8A98 } };

static const union {int4 i[4350]; double x[2175]; } vj = { .i = {
/**/                   0x3F46A400, 0x7D161C28,
/**/                   0xBF46A200, 0x20600000,
/**/                   0x3D27DC4E, 0xAA7623D9,
/**/                   0x3F4693FA, 0xD596E639,
/**/                   0xBF4691FD, 0x4CE00000,
/**/                   0x3D26B0CF, 0x29C3F0AD,
/**/                   0x3F4683F5, 0x3219CE89,
/**/                   0xBF4681FA, 0x7B600000,
/**/                   0x3D22B290, 0x95B9FDCC,
/**/                   0x3F4673EF, 0x929ED397,
/**/                   0xBF4671F7, 0xABE00000,
/**/                   0x3D17C727, 0xFA2F2D87,
/**/                   0x3F4663E9, 0xF725F3E2,
/**/                   0xBF4661F4, 0xDE600000,
/**/                   0x3CF22ED3, 0x6EDBFF1C,
/**/                   0x3F4653E4, 0x5FAF2DE9,
/**/                   0xBF4651F2, 0x12E00000,
/**/                   0xBD144936, 0x157812BB,
/**/                   0x3F4643DE, 0xCC3A802B,
/**/                   0xBF4641EF, 0x49600000,
/**/                   0xBD2959CB, 0x60314E05,
/**/                   0x3F4633D9, 0x3CC7E927,
/**/                   0xBF4631EC, 0x81E00000,
/**/                   0xBD35ABDA, 0xC3638E99,
/**/                   0x3F4623D3, 0xB157675C,
/**/                   0xBF4621E9, 0xBC800000,
/**/                   0x3D3FF1D3, 0xC63F9A21,
/**/                   0x3F4613CE, 0x29E8F948,
/**/                   0xBF4611E6, 0xF9000000,
/**/                   0x3D342D26, 0x71EEE611,
/**/                   0x3F4603C8, 0xA67C9D6B,
/**/                   0xBF4601E4, 0x37800000,
/**/                   0x3D1C1C77, 0x11A09689,
/**/                   0x3F45F3C3, 0x27125244,
/**/                   0xBF45F1E1, 0x78000000,
/**/                   0xBD1DFD16, 0xF7DC643C,
/**/                   0x3F45E3BD, 0xABAA1651,
/**/                   0xBF45E1DE, 0xBA800000,
/**/                   0xBD376503, 0x91318A02,
/**/                   0x3F45D3B8, 0x3443E812,
/**/                   0xBF45D1DB, 0xFF200000,
/**/                   0x3D3756E4, 0xCE55DCDD,
/**/                   0x3F45C3B2, 0xC0DFC606,
/**/                   0xBF45C1D9, 0x45A00000,
/**/                   0x3D12D5CF, 0x8F6F8FA0,
/**/                   0x3F45B3AD, 0x517DAEAB,
/**/                   0xBF45B1D6, 0x8E200000,
/**/                   0xBD2E90AB, 0x9B85DC2C,
/**/                   0x3F45A3A7, 0xE61DA081,
/**/                   0xBF45A1D3, 0xD8C00000,
/**/                   0x3D3B5E88, 0x3BF5AC54,
/**/                   0x3F4593A2, 0x7EBF9A07,
/**/                   0xBF4591D1, 0x25400000,
/**/                   0x3D12AC3A, 0x0C86DDB1,
/**/                   0x3F45839D, 0x1B6399BB,
/**/                   0xBF4581CE, 0x73C00000,
/**/                   0xBD3361C2, 0x76830985,
/**/                   0x3F457397, 0xBC099E1C,
/**/                   0xBF4571CB, 0xC4600000,
/**/                   0x3D333915, 0xD062EBFF,
/**/                   0x3F456392, 0x60B1A5AA,
/**/                   0xBF4561C9, 0x16E00000,
/**/                   0xBD1E0DA0, 0x9CC4988F,
/**/                   0x3F45538D, 0x095BAEE4,
/**/                   0xBF4551C6, 0x6B800000,
/**/                   0x3D3C69C4, 0x235BC18A,
/**/                   0x3F454387, 0xB607B848,
/**/                   0xBF4541C3, 0xC2000000,
/**/                   0xBCEFCC99, 0xF7737723,
/**/                   0x3F453382, 0x66B5C056,
/**/                   0xBF4531C1, 0x1A800000,
/**/                   0xBD3FBAE2, 0x809CBCBB,
/**/                   0x3F45237D, 0x1B65C58C,
/**/                   0xBF4521BE, 0x75200000,
/**/                   0x3CCAA5C8, 0x194FEE63,
/**/                   0x3F451377, 0xD417C66A,
/**/                   0xBF4511BB, 0xD1C00000,
/**/                   0x3D3ED325, 0xE1CC7BBC,
/**/                   0x3F450372, 0x90CBC16E,
/**/                   0xBF4501B9, 0x30400000,
/**/                   0xBD0F0298, 0x68AB3742,
/**/                   0x3F44F36D, 0x5181B517,
/**/                   0xBF44F1B6, 0x90E00000,
/**/                   0x3D381BE1, 0x41E67AD9,
/**/                   0x3F44E368, 0x16399FE6,
/**/                   0xBF44E1B3, 0xF3600000,
/**/                   0xBD2A6E79, 0x668D3662,
/**/                   0x3F44D362, 0xDEF38058,
/**/                   0xBF44D1B1, 0x58000000,
/**/                   0x3D284EA7, 0x21F8B7C2,
/**/                   0x3F44C35D, 0xABAF54EC,
/**/                   0xBF44C1AE, 0xBE800000,
/**/                   0xBD3BC76D, 0x7417D9C5,
/**/                   0x3F44B358, 0x7C6D1C22,
/**/                   0xBF44B1AC, 0x27200000,
/**/                   0xBD1409FD, 0x16AAD1FC,
/**/                   0x3F44A353, 0x512CD479,
/**/                   0xBF44A1A9, 0x91C00000,
/**/                   0x3D30771E, 0x98BC14FD,
/**/                   0x3F44934E, 0x29EE7C70,
/**/                   0xBF4491A6, 0xFE400000,
/**/                   0xBD3B5993, 0x5CCB7232,
/**/                   0x3F448349, 0x06B21285,
/**/                   0xBF4481A4, 0x6CE00000,
/**/                   0xBD20E729, 0x5512F9C2,
/**/                   0x3F447343, 0xE7779538,
/**/                   0xBF4471A1, 0xDD800000,
/**/                   0x3D225436, 0x55B30899,
/**/                   0x3F44633E, 0xCC3F0308,
/**/                   0xBF44619F, 0x50200000,
/**/                   0x3D39807C, 0x9E54E31F,
/**/                   0x3F445339, 0xB5085A73,
/**/                   0xBF44519C, 0xC4A00000,
/**/                   0xBD376F6F, 0xD5804C0E,
/**/                   0x3F444334, 0xA1D399FA,
/**/                   0xBF44419A, 0x3B400000,
/**/                   0xBD234953, 0x6CDE6425,
/**/                   0x3F44332F, 0x92A0C01A,
/**/                   0xBF443197, 0xB3E00000,
/**/                   0x3D070E7B, 0xAAF6596F,
/**/                   0x3F44232A, 0x876FCB54,
/**/                   0xBF442195, 0x2E800000,
/**/                   0x3D2C49F8, 0x4EC011F1,
/**/                   0x3F441325, 0x8040BA25,
/**/                   0xBF441192, 0xAB200000,
/**/                   0x3D3825DC, 0xD8AAA7EB,
/**/                   0x3F440320, 0x7D138B0E,
/**/                   0xBF440190, 0x29A00000,
/**/                   0xBD3F1A8D, 0xFE0B73D6,
/**/                   0x3F43F31B, 0x7DE83C8C,
/**/                   0xBF43F18D, 0xAA400000,
/**/                   0xBD379B43, 0xE46CA26B,
/**/                   0x3F43E316, 0x82BECD20,
/**/                   0xBF43E18B, 0x2CE00000,
/**/                   0xBD315B44, 0x6283780D,
/**/                   0x3F43D311, 0x8B973B49,
/**/                   0xBF43D188, 0xB1800000,
/**/                   0xBD28B31E, 0x017589BE,
/**/                   0x3F43C30C, 0x98718584,
/**/                   0xBF43C186, 0x38200000,
/**/                   0xBD212A46, 0x8FBB296E,
/**/                   0x3F43B307, 0xA94DAA52,
/**/                   0xBF43B183, 0xC0C00000,
/**/                   0xBD183403, 0x045CBBD2,
/**/                   0x3F43A302, 0xBE2BA832,
/**/                   0xBF43A181, 0x4B600000,
/**/                   0xBD13009B, 0xD7CC5936,
/**/                   0x3F4392FD, 0xD70B7DA2,
/**/                   0xBF43917E, 0xD8000000,
/**/                   0xBD12B655, 0xC1742279,
/**/                   0x3F4382F8, 0xF3ED2921,
/**/                   0xBF43817C, 0x66A00000,
/**/                   0xBD17512E, 0xEA83FAE8,
/**/                   0x3F4372F4, 0x14D0A930,
/**/                   0xBF437179, 0xF7400000,
/**/                   0xBD206692, 0xBED65875,
/**/                   0x3F4362EF, 0x39B5FC4C,
/**/                   0xBF436177, 0x89E00000,
/**/                   0xBD27931B, 0xD38FFE9E,
/**/                   0x3F4352EA, 0x629D20F5,
/**/                   0xBF435175, 0x1E800000,
/**/                   0xBD309618, 0xE524208F,
/**/                   0x3F4342E5, 0x8F8615AA,
/**/                   0xBF434172, 0xB5200000,
/**/                   0xBD3697E9, 0xDD4C72C5,
/**/                   0x3F4332E0, 0xC070D8EB,
/**/                   0xBF433170, 0x4DC00000,
/**/                   0xBD3DCE00, 0x5E6E12C3,
/**/                   0x3F4322DB, 0xF55D6935,
/**/                   0xBF43216D, 0xE8800000,
/**/                   0x3D39C8A4, 0x0AE9A8CE,
/**/                   0x3F4312D7, 0x2E4BC509,
/**/                   0xBF43116B, 0x85200000,
/**/                   0x3D302D03, 0xD1CD2FA1,
/**/                   0x3F4302D2, 0x6B3BEAE5,
/**/                   0xBF430169, 0x23C00000,
/**/                   0x3D15807D, 0xA3BADFD1,
/**/                   0x3F42F2CD, 0xAC2DD949,
/**/                   0xBF42F166, 0xC4600000,
/**/                   0xBD1A7422, 0xF57F0504,
/**/                   0x3F42E2C8, 0xF1218EB3,
/**/                   0xBF42E164, 0x67000000,
/**/                   0xBD33C974, 0x2F2C781C,
/**/                   0x3F42D2C4, 0x3A1709A3,
/**/                   0xBF42D162, 0x0BC00000,
/**/                   0x3D3DDBDD, 0x851A1E61,
/**/                   0x3F42C2BF, 0x870E4898,
/**/                   0xBF42C15F, 0xB2600000,
/**/                   0x3D2CA7D9, 0xA14AA8FD,
/**/                   0x3F42B2BA, 0xD8074A10,
/**/                   0xBF42B15D, 0x5B000000,
/**/                   0xBD03022E, 0xDDCDDFF5,
/**/                   0x3F42A2B6, 0x2D020C8C,
/**/                   0xBF42A15B, 0x05A00000,
/**/                   0xBD343FBA, 0x0F9231A8,
/**/                   0x3F4292B1, 0x85FE8E8A,
/**/                   0xBF429158, 0xB2600000,
/**/                   0x3D38B690, 0xA52C9CCF,
/**/                   0x3F4282AC, 0xE2FCCE8A,
/**/                   0xBF428156, 0x61000000,
/**/                   0x3D120E6A, 0xC8CC82EB,
/**/                   0x3F4272A8, 0x43FCCB0A,
/**/                   0xBF427154, 0x11A00000,
/**/                   0xBD30D79B, 0x792E6C51,
/**/                   0x3F4262A3, 0xA8FE8289,
/**/                   0xBF426151, 0xC4600000,
/**/                   0x3D38A5EE, 0x91F7F7AA,
/**/                   0x3F42529F, 0x1201F387,
/**/                   0xBF42514F, 0x79000000,
/**/                   0x3CEFA728, 0x46C2E8BA,
/**/                   0x3F42429A, 0x7F071C84,
/**/                   0xBF42414D, 0x2FA00000,
/**/                   0xBD37D0BA, 0xFA447A17,
/**/                   0x3F423295, 0xF00DFBFD,
/**/                   0xBF42314A, 0xE8600000,
/**/                   0x3D2C7A24, 0x94AF3FED,
/**/                   0x3F422291, 0x65169072,
/**/                   0xBF422148, 0xA3000000,
/**/                   0xBD29B0BD, 0x050CEA04,
/**/                   0x3F42128C, 0xDE20D863,
/**/                   0xBF421146, 0x5FC00000,
/**/                   0x3D36EFF3, 0x0C3035EB,
/**/                   0x3F420288, 0x5B2CD24E,
/**/                   0xBF420144, 0x1E600000,
/**/                   0xBD19A3E2, 0x73569B27,
/**/                   0x3F41F283, 0xDC3A7CB2,
/**/                   0xBF41F141, 0xDF200000,
/**/                   0x3D3B1DDE, 0xEEB67715,
/**/                   0x3F41E27F, 0x6149D610,
/**/                   0xBF41E13F, 0xA1C00000,
/**/                   0xBD11EA17, 0x94F49154,
/**/                   0x3F41D27A, 0xEA5ADCE5,
/**/                   0xBF41D13D, 0x66800000,
/**/                   0x3D3ACED9, 0x52DD9D37,
/**/                   0x3F41C276, 0x776D8FB1,
/**/                   0xBF41C13B, 0x2D200000,
/**/                   0xBD1C140B, 0xF72D8EEB,
/**/                   0x3F41B272, 0x0881ECF4,
/**/                   0xBF41B138, 0xF5E00000,
/**/                   0x3D360AE5, 0x939583E1,
/**/                   0x3F41A26D, 0x9D97F32C,
/**/                   0xBF41A136, 0xC0800000,
/**/                   0xBD2C00D9, 0x1D246C7C,
/**/                   0x3F419269, 0x36AFA0D9,
/**/                   0xBF419134, 0x8D400000,
/**/                   0x3D29B40E, 0x0B955CFB,
/**/                   0x3F418264, 0xD3C8F479,
/**/                   0xBF418132, 0x5BE00000,
/**/                   0xBD3964BF, 0x45A6C249,
/**/                   0x3F417260, 0x74E3EC8D,
/**/                   0xBF417130, 0x2CA00000,
/**/                   0xBCE777E0, 0xF3363612,
/**/                   0x3F41625C, 0x1A008792,
/**/                   0xBF41612D, 0xFF600000,
/**/                   0x3D36D608, 0x28DE8296,
/**/                   0x3F415257, 0xC31EC409,
/**/                   0xBF41512B, 0xD4000000,
/**/                   0xBD32AE69, 0x4BB1B788,
/**/                   0x3F414253, 0x703EA071,
/**/                   0xBF414129, 0xAAC00000,
/**/                   0x3D05BF68, 0x170ECD8C,
/**/                   0x3F41324F, 0x21601B48,
/**/                   0xBF413127, 0x83800000,
/**/                   0x3D370A0B, 0x7C653BFC,
/**/                   0x3F41224A, 0xD683330E,
/**/                   0xBF412125, 0x5E200000,
/**/                   0xBD35B70D, 0x77BBBEBF,
/**/                   0x3F411246, 0x8FA7E642,
/**/                   0xBF411123, 0x3AE00000,
/**/                   0xBD0C52EB, 0x93ABC1CD,
/**/                   0x3F410242, 0x4CCE3363,
/**/                   0xBF410121, 0x19A00000,
/**/                   0x3D2B2237, 0xE5C6F4C7,
/**/                   0x3F40F23E, 0x0DF618F1,
/**/                   0xBF40F11E, 0xFA600000,
/**/                   0x3D3D9C5F, 0x1E9A50AD,
/**/                   0x3F40E239, 0xD31F956A,
/**/                   0xBF40E11C, 0xDD000000,
/**/                   0xBD336793, 0x8965F0DA,
/**/                   0x3F40D235, 0x9C4AA74E,
/**/                   0xBF40D11A, 0xC1C00000,
/**/                   0xBD15E6EE, 0x7E49E231,
/**/                   0x3F40C231, 0x69774D1D,
/**/                   0xBF40C118, 0xA8800000,
/**/                   0x3D1D9B9D, 0x04FD621C,
/**/                   0x3F40B22D, 0x3AA58554,
/**/                   0xBF40B116, 0x91400000,
/**/                   0x3D333B55, 0x7DD9EED3,
/**/                   0x3F40A229, 0x0FD54E74,
/**/                   0xBF40A114, 0x7C000000,
/**/                   0x3D3E048F, 0x7AA78478,
/**/                   0x3F409224, 0xE906A6FC,
/**/                   0xBF409112, 0x68A00000,
/**/                   0xBD383C6A, 0x644DDE88,
/**/                   0x3F408220, 0xC6398D6B,
/**/                   0xBF408110, 0x57600000,
/**/                   0xBD2F0D2F, 0x76B8C83A,
/**/                   0x3F40721C, 0xA76E0040,
/**/                   0xBF40710E, 0x48200000,
/**/                   0xBD1F63E0, 0x9CE99FD3,
/**/                   0x3F406218, 0x8CA3FDFB,
/**/                   0xBF40610C, 0x3AE00000,
/**/                   0xBCF328B4, 0x4FE774F2,
/**/                   0x3F405214, 0x75DB851A,
/**/                   0xBF40510A, 0x2FA00000,
/**/                   0x3D11B6BD, 0x3782BCD4,
/**/                   0x3F404210, 0x6314941D,
/**/                   0xBF404108, 0x26600000,
/**/                   0x3D22116F, 0xE7183792,
/**/                   0x3F40320C, 0x544F2983,
/**/                   0xBF403106, 0x1F200000,
/**/                   0x3D293F1E, 0x1B995B3D,
/**/                   0x3F402208, 0x498B43CB,
/**/                   0xBF402104, 0x19E00000,
/**/                   0x3D2E6669, 0xFC162630,
/**/                   0x3F401204, 0x42C8E175,
/**/                   0xBF401102, 0x16A00000,
/**/                   0x3D30C4AA, 0x254FC9F8,
/**/                   0x3F400200, 0x40080100,
/**/                   0xBF400100, 0x15600000,
/**/                   0x3D3154EE, 0xE4431F92,
/**/                   0x3F3FE3F8, 0x829141D6,
/**/                   0xBF3FE1FC, 0x2C400000,
/**/                   0x3D30E503, 0x9B2D30FB,
/**/                   0x3F3FC3F0, 0x8D157F6B,
/**/                   0xBF3FC1F8, 0x31C00000,
/**/                   0x3D2EEBD1, 0x53EBD670,
/**/                   0x3F3FA3E8, 0x9F9CB7BC,
/**/                   0xBF3FA1F4, 0x3B400000,
/**/                   0x3D2A113C, 0xE04A16E0,
/**/                   0x3F3F83E0, 0xBA26E7CA,
/**/                   0xBF3F81F0, 0x48C00000,
/**/                   0x3D233C4A, 0x99C43E34,
/**/                   0x3F3F63D8, 0xDCB40C91,
/**/                   0xBF3F61EC, 0x5A400000,
/**/                   0x3D14DDF6, 0x7BD210C1,
/**/                   0x3F3F43D1, 0x07442311,
/**/                   0xBF3F41E8, 0x6FC00000,
/**/                   0xBCC52C1D, 0x9E4B51C8,
/**/                   0x3F3F23C9, 0x39D72849,
/**/                   0xBF3F21E4, 0x89400000,
/**/                   0xBD1A196F, 0x8EA8C754,
/**/                   0x3F3F03C1, 0x746D1936,
/**/                   0xBF3F01E0, 0xA6C00000,
/**/                   0xBD2BB719, 0xF95AF98D,
/**/                   0x3F3EE3B9, 0xB705F2D8,
/**/                   0xBF3EE1DC, 0xC8400000,
/**/                   0xBD3628EB, 0x28FFD598,
/**/                   0x3F3EC3B2, 0x01A1B22C,
/**/                   0xBF3EC1D8, 0xEDC00000,
/**/                   0xBD3F6D76, 0x0BBAC8F8,
/**/                   0x3F3EA3AA, 0x54405432,
/**/                   0xBF3EA1D5, 0x17800000,
/**/                   0x3D3657D2, 0xB7A7EE0D,
/**/                   0x3F3E83A2, 0xAEE1D5E8,
/**/                   0xBF3E81D1, 0x45000000,
/**/                   0x3D264FDE, 0xFA9CCC78,
/**/                   0x3F3E639B, 0x1186344C,
/**/                   0xBF3E61CD, 0x76800000,
/**/                   0xBCEF83EB, 0xE02EF455,
/**/                   0x3F3E4393, 0x7C2D6C5E,
/**/                   0xBF3E41C9, 0xAC000000,
/**/                   0xBD2C26B3, 0x03C3E129,
/**/                   0x3F3E238B, 0xEED77B1B,
/**/                   0xBF3E21C5, 0xE5800000,
/**/                   0xBD3C1CBE, 0x904D773D,
/**/                   0x3F3E0384, 0x69845D83,
/**/                   0xBF3E01C2, 0x23400000,
/**/                   0x3D34E8B1, 0xD0615454,
/**/                   0x3F3DE37C, 0xEC341093,
/**/                   0xBF3DE1BE, 0x64C00000,
/**/                   0x3D13F7DF, 0xE9BE933E,
/**/                   0x3F3DC375, 0x76E6914B,
/**/                   0xBF3DC1BA, 0xAA400000,
/**/                   0xBD27B7D7, 0x707B004A,
/**/                   0x3F3DA36E, 0x099BDCA9,
/**/                   0xBF3DA1B6, 0xF3C00000,
/**/                   0xBD3DA3F8, 0xEE2141C3,
/**/                   0x3F3D8366, 0xA453EFAC,
/**/                   0xBF3D81B3, 0x41800000,
/**/                   0x3D2F4DA1, 0x63D21825,
/**/                   0x3F3D635F, 0x470EC752,
/**/                   0xBF3D61AF, 0x93000000,
/**/                   0xBD0FD473, 0xFAD0B844,
/**/                   0x3F3D4357, 0xF1CC609A,
/**/                   0xBF3D41AB, 0xE8800000,
/**/                   0xBD388716, 0x298657C2,
/**/                   0x3F3D2350, 0xA48CB882,
/**/                   0xBF3D21A8, 0x42400000,
/**/                   0x3D32023A, 0x0B68711A,
/**/                   0x3F3D0349, 0x5F4FCC0A,
/**/                   0xBF3D01A4, 0x9FC00000,
/**/                   0xBD117676, 0x23A704B0,
/**/                   0x3F3CE342, 0x22159830,
/**/                   0xBF3CE1A1, 0x01400000,
/**/                   0xBD3BA59C, 0x8F391F09,
/**/                   0x3F3CC33A, 0xECDE19F1,
/**/                   0xBF3CC19D, 0x67000000,
/**/                   0x3D28567A, 0x9EBBF706,
/**/                   0x3F3CA333, 0xBFA94E4E,
/**/                   0xBF3CA199, 0xD0800000,
/**/                   0xBD29D41F, 0x2D41F1CC,
/**/                   0x3F3C832C, 0x9A773245,
/**/                   0xBF3C8196, 0x3E400000,
/**/                   0x3D391B7D, 0x14ED5134,
/**/                   0x3F3C6325, 0x7D47C2D4,
/**/                   0xBF3C6192, 0xAFC00000,
/**/                   0xBCFC31C5, 0x83403B5B,
/**/                   0x3F3C431E, 0x681AFCFA,
/**/                   0xBF3C418F, 0x25400000,
/**/                   0xBD3D84DB, 0x88A1FFF3,
/**/                   0x3F3C2317, 0x5AF0DDB6,
/**/                   0xBF3C218B, 0x9F000000,
/**/                   0x3D175CFF, 0x6298A63B,
/**/                   0x3F3C0310, 0x55C96207,
/**/                   0xBF3C0188, 0x1C800000,
/**/                   0xBD37ADC9, 0xDFB8E489,
/**/                   0x3F3BE309, 0x58A486EA,
/**/                   0xBF3BE184, 0x9E400000,
/**/                   0x3D23DA0F, 0x45069C64,
/**/                   0x3F3BC302, 0x6382495F,
/**/                   0xBF3BC181, 0x23C00000,
/**/                   0xBD35574B, 0x4CC2EFE0,
/**/                   0x3F3BA2FB, 0x7662A665,
/**/                   0xBF3BA17D, 0xAD800000,
/**/                   0x3D250C7B, 0x4BED0B89,
/**/                   0x3F3B82F4, 0x91459AFA,
/**/                   0xBF3B817A, 0x3B000000,
/**/                   0xBD36795D, 0x322E5605,
/**/                   0x3F3B62ED, 0xB42B241D,
/**/                   0xBF3B6176, 0xCCC00000,
/**/                   0x3D1EAB91, 0xF6413886,
/**/                   0x3F3B42E6, 0xDF133ECC,
/**/                   0xBF3B4173, 0x62400000,
/**/                   0xBD3B0BFC, 0xF86BE5B5,
/**/                   0x3F3B22E0, 0x11FDE807,
/**/                   0xBF3B216F, 0xFC000000,
/**/                   0x3CF62FEB, 0xDDE8D701,
/**/                   0x3F3B02D9, 0x4CEB1CCC,
/**/                   0xBF3B016C, 0x99C00000,
/**/                   0x3D3CF8D7, 0xF210FD9E,
/**/                   0x3F3AE2D2, 0x8FDADA1A,
/**/                   0xBF3AE169, 0x3B400000,
/**/                   0xBD2092E2, 0x1526CFB0,
/**/                   0x3F3AC2CB, 0xDACD1CEF,
/**/                   0xBF3AC165, 0xE1000000,
/**/                   0x3D319D24, 0x18D261D5,
/**/                   0x3F3AA2C5, 0x2DC1E24A,
/**/                   0xBF3AA162, 0x8A800000,
/**/                   0xBD355268, 0x533CC8EC,
/**/                   0x3F3A82BE, 0x88B9272B,
/**/                   0xBF3A815F, 0x38400000,
/**/                   0x3D074750, 0x0AFE6139,
/**/                   0x3F3A62B7, 0xEBB2E88F,
/**/                   0xBF3A615B, 0xEA000000,
/**/                   0x3D3A501B, 0x6668AD57,
/**/                   0x3F3A42B1, 0x56AF2375,
/**/                   0xBF3A4158, 0x9F800000,
/**/                   0xBD2E37A7, 0xA98381BD,
/**/                   0x3F3A22AA, 0xC9ADD4DD,
/**/                   0xBF3A2155, 0x59400000,
/**/                   0x3D1A9872, 0x7B82F9AC,
/**/                   0x3F3A02A4, 0x44AEF9C5,
/**/                   0xBF3A0152, 0x17000000,
/**/                   0x3D3B96ED, 0x0FF040AD,
/**/                   0x3F39E29D, 0xC7B28F2C,
/**/                   0xBF39E14E, 0xD8800000,
/**/                   0xBD304862, 0x33534BD7,
/**/                   0x3F39C297, 0x52B89211,
/**/                   0xBF39C14B, 0x9E400000,
/**/                   0x3D084979, 0x17AF009B,
/**/                   0x3F39A290, 0xE5C0FF72,
/**/                   0xBF39A148, 0x68000000,
/**/                   0x3D358CA1, 0x604B64C9,
/**/                   0x3F39828A, 0x80CBD44E,
/**/                   0xBF398145, 0x35800000,
/**/                   0xBD38BD0B, 0x2E334404,
/**/                   0x3F396284, 0x23D90DA4,
/**/                   0xBF396142, 0x07400000,
/**/                   0xBD1F4B58, 0xEF1B1C68,
/**/                   0x3F39427D, 0xCEE8A873,
/**/                   0xBF39413E, 0xDD000000,
/**/                   0x3D209881, 0x07E010EC,
/**/                   0x3F392277, 0x81FAA1B9,
/**/                   0xBF39213B, 0xB6C00000,
/**/                   0x3D37A139, 0x5CF03181,
/**/                   0x3F390271, 0x3D0EF676,
/**/                   0xBF390138, 0x94400000,
/**/                   0xBD39D2EB, 0x65276B0B,
/**/                   0x3F38E26B, 0x0025A3A8,
/**/                   0xBF38E135, 0x76000000,
/**/                   0xBD281E5A, 0xEE3023F6,
/**/                   0x3F38C264, 0xCB3EA64F,
/**/                   0xBF38C132, 0x5BC00000,
/**/                   0x3CEDAE6E, 0x3F9A4B53,
/**/                   0x3F38A25E, 0x9E59FB68,
/**/                   0xBF38A12F, 0x45800000,
/**/                   0x3D2A47EF, 0x412B648E,
/**/                   0x3F388258, 0x79779FF3,
/**/                   0xBF38812C, 0x33400000,
/**/                   0x3D38955F, 0x5ED0D8F2,
/**/                   0x3F386252, 0x5C9790EE,
/**/                   0xBF386129, 0x24C00000,
/**/                   0xBD3CBD55, 0x09939374,
/**/                   0x3F38424C, 0x47B9CB5A,
/**/                   0xBF384126, 0x1A800000,
/**/                   0xBD32D325, 0x4F399186,
/**/                   0x3F382246, 0x3ADE4C33,
/**/                   0xBF382123, 0x14400000,
/**/                   0xBD235622, 0x524688EB,
/**/                   0x3F380240, 0x3605107A,
/**/                   0xBF380120, 0x12000000,
/**/                   0xBCF44184, 0xEB2F3DDC,
/**/                   0x3F37E23A, 0x392E152C,
/**/                   0xBF37E11D, 0x13C00000,
/**/                   0x3D198B16, 0x2153D1B8,
/**/                   0x3F37C234, 0x4459574A,
/**/                   0xBF37C11A, 0x19800000,
/**/                   0x3D2A9511, 0x47A3C923,
/**/                   0x3F37A22E, 0x5786D3D1,
/**/                   0xBF37A117, 0x23400000,
/**/                   0x3D337431, 0x4B4128D9,
/**/                   0x3F378228, 0x72B687C1,
/**/                   0xBF378114, 0x31000000,
/**/                   0x3D38E0BF, 0xC5BFE9E8,
/**/                   0x3F376222, 0x95E87019,
/**/                   0xBF376111, 0x42C00000,
/**/                   0x3D3D9134, 0x5A0B2CE9,
/**/                   0x3F37421C, 0xC11C89D8,
/**/                   0xBF37410E, 0x58400000,
/**/                   0xBD3E7970, 0xB1802C40,
/**/                   0x3F372216, 0xF452D1FB,
/**/                   0xBF37210B, 0x72000000,
/**/                   0xBD3B3E2F, 0x16E562C9,
/**/                   0x3F370211, 0x2F8B4583,
/**/                   0xBF370108, 0x8FC00000,
/**/                   0xBD38BC06, 0x9087DACD,
/**/                   0x3F36E20B, 0x72C5E16F,
/**/                   0xBF36E105, 0xB1800000,
/**/                   0xBD36F1F6, 0xD92B1B21,
/**/                   0x3F36C205, 0xBE02A2BC,
/**/                   0xBF36C102, 0xD7400000,
/**/                   0xBD35DEFF, 0xABF2CD23,
/**/                   0x3F36A200, 0x1141866B,
/**/                   0xBF36A100, 0x01000000,
/**/                   0xBD358220, 0xC462BC85,
/**/                   0x3F3681FA, 0x6C828979,
/**/                   0xBF3680FD, 0x2EC00000,
/**/                   0xBD35DA59, 0xDE5ED723,
/**/                   0x3F3661F4, 0xCFC5A8E7,
/**/                   0xBF3660FA, 0x60800000,
/**/                   0xBD36E6AA, 0xB62B2CD1,
/**/                   0x3F3641EF, 0x3B0AE1B2,
/**/                   0xBF3640F7, 0x96400000,
/**/                   0xBD38A613, 0x086BEF29,
/**/                   0x3F3621E9, 0xAE5230DA,
/**/                   0xBF3620F4, 0xD0000000,
/**/                   0xBD3B1792, 0x9225715D,
/**/                   0x3F3601E4, 0x299B935F,
/**/                   0xBF3600F2, 0x0DC00000,
/**/                   0xBD3E3A29, 0x10BC2805,
/**/                   0x3F35E1DE, 0xACE7063E,
/**/                   0xBF35E0EF, 0x4FC00000,
/**/                   0x3D3DF329, 0xBE0B570D,
/**/                   0x3F35C1D9, 0x38348676,
/**/                   0xBF35C0EC, 0x95800000,
/**/                   0x3D397166, 0x1C0C5502,
/**/                   0x3F35A1D3, 0xCB841108,
/**/                   0xBF35A0E9, 0xDF400000,
/**/                   0x3D34418C, 0x4AC1FA2D,
/**/                   0x3F3581CE, 0x66D5A2F1,
/**/                   0xBF3580E7, 0x2D000000,
/**/                   0x3D2CC939, 0x168E9C6E,
/**/                   0x3F3561C9, 0x0A293931,
/**/                   0xBF3560E4, 0x7EC00000,
/**/                   0x3D1F6E5C, 0x795CE154,
/**/                   0x3F3541C3, 0xB57ED0C7,
/**/                   0xBF3540E1, 0xD4800000,
/**/                   0x3CE4EF88, 0x898FEE67,
/**/                   0x3F3521BE, 0x68D666B1,
/**/                   0xBF3520DF, 0x2E400000,
/**/                   0xBD1CDACF, 0x0B78D65E,
/**/                   0x3F3501B9, 0x242FF7EF,
/**/                   0xBF3500DC, 0x8C000000,
/**/                   0xBD2F7BF1, 0x6F1CBFB8,
/**/                   0x3F34E1B3, 0xE78B8180,
/**/                   0xBF34E0D9, 0xEDC00000,
/**/                   0xBD38ED52, 0x5A899820,
/**/                   0x3F34C1AE, 0xB2E90063,
/**/                   0xBF34C0D7, 0x53C00000,
/**/                   0x3D3D3C3F, 0x930A694E,
/**/                   0x3F34A1A9, 0x86487196,
/**/                   0xBF34A0D4, 0xBD800000,
/**/                   0x3D32BFBD, 0x4FA7CCCB,
/**/                   0x3F3481A4, 0x61A9D219,
/**/                   0xBF3480D2, 0x2B400000,
/**/                   0x3D1E789C, 0x65A26E32,
/**/                   0x3F34619F, 0x450D1EEB,
/**/                   0xBF3460CF, 0x9D000000,
/**/                   0xBD109E0B, 0x47E500B5,
/**/                   0x3F34419A, 0x3072550B,
/**/                   0xBF3440CD, 0x12C00000,
/**/                   0xBD309040, 0x3523FAE9,
/**/                   0x3F342195, 0x23D97178,
/**/                   0xBF3420CA, 0x8C800000,
/**/                   0xBD3D9B10, 0xD31DE7C2,
/**/                   0x3F340190, 0x1F427131,
/**/                   0xBF3400C8, 0x0A800000,
/**/                   0x3D34B90B, 0x90B287C4,
/**/                   0x3F33E18B, 0x22AD5135,
/**/                   0xBF33E0C5, 0x8C400000,
/**/                   0x3D19B454, 0xCA1B0FC2,
/**/                   0x3F33C186, 0x2E1A0E83,
/**/                   0xBF33C0C3, 0x12000000,
/**/                   0xBD20FBE7, 0x638FC1F4,
/**/                   0x3F33A181, 0x4188A61A,
/**/                   0xBF33A0C0, 0x9BC00000,
/**/                   0xBD38070E, 0xE0C03290,
/**/                   0x3F33817C, 0x5CF914F9,
/**/                   0xBF3380BE, 0x29C00000,
/**/                   0x3D37D2C3, 0xE0B6E5F5,
/**/                   0x3F336177, 0x806B5820,
/**/                   0xBF3360BB, 0xBB800000,
/**/                   0x3D1C4213, 0x35598794,
/**/                   0x3F334172, 0xABDF6C8D,
/**/                   0xBF3340B9, 0x51400000,
/**/                   0xBD249997, 0xC111C569,
/**/                   0x3F33216D, 0xDF554F40,
/**/                   0xBF3320B6, 0xEB000000,
/**/                   0xBD3C442D, 0xEEEE28E2,
/**/                   0x3F330169, 0x1ACCFD37,
/**/                   0xBF3300B4, 0x89000000,
/**/                   0x3D312B5E, 0xDBBF316D,
/**/                   0x3F32E164, 0x5E467372,
/**/                   0xBF32E0B2, 0x2AC00000,
/**/                   0xBCFFD254, 0x7484E6E1,
/**/                   0x3F32C15F, 0xA9C1AEF0,
/**/                   0xBF32C0AF, 0xD0800000,
/**/                   0xBD35BCBA, 0x1F2C3F9D,
/**/                   0x3F32A15A, 0xFD3EACAF,
/**/                   0xBF32A0AD, 0x7A800000,
/**/                   0x3D35EDA0, 0x8C8BAA61,
/**/                   0x3F328156, 0x58BD69B0,
/**/                   0xBF3280AB, 0x28400000,
/**/                   0x3CF02EAF, 0x3F79FE5E,
/**/                   0x3F326151, 0xBC3DE2F1,
/**/                   0xBF3260A8, 0xDA000000,
/**/                   0xBD347BDA, 0xB1304AA8,
/**/                   0x3F32414D, 0x27C01572,
/**/                   0xBF3240A6, 0x90000000,
/**/                   0x3D35724F, 0xD46BE359,
/**/                   0x3F322148, 0x9B43FE30,
/**/                   0xBF3220A4, 0x49C00000,
/**/                   0xBCF31954, 0x43BF90C9,
/**/                   0x3F320144, 0x16C99A2D,
/**/                   0xBF3200A2, 0x07800000,
/**/                   0xBD386689, 0xC4901E30,
/**/                   0x3F31E13F, 0x9A50E666,
/**/                   0xBF31E09F, 0xC9800000,
/**/                   0x3D2FA8E5, 0x134E34BF,
/**/                   0x3F31C13B, 0x25D9DFDB,
/**/                   0xBF31C09D, 0x8F400000,
/**/                   0xBD20FF40, 0x477D87DF,
/**/                   0x3F31A136, 0xB964838C,
/**/                   0xBF31A09B, 0x59400000,
/**/                   0x3D3E9E3E, 0x68B5B77B,
/**/                   0x3F318132, 0x54F0CE76,
/**/                   0xBF318099, 0x27000000,
/**/                   0x3D14BC39, 0x906F8A53,
/**/                   0x3F31612D, 0xF87EBD9A,
/**/                   0xBF316096, 0xF8C00000,
/**/                   0xBD34CC2F, 0xFCD50724,
/**/                   0x3F314129, 0xA40E4DF7,
/**/                   0xBF314094, 0xCEC00000,
/**/                   0x3D30AD83, 0x7A3A1B8D,
/**/                   0x3F312125, 0x579F7C8B,
/**/                   0xBF312092, 0xA8800000,
/**/                   0xBD24C5AE, 0x057F5C66,
/**/                   0x3F310121, 0x13324657,
/**/                   0xBF310090, 0x86800000,
/**/                   0x3D3A03C0, 0xBFD488E0,
/**/                   0x3F30E11C, 0xD6C6A858,
/**/                   0xBF30E08E, 0x68400000,
/**/                   0xBD00EDA8, 0x56935D63,
/**/                   0x3F30C118, 0xA25C9F8F,
/**/                   0xBF30C08C, 0x4E000000,
/**/                   0xBD3EC638, 0x2FDDD1CE,
/**/                   0x3F30A114, 0x75F428FB,
/**/                   0xBF30A08A, 0x38000000,
/**/                   0x3D102CDE, 0x0CA3DCBE,
/**/                   0x3F308110, 0x518D419B,
/**/                   0xBF308088, 0x25C00000,
/**/                   0xBD39A865, 0xBFA78921,
/**/                   0x3F30610C, 0x3527E66D,
/**/                   0xBF306086, 0x17C00000,
/**/                   0x3D203FE0, 0x72CE37BD,
/**/                   0x3F304108, 0x20C41472,
/**/                   0xBF304084, 0x0D800000,
/**/                   0xBD369AC6, 0x6054C3FA,
/**/                   0x3F302104, 0x1461C8A9,
/**/                   0xBF302082, 0x07800000,
/**/                   0x3D2450ED, 0x4836293A,
/**/                   0x3F300100, 0x10010010,
/**/                   0xBF300080, 0x05400000,
/**/                   0xBD359558, 0x88B3357C,
/**/                   0x3F2FC1F8, 0x27436F4F,
/**/                   0xBF2FC0FC, 0x0E800000,
/**/                   0x3D245998, 0x92ECD4D1,
/**/                   0x3F2F81F0, 0x3E87D8DC,
/**/                   0xBF2F80F8, 0x1A000000,
/**/                   0xBD36901A, 0xB592170A,
/**/                   0x3F2F41E8, 0x65CF36C6,
/**/                   0xBF2F40F4, 0x2E000000,
/**/                   0x3D2069E5, 0x53524603,
/**/                   0x3F2F01E0, 0x9D19830B,
/**/                   0xBF2F00F0, 0x49800000,
/**/                   0xBD39830B, 0x69C22240,
/**/                   0x3F2EC1D8, 0xE466B7AB,
/**/                   0xBF2EC0EC, 0x6D800000,
/**/                   0x3D1123AC, 0xFB871BBA,
/**/                   0x3F2E81D1, 0x3BB6CEA4,
/**/                   0xBF2E80E8, 0x99000000,
/**/                   0xBD3E6629, 0x2E158AF6,
/**/                   0x3F2E41C9, 0xA309C1F4,
/**/                   0xBF2E40E4, 0xCD000000,
/**/                   0xBCF8F488, 0x2B29884E,
/**/                   0x3F2E01C2, 0x1A5F8B99,
/**/                   0xBF2E00E1, 0x09000000,
/**/                   0x3D3ACE8D, 0x6EA006C6,
/**/                   0x3F2DC1BA, 0xA1B82593,
/**/                   0xBF2DC0DD, 0x4C800000,
/**/                   0xBD22974E, 0x59D0B687,
/**/                   0x3F2D81B3, 0x391389E0,
/**/                   0xBF2D80D9, 0x98800000,
/**/                   0x3D322319, 0xD7897CAD,
/**/                   0x3F2D41AB, 0xE071B27F,
/**/                   0xBF2D40D5, 0xEC000000,
/**/                   0xBD32E42F, 0x57954C6E,
/**/                   0x3F2D01A4, 0x97D2996E,
/**/                   0xBF2D00D2, 0x48000000,
/**/                   0x3D1E7DF5, 0xC741610E,
/**/                   0x3F2CC19D, 0x5F3638AB,
/**/                   0xBF2CC0CE, 0xAB800000,
/**/                   0xBD3E50DF, 0xA0909C5A,
/**/                   0x3F2C8196, 0x369C8A37,
/**/                   0xBF2C80CB, 0x17800000,
/**/                   0xBD12D119, 0x8D8D1C8F,
/**/                   0x3F2C418F, 0x1E05880E,
/**/                   0xBF2C40C7, 0x8B800000,
/**/                   0x3D347649, 0x544D2574,
/**/                   0x3F2C0188, 0x15712C30,
/**/                   0xBF2C00C4, 0x07000000,
/**/                   0xBD32D030, 0x4EEA9E68,
/**/                   0x3F2BC181, 0x1CDF709C,
/**/                   0xBF2BC0C0, 0x8B000000,
/**/                   0x3D15E533, 0x74A84109,
/**/                   0x3F2B817A, 0x34504F50,
/**/                   0xBF2B80BD, 0x17000000,
/**/                   0x3D3D53C1, 0x025FBF68,
/**/                   0x3F2B4173, 0x5BC3C24B,
/**/                   0xBF2B40B9, 0xAA800000,
/**/                   0xBD267FA7, 0x6BAA2FA8,
/**/                   0x3F2B016C, 0x9339C38C,
/**/                   0xBF2B00B6, 0x46800000,
/**/                   0x3D277F1D, 0xBB3FDE1E,
/**/                   0x3F2AC165, 0xDAB24D11,
/**/                   0xBF2AC0B2, 0xEA000000,
/**/                   0xBD3DAD17, 0x1A8CDBE2,
/**/                   0x3F2A815F, 0x322D58D9,
/**/                   0xBF2A80AF, 0x96000000,
/**/                   0xBD1E1315, 0xD81CF36E,
/**/                   0x3F2A4158, 0x99AAE0E3,
/**/                   0xBF2A40AC, 0x4A000000,
/**/                   0x3D2C7307, 0xE649E7B4,
/**/                   0x3F2A0152, 0x112ADF2D,
/**/                   0xBF2A00A9, 0x05800000,
/**/                   0xBD3C713A, 0xB77435EC,
/**/                   0x3F29C14B, 0x98AD4DB7,
/**/                   0xBF29C0A5, 0xC9800000,
/**/                   0xBD1E1005, 0x3A7AE827,
/**/                   0x3F298145, 0x3032267F,
/**/                   0xBF2980A2, 0x95800000,
/**/                   0x3D2A0460, 0xA8F2A842,
/**/                   0x3F29413E, 0xD7B96385,
/**/                   0xBF29409F, 0x69000000,
/**/                   0xBD3EDDA5, 0xA7B8321E,
/**/                   0x3F290138, 0x8F42FEC5,
/**/                   0xBF29009C, 0x45000000,
/**/                   0xBD264506, 0x3A3F0D33,
/**/                   0x3F28C132, 0x56CEF241,
/**/                   0xBF28C099, 0x29000000,
/**/                   0x3D206930, 0x33EE13CD,
/**/                   0x3F28812C, 0x2E5D37F6,
/**/                   0xBF288096, 0x15000000,
/**/                   0x3D3B28AC, 0x22DF1FDA,
/**/                   0x3F284126, 0x15EDC9E3,
/**/                   0xBF284093, 0x08800000,
/**/                   0xBD324546, 0xDD73B6DB,
/**/                   0x3F280120, 0x0D80A208,
/**/                   0xBF280090, 0x04800000,
/**/                   0xBCB440C2, 0x6DFEB485,
/**/                   0x3F27C11A, 0x1515BA62,
/**/                   0xBF27C08D, 0x08800000,
/**/                   0x3D31BCBE, 0x9823B19D,
/**/                   0x3F278114, 0x2CAD0CF1,
/**/                   0xBF27808A, 0x14000000,
/**/                   0xBD3CD148, 0xA9EB4E97,
/**/                   0x3F27410E, 0x544693B4,
/**/                   0xBF274087, 0x28000000,
/**/                   0xBD277AAC, 0xCA4F73AA,
/**/                   0x3F270108, 0x8BE248AA,
/**/                   0xBF270084, 0x44000000,
/**/                   0x3D13E656, 0x26068EF7,
/**/                   0x3F26C102, 0xD38025D2,
/**/                   0xBF26C081, 0x68000000,
/**/                   0x3D35547B, 0x44C3EC8A,
/**/                   0x3F2680FD, 0x2B20252A,
/**/                   0xBF26807E, 0x93800000,
/**/                   0xBD3AABA5, 0x110DCE4B,
/**/                   0x3F2640F7, 0x92C240B1,
/**/                   0xBF26407B, 0xC7800000,
/**/                   0xBD260B96, 0xAC011956,
/**/                   0x3F2600F2, 0x0A667267,
/**/                   0xBF260079, 0x03800000,
/**/                   0x3D111C22, 0x5DFA826E,
/**/                   0x3F25C0EC, 0x920CB44A,
/**/                   0xBF25C076, 0x47800000,
/**/                   0x3D333BD6, 0xD8A2980A,
/**/                   0x3F2580E7, 0x29B5005A,
/**/                   0xBF258073, 0x93000000,
/**/                   0xBD3E2660, 0x71C1D861,
/**/                   0x3F2540E1, 0xD15F5095,
/**/                   0xBF254070, 0xE7000000,
/**/                   0xBD2FBD3A, 0x4E77E5EE,
/**/                   0x3F2500DC, 0x890B9EFA,
/**/                   0xBF25006E, 0x43000000,
/**/                   0xBCFEBDF2, 0x7B90A2D9,
/**/                   0x3F24C0D7, 0x50B9E589,
/**/                   0xBF24C06B, 0xA7000000,
/**/                   0x3D2765B3, 0x58F2FF2C,
/**/                   0x3F2480D2, 0x286A1E40,
/**/                   0xBF248069, 0x13000000,
/**/                   0x3D38FE8D, 0x74AE382C,
/**/                   0x3F2440CD, 0x101C431E,
/**/                   0xBF244066, 0x86800000,
/**/                   0xBD3A07C3, 0xB0286224,
/**/                   0x3F2400C8, 0x07D04E23,
/**/                   0xBF240064, 0x02800000,
/**/                   0xBD2ABE33, 0x46EFC0EC,
/**/                   0x3F23C0C3, 0x0F86394D,
/**/                   0xBF23C061, 0x86800000,
/**/                   0xBCF06744, 0x70DE3151,
/**/                   0x3F2380BE, 0x273DFE9C,
/**/                   0xBF23805F, 0x12800000,
/**/                   0x3D260659, 0x05CFCD61,
/**/                   0x3F2340B9, 0x4EF7980F,
/**/                   0xBF23405C, 0xA6800000,
/**/                   0x3D36BEC8, 0xD7DBBEBC,
/**/                   0x3F2300B4, 0x86B2FFA4,
/**/                   0xBF23005A, 0x42000000,
/**/                   0xBD3DD29F, 0x2B2027B4,
/**/                   0x3F22C0AF, 0xCE702F5C,
/**/                   0xBF22C057, 0xE6000000,
/**/                   0xBD32B00B, 0x6959A7D0,
/**/                   0x3F2280AB, 0x262F2134,
/**/                   0xBF228055, 0x92000000,
/**/                   0xBD1F61EF, 0x19FAAC2D,
/**/                   0x3F2240A6, 0x8DEFCF2C,
/**/                   0xBF224053, 0x46000000,
/**/                   0x3D05A87E, 0xCB16B8A8,
/**/                   0x3F2200A2, 0x05B23344,
/**/                   0xBF220051, 0x02000000,
/**/                   0x3D29F32F, 0x23B9B257,
/**/                   0x3F21C09D, 0x8D76477A,
/**/                   0xBF21C04E, 0xC6000000,
/**/                   0x3D36F61B, 0x7E214821,
/**/                   0x3F218099, 0x253C05CD,
/**/                   0xBF21804C, 0x91800000,
/**/                   0xBD3F5464, 0x46FDFCA2,
/**/                   0x3F214094, 0xCD03683D,
/**/                   0xBF21404A, 0x65800000,
/**/                   0xBD35E4E7, 0xA30F2308,
/**/                   0x3F210090, 0x84CC68C9,
/**/                   0xBF210048, 0x41800000,
/**/                   0xBD2974DC, 0xF800CC34,
/**/                   0x3F20C08C, 0x4C970171,
/**/                   0xBF20C046, 0x25800000,
/**/                   0xBD0E9FC5, 0xC1006E9D,
/**/                   0x3F208088, 0x24632C32,
/**/                   0xBF208044, 0x11800000,
/**/                   0x3D133DE7, 0x078E4438,
/**/                   0x3F204084, 0x0C30E30D,
/**/                   0xBF204042, 0x05800000,
/**/                   0x3D2A61D2, 0x15F82A7B,
/**/                   0x3F200080, 0x04002001,
/**/                   0xBF200040, 0x01800000,
/**/                   0x3D355155, 0x3BBB110C,
/**/                   0x3F1F80F8, 0x17A1BA1A,
/**/                   0xBF1F807C, 0x0B000000,
/**/                   0x3D3D31BE, 0x6C520A9B,
/**/                   0x3F1F00F0, 0x47462860,
/**/                   0xBF1F0078, 0x22000000,
/**/                   0xBD3B2CDB, 0x4B6D83F6,
/**/                   0x3F1E80E8, 0x96ED7ED3,
/**/                   0xBF1E8074, 0x4A000000,
/**/                   0xBD33C977, 0xD4122C5A,
/**/                   0x3F1E00E1, 0x0697B172,
/**/                   0xBF1E0070, 0x82000000,
/**/                   0xBD29462E, 0x2D1517C4,
/**/                   0x3F1D80D9, 0x9644B43B,
/**/                   0xBF1D806C, 0xCA000000,
/**/                   0xBD16E2E3, 0xF0952D45,
/**/                   0x3F1D00D2, 0x45F47B2C,
/**/                   0xBF1D0069, 0x22000000,
/**/                   0x3CEED452, 0x2DDC2A8D,
/**/                   0x3F1C80CB, 0x15A6FA46,
/**/                   0xBF1C8065, 0x8A000000,
/**/                   0x3D1DAFEE, 0xA08CEBE8,
/**/                   0x3F1C00C4, 0x055C2585,
/**/                   0xBF1C0062, 0x02000000,
/**/                   0x3D2B50A4, 0xBB11EF55,
/**/                   0x3F1B80BD, 0x1513F0E9,
/**/                   0xBF1B805E, 0x8A000000,
/**/                   0x3D33ACA6, 0xC6D142BF,
/**/                   0x3F1B00B6, 0x44CE5071,
/**/                   0xBF1B005B, 0x22000000,
/**/                   0x3D3979F8, 0xF8CD3D11,
/**/                   0x3F1A80AF, 0x948B381A,
/**/                   0xBF1A8057, 0xCA000000,
/**/                   0x3D3F1149, 0x07EDFD29,
/**/                   0x3F1A00A9, 0x044A9BE5,
/**/                   0xBF1A0054, 0x81000000,
/**/                   0xBD3B8C68, 0xF7BB7092,
/**/                   0x3F1980A2, 0x940C6FCF,
/**/                   0xBF198051, 0x49000000,
/**/                   0xBD365E1C, 0xF27E09A9,
/**/                   0x3F19009C, 0x43D0A7D8,
/**/                   0xBF19004E, 0x21000000,
/**/                   0xBD3162D2, 0xD508D564,
/**/                   0x3F188096, 0x139737FE,
/**/                   0xBF18804B, 0x09000000,
/**/                   0xBD293315, 0x18D5C93E,
/**/                   0x3F180090, 0x03601440,
/**/                   0xBF180048, 0x01000000,
/**/                   0xBD200288, 0x0C26A328,
/**/                   0x3F17808A, 0x132B309E,
/**/                   0xBF178045, 0x09000000,
/**/                   0xBD0CC7F9, 0x7E89FD6F,
/**/                   0x3F170084, 0x42F88115,
/**/                   0xBF170042, 0x21000000,
/**/                   0x3CE40881, 0x058494DC,
/**/                   0x3F16807E, 0x92C7F9A5,
/**/                   0xBF16803F, 0x49000000,
/**/                   0x3D12AE16, 0xCD5698B9,
/**/                   0x3F160079, 0x02998E4D,
/**/                   0xBF16003C, 0x81000000,
/**/                   0x3D21138B, 0xC5780E17,
/**/                   0x3F158073, 0x926D330B,
/**/                   0xBF158039, 0xC9000000,
/**/                   0x3D287809, 0x4E2001E2,
/**/                   0x3F15006E, 0x4242DBDF,
/**/                   0xBF150037, 0x21000000,
/**/                   0x3D2F8684, 0x21448AA2,
/**/                   0x3F148069, 0x121A7CC8,
/**/                   0xBF148034, 0x89000000,
/**/                   0x3D33207E, 0x2F637D8E,
/**/                   0x3F140064, 0x01F409C4,
/**/                   0xBF140032, 0x01000000,
/**/                   0x3D3654B9, 0x12E44B29,
/**/                   0x3F13805F, 0x11CF76D3,
/**/                   0xBF13802F, 0x89000000,
/**/                   0x3D3960F2, 0xCA5547F3,
/**/                   0x3F13005A, 0x41ACB7F4,
/**/                   0xBF13002D, 0x21000000,
/**/                   0x3D3C462B, 0x6487063D,
/**/                   0x3F128055, 0x918BC126,
/**/                   0xBF12802A, 0xC9000000,
/**/                   0x3D3F0562, 0xEFEA1107,
/**/                   0x3F120051, 0x016C8668,
/**/                   0xBF120028, 0x80000000,
/**/                   0xBD3E6066, 0x857113CE,
/**/                   0x3F11804C, 0x914EFBBA,
/**/                   0xBF118026, 0x48000000,
/**/                   0xBD3BEA30, 0xEDD9EB54,
/**/                   0x3F110048, 0x41331519,
/**/                   0xBF110024, 0x20000000,
/**/                   0xBD3996FC, 0x3BFFFF5A,
/**/                   0x3F108044, 0x1118C686,
/**/                   0xBF108022, 0x08000000,
/**/                   0xBD3765C8, 0x62F2E042,
/**/                   0x3F100040, 0x01000400,
/**/                   0xBF100020, 0x00000000,
/**/                   0xBD355595, 0x562224CD,
/**/                   0x3F0F0078, 0x21D1830C,
/**/                   0xBF0F003C, 0x10000000,
/**/                   0xBD336563, 0x095D69EB,
/**/                   0x3F0E0070, 0x81A5E62E,
/**/                   0xBF0E0038, 0x40000000,
/**/                   0xBD319431, 0x70D45290,
/**/                   0x3F0D0069, 0x217D1965,
/**/                   0xBF0D0034, 0x90000000,
/**/                   0xBD2FC201, 0x022D0EF6,
/**/                   0x3F0C0062, 0x015704B1,
/**/                   0xBF0C0031, 0x00000000,
/**/                   0xBD2C95A0, 0x5E276E21,
/**/                   0x3F0B005B, 0x2133900E,
/**/                   0xBF0B002D, 0x90000000,
/**/                   0xBD29A140, 0xE0372A42,
/**/                   0x3F0A0054, 0x8112A37D,
/**/                   0xBF0A002A, 0x40000000,
/**/                   0xBD26E2E2, 0x73BBB580,
/**/                   0x3F09004E, 0x20F426FB,
/**/                   0xBF090027, 0x10000000,
/**/                   0xBD245885, 0x04D48C20,
/**/                   0x3F080048, 0x00D80288,
/**/                   0xBF080024, 0x00000000,
/**/                   0xBD220028, 0x80613426,
/**/                   0x3F070042, 0x20BE1E23,
/**/                   0xBF070021, 0x10000000,
/**/                   0xBD1FAF99, 0xA80279F3,
/**/                   0x3F06003C, 0x80A661CA,
/**/                   0xBF06001E, 0x40000000,
/**/                   0xBD1BBAE3, 0xDC287DFE,
/**/                   0x3F050037, 0x2090B57C,
/**/                   0xBF05001B, 0x90000000,
/**/                   0xBD181E2F, 0x7B73B67C,
/**/                   0x3F040032, 0x007D0139,
/**/                   0xBF040019, 0x00000000,
/**/                   0xBD14D57C, 0x65A375F8,
/**/                   0x3F03002D, 0x206B2CFF,
/**/                   0xBF030016, 0x90000000,
/**/                   0xBD11DCCA, 0x7BF71EC1,
/**/                   0x3F020028, 0x805B20CD,
/**/                   0xBF020014, 0x40000000,
/**/                   0xBD0E6033, 0x425C4447,
/**/                   0x3F010024, 0x204CC4A3,
/**/                   0xBF010012, 0x10000000,
/**/                   0xBD0996D3, 0x730FFF5C,
/**/                   0x3F000020, 0x00400080,
/**/                   0xBF000010, 0x00000000,
/**/                   0xBD055575, 0x558888DE,
/**/                   0x3EFE0038, 0x406978C6,
/**/                   0xBEFE001C, 0x20000000,
/**/                   0xBD019418, 0xB845146A,
/**/                   0x3EFC0031, 0x0055C096,
/**/                   0xBEFC0018, 0x80000000,
/**/                   0xBCFC957A, 0xD989DB3C,
/**/                   0x3EFA002A, 0x4044A870,
/**/                   0xBEFA0015, 0x20000000,
/**/                   0xBCF6E2C6, 0x8F0EED2F,
/**/                   0x3EF80024, 0x00360051,
/**/                   0xBEF80012, 0x00000000,
/**/                   0xBCF20014, 0x40184CEB,
/**/                   0x3EF6001E, 0x40299839,
/**/                   0xBEF6000F, 0x20000000,
/**/                   0xBCEBBAC7, 0x434A1F5C,
/**/                   0x3EF40019, 0x001F4027,
/**/                   0xBEF4000C, 0x80000000,
/**/                   0xBCE4D568, 0xDD68DD6A,
/**/                   0x3EF20014, 0x4016C81A,
/**/                   0xBEF2000A, 0x20000000,
/**/                   0xBCDE6019, 0xA11710FC,
/**/                   0x3EF00010, 0x00100010,
/**/                   0xBEF00008, 0x00000000,
/**/                   0xBCD55565, 0x5562222D,
/**/                   0x3EEC0018, 0x80157013,
/**/                   0xBEEC000C, 0x40000000,
/**/                   0xBCCC9568, 0x176276C5,
/**/                   0x3EE80012, 0x000D800A,
/**/                   0xBEE80009, 0x00000000,
/**/                   0xBCC2000A, 0x20061337,
/**/                   0x3EE4000C, 0x8007D005,
/**/                   0xBEE40006, 0x40000000,
/**/                   0xBCB4D55F, 0x195A3758,
/**/                   0x3EE00008, 0x00040002,
/**/                   0xBEE00004, 0x00000000,
/**/                   0xBCA5555D, 0x5558888A,
/**/                   0x3ED80009, 0x00036001,
/**/                   0xBED80004, 0x80000000,
/**/                   0xBC920005, 0x100184CD,
/**/                   0x3ED00004, 0x00010000,
/**/                   0xBED00002, 0x00000000,
/**/                   0xBC755559, 0x55562222,
/**/                   0x3EC00002, 0x00004000,
/**/                   0xBEC00001, 0x00000000,
/**/                   0xBC455557, 0x55558889,
/**/                   0x00000000, 0x00000000,
/**/                   0x00000000, 0x00000000,
/**/                   0x00000000, 0x00000000,
/**/                   0xBEBFFFFC, 0x00008000,
/**/                   0x3EBFFFFE, 0x00000000,
/**/                   0x3C455553, 0x55558889,
/**/                   0xBECFFFF8, 0x00020000,
/**/                   0x3ECFFFFC, 0x00000000,
/**/                   0x3C755551, 0x55562222,
/**/                   0xBED7FFF7, 0x00035FFF,
/**/                   0x3ED7FFFB, 0x80000000,
/**/                   0x3C91FFFA, 0xF00184CC,
/**/                   0xBEDFFFF0, 0x0007FFFC,
/**/                   0x3EDFFFF8, 0x00000000,
/**/                   0x3CA5554D, 0x55588887,
/**/                   0xBEE3FFF3, 0x8007CFFB,
/**/                   0x3EE3FFF9, 0xC0000000,
/**/                   0x3CB4D54B, 0x915A3753,
/**/                   0xBEE7FFEE, 0x000D7FF6,
/**/                   0x3EE7FFF7, 0x00000000,
/**/                   0x3CC1FFF5, 0xE006132F,
/**/                   0xBEEBFFE7, 0x80156FED,
/**/                   0x3EEBFFF3, 0xC0000000,
/**/                   0x3CCC9542, 0x936276B2,
/**/                   0xBEEFFFE0, 0x001FFFE0,
/**/                   0x3EEFFFF0, 0x00000000,
/**/                   0x3CD55545, 0x55622217,
/**/                   0xBEF1FFEB, 0xC016C7E6,
/**/                   0x3EF1FFF5, 0xE0000000,
/**/                   0x3CDE5FE6, 0x5F1710D1,
/**/                   0xBEF3FFE7, 0x001F3FD9,
/**/                   0x3EF3FFF3, 0x80000000,
/**/                   0x3CE4D541, 0xCD68DD41,
/**/                   0xBEF5FFE1, 0xC02997C7,
/**/                   0x3EF5FFF0, 0xE0000000,
/**/                   0x3CEBBA8E, 0x124A1F13,
/**/                   0xBEF7FFDC, 0x0035FFAF,
/**/                   0x3EF7FFEE, 0x00000000,
/**/                   0x3CF1FFEB, 0xC0184CAE,
/**/                   0xBEF9FFD5, 0xC044A790,
/**/                   0x3EF9FFEA, 0xE0000000,
/**/                   0x3CF6E28E, 0xC68EECCD,
/**/                   0xBEFBFFCF, 0x0055BF6A,
/**/                   0x3EFBFFE7, 0x80000000,
/**/                   0x3CFC952F, 0xD189DAA2,
/**/                   0xBEFDFFC7, 0xC069773A,
/**/                   0x3EFDFFE3, 0xE0000000,
/**/                   0x3D0193E7, 0x480513F6,
/**/                   0xBEFFFFC0, 0x007FFF00,
/**/                   0x3EFFFFE0, 0x00000000,
/**/                   0x3D055535, 0x55888833,
/**/                   0xBF00FFDB, 0xE04CC35D,
/**/                   0x3F00FFED, 0xF0000000,
/**/                   0x3D099681, 0xE2CFFE66,
/**/                   0xBF01FFD7, 0x805B1F33,
/**/                   0x3F01FFEB, 0xC0000000,
/**/                   0x3D0E5FCC, 0xBE5C42ED,
/**/                   0xBF02FFD2, 0xE06B2B01,
/**/                   0x3F02FFE9, 0x70000000,
/**/                   0x3D11DC8A, 0xD9D71DD1,
/**/                   0xBF03FFCE, 0x007CFEC8,
/**/                   0x3F03FFE7, 0x00000000,
/**/                   0x3D14D52E, 0x45A374B3,
/**/                   0xBF04FFC8, 0xE090B284,
/**/                   0x3F04FFE4, 0x70000000,
/**/                   0x3D181DD0, 0x8553B4C7,
/**/                   0xBF05FFC3, 0x80A65E36,
/**/                   0x3F05FFE1, 0xC0000000,
/**/                   0x3D1BBA71, 0x7A287BBE,
/**/                   0xBF06FFBD, 0xE0BE19DD,
/**/                   0x3F06FFDE, 0xF0000000,
/**/                   0x3D1FAF11, 0x03E27702,
/**/                   0xBF07FFB8, 0x00D7FD78,
/**/                   0x3F07FFDC, 0x00000000,
/**/                   0x3D21FFD7, 0x80613240,
/**/                   0xBF08FFB1, 0xE0F42105,
/**/                   0x3F08FFD8, 0xF0000000,
/**/                   0x3D245825, 0xA6C489B3,
/**/                   0xBF09FFAB, 0x81129C84,
/**/                   0x3F09FFD5, 0xC0000000,
/**/                   0x3D26E272, 0xE2BBB26F,
/**/                   0xBF0AFFA4, 0xE13387F2,
/**/                   0x3F0AFFD2, 0x70000000,
/**/                   0x3D29A0BF, 0x21272669,
/**/                   0xBF0BFF9E, 0x0156FB50,
/**/                   0x3F0BFFCF, 0x00000000,
/**/                   0x3D2C950A, 0x4E276957,
/**/                   0xBF0CFF96, 0xE17D0E9B,
/**/                   0x3F0CFFCB, 0x70000000,
/**/                   0x3D2FC154, 0x551D090E,
/**/                   0xBF0DFF8F, 0x81A5D9D2,
/**/                   0x3F0DFFC7, 0xC0000000,
/**/                   0x3D3193CE, 0x90544EF1,
/**/                   0xBF0EFF87, 0xE1D174F4,
/**/                   0x3F0EFFC3, 0xF0000000,
/**/                   0x3D3364F2, 0x4D556583,
/**/                   0xBF0FFF80, 0x01FFF800,
/**/                   0x3F0FFFC0, 0x00000000,
/**/                   0x3D355515, 0x56221F78,
/**/                   0xBF107FBB, 0xF118BD7A,
/**/                   0x3F107FDD, 0xF8000000,
/**/                   0x3D376537, 0x9EEAD9D8,
/**/                   0xBF10FFB7, 0xC1330AE7,
/**/                   0x3F10FFDB, 0xE0000000,
/**/                   0x3D399659, 0x1B7FF7AE,
/**/                   0xBF117FB3, 0x714EF047,
/**/                   0x3F117FD9, 0xB8000000,
/**/                   0x3D3BE979, 0xBF51E233,
/**/                   0xBF11FFAF, 0x016C7998,
/**/                   0x3F11FFD7, 0x80000000,
/**/                   0x3D3E5F99, 0x7D7108FF,
/**/                   0xBF127FAA, 0x718BB2DA,
/**/                   0x3F127FD5, 0x39000000,
/**/                   0xBD3F0647, 0xB7721DC6,
/**/                   0xBF12FFA5, 0xC1ACA80C,
/**/                   0x3F12FFD2, 0xE1000000,
/**/                   0xBD3C4729, 0xED071532,
/**/                   0xBF137FA0, 0xF1CF652D,
/**/                   0x3F137FD0, 0x79000000,
/**/                   0xBD39620D, 0x315D596D,
/**/                   0xBF13FF9C, 0x01F3F63C,
/**/                   0x3F13FFCE, 0x01000000,
/**/                   0xBD3655F1, 0x92E45F81,
/**/                   0xBF147F96, 0xF21A6739,
/**/                   0x3F147FCB, 0x79000000,
/**/                   0xBD3321D7, 0x206B9526,
/**/                   0xBF14FF91, 0xC242C421,
/**/                   0x3F14FFC8, 0xE1000000,
/**/                   0xBD2F897B, 0xD244C12A,
/**/                   0xBF157F8C, 0x726D18F6,
/**/                   0x3F157FC6, 0x39000000,
/**/                   0xBD287B4B, 0xF93040AE,
/**/                   0xBF15FF87, 0x029971B4,
/**/                   0x3F15FFC3, 0x81000000,
/**/                   0xBD21171E, 0xD578562C,
/**/                   0xBF167F81, 0x72C7DA5C,
/**/                   0x3F167FC0, 0xB9000000,
/**/                   0xBD12B5E9, 0x0F773DB4,
/**/                   0xBF16FF7B, 0xC2F85EEC,
/**/                   0x3F16FFBD, 0xE1000000,
/**/                   0xBCE44CD3, 0x158A76C2,
/**/                   0xBF177F75, 0xF32B0B63,
/**/                   0x3F177FBA, 0xF9000000,
/**/                   0x3D0CB55C, 0x2E48511B,
/**/                   0xBF17FF70, 0x035FEBC0,
/**/                   0x3F17FFB8, 0x01000000,
/**/                   0x3D1FFAF0, 0x184C534F,
/**/                   0xBF187F69, 0xF3970C03,
/**/                   0x3F187FB4, 0xF9000000,
/**/                   0x3D292D95, 0xACC53FBE,
/**/                   0xBF18FF63, 0xC3D07829,
/**/                   0x3F18FFB1, 0xE1000000,
/**/                   0x3D315FD7, 0xE48887C8,
/**/                   0xBF197F5D, 0x740C3C32,
/**/                   0x3F197FAE, 0xB9000000,
/**/                   0x3D365AE3, 0x1DF5B242,
/**/                   0xBF19FF57, 0x044A641C,
/**/                   0x3F19FFAB, 0x81000000,
/**/                   0x3D3B88EC, 0x6FBB0E5F,
/**/                   0xBF1A7F50, 0x748AFBE7,
/**/                   0x3F1A7FA8, 0x3A000000,
/**/                   0xBD3F150C, 0x39766B40,
/**/                   0xBF1AFF49, 0xC4CE0F91,
/**/                   0x3F1AFFA4, 0xE2000000,
/**/                   0xBD397E06, 0xF14DB839,
/**/                   0xBF1B7F42, 0xF513AB19,
/**/                   0x3F1B7FA1, 0x7A000000,
/**/                   0xBD33B103, 0xCBD9CC3D,
/**/                   0xBF1BFF3C, 0x055BDA7D,
/**/                   0x3F1BFF9E, 0x02000000,
/**/                   0xBD2B5A05, 0xBB1321B5,
/**/                   0xBF1C7F34, 0xF5A6A9BD,
/**/                   0x3F1C7F9A, 0x7A000000,
/**/                   0xBD1DC410, 0xECAF9551,
/**/                   0xBF1CFF2D, 0xC5F424D6,
/**/                   0x3F1CFF96, 0xE2000000,
/**/                   0xBCEF80FF, 0x3DF3CD68,
/**/                   0xBF1D7F26, 0x764457C8,
/**/                   0x3F1D7F93, 0x3A000000,
/**/                   0x3D16CBC7, 0x4271E737,
/**/                   0xBF1DFF1F, 0x06974E91,
/**/                   0x3F1DFF8F, 0x82000000,
/**/                   0x3D2939D2, 0x1D134848,
/**/                   0xBF1E7F17, 0x76ED1530,
/**/                   0x3F1E7F8B, 0xBA000000,
/**/                   0x3D33C2DD, 0xA9892C73,
/**/                   0xBF1EFF0F, 0xC745B7A4,
/**/                   0x3F1EFF87, 0xE2000000,
/**/                   0x3D3B25CF, 0x8AEC69D5,
/**/                   0xBF1F7F07, 0xF7A141EA,
/**/                   0x3F1F7F83, 0xFB000000,
/**/                   0xBD3D3941, 0x645B412A,
/**/                   0xBF1FFF00, 0x07FFC002,
/**/                   0x3F1FFF80, 0x03000000,
/**/                   0xBD355955, 0x3BBC6662,
/**/                   0xBF203F7B, 0xFC309EF5,
/**/                   0x3F203FBD, 0xFD800000,
/**/                   0xBD2A72D8, 0x260B17B3,
/**/                   0xBF207F77, 0xE462E3D0,
/**/                   0x3F207FBB, 0xF1800000,
/**/                   0xBD136218, 0x0994AE68,
/**/                   0xBF20BF73, 0xBC96B492,
/**/                   0x3F20BFB9, 0xDD800000,
/**/                   0x3D0E52E6, 0xECB2641F,
/**/                   0xBF20FF6F, 0x84CC1739,
/**/                   0x3F20FFB7, 0xC1800000,
/**/                   0x3D296078, 0xE7FCF60B,
/**/                   0xBF213F6B, 0x3D0311C6,
/**/                   0x3F213FB5, 0x9D800000,
/**/                   0x3D35DA18, 0xA7850AFF,
/**/                   0xBF217F66, 0xE53BAA36,
/**/                   0x3F217FB3, 0x71800000,
/**/                   0x3D3F48F1, 0x5E7BB444,
/**/                   0xBF21BF62, 0x7D75E68A,
/**/                   0x3F21BFB1, 0x3E000000,
/**/                   0xBD370239, 0x812BC469,
/**/                   0xBF21FF5E, 0x05B1CCC0,
/**/                   0x3F21FFAF, 0x02000000,
/**/                   0xBD2A0CD0, 0x23BF1A4D,
/**/                   0xBF223F59, 0x7DEF62D8,
/**/                   0x3F223FAC, 0xBE000000,
/**/                   0xBD0614D3, 0x736E3623,
/**/                   0xBF227F54, 0xE62EAED0,
/**/                   0x3F227FAA, 0x72000000,
/**/                   0x3D1F28BD, 0x37EDEDB0,
/**/                   0xBF22BF50, 0x3E6FB6A9,
/**/                   0x3F22BFA8, 0x1E000000,
/**/                   0x3D32A0F5, 0x07CE33C8,
/**/                   0xBF22FF4B, 0x86B28060,
/**/                   0x3F22FFA5, 0xC2000000,
/**/                   0x3D3DC2B6, 0xA31C6A8D,
/**/                   0xBF233F46, 0xBEF711F6,
/**/                   0x3F233FA3, 0x5E800000,
/**/                   0xBD36CF8B, 0xFC67C9FB,
/**/                   0xBF237F41, 0xE73D7169,
/**/                   0x3F237FA0, 0xF2800000,
/**/                   0xBD2629A5, 0xE6D88A89,
/**/                   0xBF23BF3C, 0xFF85A4B8,
/**/                   0x3F23BF9E, 0x7E800000,
/**/                   0x3CEE7C34, 0x202574EC,
/**/                   0xBF23FF38, 0x07CFB1E3,
/**/                   0x3F23FF9C, 0x02800000,
/**/                   0x3D2A9723, 0x46E594C1,
/**/                   0xBF243F33, 0x001B9EE8,
/**/                   0x3F243F99, 0x7E800000,
/**/                   0x3D39F33C, 0xF61AE74C,
/**/                   0xBF247F2D, 0xE86971C7,
/**/                   0x3F247F96, 0xF3000000,
/**/                   0xBD39141C, 0x85341E31,
/**/                   0xBF24BF28, 0xC0B9307F,
/**/                   0x3F24BF94, 0x5F000000,
/**/                   0xBD2792F5, 0xDA0FAF09,
/**/                   0xBF24FF23, 0x890AE10E,
/**/                   0x3F24FF91, 0xC3000000,
/**/                   0x3CFD4219, 0xFB239430,
/**/                   0xBF253F1E, 0x415E8974,
/**/                   0x3F253F8F, 0x1F000000,
/**/                   0x3D2F8B72, 0x0359434A,
/**/                   0xBF257F18, 0xE9B42FAF,
/**/                   0x3F257F8C, 0x73000000,
/**/                   0x3D3E0C4B, 0x1939FEDF,
/**/                   0xBF25BF13, 0x820BD9BF,
/**/                   0x3F25BF89, 0xBF800000,
/**/                   0xBD335728, 0x39B301E2,
/**/                   0xBF25FF0E, 0x0A658DA3,
/**/                   0x3F25FF87, 0x03800000,
/**/                   0xBD118E84, 0x5E1E8D4F,
/**/                   0xBF263F08, 0x82C15159,
/**/                   0x3F263F84, 0x3F800000,
/**/                   0x3D25CFC0, 0xBDDDD045,
/**/                   0xBF267F02, 0xEB1F2AE1,
/**/                   0x3F267F81, 0x73800000,
/**/                   0x3D3A8C5C, 0x08837E99,
/**/                   0xBF26BEFD, 0x437F203A,
/**/                   0x3F26BF7E, 0xA0000000,
/**/                   0xBD35752E, 0x3C56F12D,
/**/                   0xBF26FEF7, 0x8BE13762,
/**/                   0x3F26FF7B, 0xC4000000,
/**/                   0xBD146EFA, 0x46359E28,
/**/                   0xBF273EF1, 0xC4457659,
/**/                   0x3F273F78, 0xE0000000,
/**/                   0x3D273355, 0xCD265865,
/**/                   0xBF277EEB, 0xECABE31C,
/**/                   0x3F277F75, 0xF4000000,
/**/                   0x3D3CAC0E, 0x095DEBF8,
/**/                   0xBF27BEE6, 0x051483AC,
/**/                   0x3F27BF73, 0x00800000,
/**/                   0xBD31E395, 0x4C39F4DB,
/**/                   0xBF27FEE0, 0x0D7F5E08,
/**/                   0x3F27FF70, 0x04800000,
/**/                   0xBCB43F3D, 0xA1314B81,
/**/                   0xBF283EDA, 0x05EC782D,
/**/                   0x3F283F6D, 0x00800000,
/**/                   0x3D321B10, 0x115B8D70,
/**/                   0xBF287ED3, 0xEE5BD81B,
/**/                   0x3F287F69, 0xF5000000,
/**/                   0xBD3B54A7, 0x83704FE1,
/**/                   0xBF28BECD, 0xC6CD83D1,
/**/                   0x3F28BF66, 0xE1000000,
/**/                   0xBD20C4CC, 0x41229C91,
/**/                   0xBF28FEC7, 0x8F41814D,
/**/                   0x3F28FF63, 0xC5000000,
/**/                   0x3D25E5A8, 0x2A183F17,
/**/                   0xBF293EC1, 0x47B7D68F,
/**/                   0x3F293F60, 0xA1000000,
/**/                   0x3D3EAC06, 0xF81B997D,
/**/                   0xBF297EBA, 0xF0308995,
/**/                   0x3F297F5D, 0x75800000,
/**/                   0xBD2A6B9B, 0x3A1E5BAD,
/**/                   0xBF29BEB4, 0x88ABA05E,
/**/                   0x3F29BF5A, 0x41800000,
/**/                   0x3D1D3958, 0xBDFE3C77,
/**/                   0xBF29FEAE, 0x112920E9,
/**/                   0x3F29FF57, 0x05800000,
/**/                   0x3D3C3972, 0x375BA904,
/**/                   0xBF2A3EA7, 0x89A91135,
/**/                   0x3F2A3F53, 0xC2000000,
/**/                   0xBD2CE6F3, 0x588DE85B,
/**/                   0xBF2A7EA0, 0xF22B7740,
/**/                   0x3F2A7F50, 0x76000000,
/**/                   0x3D1D2249, 0x75AEDBFD,
/**/                   0xBF2ABE9A, 0x4AB05909,
/**/                   0x3F2ABF4D, 0x22000000,
/**/                   0x3D3D6E96, 0x2CE7BDAC,
/**/                   0xBF2AFE93, 0x9337BC90,
/**/                   0x3F2AFF49, 0xC6800000,
/**/                   0xBD2800DC, 0xCB7D724C,
/**/                   0xBF2B3E8C, 0xCBC1A7D1,
/**/                   0x3F2B3F46, 0x62800000,
/**/                   0x3D25F908, 0xFA591B29,
/**/                   0xBF2B7E85, 0xF44E20CE,
/**/                   0x3F2B7F42, 0xF7000000,
/**/                   0xBD3D9991, 0x53021ED8,
/**/                   0xBF2BBE7F, 0x0CDD2D83,
/**/                   0x3F2BBF3F, 0x83000000,
/**/                   0xBD1706BF, 0xFD596AD6,
/**/                   0xBF2BFE78, 0x156ED3F0,
/**/                   0x3F2BFF3C, 0x07000000,
/**/                   0x3D328528, 0x4EC45253,
/**/                   0xBF2C3E71, 0x0E031A14,
/**/                   0x3F2C3F38, 0x83800000,
/**/                   0xBD34C408, 0x927D8A9E,
/**/                   0xBF2C7E69, 0xF69A05ED,
/**/                   0x3F2C7F34, 0xF7800000,
/**/                   0x3D118EF4, 0xCAE2C25F,
/**/                   0xBF2CBE62, 0xCF339D7A,
/**/                   0x3F2CBF31, 0x63800000,
/**/                   0x3D3DFD79, 0x73DBBB41,
/**/                   0xBF2CFE5B, 0x97CFE6B9,
/**/                   0x3F2CFF2D, 0xC8000000,
/**/                   0xBD1FD74F, 0xE7FE77E6,
/**/                   0xBF2D3E54, 0x506EE7AA,
/**/                   0x3F2D3F2A, 0x24000000,
/**/                   0x3D328AD4, 0xBDDB871F,
/**/                   0xBF2D7E4C, 0xF910A64A,
/**/                   0x3F2D7F26, 0x78800000,
/**/                   0xBD327F8C, 0x903DDD81,
/**/                   0xBF2DBE45, 0x91B52899,
/**/                   0x3F2DBF22, 0xC4800000,
/**/                   0x3D21D80F, 0xDF52840A,
/**/                   0xBF2DFE3E, 0x1A5C7495,
/**/                   0x3F2DFF1F, 0x09000000,
/**/                   0xBD3B316D, 0xEED9F651,
/**/                   0xBF2E3E36, 0x9306903D,
/**/                   0x3F2E3F1B, 0x45000000,
/**/                   0x3CF2911A, 0x76DB3C6B,
/**/                   0xBF2E7E2E, 0xFBB3818F,
/**/                   0x3F2E7F17, 0x79000000,
/**/                   0x3D3DFC86, 0x85559113,
/**/                   0xBF2EBE27, 0x54634E89,
/**/                   0x3F2EBF13, 0xA5800000,
/**/                   0xBD12D83E, 0x0AB3DBE7,
/**/                   0xBF2EFE1F, 0x9D15FD2B,
/**/                   0x3F2EFF0F, 0xC9800000,
/**/                   0x3D39124F, 0x617B99F1,
/**/                   0xBF2F3E17, 0xD5CB9373,
/**/                   0x3F2F3F0B, 0xE6000000,
/**/                   0xBD2152B9, 0xF8F64DA1,
/**/                   0xBF2F7E0F, 0xFE841760,
/**/                   0x3F2F7F07, 0xFA000000,
/**/                   0x3D3617EB, 0x34C4735B,
/**/                   0xBF2FBE08, 0x173F8EEF,
/**/                   0x3F2FBF04, 0x06800000,
/**/                   0xBD2551B0, 0x739FA712,
/**/                   0xBF2FFE00, 0x1FFE0020,
/**/                   0x3F2FFF00, 0x0A800000,
/**/                   0x3D351558, 0x885DE027,
/**/                   0xBF301EFC, 0x0C5FB879,
/**/                   0x3F301F7E, 0x03800000,
/**/                   0xBD255905, 0x68F8FC50,
/**/                   0xBF303EF8, 0x00C1F3B0,
/**/                   0x3F303F7B, 0xFD800000,
/**/                   0x3D361295, 0xDF771CF4,
/**/                   0xBF305EF3, 0xED25B4B7,
/**/                   0x3F305F79, 0xF3C00000,
/**/                   0xBD2158BB, 0xD8A255DB,
/**/                   0xBF307EEF, 0xD18AFE8B,
/**/                   0x3F307F77, 0xE5C00000,
/**/                   0x3D3917A1, 0xB740E625,
/**/                   0xBF309EEB, 0xADF1D42C,
/**/                   0x3F309F75, 0xD4000000,
/**/                   0xBD1281AD, 0x9C716D59,
/**/                   0xBF30BEE7, 0x825A3899,
/**/                   0x3F30BF73, 0xBE000000,
/**/                   0x3D3E2C7A, 0x86ED7DDC,
/**/                   0xBF30DEE3, 0x4EC42ED1,
/**/                   0x3F30DF71, 0xA4400000,
/**/                   0x3CF7F534, 0xF54F7E28,
/**/                   0xBF30FEDF, 0x132FB9D5,
/**/                   0x3F30FF6F, 0x86800000,
/**/                   0xBD3AA6E1, 0x404F4E01,
/**/                   0xBF311EDA, 0xCF9CDCA2,
/**/                   0x3F311F6D, 0x64800000,
/**/                   0x3D2375B9, 0x4A6EC981,
/**/                   0xBF313ED6, 0x840B9A38,
/**/                   0x3F313F6B, 0x3EC00000,
/**/                   0xBD315A73, 0x33401DD0,
/**/                   0xBF315ED2, 0x307BF596,
/**/                   0x3F315F69, 0x14C00000,
/**/                   0x3D341A2F, 0x02C11605,
/**/                   0xBF317ECD, 0xD4EDF1BC,
/**/                   0x3F317F66, 0xE7000000,
/**/                   0xBD1798F3, 0xB2B7E8C5,
/**/                   0xBF319EC9, 0x716191A8,
/**/                   0x3F319F64, 0xB5400000,
/**/                   0xBD3F5AB7, 0x35D62ED5,
/**/                   0xBF31BEC5, 0x05D6D85A,
/**/                   0x3F31BF62, 0x7F400000,
/**/                   0x3D1EF6FF, 0xCA7EC7CD,
/**/                   0xBF31DEC0, 0x924DC8D2,
/**/                   0x3F31DF60, 0x45800000,
/**/                   0xBD309BD7, 0xA8550396,
/**/                   0xBF31FEBC, 0x16C6660D,
/**/                   0x3F31FF5E, 0x07800000,
/**/                   0x3D379981, 0xC3E31F70,
/**/                   0xBF321EB7, 0x9340B30B,
/**/                   0x3F321F5B, 0xC5C00000,
/**/                   0x3CD7B300, 0x5FE92B94,
/**/                   0xBF323EB3, 0x07BCB2CC,
/**/                   0x3F323F59, 0x80000000,
/**/                   0xBD364AF9, 0x25A7CF34,
/**/                   0xBF325EAE, 0x743A684F,
/**/                   0x3F325F57, 0x36000000,
/**/                   0x3D339D32, 0x17E48399,
/**/                   0xBF327EA9, 0xD8B9D692,
/**/                   0x3F327F54, 0xE8400000,
/**/                   0xBCFE7B27, 0xCC387BD1,
/**/                   0xBF329EA5, 0x353B0095,
/**/                   0x3F329F52, 0x96800000,
/**/                   0xBD36D8A7, 0x1AE7FA80,
/**/                   0xBF32BEA0, 0x89BDE957,
/**/                   0x3F32BF50, 0x40800000,
/**/                   0x3D34CB54, 0x05CF3DC3,
/**/                   0xBF32DE9B, 0xD64293D7,
/**/                   0x3F32DF4D, 0xE6C00000,
/**/                   0x3CF053EA, 0xD5A4F691,
/**/                   0xBF32FE97, 0x1AC90315,
/**/                   0x3F32FF4B, 0x89000000,
/**/                   0xBD3229E7, 0x5CAE7B16,
/**/                   0xBF331E92, 0x57513A0F,
/**/                   0x3F331F49, 0x27000000,
/**/                   0x3D3B3EE1, 0xAEED4509,
/**/                   0xBF333E8D, 0x8BDB3BC4,
/**/                   0x3F333F46, 0xC1400000,
/**/                   0x3D228133, 0x2E0C2605,
/**/                   0xBF335E88, 0xB8670B34,
/**/                   0x3F335F44, 0x57800000,
/**/                   0xBD20477F, 0xBBD6E280,
/**/                   0xBF337E83, 0xDCF4AB5D,
/**/                   0x3F337F41, 0xE9C00000,
/**/                   0xBD38ED2A, 0xE9CE8AFC,
/**/                   0xBF339E7E, 0xF9841F3F,
/**/                   0x3F339F3F, 0x77C00000,
/**/                   0x3D36E558, 0x39159F9B,
/**/                   0xBF33BE7A, 0x0E1569D9,
/**/                   0x3F33BF3D, 0x02000000,
/**/                   0x3D1D5325, 0x40681634,
/**/                   0xBF33DE75, 0x1AA88E2A,
/**/                   0x3F33DF3A, 0x88400000,
/**/                   0xBD1E775F, 0x7F2112CE,
/**/                   0xBF33FE70, 0x1F3D8F31,
/**/                   0x3F33FF38, 0x0A800000,
/**/                   0xBD35F18B, 0x91F80D1B,
/**/                   0xBF341E6B, 0x1BD46FED,
/**/                   0x3F341F35, 0x88800000,
/**/                   0x3D3C5AAD, 0xFDC3FC2F,
/**/                   0xBF343E66, 0x106D335D,
/**/                   0x3F343F33, 0x02C00000,
/**/                   0x3D2E8FA9, 0x268A89F1,
/**/                   0xBF345E60, 0xFD07DC80,
/**/                   0x3F345F30, 0x79000000,
/**/                   0x3D06B73F, 0x902AC9EE,
/**/                   0xBF347E5B, 0xE1A46E55,
/**/                   0x3F347F2D, 0xEB400000,
/**/                   0xBD21EE30, 0x45C43959,
/**/                   0xBF349E56, 0xBE42EBDC,
/**/                   0x3F349F2B, 0x59800000,
/**/                   0xBD34212B, 0xE8B753E8,
/**/                   0xBF34BE51, 0x92E35813,
/**/                   0x3F34BF28, 0xC3C00000,
/**/                   0xBD3EA653, 0x9D2064DB,
/**/                   0xBF34DE4C, 0x5F85B5F9,
/**/                   0x3F34DF26, 0x29C00000,
/**/                   0x3D377A70, 0x81DCB6FB,
/**/                   0xBF34FE47, 0x242A088D,
/**/                   0x3F34FF23, 0x8C000000,
/**/                   0x3D2C8440, 0x6BB44A6D,
/**/                   0xBF351E41, 0xE0D052CF,
/**/                   0x3F351F20, 0xEA400000,
/**/                   0x3D16C6ED, 0x0048AAF8,
/**/                   0xBF353E3C, 0x957897BD,
/**/                   0x3F353F1E, 0x44800000,
/**/                   0xBD01ADF4, 0xF506A07E,
/**/                   0xBF355E37, 0x4222DA57,
/**/                   0x3F355F1B, 0x9AC00000,
/**/                   0xBD22E69B, 0x4B88A655,
/**/                   0xBF357E31, 0xE6CF1D9B,
/**/                   0x3F357F18, 0xED000000,
/**/                   0xBD3005F2, 0x153DAEB0,
/**/                   0xBF359E2C, 0x837D6488,
/**/                   0x3F359F16, 0x3B400000,
/**/                   0xBD35ECAC, 0x2D5222B4,
/**/                   0xBF35BE27, 0x182DB21E,
/**/                   0x3F35BF13, 0x85800000,
/**/                   0xBD3B267C, 0x2EA6CB14,
/**/                   0xBF35DE21, 0xA4E0095B,
/**/                   0x3F35DF10, 0xCBC00000,
/**/                   0xBD3FB262, 0x5A40A340,
/**/                   0xBF35FE1C, 0x29946D3F,
/**/                   0x3F35FF0E, 0x0DC00000,
/**/                   0x3D3C70A1, 0x0E7B79ED,
/**/                   0xBF361E16, 0xA64AE0C7,
/**/                   0x3F361F0B, 0x4C000000,
/**/                   0x3D39438D, 0xC9C8D263,
/**/                   0xBF363E11, 0x1B0366F4,
/**/                   0x3F363F08, 0x86400000,
/**/                   0x3D36C763, 0x9582CD0C,
/**/                   0xBF365E0B, 0x87BE02C5,
/**/                   0x3F365F05, 0xBC800000,
/**/                   0x3D34FD22, 0x2F24F1F9,
/**/                   0xBF367E05, 0xEC7AB737,
/**/                   0x3F367F02, 0xEEC00000,
/**/                   0x3D33E5C9, 0x53CAEA94,
/**/                   0xBF369E00, 0x4939874A,
/**/                   0x3F369F00, 0x1D000000,
/**/                   0x3D338258, 0xC03081D0,
/**/                   0xBF36BDFA, 0x9DFA75FE,
/**/                   0x3F36BEFD, 0x47400000,
/**/                   0x3D33D3D0, 0x30B1A458,
/**/                   0xBF36DDF4, 0xEABD8651,
/**/                   0x3F36DEFA, 0x6D800000,
/**/                   0x3D34DB2F, 0x614A60C1,
/**/                   0xBF36FDEF, 0x2F82BB41,
/**/                   0x3F36FEF7, 0x8FC00000,
/**/                   0x3D369976, 0x0D96E7B8,
/**/                   0xBF371DE9, 0x6C4A17CF,
/**/                   0x3F371EF4, 0xAE000000,
/**/                   0x3D390FA3, 0xF0D38C30,
/**/                   0xBF373DE3, 0xA1139EF8,
/**/                   0x3F373EF1, 0xC8400000,
/**/                   0x3D3C3EB8, 0xC5DCC397,
/**/                   0xBF375DDD, 0xCDDF53BC,
/**/                   0x3F375EEE, 0xDEC00000,
/**/                   0xBD3FD84B, 0xB8D0D9FD,
/**/                   0xBF377DD7, 0xF2AD3919,
/**/                   0x3F377EEB, 0xF1000000,
/**/                   0xBD3B3469, 0xD11891A0,
/**/                   0xBF379DD2, 0x0F7D520F,
/**/                   0x3F379EE8, 0xFF400000,
/**/                   0xBD35D4A1, 0xC93D855B,
/**/                   0xBF37BDCC, 0x244FA19D,
/**/                   0x3F37BEE6, 0x09800000,
/**/                   0xBD2F6FE7, 0xCFC56806,
/**/                   0xBF37DDC6, 0x31242AC1,
/**/                   0x3F37DEE3, 0x0FC00000,
/**/                   0xBD21BAC0, 0xE815F202,
/**/                   0xBF37FDC0, 0x35FAF079,
/**/                   0x3F37FEE0, 0x12000000,
/**/                   0xBCF43E7B, 0x5190C28B,
/**/                   0xBF381DBA, 0x32D3F5C6,
/**/                   0x3F381EDD, 0x10400000,
/**/                   0x3D1C55D8, 0x34C1F9E9,
/**/                   0xBF383DB4, 0x27AF3DA6,
/**/                   0x3F383EDA, 0x0A800000,
/**/                   0x3D302FB8, 0x8AAF36D4,
/**/                   0xBF385DAE, 0x148CCB18,
/**/                   0x3F385ED7, 0x00C00000,
/**/                   0x3D3A0BDF, 0x7AE0D0F8,
/**/                   0xBF387DA7, 0xF96CA11B,
/**/                   0x3F387ED3, 0xF3400000,
/**/                   0xBD3B5515, 0x6B1CDAAF,
/**/                   0xBF389DA1, 0xD64EC2AD,
/**/                   0x3F389ED0, 0xE1800000,
/**/                   0xBD2FE44C, 0xE1179E5E,
/**/                   0xBF38BD9B, 0xAB3332CD,
/**/                   0x3F38BECD, 0xCBC00000,
/**/                   0xBD0E529E, 0xF86F56EC,
/**/                   0xBF38DD95, 0x7819F47A,
/**/                   0x3F38DECA, 0xB2000000,
/**/                   0x3D2246C3, 0xFEB631AB,
/**/                   0xBF38FD8F, 0x3D030AB4,
/**/                   0x3F38FEC7, 0x94400000,
/**/                   0x3D36D7FA, 0xE04DA791,
/**/                   0xBF391D88, 0xF9EE7878,
/**/                   0x3F391EC4, 0x72C00000,
/**/                   0xBD3AAB89, 0x86F7ADBB,
/**/                   0xBF393D82, 0xAEDC40C7,
/**/                   0x3F393EC1, 0x4D000000,
/**/                   0xBD26CC57, 0x032C6155,
/**/                   0xBF395D7C, 0x5BCC669D,
/**/                   0x3F395EBE, 0x23400000,
/**/                   0x3D12A452, 0x93C3EB3D,
/**/                   0xBF397D76, 0x00BEECFB,
/**/                   0x3F397EBA, 0xF5800000,
/**/                   0x3D358336, 0xA0BCD695,
/**/                   0xBF399D6F, 0x9DB3D6E0,
/**/                   0x3F399EB7, 0xC4000000,
/**/                   0xBD38D6C5, 0xDA737570,
/**/                   0xBF39BD69, 0x32AB2749,
/**/                   0x3F39BEB4, 0x8E400000,
/**/                   0xBD198F84, 0x65026C7D,
/**/                   0xBF39DD62, 0xBFA4E136,
/**/                   0x3F39DEB1, 0x54800000,
/**/                   0x3D29B9C9, 0x2EA9B41A,
/**/                   0xBF39FD5C, 0x44A107A5,
/**/                   0x3F39FEAE, 0x17000000,
/**/                   0xBD3F1375, 0x16137ACF,
/**/                   0xBF3A1D55, 0xC19F9D96,
/**/                   0x3F3A1EAA, 0xD5400000,
/**/                   0xBD2467DC, 0xDE73AFA0,
/**/                   0xBF3A3D4F, 0x36A0A607,
/**/                   0x3F3A3EA7, 0x8F800000,
/**/                   0x3D26F8F0, 0x7B8357C6,
/**/                   0xBF3A5D48, 0xA3A423F7,
/**/                   0x3F3A5EA4, 0x46000000,
/**/                   0xBD3E0141, 0x5DA0DFB7,
/**/                   0xBF3A7D42, 0x08AA1A64,
/**/                   0x3F3A7EA0, 0xF8400000,
/**/                   0xBD1AB06E, 0x41050D29,
/**/                   0xBF3A9D3B, 0x65B28C4E,
/**/                   0x3F3A9E9D, 0xA6800000,
/**/                   0x3D317CE9, 0x56A0E005,
/**/                   0xBF3ABD34, 0xBABD7CB3,
/**/                   0x3F3ABE9A, 0x51000000,
/**/                   0xBD358532, 0xF899EF39,
/**/                   0xBF3ADD2E, 0x07CAEE92,
/**/                   0x3F3ADE96, 0xF7400000,
/**/                   0x3D113A3C, 0xC83BF5C2,
/**/                   0xBF3AFD27, 0x4CDAE4EA,
/**/                   0x3F3AFE93, 0x99800000,
/**/                   0x3D3EF92F, 0x863C7C8E,
/**/                   0xBF3B1D20, 0x89ED62B9,
/**/                   0x3F3B1E90, 0x38000000,
/**/                   0xBD161149, 0x3341CC3C,
/**/                   0xBF3B3D19, 0xBF026AFE,
/**/                   0x3F3B3E8C, 0xD2400000,
/**/                   0x3D36D709, 0x67C955DF,
/**/                   0xBF3B5D12, 0xEC1A00B8,
/**/                   0x3F3B5E89, 0x68C00000,
/**/                   0xBD27E77B, 0x5AE9B17A,
/**/                   0xBF3B7D0C, 0x113426E6,
/**/                   0x3F3B7E85, 0xFB000000,
/**/                   0x3D321C58, 0x219679DE,
/**/                   0xBF3B9D05, 0x2E50E086,
/**/                   0x3F3B9E82, 0x89800000,
/**/                   0xBD2DEF6A, 0xFAA62113,
/**/                   0xBF3BBCFE, 0x43703097,
/**/                   0x3F3BBE7F, 0x13C00000,
/**/                   0x3D30D119, 0x23305306,
/**/                   0xBF3BDCF7, 0x50921A17,
/**/                   0x3F3BDE7B, 0x9A400000,
/**/                   0xBD2D1078, 0x9FBACE27,
/**/                   0xBF3BFCF0, 0x55B6A006,
/**/                   0x3F3BFE78, 0x1C800000,
/**/                   0x3D32FD49, 0xD625DF1E,
/**/                   0xBF3C1CE9, 0x52DDC563,
/**/                   0x3F3C1E74, 0x9B000000,
/**/                   0xBD253AA9, 0x7D07255B,
/**/                   0xBF3C3CE2, 0x48078D2B,
/**/                   0x3F3C3E71, 0x15400000,
/**/                   0x3D38A8E7, 0x9E08B538,
/**/                   0xBF3C5CDB, 0x3533FA5D,
/**/                   0x3F3C5E6D, 0x8BC00000,
/**/                   0xBD09780B, 0x45956AFC,
/**/                   0xBF3C7CD4, 0x1A630FF9,
/**/                   0x3F3C7E69, 0xFE400000,
/**/                   0xBD3E2410, 0x2792F44E,
/**/                   0xBF3C9CCC, 0xF794D0FC,
/**/                   0x3F3C9E66, 0x6C800000,
/**/                   0x3D1F2AEC, 0x30AB4456,
/**/                   0xBF3CBCC5, 0xCCC94066,
/**/                   0x3F3CBE62, 0xD7000000,
/**/                   0xBD3161A0, 0x231641D5,
/**/                   0xBF3CDCBE, 0x9A006135,
/**/                   0x3F3CDE5F, 0x3D400000,
/**/                   0x3D3657DD, 0xF4AD1934,
/**/                   0xBF3CFCB7, 0x5F3A3668,
/**/                   0x3F3CFE5B, 0x9FC00000,
/**/                   0xBCF07CB0, 0x2E7AC798,
/**/                   0xBF3D1CB0, 0x1C76C2FD,
/**/                   0x3F3D1E57, 0xFE400000,
/**/                   0xBD377F9B, 0x6090F643,
/**/                   0xBF3D3CA8, 0xD1B609F3,
/**/                   0x3F3D3E54, 0x58800000,
/**/                   0x3D32F16C, 0x849503E6,
/**/                   0xBF3D5CA1, 0x7EF80E49,
/**/                   0x3F3D5E50, 0xAF000000,
/**/                   0xBCFB3B3A, 0xAF1CA4EA,
/**/                   0xBF3D7C9A, 0x243CD2FE,
/**/                   0x3F3D7E4D, 0x01800000,
/**/                   0xBD356DFC, 0x4701415B,
/**/                   0xBF3D9C92, 0xC1845B0F,
/**/                   0x3F3D9E49, 0x4FC00000,
/**/                   0x3D37C392, 0x582AEA48,
/**/                   0xBF3DBC8B, 0x56CEA97C,
/**/                   0x3F3DBE45, 0x9A400000,
/**/                   0x3D1787DF, 0x67DCC15E,
/**/                   0xBF3DDC83, 0xE41BC143,
/**/                   0x3F3DDE41, 0xE0C00000,
/**/                   0xBD262398, 0x352F961F,
/**/                   0xBF3DFC7C, 0x696BA563,
/**/                   0x3F3DFE3E, 0x23400000,
/**/                   0xBD3B16B9, 0xDEDD373A,
/**/                   0xBF3E1C74, 0xE6BE58DA,
/**/                   0x3F3E1E3A, 0x61800000,
/**/                   0x3D35D42E, 0x336BE94B,
/**/                   0xBF3E3C6D, 0x5C13DEA7,
/**/                   0x3F3E3E36, 0x9C000000,
/**/                   0x3D1EBFAF, 0x08A303A2,
/**/                   0xBF3E5C65, 0xC96C39C9,
/**/                   0x3F3E5E32, 0xD2800000,
/**/                   0xBD160A06, 0x34856362,
/**/                   0xBF3E7C5E, 0x2EC76D3D,
/**/                   0x3F3E7E2F, 0x05000000,
/**/                   0xBD31C21A, 0x154CDF1A,
/**/                   0xBF3E9C56, 0x8C257C04,
/**/                   0x3F3E9E2B, 0x33800000,
/**/                   0xBD3D0DDE, 0x31941F7F,
/**/                   0xBF3EBC4E, 0xE186691B,
/**/                   0x3F3EBE27, 0x5DC00000,
/**/                   0x3D389B31, 0xC26EC60D,
/**/                   0xBF3EDC47, 0x2EEA3781,
/**/                   0x3F3EDE23, 0x84400000,
/**/                   0x3D2E742A, 0xD583BEF8,
/**/                   0xBF3EFC3F, 0x7450EA34,
/**/                   0x3F3EFE1F, 0xA6C00000,
/**/                   0x3D1B3F31, 0xAC2DA351,
/**/                   0xBF3F1C37, 0xB1BA8433,
/**/                   0x3F3F1E1B, 0xC5400000,
/**/                   0xBCE45533, 0x2DC67430,
/**/                   0xBF3F3C2F, 0xE727087C,
/**/                   0x3F3F3E17, 0xDFC00000,
/**/                   0xBD1C7133, 0xFF1174AE,
/**/                   0xBF3F5C28, 0x14967A0F,
/**/                   0x3F3F5E13, 0xF6400000,
/**/                   0xBD29383C, 0x4AE098DC,
/**/                   0xBF3F7C20, 0x3A08DBE9,
/**/                   0x3F3F7E10, 0x08C00000,
/**/                   0xBD31211D, 0x684B0B3B,
/**/                   0xBF3F9C18, 0x577E3109,
/**/                   0x3F3F9E0C, 0x17400000,
/**/                   0xBD34AA4B, 0x268D7464,
/**/                   0xBF3FBC10, 0x6CF67C6E,
/**/                   0x3F3FBE08, 0x21C00000,
/**/                   0xBD3736A7, 0xBED03388,
/**/                   0xBF3FDC08, 0x7A71C116,
/**/                   0x3F3FDE04, 0x28400000,
/**/                   0xBD38C533, 0x900BC4E5,
/**/                   0xBF3FFC00, 0x7FF00200,
/**/                   0x3F3FFE00, 0x2AC00000,
/**/                   0xBD3954EE, 0xF9987527,
/**/                   0xBF400DFC, 0x3EB8A115,
/**/                   0x3F400EFE, 0x14A00000,
/**/                   0xBD38E4DA, 0x5B2E613B,
/**/                   0xBF401DF8, 0x397AC249,
/**/                   0x3F401EFC, 0x11E00000,
/**/                   0xBD3773F6, 0x14E5761B,
/**/                   0xBF402DF4, 0x303E661C,
/**/                   0x3F402EFA, 0x0D200000,
/**/                   0xBD350142, 0x873570A0,
/**/                   0xBF403DF0, 0x23038E0C,
/**/                   0x3F403EF8, 0x06600000,
/**/                   0xBD318BC0, 0x12F5DD53,
/**/                   0xBF404DEC, 0x11CA3B9A,
/**/                   0x3F404EF5, 0xFDA00000,
/**/                   0xBD2A24DE, 0x32BC307C,
/**/                   0xBF405DE7, 0xFC927044,
/**/                   0x3F405EF3, 0xF2E00000,
/**/                   0xBD1E513F, 0xF01532DA,
/**/                   0xBF406DE3, 0xE35C2D8A,
/**/                   0x3F406EF1, 0xE6200000,
/**/                   0xBCF10631, 0xCE27534E,
/**/                   0xBF407DDF, 0xC62774EA,
/**/                   0x3F407EEF, 0xD7600000,
/**/                   0x3D19E95C, 0x86CE9380,
/**/                   0xBF408DDB, 0xA4F447E4,
/**/                   0x3F408EED, 0xC6A00000,
/**/                   0x3D2E19BC, 0xBA0CD2C3,
/**/                   0xBF409DD7, 0x7FC2A7F8,
/**/                   0x3F409EEB, 0xB3E00000,
/**/                   0x3D38A832, 0x31FF7199,
/**/                   0xBF40ADD3, 0x569296A4,
/**/                   0x3F40AEE9, 0x9F400000,
/**/                   0xBD3CB2AD, 0xC2D77791,
/**/                   0xBF40BDCF, 0x29641567,
/**/                   0x3F40BEE7, 0x88800000,
/**/                   0xBD3102C1, 0xE5545563,
/**/                   0xBF40CDCA, 0xF83725C2,
/**/                   0x3F40CEE5, 0x6FC00000,
/**/                   0xBD111C2A, 0x66B3E48D,
/**/                   0xBF40DDC6, 0xC30BC932,
/**/                   0x3F40DEE3, 0x55000000,
/**/                   0x3D2302EF, 0x7711FC2A,
/**/                   0xBF40EDC2, 0x89E20138,
/**/                   0x3F40EEE1, 0x38400000,
/**/                   0x3D3857C4, 0xB558238E,
/**/                   0xBF40FDBE, 0x4CB9CF52,
/**/                   0x3F40FEDF, 0x19A00000,
/**/                   0xBD37C324, 0x1194C2E1,
/**/                   0xBF410DBA, 0x0B933501,
/**/                   0x3F410EDC, 0xF8E00000,
/**/                   0xBD1B390B, 0xFBCAF285,
/**/                   0xBF411DB5, 0xC66E33C2,
/**/                   0x3F411EDA, 0xD6200000,
/**/                   0x3D266ECF, 0x0E52C3A4,
/**/                   0xBF412DB1, 0x7D4ACD15,
/**/                   0x3F412ED8, 0xB1600000,
/**/                   0x3D3E4EDB, 0x1A4AF71D,
/**/                   0xBF413DAD, 0x30290279,
/**/                   0x3F413ED6, 0x8AC00000,
/**/                   0xBD2B0DD1, 0x58C4D599,
/**/                   0xBF414DA8, 0xDF08D56E,
/**/                   0x3F414ED4, 0x62000000,
/**/                   0x3D1EDC6F, 0x2FB4061D,
/**/                   0xBF415DA4, 0x89EA4773,
/**/                   0x3F415ED2, 0x37400000,
/**/                   0x3D3E09E8, 0x1BA53538,
/**/                   0xBF416DA0, 0x30CD5A06,
/**/                   0x3F416ED0, 0x0AA00000,
/**/                   0xBD251B08, 0x4A5B4574,
/**/                   0xBF417D9B, 0xD3B20EA8,
/**/                   0x3F417ECD, 0xDBE00000,
/**/                   0x3D2BE3AD, 0x4241B57B,
/**/                   0xBF418D97, 0x729866D7,
/**/                   0x3F418ECB, 0xAB400000,
/**/                   0xBD387707, 0xFA22BD16,
/**/                   0xBF419D93, 0x0D806412,
/**/                   0x3F419EC9, 0x78800000,
/**/                   0x3D01C6FC, 0xFFA2FC2F,
/**/                   0xBF41AD8E, 0xA46A07D9,
/**/                   0x3F41AEC7, 0x43C00000,
/**/                   0x3D3E028D, 0x05F32EE8,
/**/                   0xBF41BD8A, 0x375553AB,
/**/                   0x3F41BEC5, 0x0D200000,
/**/                   0xBD146400, 0xC7E46F2B,
/**/                   0xBF41CD85, 0xC6424907,
/**/                   0x3F41CEC2, 0xD4600000,
/**/                   0x3D38E737, 0x8DFCE791,
/**/                   0xBF41DD81, 0x5130E96B,
/**/                   0x3F41DEC0, 0x99C00000,
/**/                   0xBD1FEF30, 0x92F4A6CE,
/**/                   0xBF41ED7C, 0xD8213659,
/**/                   0x3F41EEBE, 0x5D000000,
/**/                   0x3D383EF4, 0x4AE68315,
/**/                   0xBF41FD78, 0x5B13314D,
/**/                   0x3F41FEBC, 0x1E600000,
/**/                   0xBD199E1E, 0x39A8276A,
/**/                   0xBF420D73, 0xDA06DBC8,
/**/                   0x3F420EB9, 0xDDA00000,
/**/                   0x3D3C11BF, 0xE39F6D77,
/**/                   0xBF421D6F, 0x54FC3749,
/**/                   0x3F421EB7, 0x9B000000,
/**/                   0xBCD50D72, 0xC3A8C440,
/**/                   0xBF422D6A, 0xCBF3454F,
/**/                   0x3F422EB5, 0x56600000,
/**/                   0xBD3B9869, 0x06E59170,
/**/                   0xBF423D66, 0x3EEC0759,
/**/                   0x3F423EB3, 0x0FA00000,
/**/                   0x3D248C4B, 0x86930551,
/**/                   0xBF424D61, 0xADE67EE6,
/**/                   0x3F424EB0, 0xC7000000,
/**/                   0xBD2D6F13, 0xB3649FF7,
/**/                   0xBF425D5D, 0x18E2AD76,
/**/                   0x3F425EAE, 0x7C400000,
/**/                   0x3D396F87, 0xB496441D,
/**/                   0xBF426D58, 0x7FE09487,
/**/                   0x3F426EAC, 0x2FA00000,
/**/                   0x3D05E2D0, 0x01961A2F,
/**/                   0xBF427D53, 0xE2E03598,
/**/                   0x3F427EA9, 0xE1000000,
/**/                   0xBD32D013, 0x652D1720,
/**/                   0xBF428D4F, 0x41E1922A,
/**/                   0x3F428EA7, 0x90400000,
/**/                   0x3D38CB3F, 0x15C6A78A,
/**/                   0xBF429D4A, 0x9CE4ABBA,
/**/                   0x3F429EA5, 0x3DA00000,
/**/                   0x3D163D44, 0x07F8A52A,
/**/                   0xBF42AD45, 0xF3E983C8,
/**/                   0x3F42AEA2, 0xE9000000,
/**/                   0xBD2905BC, 0x1FEC6070,
/**/                   0xBF42BD41, 0x46F01BD4,
/**/                   0x3F42BEA0, 0x92600000,
/**/                   0xBD3D6A4E, 0x8FE5CB8E,
/**/                   0xBF42CD3C, 0x95F8755C,
/**/                   0x3F42CE9E, 0x39A00000,
/**/                   0x3D32D9FF, 0x120028B6,
/**/                   0xBF42DD37, 0xE10291DF,
/**/                   0x3F42DE9B, 0xDF000000,
/**/                   0x3D112C29, 0x94B2D8A6,
/**/                   0xBF42ED33, 0x280E72DD,
/**/                   0x3F42EE99, 0x82600000,
/**/                   0xBD222C5A, 0x0E9DC27F,
/**/                   0xBF42FD2E, 0x6B1C19D4,
/**/                   0x3F42FE97, 0x23C00000,
/**/                   0xBD3548A7, 0xA4C12307,
/**/                   0xBF430D29, 0xAA2B8844,
/**/                   0x3F430E94, 0xC3000000,
/**/                   0x3D3FB49A, 0x1B27A40C,
/**/                   0xBF431D24, 0xE53CBFAC,
/**/                   0x3F431E92, 0x60600000,
/**/                   0x3D35E297, 0xC65D601D,
/**/                   0xBF432D20, 0x1C4FC18B,
/**/                   0x3F432E8F, 0xFBC00000,
/**/                   0x3D2A84A1, 0xD4E46CD5,
/**/                   0xBF433D1B, 0x4F648F60,
/**/                   0x3F433E8D, 0x95200000,
/**/                   0x3D175314, 0x526215F8,
/**/                   0xBF434D16, 0x7E7B2AAB,
/**/                   0x3F434E8B, 0x2C800000,
/**/                   0xBCD9430B, 0x9746A94C,
/**/                   0xBF435D11, 0xA99394E9,
/**/                   0x3F435E88, 0xC1E00000,
/**/                   0xBD15A88D, 0x47EF6144,
/**/                   0xBF436D0C, 0xD0ADCF9B,
/**/                   0x3F436E86, 0x55400000,
/**/                   0xBD227301, 0x94614FFB,
/**/                   0xBF437D07, 0xF3C9DC3F,
/**/                   0x3F437E83, 0xE6A00000,
/**/                   0xBD27A44A, 0x16908831,
/**/                   0xBF438D03, 0x12E7BC55,
/**/                   0x3F438E81, 0x76000000,
/**/                   0xBD2A6621, 0x13DE59AC,
/**/                   0xBF439CFE, 0x2E07715C,
/**/                   0x3F439E7F, 0x03600000,
/**/                   0xBD2AB687, 0x76635000,
/**/                   0xBF43ACF9, 0x4528FCD2,
/**/                   0x3F43AE7C, 0x8EC00000,
/**/                   0xBD28937E, 0x28F7818F,
/**/                   0xBF43BCF4, 0x584C6037,
/**/                   0x3F43BE7A, 0x18200000,
/**/                   0xBD23FB06, 0x17328F27,
/**/                   0xBF43CCEF, 0x67719D0A,
/**/                   0x3F43CE77, 0x9F800000,
/**/                   0xBD19D640, 0x5AD74747,
/**/                   0xBF43DCEA, 0x7298B4CA,
/**/                   0x3F43DE75, 0x24E00000,
/**/                   0xBCFB0E6A, 0xC5CB9C74,
/**/                   0xBF43ECE5, 0x79C1A8F6,
/**/                   0x3F43EE72, 0xA8400000,
/**/                   0x3D1145E2, 0xF21B8682,
/**/                   0xBF43FCE0, 0x7CEC7B0D,
/**/                   0x3F43FE70, 0x29A00000,
/**/                   0x3D27251B, 0x59543A06,
/**/                   0xBF440CDB, 0x7C192C8E,
/**/                   0x3F440E6D, 0xA9000000,
/**/                   0x3D341357, 0xAC6250B6,
/**/                   0xBF441CD6, 0x7747BEF8,
/**/                   0x3F441E6B, 0x26600000,
/**/                   0x3D3DD4D6, 0x43A510F7,
/**/                   0xBF442CD1, 0x6E7833CB,
/**/                   0x3F442E68, 0xA1E00000,
/**/                   0xBD3727F7, 0x05F7D1E1,
/**/                   0xBF443CCC, 0x61AA8C85,
/**/                   0x3F443E66, 0x1B400000,
/**/                   0xBD25C421, 0x527C9668,
/**/                   0xBF444CC7, 0x50DECAA5,
/**/                   0x3F444E63, 0x92A00000,
/**/                   0x3D053C47, 0x053F70AC,
/**/                   0xBF445CC2, 0x3C14EFAB,
/**/                   0x3F445E61, 0x08000000,
/**/                   0x3D3175D5, 0x1E315FBB,
/**/                   0xBF446CBD, 0x234CFD15,
/**/                   0x3F446E5E, 0x7B800000,
/**/                   0xBD3E762C, 0x6A8B33AC,
/**/                   0xBF447CB8, 0x0686F463,
/**/                   0x3F447E5B, 0xECE00000,
/**/                   0xBD2A36F8, 0x67AD9900,
/**/                   0xBF448CB2, 0xE5C2D713,
/**/                   0x3F448E59, 0x5C400000,
/**/                   0x3D161B95, 0x1E974853,
/**/                   0xBF449CAD, 0xC100A6A5,
/**/                   0x3F449E56, 0xC9A00000,
/**/                   0x3D3971F7, 0x8CE22250,
/**/                   0xBF44ACA8, 0x98406498,
/**/                   0x3F44AE54, 0x35200000,
/**/                   0xBD315945, 0xDF8A23F8,
/**/                   0xBF44BCA3, 0x6B82126A,
/**/                   0x3F44BE51, 0x9E800000,
/**/                   0x3D1498B2, 0x1A63D360,
/**/                   0xBF44CC9E, 0x3AC5B19B,
/**/                   0x3F44CE4F, 0x05E00000,
/**/                   0x3D3CF14E, 0x4323A054,
/**/                   0xBF44DC99, 0x060B43AA,
/**/                   0x3F44DE4C, 0x6B600000,
/**/                   0xBD23EDC2, 0x4CE35F94,
/**/                   0xBF44EC93, 0xCD52CA15,
/**/                   0x3F44EE49, 0xCEC00000,
/**/                   0x3D306E9D, 0xCCF1B48E,
/**/                   0xBF44FC8E, 0x909C465C,
/**/                   0x3F44FE47, 0x30400000,
/**/                   0xBD33DD35, 0x5FF9440B,
/**/                   0xBF450C89, 0x4FE7B9FF,
/**/                   0x3F450E44, 0x8FA00000,
/**/                   0x3D224D49, 0xAA4D276D,
/**/                   0xBF451C84, 0x0B35267A,
/**/                   0x3F451E41, 0xED200000,
/**/                   0xBD3884D4, 0x11B557F9,
/**/                   0xBF452C7E, 0xC2848D4F,
/**/                   0x3F452E3F, 0x48800000,
/**/                   0x3D1C857D, 0xB43290C4,
/**/                   0xBF453C79, 0x75D5EFFC,
/**/                   0x3F453E3C, 0xA2000000,
/**/                   0xBD37E5C1, 0x2D598D3C,
/**/                   0xBF454C74, 0x25294FFF,
/**/                   0x3F454E39, 0xF9600000,
/**/                   0x3D24CD93, 0x3FE47B89,
/**/                   0xBF455C6E, 0xD07EAED8,
/**/                   0x3F455E37, 0x4EE00000,
/**/                   0xBD31F800, 0xAA959122,
/**/                   0xBF456C69, 0x77D60E06,
/**/                   0x3F456E34, 0xA2400000,
/**/                   0x3D32FEDF, 0x7329AF92,
/**/                   0xBF457C64, 0x1B2F6F08,
/**/                   0x3F457E31, 0xF3C00000,
/**/                   0xBD1ACE5A, 0x1C545A6F,
/**/                   0xBF458C5E, 0xBA8AD35D,
/**/                   0x3F458E2F, 0x43400000,
/**/                   0xBD3F0E63, 0x19F6B9EF,
/**/                   0xBF459C59, 0x55E83C84,
/**/                   0x3F459E2C, 0x90A00000,
/**/                   0x3D23DEF2, 0x73005F6F,
/**/                   0xBF45AC53, 0xED47ABFB,
/**/                   0x3F45AE29, 0xDC200000,
/**/                   0xBD277204, 0x1C295DE7,
/**/                   0xBF45BC4E, 0x80A92343,
/**/                   0x3F45BE27, 0x25800000,
/**/                   0x3D3FF92A, 0x8D869589,
/**/                   0xBF45CC49, 0x100CA3D9,
/**/                   0x3F45CE24, 0x6D000000,
/**/                   0x3D2A0DFD, 0x145C5335,
/**/                   0xBF45DC43, 0x9B722F3C,
/**/                   0x3F45DE21, 0xB2800000,
/**/                   0xBD123A1A, 0x6A8614B3,
/**/                   0xBF45EC3E, 0x22D9C6ED,
/**/                   0x3F45EE1E, 0xF6000000,
/**/                   0xBD34C665, 0x63CBC7E7,
/**/                   0xBF45FC38, 0xA6436C69,
/**/                   0x3F45FE1C, 0x37600000,
/**/                   0x3D3C6061, 0xAB6C51D7,
/**/                   0xBF460C33, 0x25AF2130,
/**/                   0x3F460E19, 0x76E00000,
/**/                   0x3D2DCD9C, 0x1EC7F453,
/**/                   0xBF461C2D, 0xA11CE6C1,
/**/                   0x3F461E16, 0xB4600000,
/**/                   0x3D066EFA, 0x20C52899,
/**/                   0xBF462C28, 0x188CBE9A,
/**/                   0x3F462E13, 0xEFE00000,
/**/                   0xBD1FA5AC, 0xEB5FDD5C,
/**/                   0xBF463C22, 0x8BFEAA3B,
/**/                   0x3F463E11, 0x29600000,
/**/                   0xBD313E11, 0xF22FE2BC,
/**/                   0xBF464C1C, 0xFB72AB23,
/**/                   0x3F464E0E, 0x60E00000,
/**/                   0xBD392F15, 0x6710E251,
/**/                   0xBF465C17, 0x66E8C2D0,
/**/                   0x3F465E0B, 0x96600000,
/**/                   0xBD3FBB76, 0x1EFC78A7,
/**/                   0xBF466C11, 0xCE60F2C1,
/**/                   0x3F466E08, 0xC9C00000,
/**/                   0x3D3B1DCB, 0x602C1A84,
/**/                   0xBF467C0C, 0x31DB3C76,
/**/                   0x3F467E05, 0xFB400000,
/**/                   0x3D375DAE, 0x9027DA74,
/**/                   0xBF468C06, 0x9157A16E,
/**/                   0x3F468E03, 0x2AC00000,
/**/                   0x3D350532, 0xEA560DA0,
/**/                   0xBF469C00, 0xECD62326,
/**/                   0x3F469E00, 0x58400000,
/**/                   0x3D341557, 0xE7B63DE2 } };

#else
#ifdef LITTLE_ENDI
static const union {int4 i[5800]; double x[2900];} ui = { .i = {
/**/                   0x00000000, 0x3FF6A000,
/**/                   0x3729043E, 0x3F33CD15,
/**/                   0x0B3AB000, 0xBFD63003,
/**/                   0xE731AE00, 0x3D2DB623,
/**/                   0x00000000, 0x3FF69800,
/**/                   0xCC7267D0, 0x3F33F349,
/**/                   0xCDB03000, 0xBFD61965,
/**/                   0x603C488E, 0x3D2F08AD,
/**/                   0x00000000, 0x3FF69000,
/**/                   0x8D0BFD2E, 0x3F3473A8,
/**/                   0x8AF09000, 0xBFD602D0,
/**/                   0x76DF3F65, 0xBD1EBE91,
/**/                   0x00000000, 0x3FF68800,
/**/                   0x390B9ED0, 0x3F354DD2,
/**/                   0x3D5C3000, 0xBFD5EC43,
/**/                   0x1229D17F, 0xBD36B71A,
/**/                   0x00000000, 0x3FF68000,
/**/                   0x16816817, 0x3F368168,
/**/                   0xDF596000, 0xBFD5D5BD,
/**/                   0x08A465DC, 0x3D0A0B2A,
/**/                   0x00000000, 0x3FF67800,
/**/                   0xF08C7765, 0x3F380E0B,
/**/                   0x6B544000, 0xBFD5BF40,
/**/                   0xEB68981C, 0x3D227023,
/**/                   0x00000000, 0x3FF67000,
/**/                   0x16719F36, 0x3F39F360,
/**/                   0xDBBEE000, 0xBFD5A8CA,
/**/                   0x0AF7ECF8, 0x3CF7C79B,
/**/                   0x00000000, 0x3FF66800,
/**/                   0x5AB40167, 0x3F3C3107,
/**/                   0x2B113000, 0xBFD5925D,
/**/                   0xA7A56F34, 0x3D369BF5,
/**/                   0x00000000, 0x3FF66000,
/**/                   0x122F9016, 0x3F3EC6A5,
/**/                   0x53C8D000, 0xBFD57BF7,
/**/                   0xEE5D40EF, 0xBD1FADED,
/**/                   0x00000000, 0x3FF65C00,
/**/                   0xECCA9097, 0xBF3E4C22,
/**/                   0x50695000, 0xBFD56599,
/**/                   0x2BADC774, 0xBD14C5FD,
/**/                   0x00000000, 0x3FF65400,
/**/                   0x4B55CC62, 0xBF3B07AC,
/**/                   0x1B7BE000, 0xBFD54F43,
/**/                   0xC0910952, 0xBD1A8954,
/**/                   0x00000000, 0x3FF64C00,
/**/                   0x32DA090E, 0xBF376C52,
/**/                   0xAF8F7000, 0xBFD538F4,
/**/                   0xE45547CE, 0xBD27EC02,
/**/                   0x00000000, 0x3FF64400,
/**/                   0x4DE9BD38, 0xBF337A6F,
/**/                   0x0738A000, 0xBFD522AE,
/**/                   0x8164C759, 0xBD2EBE70,
/**/                   0x00000000, 0x3FF63C00,
/**/                   0x923C708B, 0xBF2E64BB,
/**/                   0x1D11C000, 0xBFD50C6F,
/**/                   0x7E827C2C, 0x3D3A0E6B,
/**/                   0x00000000, 0x3FF63400,
/**/                   0xA7E43FD4, 0xBF2528EE,
/**/                   0xEBBAA000, 0xBFD4F637,
/**/                   0xCB3124B9, 0x3D3FC158,
/**/                   0x00000000, 0x3FF62C00,
/**/                   0x86689DF7, 0xBF168454,
/**/                   0x6DD8C000, 0xBFD4E008,
/**/                   0xA1E44788, 0x3D34D692,
/**/                   0x00000000, 0x3FF62400,
/**/                   0x77016240, 0xBED623FA,
/**/                   0x9E173000, 0xBFD4C9E0,
/**/                   0x1B0AD8A4, 0x3D2E2089,
/**/                   0x00000000, 0x3FF61C00,
/**/                   0x58715130, 0x3F151300,
/**/                   0x77268000, 0xBFD4B3C0,
/**/                   0x81052B9F, 0x3D165B46,
/**/                   0x00000000, 0x3FF61400,
/**/                   0x35D2754E, 0x3F266D06,
/**/                   0xF3BCC000, 0xBFD49DA7,
/**/                   0x4DAF4B9A, 0xBD307B33,
/**/                   0x00000000, 0x3FF60C00,
/**/                   0xDA197F23, 0x3F317C61,
/**/                   0x0E958000, 0xBFD48797,
/**/                   0x465CF25F, 0xBD3DC1B8,
/**/                   0x00000000, 0x3FF60400,
/**/                   0x81605816, 0x3F381605,
/**/                   0xC271C000, 0xBFD4718D,
/**/                   0xFB4C14C5, 0xBD306C18,
/**/                   0x00000000, 0x3FF5FC00,
/**/                   0xB5C6F559, 0x3F3F0317,
/**/                   0x0A17E000, 0xBFD45B8C,
/**/                   0xE7D0A853, 0x3D0D9120,
/**/                   0x00000000, 0x3FF5F800,
/**/                   0x6D2041E3, 0xBF39BCBD,
/**/                   0xE053A000, 0xBFD44591,
/**/                   0x92923D88, 0x3D06E958,
/**/                   0x00000000, 0x3FF5F000,
/**/                   0x5604CC40, 0xBF3229CF,
/**/                   0x3FF62000, 0xBFD42F9F,
/**/                   0x0F7D3354, 0xBD390644,
/**/                   0x00000000, 0x3FF5E800,
/**/                   0xFD431489, 0xBF2488E5,
/**/                   0x23D5F000, 0xBFD419B4,
/**/                   0x226DE3EC, 0x3D3CE379,
/**/                   0x00000000, 0x3FF5E000,
/**/                   0x6424E9C9, 0xBF0067E7,
/**/                   0x86CEA000, 0xBFD403D0,
/**/                   0x74487308, 0xBD3E6EF5,
/**/                   0x00000000, 0x3FF5D800,
/**/                   0x38A94D24, 0x3F19F0FB,
/**/                   0x63C17000, 0xBFD3EDF4,
/**/                   0x297F2C3F, 0x3D3F067C,
/**/                   0x00000000, 0x3FF5D000,
/**/                   0x23CAD2AA, 0x3F2EADD9,
/**/                   0xB5947000, 0xBFD3D81F,
/**/                   0x2A9D37A4, 0x3D222C7C,
/**/                   0x00000000, 0x3FF5C800,
/**/                   0x31057262, 0x3F3882B9,
/**/                   0x77333000, 0xBFD3C252,
/**/                   0xB606BD5C, 0xBD183B54,
/**/                   0x00000000, 0x3FF5C400,
/**/                   0x10FFA8F8, 0xBF3E00AE,
/**/                   0xA38E6000, 0xBFD3AC8C,
/**/                   0xBC02BE4A, 0x3D2D0BEF,
/**/                   0x00000000, 0x3FF5BC00,
/**/                   0x8056EAF3, 0xBF34339B,
/**/                   0x359BC000, 0xBFD396CE,
/**/                   0x5663663D, 0x3D05839C,
/**/                   0x00000000, 0x3FF5B400,
/**/                   0xF31D7FD5, 0xBF242CC1,
/**/                   0x28565000, 0xBFD38117,
/**/                   0x93A0702B, 0x3D2A71E4,
/**/                   0x00000000, 0x3FF5AC00,
/**/                   0x6B015AC0, 0x3ED5AC05,
/**/                   0x76BE1000, 0xBFD36B67,
/**/                   0xB0F177C8, 0xBD116ECD,
/**/                   0x00000000, 0x3FF5A400,
/**/                   0x5BA55E5A, 0x3F26268D,
/**/                   0x1BD83000, 0xBFD355BF,
/**/                   0x8964F0E8, 0x3D2BA99B,
/**/                   0x00000000, 0x3FF59C00,
/**/                   0x3CCAA376, 0x3F361F12,
/**/                   0x12AED000, 0xBFD3401E,
/**/                   0x556E291D, 0x3D317C73,
/**/                   0x00000000, 0x3FF59800,
/**/                   0x62D32417, 0xBF3E863D,
/**/                   0x56512000, 0xBFD32A84,
/**/                   0x139AF5D6, 0xBD04F928,
/**/                   0x00000000, 0x3FF59000,
/**/                   0xEA712DCF, 0xBF32DCF7,
/**/                   0xE1D36000, 0xBFD314F1,
/**/                   0xD3213CB8, 0x3D28E27A,
/**/                   0x00000000, 0x3FF58800,
/**/                   0xA0CC87E8, 0xBF1B95B2,
/**/                   0xB04EB000, 0xBFD2FF66,
/**/                   0x541E6E2E, 0x3D38AED2,
/**/                   0x00000000, 0x3FF58000,
/**/                   0x01580560, 0x3F158056,
/**/                   0xBCE12000, 0xBFD2E9E2,
/**/                   0x128D1DC2, 0xBD24300C,
/**/                   0x00000000, 0x3FF57800,
/**/                   0x15791F34, 0x3F31F340,
/**/                   0x02ADD000, 0xBFD2D466,
/**/                   0xDCD54196, 0x3D288D0D,
/**/                   0x00000000, 0x3FF57000,
/**/                   0x06B39A23, 0x3F3ED3C5,
/**/                   0x7CDC9000, 0xBFD2BEF0,
/**/                   0x4A5004F4, 0xBD2A9CFA,
/**/                   0x00000000, 0x3FF56C00,
/**/                   0x53FEA954, 0xBF33FEA9,
/**/                   0x269A4000, 0xBFD2A982,
/**/                   0x557285CF, 0x3D22058E,
/**/                   0x00000000, 0x3FF56400,
/**/                   0xEB478503, 0xBF1A1160,
/**/                   0xFB187000, 0xBFD2941A,
/**/                   0xB730E28B, 0x3D3210C2,
/**/                   0x00000000, 0x3FF55C00,
/**/                   0xE4A18B2E, 0x3F1D09AD,
/**/                   0xF58D9000, 0xBFD27EBA,
/**/                   0x00B4BDA7, 0x3D2B1988,
/**/                   0x00000000, 0x3FF55400,
/**/                   0x55555555, 0x3F355555,
/**/                   0x1134E000, 0xBFD26962,
/**/                   0x10522625, 0x3D31B61F,
/**/                   0x00000000, 0x3FF55000,
/**/                   0xB319A21F, 0xBF3C4BE6,
/**/                   0x494E5000, 0xBFD25410,
/**/                   0xC0EF77F2, 0xBD3B1D7A,
/**/                   0x00000000, 0x3FF54800,
/**/                   0x8FA03FD5, 0xBF2B4328,
/**/                   0x991EC000, 0xBFD23EC5,
/**/                   0x48A2E522, 0x3D36DBE4,
/**/                   0x00000000, 0x3FF54000,
/**/                   0x40154015, 0x3EF54015,
/**/                   0xFBEF8000, 0xBFD22981,
/**/                   0x609580DA, 0x3D3A1421,
/**/                   0x00000000, 0x3FF53800,
/**/                   0x40FEAC6F, 0x3F30948F,
/**/                   0x6D0EC000, 0xBFD21445,
/**/                   0x28B728A3, 0x3D3CAF04,
/**/                   0x00000000, 0x3FF53400,
/**/                   0xFD04F7B8, 0xBF3FE034,
/**/                   0xE7CF4000, 0xBFD1FF0F,
/**/                   0x513FF0C1, 0xBD3E9D5B,
/**/                   0x00000000, 0x3FF52C00,
/**/                   0x7FAB5403, 0xBF300A95,
/**/                   0x6788A000, 0xBFD1E9E1,
/**/                   0xD3C8B65E, 0x3D382EAE,
/**/                   0x00000000, 0x3FF52400,
/**/                   0x52401524, 0x3EB52401,
/**/                   0xE796C000, 0xBFD1D4B9,
/**/                   0x7C42E56D, 0xBD222A66,
/**/                   0x00000000, 0x3FF51C00,
/**/                   0x2F8151D0, 0x3F307EAE,
/**/                   0x635A7000, 0xBFD1BF99,
/**/                   0x575C2125, 0x3D31AC89,
/**/                   0x00000000, 0x3FF51800,
/**/                   0xEAE9ECE4, 0xBF3ECE3F,
/**/                   0xD638D000, 0xBFD1AA7F,
/**/                   0x9616F7A0, 0xBD29F60A,
/**/                   0x00000000, 0x3FF51000,
/**/                   0xC7675243, 0xBF2BA3DD,
/**/                   0x3B9BC000, 0xBFD1956D,
/**/                   0x3AD1AA14, 0xBD27D2F7,
/**/                   0x00000000, 0x3FF50800,
/**/                   0x764E368D, 0x3F0B9AC8,
/**/                   0x8EF19000, 0xBFD18061,
/**/                   0xC86D38E5, 0x3D3482FF,
/**/                   0x00000000, 0x3FF50000,
/**/                   0x15015015, 0x3F350150,
/**/                   0xCBAD0000, 0xBFD16B5C,
/**/                   0x042D74BF, 0x3D323299,
/**/                   0x00000000, 0x3FF4FC00,
/**/                   0x4A683C50, 0xBF392851,
/**/                   0xED456000, 0xBFD1565E,
/**/                   0xFB6ABA25, 0x3CEE75AD,
/**/                   0x00000000, 0x3FF4F400,
/**/                   0xACD95EF0, 0xBF1C2748,
/**/                   0xEF367000, 0xBFD14167,
/**/                   0x824DAAF5, 0xBD3E0C07,
/**/                   0x00000000, 0x3FF4EC00,
/**/                   0x67A47465, 0x3F26B90D,
/**/                   0xCD007000, 0xBFD12C77,
/**/                   0x8A11F797, 0xBD13B294,
/**/                   0x00000000, 0x3FF4E400,
/**/                   0xF0539783, 0x3F3E0A72,
/**/                   0x8227E000, 0xBFD1178E,
/**/                   0xCE2D07F2, 0xBD31EF78,
/**/                   0x00000000, 0x3FF4E000,
/**/                   0xF87FD642, 0xBF2E00A6,
/**/                   0x0A35D000, 0xBFD102AC,
/**/                   0xDFDFD686, 0x3D2F1FBD,
/**/                   0x00000000, 0x3FF4D800,
/**/                   0x0B12E3FD, 0x3F10EFB7,
/**/                   0x60B78000, 0xBFD0EDD0,
/**/                   0x2D8435F5, 0xBD0019B5,
/**/                   0x00000000, 0x3FF4D000,
/**/                   0x5CB4DBE5, 0x3F37BEF1,
/**/                   0x813EB000, 0xBFD0D8FB,
/**/                   0x8753FA35, 0xBD1EE8C8,
/**/                   0x00000000, 0x3FF4CC00,
/**/                   0xA50918B1, 0xBF34778D,
/**/                   0x67616000, 0xBFD0C42D,
/**/                   0x163CEAE9, 0xBD27188B,
/**/                   0x00000000, 0x3FF4C400,
/**/                   0xE37288EC, 0xBED9F4F7,
/**/                   0x0EB9E000, 0xBFD0AF66,
/**/                   0xF528D80A, 0xBD23C7C3,
/**/                   0x00000000, 0x3FF4BC00,
/**/                   0x68FE0E42, 0x3F33EDDA,
/**/                   0x72E6C000, 0xBFD09AA5,
/**/                   0xE1734342, 0xBD3B50A1,
/**/                   0x00000000, 0x3FF4B800,
/**/                   0xB72E47D9, 0xBF3776C6,
/**/                   0x8F8AE000, 0xBFD085EB,
/**/                   0x3F45FE7B, 0xBD3E5D51,
/**/                   0x00000000, 0x3FF4B000,
/**/                   0xA052BF5B, 0xBF04AFD6,
/**/                   0x604D6000, 0xBFD07138,
/**/                   0x4E912B17, 0x3D3E7632,
/**/                   0x00000000, 0x3FF4A800,
/**/                   0xD5B5C015, 0x3F328FFA,
/**/                   0xE0D96000, 0xBFD05C8B,
/**/                   0xC77CCB58, 0xBD2AD0F1,
/**/                   0x00000000, 0x3FF4A400,
/**/                   0x9FEB5D80, 0xBF380528,
/**/                   0x0CDE8000, 0xBFD047E6,
/**/                   0x0D397F3C, 0xBD2DBDF1,
/**/                   0x00000000, 0x3FF49C00,
/**/                   0x25FF5B21, 0xBF02AD3E,
/**/                   0xE0106000, 0xBFD03346,
/**/                   0xA966395C, 0xBCF89FF8,
/**/                   0x00000000, 0x3FF49400,
/**/                   0x2D066EA2, 0x3F339E3B,
/**/                   0x5626C000, 0xBFD01EAE,
/**/                   0xFADE85AE, 0xBD3A43DC,
/**/                   0x00000000, 0x3FF49000,
/**/                   0xAFB2E932, 0xBF3629C1,
/**/                   0x6ADDA000, 0xBFD00A1C,
/**/                   0x688B9E18, 0xBD31CD8D,
/**/                   0x00000000, 0x3FF48800,
/**/                   0x22014880, 0x3ED48805,
/**/                   0x33EA0000, 0xBFCFEB22,
/**/                   0xDE00938B, 0xBD2F3418,
/**/                   0x00000000, 0x3FF48000,
/**/                   0x3D324D89, 0x3F37119F,
/**/                   0xBE620000, 0xBFCFC218,
/**/                   0x6F1CF6A0, 0xBD34BBA4,
/**/                   0x00000000, 0x3FF47C00,
/**/                   0x1EB851EC, 0xBF31EB85,
/**/                   0x6CB3C000, 0xBFCF991C,
/**/                   0xCD7CC834, 0x3D390D04,
/**/                   0x00000000, 0x3FF47400,
/**/                   0xAAFC7C01, 0x3F1569C9,
/**/                   0x36778000, 0xBFCF702D,
/**/                   0x16673E23, 0x3D108195,
/**/                   0x00000000, 0x3FF46C00,
/**/                   0x96066250, 0x3F3CE345,
/**/                   0x134E0000, 0xBFCF474B,
/**/                   0xF1DF7B5E, 0x3D3BAE49,
/**/                   0x00000000, 0x3FF46800,
/**/                   0x1D02DE87, 0xBF26A297,
/**/                   0xFADFA000, 0xBFCF1E75,
/**/                   0x25D83F6D, 0x3D20862B,
/**/                   0x00000000, 0x3FF46000,
/**/                   0xB9F34381, 0x3F2978FE,
/**/                   0xE4DD0000, 0xBFCEF5AD,
/**/                   0x65BB8E11, 0x3CCA2115,
/**/                   0x00000000, 0x3FF45C00,
/**/                   0xF6C71366, 0xBF3AF398,
/**/                   0xC8FEA000, 0xBFCECCF2,
/**/                   0xA3E75640, 0x3D3BEC63,
/**/                   0x00000000, 0x3FF45400,
/**/                   0x449AFF5D, 0xBF030E9C,
/**/                   0x9F04A000, 0xBFCEA444,
/**/                   0x63732A36, 0xBD35E916,
/**/                   0x00000000, 0x3FF44C00,
/**/                   0xF8B42EF3, 0x3F367190,
/**/                   0x5EB78000, 0xBFCE7BA3,
/**/                   0x23793649, 0x3D0D5EEE,
/**/                   0x00000000, 0x3FF44800,
/**/                   0xD260511C, 0xBF3079A9,
/**/                   0xFFE72000, 0xBFCE530E,
/**/                   0xB13F7C18, 0x3D3FDBDB,
/**/                   0x00000000, 0x3FF44000,
/**/                   0x0B644FBE, 0x3F21B87C,
/**/                   0x7A6B2000, 0xBFCE2A87,
/**/                   0x7787081A, 0xBD382381,
/**/                   0x00000000, 0x3FF43C00,
/**/                   0x411B2E25, 0xBF3D8CF5,
/**/                   0xC6236000, 0xBFCE020C,
/**/                   0xADB91424, 0x3D252B00,
/**/                   0x00000000, 0x3FF43400,
/**/                   0xD6A60978, 0xBF0DAC08,
/**/                   0xDAF6E000, 0xBFCDD99E,
/**/                   0x69C756EB, 0x3D302EC6,
/**/                   0x00000000, 0x3FF42C00,
/**/                   0x51F86EFA, 0x3F36625D,
/**/                   0xB0D48000, 0xBFCDB13D,
/**/                   0x847527E6, 0xBD32806A,
/**/                   0x00000000, 0x3FF42800,
/**/                   0xA8766564, 0xBF2E8B2D,
/**/                   0x3FB30000, 0xBFCD88E9,
/**/                   0x0234BF51, 0x3D375F28,
/**/                   0x00000000, 0x3FF42000,
/**/                   0xCB2A247B, 0x3F26A4CB,
/**/                   0x7F904000, 0xBFCD60A1,
/**/                   0x6FC20D39, 0x3D35D6E0,
/**/                   0x00000000, 0x3FF41C00,
/**/                   0xC17DF552, 0xBF39D5E8,
/**/                   0x68720000, 0xBFCD3866,
/**/                   0xB38932BC, 0x3D373650,
/**/                   0x00000000, 0x3FF41400,
/**/                   0x14141414, 0x3EF41414,
/**/                   0xF2656000, 0xBFCD1037,
/**/                   0x75B6F6E4, 0x3D084A7E,
/**/                   0x00000000, 0x3FF40C00,
/**/                   0x43AE87FD, 0x3F3C97A8,
/**/                   0x157F2000, 0xBFCCE816,
/**/                   0xA2099515, 0x3D29E0AB,
/**/                   0x00000000, 0x3FF40800,
/**/                   0x66A67E6F, 0xBF1F4BBC,
/**/                   0xC9DB4000, 0xBFCCC000,
/**/                   0x5D57AFF9, 0x3D1D6D58,
/**/                   0x00000000, 0x3FF40000,
/**/                   0x14014014, 0x3F340140,
/**/                   0x079D4000, 0xBFCC97F8,
/**/                   0xA8C6E6C5, 0xBD23B161,
/**/                   0x00000000, 0x3FF3FC00,
/**/                   0xFD809FD8, 0xBF2FD809,
/**/                   0xC6F00000, 0xBFCC6FFB,
/**/                   0xD3A69D43, 0xBD3EE138,
/**/                   0x00000000, 0x3FF3F400,
/**/                   0x57EE89D2, 0x3F28CA0E,
/**/                   0x0005C000, 0xBFCC480C,
/**/                   0xD5E44E76, 0xBD39A294,
/**/                   0x00000000, 0x3FF3F000,
/**/                   0xA50F9260, 0xBF370BD5,
/**/                   0xAB180000, 0xBFCC2028,
/**/                   0xE55C7AC6, 0x3D292E0E,
/**/                   0x00000000, 0x3FF3E800,
/**/                   0x75945FCE, 0x3F1704AA,
/**/                   0xC0676000, 0xBFCBF851,
/**/                   0x4C0854AD, 0x3D35420E,
/**/                   0x00000000, 0x3FF3E400,
/**/                   0xB56FD83C, 0xBF3D3431,
/**/                   0x383BE000, 0xBFCBD087,
/**/                   0x595412B6, 0x3D2D4BC4,
/**/                   0x00000000, 0x3FF3DC00,
/**/                   0x3DC013DC, 0x3EB3DC01,
/**/                   0x0AE4A000, 0xBFCBA8C9,
/**/                   0xF44432DA, 0xBD3A32E7,
/**/                   0x00000000, 0x3FF3D400,
/**/                   0xA75C5BBD, 0x3F3D991A,
/**/                   0x30B82000, 0xBFCB8117,
/**/                   0x3B9CD768, 0xBD1E9068,
/**/                   0x00000000, 0x3FF3D000,
/**/                   0x59C52F5D, 0xBF1292BA,
/**/                   0xA213A000, 0xBFCB5971,
/**/                   0x83AA91DF, 0xBD39B50E,
/**/                   0x00000000, 0x3FF3C800,
/**/                   0xBABE7440, 0x3F395A47,
/**/                   0x575BC000, 0xBFCB31D8,
/**/                   0x562A63CB, 0xBD3C794E,
/**/                   0x00000000, 0x3FF3C400,
/**/                   0x58A0943A, 0xBF20D475,
/**/                   0x48FC2000, 0xBFCB0A4B,
/**/                   0x5C3998ED, 0x3D22E72D,
/**/                   0x00000000, 0x3FF3BC00,
/**/                   0x3295482C, 0x3F360D92,
/**/                   0x6F672000, 0xBFCAE2CA,
/**/                   0xAE54F550, 0xBD37A8D5,
/**/                   0x00000000, 0x3FF3B800,
/**/                   0xCAB48651, 0xBF267D12,
/**/                   0xC316A000, 0xBFCABB55,
/**/                   0xCAF14CD8, 0x3D38A65A,
/**/                   0x00000000, 0x3FF3B000,
/**/                   0x13B13B14, 0x3F33B13B,
/**/                   0x3C8AE000, 0xBFCA93ED,
/**/                   0x50562169, 0x3D287243,
/**/                   0x00000000, 0x3FF3AC00,
/**/                   0x2C8FD3BF, 0xBF2A46AF,
/**/                   0xD44B8000, 0xBFCA6C90,
/**/                   0xF037B0C6, 0x3D3F63B7,
/**/                   0x00000000, 0x3FF3A400,
/**/                   0xAC822610, 0x3F324387,
/**/                   0x82E6A000, 0xBFCA4540,
/**/                   0xC81F7171, 0xBD360A77,
/**/                   0x00000000, 0x3FF3A000,
/**/                   0xA1923DEE, 0xBF2C34BB,
/**/                   0x40F1C000, 0xBFCA1DFC,
/**/                   0x004F3781, 0x3D301E0F,
/**/                   0x00000000, 0x3FF39800,
/**/                   0x87F63372, 0x3F31C2C1,
/**/                   0x0708A000, 0xBFC9F6C4,
/**/                   0x4BCD3F43, 0x3D3337D9,
/**/                   0x00000000, 0x3FF39400,
/**/                   0xE11BD52E, 0xBF2C4AA0,
/**/                   0xCDCE0000, 0xBFC9CF97,
/**/                   0x10C414E3, 0xBD3D862F,
/**/                   0x00000000, 0x3FF38C00,
/**/                   0x6088DBF4, 0x3F322D36,
/**/                   0x8DEBA000, 0xBFC9A877,
/**/                   0x3EFEC390, 0xBD3470FA,
/**/                   0x00000000, 0x3FF38800,
/**/                   0x503F774E, 0xBF2A8BBF,
/**/                   0x4011A000, 0xBFC98163,
/**/                   0x9E9045E2, 0xBD34EADD,
/**/                   0x00000000, 0x3FF38000,
/**/                   0x13813814, 0x3F338138,
/**/                   0xDCF70000, 0xBFC95A5A,
/**/                   0x58A0FF6F, 0xBD07F228,
/**/                   0x00000000, 0x3FF37C00,
/**/                   0x1B177053, 0xBF26FB6F,
/**/                   0x5D594000, 0xBFC9335E,
/**/                   0x3ABD47DA, 0xBD33115C,
/**/                   0x00000000, 0x3FF37400,
/**/                   0x945EDC20, 0x3F35BD1C,
/**/                   0xB9FCC000, 0xBFC90C6D,
/**/                   0x7718D7CA, 0x3D1935F5,
/**/                   0x00000000, 0x3FF37000,
/**/                   0x4DBDCC60, 0xBF219D00,
/**/                   0xEBAC2000, 0xBFC8E588,
/**/                   0xAB2D1140, 0xBD3B7D5C,
/**/                   0x00000000, 0x3FF36800,
/**/                   0xE0747954, 0x3F38DF3D,
/**/                   0xEB390000, 0xBFC8BEAF,
/**/                   0xAAE92CD1, 0x3D073D54,
/**/                   0x00000000, 0x3FF36400,
/**/                   0xD9D3C49F, 0xBF14E775,
/**/                   0xB17B2000, 0xBFC897E2,
/**/                   0x380CBE9E, 0x3D296B37,
/**/                   0x00000000, 0x3FF35C00,
/**/                   0xF2AF821E, 0x3F3CE5F9,
/**/                   0x3750E000, 0xBFC87121,
/**/                   0x42F9AF75, 0xBD3328EB,
/**/                   0x00000000, 0x3FF35800,
/**/                   0xE34971F2, 0xBEE82DF0,
/**/                   0x759F6000, 0xBFC84A6B,
/**/                   0x2ADF8609, 0x3D3DA280,
/**/                   0x00000000, 0x3FF35400,
/**/                   0x4873ECAE, 0xBF3E304D,
/**/                   0x6551A000, 0xBFC823C1,
/**/                   0x9A631E83, 0xBD1E0DDB,
/**/                   0x00000000, 0x3FF34C00,
/**/                   0x1FF659DB, 0x3F1264B6,
/**/                   0xFF59A000, 0xBFC7FD22,
/**/                   0xF457B7D2, 0x3D158BEB,
/**/                   0x00000000, 0x3FF34800,
/**/                   0xFECB9865, 0xBF386531,
/**/                   0x3CAF6000, 0xBFC7D690,
/**/                   0x17C301D7, 0x3D24C06B,
/**/                   0x00000000, 0x3FF34000,
/**/                   0xEEDA65AE, 0x3F25A8C2,
/**/                   0x16516000, 0xBFC7B009,
/**/                   0xCB067E57, 0x3D3AE75F,
/**/                   0x00000000, 0x3FF33C00,
/**/                   0x8434E1F4, 0xBF31BA4A,
/**/                   0x85444000, 0xBFC7898D,
/**/                   0xE3DBAF3F, 0xBD38E67B,
/**/                   0x00000000, 0x3FF33400,
/**/                   0xDBFC660A, 0x3F31EE97,
/**/                   0x82936000, 0xBFC7631D,
/**/                   0xC7C5F3E1, 0x3D25E77D,
/**/                   0x00000000, 0x3FF33000,
/**/                   0xBC40BFDA, 0xBF246252,
/**/                   0x074FE000, 0xBFC73CB9,
/**/                   0x0D0005A6, 0x3D3D66A9,
/**/                   0x00000000, 0x3FF32800,
/**/                   0x13299E64, 0x3F39E640,
/**/                   0x0C914000, 0xBFC71660,
/**/                   0x7CEC3838, 0xBCE51B15,
/**/                   0x00000000, 0x3FF32400,
/**/                   0xEF40991F, 0xBEFCB5D4,
/**/                   0x8B756000, 0xBFC6F012,
/**/                   0x0D31EF0F, 0xBD357739,
/**/                   0x00000000, 0x3FF32000,
/**/                   0xC823D892, 0xBF3D4632,
/**/                   0x7D204000, 0xBFC6C9D0,
/**/                   0xFD9B2DCA, 0x3CDC73FA,
/**/                   0x00000000, 0x3FF31800,
/**/                   0x7AED804C, 0x3F1DD63A,
/**/                   0xDABBE000, 0xBFC6A399,
/**/                   0xE66A15A6, 0x3D38F934,
/**/                   0x00000000, 0x3FF31400,
/**/                   0xE8C11E1A, 0xBF339849,
/**/                   0x9D786000, 0xBFC67D6E,
/**/                   0x30A706D3, 0x3D311E88,
/**/                   0x00000000, 0x3FF30C00,
/**/                   0x0D190131, 0x3F319013,
/**/                   0xBE8C2000, 0xBFC6574E,
/**/                   0x34F0F462, 0x3D398C1D,
/**/                   0x00000000, 0x3FF30800,
/**/                   0xB47A7FDA, 0xBF222315,
/**/                   0x37336000, 0xBFC6313A,
/**/                   0x4F21EA6D, 0x3D144DF5,
/**/                   0x00000000, 0x3FF30000,
/**/                   0x40260390, 0x3F3C82AC,
/**/                   0x00B0A000, 0xBFC60B31,
/**/                   0xC988F814, 0x3D371456,
/**/                   0x00000000, 0x3FF2FC00,
/**/                   0xA2430A62, 0x3F026443,
/**/                   0x144C2000, 0xBFC5E533,
/**/                   0xF3B290EA, 0x3D31CE0B,
/**/                   0x00000000, 0x3FF2F800,
/**/                   0xED097B42, 0xBF37B425,
/**/                   0x6B544000, 0xBFC5BF40,
/**/                   0xEB68981C, 0x3D127023,
/**/                   0x00000000, 0x3FF2F000,
/**/                   0x4AE0553C, 0x3F2D00E3,
/**/                   0xFF1D6000, 0xBFC59958,
/**/                   0x9769CA05, 0x3D3A1D05,
/**/                   0x00000000, 0x3FF2EC00,
/**/                   0x25D69D44, 0xBF262BC0,
/**/                   0xC9018000, 0xBFC5737C,
/**/                   0xA6B887F6, 0xBD39BAA7,
/**/                   0x00000000, 0x3FF2E400,
/**/                   0xE3103D6B, 0x3F3B88B5,
/**/                   0xC2610000, 0xBFC54DAB,
/**/                   0xE5C8D0D8, 0xBD2746FE,
/**/                   0x00000000, 0x3FF2E000,
/**/                   0xC04B8097, 0x3F02E025,
/**/                   0xE4A1C000, 0xBFC527E5,
/**/                   0x8D4B411D, 0x3D34E60B,
/**/                   0x00000000, 0x3FF2DC00,
/**/                   0x2C305021, 0xBF369C22,
/**/                   0x292F6000, 0xBFC5022B,
/**/                   0xFF36A25B, 0xBD348A05,
/**/                   0x00000000, 0x3FF2D400,
/**/                   0xD50A012D, 0x3F30A012,
/**/                   0x897BC000, 0xBFC4DC7B,
/**/                   0x0AE1FF0F, 0xBD0C79B6,
/**/                   0x00000000, 0x3FF2D000,
/**/                   0xBC66484E, 0xBF1FBE29,
/**/                   0xFEFE2000, 0xBFC4B6D6,
/**/                   0xF56E7952, 0xBD1522EC,
/**/                   0x00000000, 0x3FF2C800,
/**/                   0x12C9FB4E, 0x3F3FB4D8,
/**/                   0x8333C000, 0xBFC4913D,
/**/                   0x558124C4, 0x3D353E43,
/**/                   0x00000000, 0x3FF2C400,
/**/                   0x7004B11E, 0x3F1E3432,
/**/                   0x0F9F6000, 0xBFC46BAF,
/**/                   0x0790841A, 0x3D1249CD,
/**/                   0x00000000, 0x3FF2C000,
/**/                   0x5C8EF02F, 0xBF30671A,
/**/                   0x9DC9C000, 0xBFC4462B,
/**/                   0xA711B062, 0x3D384858,
/**/                   0x00000000, 0x3FF2B800,
/**/                   0xD548D9AC, 0x3F37D835,
/**/                   0x27410000, 0xBFC420B3,
/**/                   0xC85A0884, 0x3D116282,
/**/                   0x00000000, 0x3FF2B400,
/**/                   0xAD012B40, 0x3ED2B404,
/**/                   0xA5992000, 0xBFC3FB45,
/**/                   0xC0CAE559, 0xBD319713,
/**/                   0x00000000, 0x3FF2B000,
/**/                   0x8E7302A1, 0xBF370F78,
/**/                   0x126BC000, 0xBFC3D5E3,
/**/                   0x85096C4B, 0xBD13FB2F,
/**/                   0x00000000, 0x3FF2A800,
/**/                   0x3C1053F9, 0x3F31C92F,
/**/                   0x67580000, 0xBFC3B08B,
/**/                   0xF29320FB, 0x3D3AADE8,
/**/                   0x00000000, 0x3FF2A400,
/**/                   0x3DBE2E04, 0xBF14AD94,
/**/                   0x9E028000, 0xBFC38B3E,
/**/                   0x545C17F9, 0x3D370EF0,
/**/                   0x00000000, 0x3FF2A000,
/**/                   0xBED61BED, 0xBF3BED61,
/**/                   0xB015A000, 0xBFC365FC,
/**/                   0xAFB9691B, 0x3D3FD3A0,
/**/                   0x00000000, 0x3FF29800,
/**/                   0x26F004A6, 0x3F2B061A,
/**/                   0x97412000, 0xBFC340C5,
/**/                   0xF7D9D386, 0x3D37A3DC,
/**/                   0x00000000, 0x3FF29400,
/**/                   0xFF6B646D, 0xBF21B488,
/**/                   0x4D3A4000, 0xBFC31B99,
/**/                   0xE3A50810, 0xBD3F098E,
/**/                   0x00000000, 0x3FF29000,
/**/                   0x2CA5D5AC, 0xBF3F0582,
/**/                   0xCBBC0000, 0xBFC2F677,
/**/                   0x2160F40D, 0xBD352B30,
/**/                   0x00000000, 0x3FF28800,
/**/                   0x16025116, 0x3F260251,
/**/                   0x0C868000, 0xBFC2D161,
/**/                   0xCB81B4A1, 0xBD039D6C,
/**/                   0x00000000, 0x3FF28400,
/**/                   0x502065D2, 0xBF258CDF,
/**/                   0x095F6000, 0xBFC2AC55,
/**/                   0xD0C6C8A8, 0x3D1D3466,
/**/                   0x00000000, 0x3FF27C00,
/**/                   0x1CE4D6F8, 0x3F3FA38A,
/**/                   0xBC11A000, 0xBFC28753,
/**/                   0x359302E6, 0xBD37494E,
/**/                   0x00000000, 0x3FF27800,
/**/                   0xDCCA0781, 0x3F247DD5,
/**/                   0x1E6DE000, 0xBFC2625D,
/**/                   0xF09E3D82, 0x3CF52962,
/**/                   0x00000000, 0x3FF27400,
/**/                   0xDB195E8F, 0xBF25E8EF,
/**/                   0x2A49C000, 0xBFC23D71,
/**/                   0x8FD3DF5C, 0xBD100D23,
/**/                   0x00000000, 0x3FF27000,
/**/                   0xFFB647FE, 0xBF3FF6C8,
/**/                   0xD9808000, 0xBFC2188F,
/**/                   0x7F50C701, 0x3D3B3A1E,
/**/                   0x00000000, 0x3FF26800,
/**/                   0xC024D167, 0x3F266F9A,
/**/                   0x25F26000, 0xBFC1F3B9,
/**/                   0x9B083633, 0x3D15F74E,
/**/                   0x00000000, 0x3FF26400,
/**/                   0xEABD0E14, 0xBF22D1BD,
/**/                   0x09854000, 0xBFC1CEED,
/**/                   0x39192AF9, 0x3D315C1C,
/**/                   0x00000000, 0x3FF26000,
/**/                   0xF6D0EEC8, 0xBF3DD8F7,
/**/                   0x7E240000, 0xBFC1AA2B,
/**/                   0xDDE3B366, 0x3D31AC38,
/**/                   0x00000000, 0x3FF25800,
/**/                   0x2A241EF6, 0x3F2BCEB1,
/**/                   0x7DBEC000, 0xBFC18574,
/**/                   0x45BD9B49, 0xBD3E6744,
/**/                   0x00000000, 0x3FF25400,
/**/                   0xA21378D7, 0xBF18A05B,
/**/                   0x024B2000, 0xBFC160C8,
/**/                   0xA9009E3D, 0xBD2EC2D2,
/**/                   0x00000000, 0x3FF25000,
/**/                   0xD6CFA90C, 0xBF3A076F,
/**/                   0x05C3A000, 0xBFC13C26,
/**/                   0xD94F6509, 0x3D2CF5FD,
/**/                   0x00000000, 0x3FF24800,
/**/                   0x92492492, 0x3F324924,
/**/                   0x8227E000, 0xBFC1178E,
/**/                   0xCE2D07F2, 0xBD21EF78,
/**/                   0x00000000, 0x3FF24400,
/**/                   0x6151E899, 0xBEF3682B,
/**/                   0x717D0000, 0xBFC0F301,
/**/                   0x41AE86C5, 0x3D3E09B4,
/**/                   0x00000000, 0x3FF24000,
/**/                   0x89FA4C67, 0xBF34868E,
/**/                   0xCDCCC000, 0xBFC0CE7E,
/**/                   0xABFF5447, 0xBD14652D,
/**/                   0x00000000, 0x3FF23800,
/**/                   0x6B11F09F, 0x3F3858D8,
/**/                   0x91268000, 0xBFC0AA06,
/**/                   0xD7032129, 0x3D345519,
/**/                   0x00000000, 0x3FF23400,
/**/                   0xAF37C049, 0x3F159E26,
/**/                   0xB59E4000, 0xBFC08598,
/**/                   0x7009902C, 0x3D27E5DD,
/**/                   0x00000000, 0x3FF23000,
/**/                   0x2E076329, 0xBF2AB546,
/**/                   0x354D4000, 0xBFC06135,
/**/                   0x28340EE9, 0xBD363046,
/**/                   0x00000000, 0x3FF22C00,
/**/                   0xFEDD5FEE, 0xBF3FEDD5,
/**/                   0x0A51E000, 0xBFC03CDC,
/**/                   0xF169FC5C, 0xBD381A9C,
/**/                   0x00000000, 0x3FF22400,
/**/                   0x009126D7, 0x3F2B5B92,
/**/                   0x2ECF6000, 0xBFC0188D,
/**/                   0x1CFF9DFE, 0xBD03F965,
/**/                   0x00000000, 0x3FF22000,
/**/                   0x8121FB78, 0xBF121FB7,
/**/                   0x39DBC000, 0xBFBFE891,
/**/                   0xD82F7A82, 0xBD356594,
/**/                   0x00000000, 0x3FF21C00,
/**/                   0x3A459635, 0xBF368F22,
/**/                   0x9DB58000, 0xBFBFA01C,
/**/                   0xFA48A730, 0x3D08F351,
/**/                   0x00000000, 0x3FF21400,
/**/                   0x855E6012, 0x3F379804,
/**/                   0x7D900000, 0xBFBF57BC,
/**/                   0x9EA8B04E, 0xBD176A6C,
/**/                   0x00000000, 0x3FF21000,
/**/                   0x78CD7A37, 0x3F17B57C,
/**/                   0xCDD98000, 0xBFBF0F70,
/**/                   0x6C272C1E, 0xBD32E31F,
/**/                   0x00000000, 0x3FF20C00,
/**/                   0x07E4EF15, 0xBF271E73,
/**/                   0x830A0000, 0xBFBEC739,
/**/                   0xA80CDD10, 0xBD311FCB,
/**/                   0x00000000, 0x3FF20800,
/**/                   0x49392BA7, 0xBF3CDDEC,
/**/                   0x91A34000, 0xBFBE7F16,
/**/                   0x9BC77BFA, 0x3D32C1C5,
/**/                   0x00000000, 0x3FF20000,
/**/                   0x12012012, 0x3F320120,
/**/                   0xEE304000, 0xBFBE3707,
/**/                   0xE6766ABD, 0xBD20F684,
/**/                   0x00000000, 0x3FF1FC00,
/**/                   0xCE8AD1A2, 0x3EF0DC4F,
/**/                   0x8D468000, 0xBFBDEF0D,
/**/                   0x412E9A74, 0x3D324750,
/**/                   0x00000000, 0x3FF1F800,
/**/                   0xDC11F704, 0xBF2F7047,
/**/                   0x63844000, 0xBFBDA727,
/**/                   0x1FA71733, 0xBD1A8940,
/**/                   0x00000000, 0x3FF1F000,
/**/                   0x16B6419D, 0x3F3FAF3F,
/**/                   0x65920000, 0xBFBD5F55,
/**/                   0xCC185469, 0xBD30E239,
/**/                   0x00000000, 0x3FF1EC00,
/**/                   0xF70985E2, 0x3F2E878F,
/**/                   0x88218000, 0xBFBD1797,
/**/                   0xB5EFBEED, 0xBD336433,
/**/                   0x00000000, 0x3FF1E800,
/**/                   0x94D7FDC3, 0xBEEF55E4,
/**/                   0xBFEE0000, 0xBFBCCFED,
/**/                   0x2FE71256, 0xBD33A823,
/**/                   0x00000000, 0x3FF1E400,
/**/                   0x0478BBCF, 0xBF310C4C,
/**/                   0x01BC4000, 0xBFBC8858,
/**/                   0xC65AACD3, 0xBD2646D1,
/**/                   0x00000000, 0x3FF1DC00,
/**/                   0xCB840C49, 0x3F3F0ECB,
/**/                   0x425A4000, 0xBFBC40D6,
/**/                   0x1D1930DD, 0xBD3CB112,
/**/                   0x00000000, 0x3FF1D800,
/**/                   0xC9579074, 0x3F2EACE5,
/**/                   0x769FC000, 0xBFBBF968,
/**/                   0x8D824283, 0xBD24218C,
/**/                   0x00000000, 0x3FF1D400,
/**/                   0xFC60F0AE, 0xBECABDFA,
/**/                   0x936D8000, 0xBFBBB20E,
/**/                   0x35459B8E, 0x3D368BA8,
/**/                   0x00000000, 0x3FF1D000,
/**/                   0xAFDC61F3, 0xBF2F2A4B,
/**/                   0x8DAD4000, 0xBFBB6AC8,
/**/                   0xF50225C7, 0xBD3B1BDF,
/**/                   0x00000000, 0x3FF1CC00,
/**/                   0xAB802394, 0xBF3EC8AF,
/**/                   0x5A530000, 0xBFBB2396,
/**/                   0xEA137079, 0x3CEFF64E,
/**/                   0x00000000, 0x3FF1C400,
/**/                   0xCE058D9B, 0x3F322FC1,
/**/                   0xEE5B0000, 0xBFBADC77,
/**/                   0x09C31904, 0x3D3573B2,
/**/                   0x00000000, 0x3FF1C000,
/**/                   0xE0EFA2CF, 0x3F0AA04F,
/**/                   0x3ECAC000, 0xBFBA956D,
/**/                   0x4C02C4AF, 0xBD3E6379,
/**/                   0x00000000, 0x3FF1BC00,
/**/                   0x225ADFDD, 0xBF26B7F7,
/**/                   0x40B1C000, 0xBFBA4E76,
/**/                   0xB94407C8, 0x3D0E42B6,
/**/                   0x00000000, 0x3FF1B800,
/**/                   0x217CD13A, 0xBF39E073,
/**/                   0xE9278000, 0xBFBA0792,
/**/                   0xC9AD51BF, 0x3D0A9CE6,
/**/                   0x00000000, 0x3FF1B000,
/**/                   0x2BAE2B21, 0x3F37C67F,
/**/                   0x2D4D4000, 0xBFB9C0C3,
/**/                   0x9E838668, 0x3D3AB7C0,
/**/                   0x00000000, 0x3FF1AC00,
/**/                   0xBD720DCF, 0x3F23316E,
/**/                   0x024CC000, 0xBFB97A07,
/**/                   0x732093CE, 0x3CF8BCC1,
/**/                   0x00000000, 0x3FF1A800,
/**/                   0x611A7B96, 0xBF11A7B9,
/**/                   0x5D594000, 0xBFB9335E,
/**/                   0x3ABD47DA, 0xBD23115C,
/**/                   0x00000000, 0x3FF1A400,
/**/                   0xA1C1B8E7, 0xBF324195,
/**/                   0x33AEC000, 0xBFB8ECC9,
/**/                   0xBE67F7AA, 0x3D222F39,
/**/                   0x00000000, 0x3FF1A000,
/**/                   0xFEE61FEE, 0xBF3FEE61,
/**/                   0x7A91C000, 0xBFB8A647,
/**/                   0xAF9BD6DF, 0xBD3C28C0,
/**/                   0x00000000, 0x3FF19800,
/**/                   0x362B721D, 0x3F328F89,
/**/                   0x27508000, 0xBFB85FD9,
/**/                   0x19970C1C, 0x3D35B818,
/**/                   0x00000000, 0x3FF19400,
/**/                   0x28A70119, 0x3F14E023,
/**/                   0x2F410000, 0xBFB8197E,
/**/                   0x60D20041, 0x3D3C0FE4,
/**/                   0x00000000, 0x3FF19000,
/**/                   0x3E48FC6F, 0xBF1FD419,
/**/                   0x87C28000, 0xBFB7D336,
/**/                   0x3E706706, 0xBD33C88C,
/**/                   0x00000000, 0x3FF18C00,
/**/                   0xFD42546B, 0xBF34F7C6,
/**/                   0x263D8000, 0xBFB78D02,
/**/                   0x94B69FB7, 0xBD069B57,
/**/                   0x00000000, 0x3FF18400,
/**/                   0x01185E30, 0x3F3E2FA4,
/**/                   0x00228000, 0xBFB746E1,
/**/                   0x6E1E21D2, 0x3D3126D1,
/**/                   0x00000000, 0x3FF18000,
/**/                   0x11811812, 0x3F318118,
/**/                   0x0AEAC000, 0xBFB700D3,
/**/                   0xA99DED32, 0xBCEC1E8D,
/**/                   0x00000000, 0x3FF17C00,
/**/                   0xFF2E2C43, 0x3F13F1CA,
/**/                   0x3C188000, 0xBFB6BAD8,
/**/                   0xC08926AE, 0xBD0DAF3C,
/**/                   0x00000000, 0x3FF17800,
/**/                   0x0A5EF9FF, 0xBF1D79B9,
/**/                   0x89364000, 0xBFB674F0,
/**/                   0x4C9D3302, 0xBD3A7999,
/**/                   0x00000000, 0x3FF17400,
/**/                   0x1ECEA765, 0xBF338FAD,
/**/                   0xE7D78000, 0xBFB62F1B,
/**/                   0x7ED63C4E, 0x3D217995,
/**/                   0x00000000, 0x3FF17000,
/**/                   0xD8C8714B, 0xBF3F976B,
/**/                   0x4D978000, 0xBFB5E95A,
/**/                   0xE1D17171, 0xBD31CB7C,
/**/                   0x00000000, 0x3FF16800,
/**/                   0xB08FA497, 0x3F348A33,
/**/                   0xB01AC000, 0xBFB5A3AB,
/**/                   0x9E6AFA18, 0xBD3E2574,
/**/                   0x00000000, 0x3FF16400,
/**/                   0x864022C9, 0x3F21AA1F,
/**/                   0x050E0000, 0xBFB55E10,
/**/                   0x0C53C72E, 0xBD0C1D74,
/**/                   0x00000000, 0x3FF16000,
/**/                   0xB487BCAD, 0xBF05B7C9,
/**/                   0x42260000, 0xBFB51887,
/**/                   0x96258B3E, 0xBD330A1D,
/**/                   0x00000000, 0x3FF15C00,
/**/                   0x5B1E5F75, 0xBF2C3411,
/**/                   0x5D208000, 0xBFB4D311,
/**/                   0x82F4E1EF, 0x3CF53A25,
/**/                   0x00000000, 0x3FF15800,
/**/                   0xEEA99544, 0xBF39543F,
/**/                   0x4BC30000, 0xBFB48DAE,
/**/                   0x208C200C, 0xBD30185B,
/**/                   0x00000000, 0x3FF15000,
/**/                   0xDD5C8CB8, 0x3F3B9A3F,
/**/                   0x03DBC000, 0xBFB4485E,
/**/                   0xE8D26AB7, 0xBD3FAD46,
/**/                   0x00000000, 0x3FF14C00,
/**/                   0xB19AE5C7, 0x3F30B155,
/**/                   0x7B414000, 0xBFB40320,
/**/                   0xAA8157C0, 0xBD26FD84,
/**/                   0x00000000, 0x3FF14800,
/**/                   0xB34EDA32, 0x3F17C382,
/**/                   0xA7D20000, 0xBFB3BDF5,
/**/                   0xAD125895, 0x3D319BD0,
/**/                   0x00000000, 0x3FF14400,
/**/                   0xBAF129D0, 0xBF129CFF,
/**/                   0x7F748000, 0xBFB378DD,
/**/                   0x28F1FACA, 0xBD371411,
/**/                   0x00000000, 0x3FF14000,
/**/                   0x771B7C7F, 0xBF2E2E59,
/**/                   0xF8184000, 0xBFB333D7,
/**/                   0xA81B8848, 0x3CE692B6,
/**/                   0x00000000, 0x3FF13C00,
/**/                   0x30FE1D9C, 0xBF395F06,
/**/                   0x07B40000, 0xBFB2EEE5,
/**/                   0xDD77C860, 0xBD08081E,
/**/                   0x00000000, 0x3FF13400,
/**/                   0x5C81135D, 0x3F3C8113,
/**/                   0xA4470000, 0xBFB2AA04,
/**/                   0xA8B1CB41, 0xBD37A48B,
/**/                   0x00000000, 0x3FF13000,
/**/                   0xBB3B5DC0, 0x3F3288FF,
/**/                   0xC3D8C000, 0xBFB26536,
/**/                   0x097C5BA3, 0xBD0B4BAC,
/**/                   0x00000000, 0x3FF12C00,
/**/                   0xB81577AE, 0x3F21713D,
/**/                   0x5C784000, 0xBFB2207B,
/**/                   0xFC10C7BF, 0xBD349D8C,
/**/                   0x00000000, 0x3FF12800,
/**/                   0xBAD6FC84, 0xBEEE05E5,
/**/                   0x643D0000, 0xBFB1DBD2,
/**/                   0xD977C494, 0xBD390B24,
/**/                   0x00000000, 0x3FF12400,
/**/                   0x59F992BF, 0xBF24E314,
/**/                   0xD1464000, 0xBFB1973B,
/**/                   0x54F930B3, 0xBD3566D1,
/**/                   0x00000000, 0x3FF12000,
/**/                   0xC9F6E7A8, 0xBF33CB91,
/**/                   0x99BB4000, 0xBFB152B7,
/**/                   0x07030829, 0x3D09BB29,
/**/                   0x00000000, 0x3FF11C00,
/**/                   0x8B7D9851, 0xBF3CFE65,
/**/                   0xB3CB0000, 0xBFB10E45,
/**/                   0x284A3465, 0x3D37CF69,
/**/                   0x00000000, 0x3FF11400,
/**/                   0x29605DF7, 0x3F39F5DB,
/**/                   0x15AC4000, 0xBFB0C9E6,
/**/                   0x0974D976, 0xBD2C2DA8,
/**/                   0x00000000, 0x3FF11000,
/**/                   0x11111111, 0x3F311111,
/**/                   0xB59E4000, 0xBFB08598,
/**/                   0x7009902C, 0x3D17E5DD,
/**/                   0x00000000, 0x3FF10C00,
/**/                   0x12A5B1AE, 0x3F20A63A,
/**/                   0x89E74000, 0xBFB0415D,
/**/                   0x5CF1D753, 0xBD1111C0,
/**/                   0x00000000, 0x3FF10800,
/**/                   0xBE011080, 0xBED107FB,
/**/                   0x11AB8000, 0xBFAFFA69,
/**/                   0x98381A8F, 0xBD23008C,
/**/                   0x00000000, 0x3FF10400,
/**/                   0x6FEABBAE, 0xBF216989,
/**/                   0x51800000, 0xBFAF723B,
/**/                   0xDD5610D3, 0x3D3D6EB0,
/**/                   0x00000000, 0x3FF10000,
/**/                   0x10FEF011, 0xBF30FEF0,
/**/                   0xC0068000, 0xBFAEEA31,
/**/                   0x3606D891, 0xBD3C3DD8,
/**/                   0x00000000, 0x3FF0FC00,
/**/                   0x98CDDC74, 0xBF3922C0,
/**/                   0x4A0B8000, 0xBFAE624C,
/**/                   0x74676689, 0x3D30F25C,
/**/                   0x00000000, 0x3FF0F400,
/**/                   0x325A1A80, 0x3F3EDFAB,
/**/                   0xDC680000, 0xBFADDA8A,
/**/                   0x64D9E42F, 0x3D21B1AC,
/**/                   0x00000000, 0x3FF0F000,
/**/                   0xF27F9A57, 0x3F370834,
/**/                   0x64060000, 0xBFAD52ED,
/**/                   0x2A29BBD6, 0x3D33C85D,
/**/                   0x00000000, 0x3FF0EC00,
/**/                   0xD391FBC5, 0x3F2EAD7C,
/**/                   0xCDDD8000, 0xBFACCB73,
/**/                   0x6E09F5FE, 0xBD3965C3,
/**/                   0x00000000, 0x3FF0E800,
/**/                   0xE9479870, 0x3F1F2CA5,
/**/                   0x06F70000, 0xBFAC441E,
/**/                   0x49850D15, 0xBD354F1F,
/**/                   0x00000000, 0x3FF0E400,
/**/                   0x80439019, 0x3ED95609,
/**/                   0xFC690000, 0xBFABBCEB,
/**/                   0x8C317C2A, 0x3D17BF86,
/**/                   0x00000000, 0x3FF0E000,
/**/                   0xC6867596, 0xBF1B6B4D,
/**/                   0x9B588000, 0xBFAB35DD,
/**/                   0xD6CF558E, 0xBD3D5674,
/**/                   0x00000000, 0x3FF0DC00,
/**/                   0x172D4CE8, 0xBF2BEAEE,
/**/                   0xD0FB0000, 0xBFAAAEF2,
/**/                   0x353BB42E, 0xBD20FC1A,
/**/                   0x00000000, 0x3FF0D800,
/**/                   0x479071A9, 0xBF34EAB0,
/**/                   0x8A938000, 0xBFAA282B,
/**/                   0x80EFC8E3, 0x3D2E8F59,
/**/                   0x00000000, 0x3FF0D400,
/**/                   0xA61C62D3, 0xBF3BBA9C,
/**/                   0xB5740000, 0xBFA9A187,
/**/                   0x4EC4D90D, 0x3D30C22E,
/**/                   0x00000000, 0x3FF0CC00,
/**/                   0x77344011, 0x3F3D9AA6,
/**/                   0x3EFD8000, 0xBFA91B07,
/**/                   0x3F76CA96, 0x3D19D7C5,
/**/                   0x00000000, 0x3FF0C800,
/**/                   0xCDA3AC11, 0x3F3714FB,
/**/                   0x149F8000, 0xBFA894AA,
/**/                   0x8BE97661, 0xBD39A19A,
/**/                   0x00000000, 0x3FF0C400,
/**/                   0x391F2E61, 0x3F30B446,
/**/                   0x23D90000, 0xBFA80E70,
/**/                   0x6F28BF45, 0x3D399DC1,
/**/                   0x00000000, 0x3FF0C000,
/**/                   0x682E11CD, 0x3F24F0D1,
/**/                   0x5A358000, 0xBFA78859,
/**/                   0x083B3A4C, 0x3D108B0D,
/**/                   0x00000000, 0x3FF0BC00,
/**/                   0x5D5A36EA, 0x3F118519,
/**/                   0xA5510000, 0xBFA70265,
/**/                   0x11FD5CE7, 0x3D2888DF,
/**/                   0x00000000, 0x3FF0B800,
/**/                   0x62386CAB, 0xBEF913DA,
/**/                   0xF2D48000, 0xBFA67C94,
/**/                   0x827CCA0C, 0xBD3DAC20,
/**/                   0x00000000, 0x3FF0B400,
/**/                   0xBD31D7D0, 0xBF1D7CFF,
/**/                   0x30790000, 0xBFA5F6E7,
/**/                   0x8012494C, 0x3D20485A,
/**/                   0x00000000, 0x3FF0B000,
/**/                   0x226951DC, 0xBF2A11BA,
/**/                   0x4C040000, 0xBFA5715C,
/**/                   0xDFC47628, 0x3D38888D,
/**/                   0x00000000, 0x3FF0AC00,
/**/                   0x7B2E9DD2, 0xBF328E31,
/**/                   0x334A0000, 0xBFA4EBF4,
/**/                   0xF73BE773, 0x3D2D9150,
/**/                   0x00000000, 0x3FF0A800,
/**/                   0x7EF597EF, 0xBF37EF59,
/**/                   0xD42E0000, 0xBFA466AE,
/**/                   0x75BDFD28, 0x3D2C1673,
/**/                   0x00000000, 0x3FF0A400,
/**/                   0x50D413C1, 0xBF3D2C71,
/**/                   0x1CA08000, 0xBFA3E18C,
/**/                   0x3F6E378E, 0xBD3748ED,
/**/                   0x00000000, 0x3FF09C00,
/**/                   0xF836010A, 0x3F3DBA6A,
/**/                   0xFAA10000, 0xBFA35C8B,
/**/                   0x5EF9EB35, 0xBD38357D,
/**/                   0x00000000, 0x3FF09800,
/**/                   0x624D4AF5, 0x3F38C51F,
/**/                   0x5C3C8000, 0xBFA2D7AE,
/**/                   0x459DA66D, 0x3D322939,
/**/                   0x00000000, 0x3FF09400,
/**/                   0x10953F39, 0x3F33F390,
/**/                   0x2F8D0000, 0xBFA252F3,
/**/                   0xE021B67B, 0xBD283E9A,
/**/                   0x00000000, 0x3FF09000,
/**/                   0x861539B9, 0x3F2E8B42,
/**/                   0x62BC0000, 0xBFA1CE5A,
/**/                   0x8D8DF999, 0xBD3A9CC7,
/**/                   0x00000000, 0x3FF08C00,
/**/                   0xACBC4021, 0x3F25766E,
/**/                   0xE4008000, 0xBFA149E3,
/**/                   0x9A4168FD, 0x3D32B98A,
/**/                   0x00000000, 0x3FF08800,
/**/                   0x0F3DBD5A, 0x3F1950DB,
/**/                   0xA19E0000, 0xBFA0C58F,
/**/                   0x58B17913, 0x3D0559D1,
/**/                   0x00000000, 0x3FF08400,
/**/                   0x08421084, 0x3F008421,
/**/                   0x89E78000, 0xBFA0415D,
/**/                   0xF461C516, 0x3D3DDDC7,
/**/                   0x00000000, 0x3FF08000,
/**/                   0x0041FF7C, 0xBF007FDF,
/**/                   0x16780000, 0xBF9F7A9B,
/**/                   0x271BE7D7, 0xBD242AD9,
/**/                   0x00000000, 0x3FF07C00,
/**/                   0xC54798FB, 0xBF183591,
/**/                   0x28140000, 0xBF9E72BF,
/**/                   0x49774D47, 0x3D28D751,
/**/                   0x00000000, 0x3FF07800,
/**/                   0x518F4EFD, 0xBF23CFA1,
/**/                   0x25980000, 0xBF9D6B27,
/**/                   0x50D1B838, 0x3D39FF7B,
/**/                   0x00000000, 0x3FF07400,
/**/                   0x01073261, 0xBF2B3EB7,
/**/                   0xEC150000, 0xBF9C63D2,
/**/                   0xE030A687, 0x3D35439C,
/**/                   0x00000000, 0x3FF07000,
/**/                   0xD6EAB025, 0xBF31341F,
/**/                   0x58B70000, 0xBF9B5CC2,
/**/                   0xB8AFBFE8, 0xBD18E611,
/**/                   0x00000000, 0x3FF06C00,
/**/                   0x6ED049E0, 0xBF34A638,
/**/                   0x48C60000, 0xBF9A55F5,
/**/                   0x9F2D03C9, 0x3D2DE070,
/**/                   0x00000000, 0x3FF06800,
/**/                   0xEF997F5C, 0xBF37F5BF,
/**/                   0x99A20000, 0xBF994F6B,
/**/                   0xF96CF7F5, 0xBD311D5E,
/**/                   0x00000000, 0x3FF06400,
/**/                   0xE5604189, 0xBF3B22D0,
/**/                   0x28C90000, 0xBF984925,
/**/                   0x325A0C34, 0x3D2AA0BA,
/**/                   0x00000000, 0x3FF06000,
/**/                   0xC1163FF0, 0xBF3E2D85,
/**/                   0xD3D00000, 0xBF974321,
/**/                   0x0FE94778, 0xBCFB4A69,
/**/                   0x00000000, 0x3FF05800,
/**/                   0x27586632, 0x3F3EEA07,
/**/                   0x78690000, 0xBF963D61,
/**/                   0x89596542, 0xBD07ABF3,
/**/                   0x00000000, 0x3FF05400,
/**/                   0x98E2A5E7, 0x3F3C23BB,
/**/                   0xF45F0000, 0xBF9537E3,
/**/                   0xD2D7F253, 0xBD2AB259,
/**/                   0x00000000, 0x3FF05000,
/**/                   0x73404146, 0x3F397F7D,
/**/                   0x25980000, 0xBF9432A9,
/**/                   0x928637FE, 0xBD098139,
/**/                   0x00000000, 0x3FF04C00,
/**/                   0xB0C7B49A, 0x3F36FD32,
/**/                   0xEA130000, 0xBF932DB0,
/**/                   0x130895FC, 0xBD2710CB,
/**/                   0x00000000, 0x3FF04800,
/**/                   0x664C578A, 0x3F349CC1,
/**/                   0x1FEA0000, 0xBF9228FB,
/**/                   0x284991FE, 0xBD2713E3,
/**/                   0x00000000, 0x3FF04400,
/**/                   0xC2FCB1F4, 0x3F325E0F,
/**/                   0xA5500000, 0xBF912487,
/**/                   0xFED4B393, 0xBD3FDBE5,
/**/                   0x00000000, 0x3FF04000,
/**/                   0x10410410, 0x3F304104,
/**/                   0x58930000, 0xBF902056,
/**/                   0x7C8E8417, 0xBD3611D2,
/**/                   0x00000000, 0x3FF03C00,
/**/                   0x6334030B, 0x3F2C8B09,
/**/                   0x30340000, 0xBF8E38CE,
/**/                   0xA3DA281A, 0x3D39DE88,
/**/                   0x00000000, 0x3FF03800,
/**/                   0x48FF7E3A, 0x3F28D6F0,
/**/                   0x84C80000, 0xBF8C3173,
/**/                   0xFCEFB9FE, 0x3D341F33,
/**/                   0x00000000, 0x3FF03400,
/**/                   0x0081A559, 0x3F25658A,
/**/                   0x6C180000, 0xBF8A2A9C,
/**/                   0x4D6D3472, 0x3D3F73BC,
/**/                   0x00000000, 0x3FF03000,
/**/                   0xEBC349DE, 0x3F2236A3,
/**/                   0xA3880000, 0xBF882448,
/**/                   0x12C584E0, 0xBD345544,
/**/                   0x00000000, 0x3FF02C00,
/**/                   0x3FEFD386, 0x3F1E9417,
/**/                   0xE8B60000, 0xBF861E77,
/**/                   0xEAF8EAF3, 0x3D38073E,
/**/                   0x00000000, 0x3FF02800,
/**/                   0xCA7A317C, 0x3F193F1D,
/**/                   0xF9680000, 0xBF841929,
/**/                   0x55D01368, 0xBD1977C7,
/**/                   0x00000000, 0x3FF02400,
/**/                   0x6CB49652, 0x3F146DF7,
/**/                   0x939E0000, 0xBF82145E,
/**/                   0x38C4EA00, 0xBD3E3D12,
/**/                   0x00000000, 0x3FF02000,
/**/                   0x81020408, 0x3F102040,
/**/                   0x75880000, 0xBF801015,
/**/                   0x1998B506, 0xBD3BCE25,
/**/                   0x00000000, 0x3FF01C00,
/**/                   0x8C355D63, 0x3F08AB2B,
/**/                   0xBB100000, 0xBF7C189C,
/**/                   0x12588560, 0x3D3D8055,
/**/                   0x00000000, 0x3FF01800,
/**/                   0xBD1BA97E, 0x3F021B28,
/**/                   0x14580000, 0xBF781212,
/**/                   0x82973F27, 0xBD1AD503,
/**/                   0x00000000, 0x3FF01400,
/**/                   0x411155AB, 0x3EF91F67,
/**/                   0x74780000, 0xBF740C8A,
/**/                   0xDF070002, 0xBD1E3871,
/**/                   0x00000000, 0x3FF01000,
/**/                   0x10101010, 0x3EF01010,
/**/                   0x59580000, 0xBF700805,
/**/                   0xCB31C67B, 0xBD2166AF,
/**/                   0x00000000, 0x3FF00C00,
/**/                   0x279DB649, 0x3EE20D8A,
/**/                   0x82880000, 0xBF680904,
/**/                   0x96A70C0C, 0xBD285C06,
/**/                   0x00000000, 0x3FF00800,
/**/                   0x02010080, 0x3ED00804,
/**/                   0x55D80000, 0xBF600401,
/**/                   0xC7CC7089, 0x3D33BB10,
/**/                   0x00000000, 0x3FF00400,
/**/                   0x00401004, 0x3EB00401,
/**/                   0x55600000, 0xBF500200,
/**/                   0xCD5F35F8, 0xBD356224,
/**/                   0x00000000, 0x3FF00000,
/**/                   0x00000000, 0x00000000,
/**/                   0x00000000, 0x00000000,
/**/                   0x00000000, 0x00000000,
/**/                   0x00000000, 0x3FEFF800,
/**/                   0xFF801FF8, 0x3EAFF801,
/**/                   0xAA800000, 0x3F4FFC00,
/**/                   0x7809A0A3, 0x3D35621F,
/**/                   0x00000000, 0x3FEFF000,
/**/                   0xFC01FF00, 0x3ECFF007,
/**/                   0xA9B00000, 0x3F5FF802,
/**/                   0x1D61C5EB, 0xBD33BC66,
/**/                   0x00000000, 0x3FEFE800,
/**/                   0x186DADBE, 0x3EE1F28A,
/**/                   0x7D780000, 0x3F67F704,
/**/                   0x89D68648, 0x3D283DA6,
/**/                   0x00000000, 0x3FEFE000,
/**/                   0xE01FE020, 0x3EEFE01F,
/**/                   0xA2B00000, 0x3F6FF00A,
/**/                   0xA086B56A, 0x3D20BC04,
/**/                   0x00000000, 0x3FEFD800,
/**/                   0xDF68BD14, 0x3EF8E0E6,
/**/                   0x60F00000, 0x3F73F38A,
/**/                   0x93C93749, 0x3D192256,
/**/                   0x00000000, 0x3FEFD000,
/**/                   0x439A981C, 0x3F01E528,
/**/                   0xEBD80000, 0x3F77EE11,
/**/                   0xC2D23A07, 0x3D0749D3,
/**/                   0x00000000, 0x3FEFC800,
/**/                   0x8596391C, 0x3F08556A,
/**/                   0x70040000, 0x3F7BE79C,
/**/                   0x9A6C0404, 0x3D38EC8F,
/**/                   0x00000000, 0x3FEFC000,
/**/                   0x01FC07F0, 0x3F0FC07F,
/**/                   0x6B100000, 0x3F7FE02A,
/**/                   0x0DDA40E4, 0x3D19E23F,
/**/                   0x00000000, 0x3FEFB800,
/**/                   0x9F5976B5, 0x3F1412D5,
/**/                   0x2D1A0000, 0x3F81EBDE,
/**/                   0xFF48DC36, 0xBD2A0683,
/**/                   0x00000000, 0x3FEFB000,
/**/                   0xBD271E34, 0x3F18C21A,
/**/                   0x5D260000, 0x3F83E729,
/**/                   0xFF29A114, 0xBD2609C1,
/**/                   0x00000000, 0x3FEFA800,
/**/                   0x5594A734, 0x3F1DEDB2,
/**/                   0x03EC0000, 0x3F85E1F7,
/**/                   0xF585DA1B, 0x3D37CA09,
/**/                   0x00000000, 0x3FEFA000,
/**/                   0x1FA11CAA, 0x3F21CAA0,
/**/                   0x5F820000, 0x3F87DC47,
/**/                   0x5B5DA1F5, 0xBD3EB124,
/**/                   0x00000000, 0x3FEF9800,
/**/                   0x55E8CB6B, 0x3F24DC34,
/**/                   0xADC60000, 0x3F89D61A,
/**/                   0x327B4257, 0x3D37B196,
/**/                   0x00000000, 0x3FEF9000,
/**/                   0x13BAF1B2, 0x3F282B68,
/**/                   0x2C740000, 0x3F8BCF71,
/**/                   0x97BD9771, 0x3D1C25E0,
/**/                   0x00000000, 0x3FEF8800,
/**/                   0xCC420861, 0x3F2BB80D,
/**/                   0x19120000, 0x3F8DC84B,
/**/                   0x1E3A5B30, 0x3D1C0A54,
/**/                   0x00000000, 0x3FEF8000,
/**/                   0x1F81F820, 0x3F2F81F8,
/**/                   0xB0FC0000, 0x3F8FC0A8,
/**/                   0xF6D3A69C, 0x3CDF1E7C,
/**/                   0x00000000, 0x3FEF7800,
/**/                   0xED1079FA, 0x3F31C47C,
/**/                   0x18B00000, 0x3F90DC45,
/**/                   0x380313FC, 0xBD29BC2F,
/**/                   0x00000000, 0x3FEF7000,
/**/                   0xFA98528D, 0x3F33E672,
/**/                   0xEB9F0000, 0x3F91D7F7,
/**/                   0x83FCC7A6, 0xBD14193A,
/**/                   0x00000000, 0x3FEF6800,
/**/                   0xCAFBD3D2, 0x3F3626C7,
/**/                   0xEFB50000, 0x3F92D36C,
/**/                   0x341706C3, 0x3D35F0BB,
/**/                   0x00000000, 0x3FEF6000,
/**/                   0x06DDABA6, 0x3F388565,
/**/                   0x43470000, 0x3F93CEA4,
/**/                   0x32D6A40B, 0xBD36A2C4,
/**/                   0x00000000, 0x3FEF5800,
/**/                   0x6CC4F5F5, 0x3F3B0234,
/**/                   0x04900000, 0x3F94C99E,
/**/                   0x5DF5F4A5, 0x3D1DECC6,
/**/                   0x00000000, 0x3FEF5000,
/**/                   0xD102728A, 0x3F3D9D1F,
/**/                   0x51B90000, 0x3F95C45A,
/**/                   0x216D87D8, 0xBD263BB6,
/**/                   0x00000000, 0x3FEF5000,
/**/                   0xE26A1DD4, 0xBF3FA9EE,
/**/                   0x48D20000, 0x3F96BED9,
/**/                   0x160A43F8, 0xBD320BC4,
/**/                   0x00000000, 0x3FEF4800,
/**/                   0xADEC7540, 0xBF3CD30D,
/**/                   0x07D60000, 0x3F97B91B,
/**/                   0xB602ACE4, 0xBD33B955,
/**/                   0x00000000, 0x3FEF4000,
/**/                   0x7C761DC6, 0xBF39DE52,
/**/                   0xACAA0000, 0x3F98B31F,
/**/                   0xA96E4964, 0xBD33FC78,
/**/                   0x00000000, 0x3FEF3800,
/**/                   0x23989FF0, 0xBF36CBD3,
/**/                   0x551D0000, 0x3F99ACE7,
/**/                   0x7EC7C410, 0xBD2D75D9,
/**/                   0x00000000, 0x3FEF3000,
/**/                   0x639F8B15, 0xBF339BA5,
/**/                   0x1EE80000, 0x3F9AA672,
/**/                   0x5C5AF494, 0x3D2AD4EB,
/**/                   0x00000000, 0x3FEF2800,
/**/                   0xE7AA579B, 0xBF304DDE,
/**/                   0x27B00000, 0x3F9B9FC0,
/**/                   0x0AE6922A, 0xBD3B9A01,
/**/                   0x00000000, 0x3FEF2000,
/**/                   0x8B8C46FD, 0xBF29C52A,
/**/                   0x8D010000, 0x3F9C98D1,
/**/                   0x0589DF0F, 0xBD2BF615,
/**/                   0x00000000, 0x3FEF1800,
/**/                   0xFE0E92B4, 0xBF22B3BB,
/**/                   0x6C540000, 0x3F9D91A6,
/**/                   0x658CFB9A, 0x3D2E61F1,
/**/                   0x00000000, 0x3FEF1000,
/**/                   0xFE8B488E, 0xBF16CF39,
/**/                   0xE30D0000, 0x3F9E8A3E,
/**/                   0x3DE53900, 0xBD21A9FA,
/**/                   0x00000000, 0x3FEF0800,
/**/                   0xF07C1F08, 0xBEFF07C1,
/**/                   0x0E780000, 0x3F9F829B,
/**/                   0x7C7E09E4, 0x3D298026,
/**/                   0x00000000, 0x3FEF0000,
/**/                   0x007C00F8, 0x3EFF003E,
/**/                   0x85E70000, 0x3FA03D5D,
/**/                   0x60ED29CF, 0x3D3F7789,
/**/                   0x00000000, 0x3FEEF800,
/**/                   0x3D759870, 0x3F17B671,
/**/                   0x7C198000, 0x3FA0B94F,
/**/                   0x6F022783, 0xBD2E8989,
/**/                   0x00000000, 0x3FEEF000,
/**/                   0x2A8BB96A, 0x3F241070,
/**/                   0x78598000, 0x3FA13523,
/**/                   0xB71FA59B, 0xBD1C1AC3,
/**/                   0x00000000, 0x3FEEE800,
/**/                   0x58E01EEA, 0x3F2C7F84,
/**/                   0x89240000, 0x3FA1B0D9,
/**/                   0x9AE889BB, 0xBD33401E,
/**/                   0x00000000, 0x3FEEE000,
/**/                   0xA3D491BC, 0x3F329425,
/**/                   0xBCEA8000, 0x3FA22C71,
/**/                   0xF87F888F, 0x3CFD2818,
/**/                   0x00000000, 0x3FEED800,
/**/                   0x9E9D2AE8, 0x3F37054D,
/**/                   0x22150000, 0x3FA2A7EC,
/**/                   0x7A9163FE, 0xBD278CE7,
/**/                   0x00000000, 0x3FEED000,
/**/                   0x540C85E6, 0x3F3B9325,
/**/                   0xC7000000, 0x3FA32348,
/**/                   0x90B1E49F, 0x3D2696DB,
/**/                   0x00000000, 0x3FEED000,
/**/                   0xF099FC26, 0xBF3FC267,
/**/                   0xB9FE8000, 0x3FA39E87,
/**/                   0x80AD9015, 0x3D3EAFD4,
/**/                   0x00000000, 0x3FEEC800,
/**/                   0xD02A4E5D, 0xBF3AFB6E,
/**/                   0x09590000, 0x3FA419A9,
/**/                   0x67D48EA7, 0x3D3B5CDC,
/**/                   0x00000000, 0x3FEEC000,
/**/                   0xD7A79FF1, 0xBF361803,
/**/                   0xC34D8000, 0x3FA494AC,
/**/                   0xA56FD247, 0x3D211C78,
/**/                   0x00000000, 0x3FEEB800,
/**/                   0x805C2197, 0xBF31183B,
/**/                   0xF60F8000, 0x3FA50F92,
/**/                   0x0A91FFE3, 0x3D296CFB,
/**/                   0x00000000, 0x3FEEB000,
/**/                   0x5FE15180, 0xBF27F854,
/**/                   0xAFC90000, 0x3FA58A5B,
/**/                   0x9570AD39, 0xBD2B2B73,
/**/                   0x00000000, 0x3FEEA800,
/**/                   0xE210C36A, 0xBF1B0F90,
/**/                   0xFE990000, 0x3FA60506,
/**/                   0x8194E036, 0xBD32BA40,
/**/                   0x00000000, 0x3FEEA000,
/**/                   0x8C33ADB2, 0xBEF6F7DD,
/**/                   0xF0948000, 0x3FA67F94,
/**/                   0x3E7E4ED7, 0x3D3ECC1F,
/**/                   0x00000000, 0x3FEE9800,
/**/                   0x1003D310, 0x3F1003D3,
/**/                   0x93C78000, 0x3FA6FA05,
/**/                   0x41D634A1, 0x3D3B415E,
/**/                   0x00000000, 0x3FEE9000,
/**/                   0x0B7672A0, 0x3F231ABF,
/**/                   0xF6330000, 0x3FA77458,
/**/                   0xE586AF09, 0xBD3181DC,
/**/                   0x00000000, 0x3FEE8800,
/**/                   0xCF172481, 0x3F2E6B5C,
/**/                   0x25CD8000, 0x3FA7EE8F,
/**/                   0x11A5C1E9, 0xBD3F4216,
/**/                   0x00000000, 0x3FEE8000,
/**/                   0x77A84876, 0x3F34F9CD,
/**/                   0x30840000, 0x3FA868A8,
/**/                   0x134AC693, 0xBD12623A,
/**/                   0x00000000, 0x3FEE7800,
/**/                   0xD7473427, 0x3F3AD9A8,
/**/                   0x243A0000, 0x3FA8E2A4,
/**/                   0x01426490, 0x3D2B9EEB,
/**/                   0x00000000, 0x3FEE7800,
/**/                   0x4578DCCA, 0xBF3F2AD3,
/**/                   0x0EC90000, 0x3FA95C83,
/**/                   0x97C5FEB8, 0xBD2C1482,
/**/                   0x00000000, 0x3FEE7000,
/**/                   0x97A6A035, 0xBF3913BA,
/**/                   0xFDFF8000, 0x3FA9D644,
/**/                   0x539A473B, 0x3D313C90,
/**/                   0x00000000, 0x3FEE6800,
/**/                   0xC594A915, 0xBF32E120,
/**/                   0xFFA40000, 0x3FAA4FE9,
/**/                   0xA0402925, 0xBD36E584,
/**/                   0x00000000, 0x3FEE6000,
/**/                   0xC5DF4232, 0xBF292632,
/**/                   0x21710000, 0x3FAAC972,
/**/                   0xF013222C, 0x3D2F8D3E,
/**/                   0x00000000, 0x3FEE5800,
/**/                   0xC3518A6E, 0xBF18A6DF,
/**/                   0x71198000, 0x3FAB42DD,
/**/                   0xE5D6704C, 0xBD1C827A,
/**/                   0x00000000, 0x3FEE5000,
/**/                   0x86833271, 0x3ED6BC08,
/**/                   0xFC450000, 0x3FABBC2B,
/**/                   0x91417DAF, 0xBD17D186,
/**/                   0x00000000, 0x3FEE4800,
/**/                   0xE672838D, 0x3F1BEB2D,
/**/                   0xD0920000, 0x3FAC355D,
/**/                   0x9ABF8388, 0x3D2F2CCC,
/**/                   0x00000000, 0x3FEE4000,
/**/                   0x9785150A, 0x3F2B6B8D,
/**/                   0xFB960000, 0x3FACAE72,
/**/                   0x2025B1BE, 0xBD3EFABF,
/**/                   0x00000000, 0x3FEE3800,
/**/                   0xE0D399FA, 0x3F348BCE,
/**/                   0x8ADB0000, 0x3FAD276B,
/**/                   0xC78A64B0, 0x3D16A423,
/**/                   0x00000000, 0x3FEE3000,
/**/                   0x933AC00F, 0x3F3B7CD0,
/**/                   0x8BE38000, 0x3FADA047,
/**/                   0xB1F6FE05, 0x3D2252C7,
/**/                   0x00000000, 0x3FEE3000,
/**/                   0x308F5281, 0xBF3D7747,
/**/                   0x0C278000, 0x3FAE1907,
/**/                   0x64629E86, 0xBD2FEA46,
/**/                   0x00000000, 0x3FEE2800,
/**/                   0x6C196F66, 0xBF36508B,
/**/                   0x19150000, 0x3FAE91AA,
/**/                   0x1DCC6A76, 0xBD0E82A0,
/**/                   0x00000000, 0x3FEE2000,
/**/                   0x1E1E1E1E, 0xBF2E1E1E,
/**/                   0xC0118000, 0x3FAF0A30,
/**/                   0x83368E91, 0xBD2D599E,
/**/                   0x00000000, 0x3FEE1800,
/**/                   0xDD355CDB, 0xBF1ECB93,
/**/                   0x0E780000, 0x3FAF829B,
/**/                   0x7C7E09E4, 0x3D398026,
/**/                   0x00000000, 0x3FEE1000,
/**/                   0x7C01E100, 0xBECE0FF8,
/**/                   0x119B8000, 0x3FAFFAE9,
/**/                   0x4262C554, 0x3D230337,
/**/                   0x00000000, 0x3FEE0800,
/**/                   0x25C73724, 0x3F1D54B5,
/**/                   0x6B624000, 0x3FB0398D,
/**/                   0xFCBFCD00, 0xBD3AB14D,
/**/                   0x00000000, 0x3FEE0000,
/**/                   0x1E01E01E, 0x3F2E01E0,
/**/                   0x35990000, 0x3FB07598,
/**/                   0xE4B59987, 0xBD3B8ECF,
/**/                   0x00000000, 0x3FEDF800,
/**/                   0xC84194BA, 0x3F36C715,
/**/                   0xEE0D0000, 0x3FB0B194,
/**/                   0x4F69EDCC, 0x3D3666EA,
/**/                   0x00000000, 0x3FEDF000,
/**/                   0xEF26D838, 0x3F3EA78B,
/**/                   0x9B554000, 0x3FB0ED83,
/**/                   0x6D48ABB4, 0xBD3901F4,
/**/                   0x00000000, 0x3FEDF000,
/**/                   0xF10995DC, 0xBF395DBF,
/**/                   0x44030000, 0x3FB12964,
/**/                   0x751AA773, 0xBD3D53BB,
/**/                   0x00000000, 0x3FEDE800,
/**/                   0x3BCBADC8, 0xBF3148E0,
/**/                   0xEEA38000, 0x3FB16536,
/**/                   0x768FA309, 0xBD147C5E,
/**/                   0x00000000, 0x3FEDE000,
/**/                   0x86E25CE1, 0xBF2233CE,
/**/                   0xA1BF8000, 0x3FB1A0FB,
/**/                   0xC319D6DC, 0x3D24A3FC,
/**/                   0x00000000, 0x3FEDD800,
/**/                   0x26B3FE23, 0xBEEA1CE9,
/**/                   0x63DB0000, 0x3FB1DCB2,
/**/                   0x5E9E8981, 0x3D39444F,
/**/                   0x00000000, 0x3FEDD000,
/**/                   0x0AB71710, 0x3F1E4836,
/**/                   0x3B75C000, 0x3FB2185B,
/**/                   0xF8F32304, 0xBD3E3189,
/**/                   0x00000000, 0x3FEDC800,
/**/                   0x00EE500F, 0x3F300EE5,
/**/                   0x2F0A0000, 0x3FB253F6,
/**/                   0xFB69A701, 0x3D3416F8,
/**/                   0x00000000, 0x3FEDC000,
/**/                   0x231C226A, 0x3F38A58D,
/**/                   0x450EC000, 0x3FB28F83,
/**/                   0xAA119769, 0x3D3A8D75,
/**/                   0x00000000, 0x3FEDC000,
/**/                   0x14715D63, 0xBF3EAA0C,
/**/                   0x83F5C000, 0x3FB2CB02,
/**/                   0xCA657021, 0x3D3E1EE2,
/**/                   0x00000000, 0x3FEDB800,
/**/                   0x92AEFFC5, 0xBF35DFF8,
/**/                   0xF22C8000, 0x3FB30673,
/**/                   0x9DCF0BA5, 0x3D24C9E2,
/**/                   0x00000000, 0x3FEDB000,
/**/                   0x67E251A0, 0xBF29F894,
/**/                   0x961BC000, 0x3FB341D7,
/**/                   0x99837610, 0x3D31D092,
/**/                   0x00000000, 0x3FEDA800,
/**/                   0x1FF89620, 0xBF0FF896,
/**/                   0x76284000, 0x3FB37D2D,
/**/                   0x9B7FF15C, 0xBD2C60AA,
/**/                   0x00000000, 0x3FEDA000,
/**/                   0x076828BD, 0x3F145E70,
/**/                   0x98B1C000, 0x3FB3B875,
/**/                   0x94ACA313, 0xBD222415,
/**/                   0x00000000, 0x3FED9800,
/**/                   0xE567D573, 0x3F2C8F60,
/**/                   0x04140000, 0x3FB3F3B0,
/**/                   0xACDFCEC5, 0x3CEE2474,
/**/                   0x00000000, 0x3FED9000,
/**/                   0xF3FC4DA2, 0x3F379118,
/**/                   0xBEA64000, 0x3FB42EDC,
/**/                   0xEA7C9ACD, 0x3D1BC0EE,
/**/                   0x00000000, 0x3FED9000,
/**/                   0x049DE4C3, 0xBF3F0C3C,
/**/                   0xCEBB4000, 0x3FB469FB,
/**/                   0x4F257194, 0x3D3B663C,
/**/                   0x00000000, 0x3FED8800,
/**/                   0xF13D5906, 0xBF35905F,
/**/                   0x3AA1C000, 0x3FB4A50D,
/**/                   0x308973E2, 0xBD2F7FE1,
/**/                   0x00000000, 0x3FED8000,
/**/                   0x77D1EA57, 0xBF27F6C8,
/**/                   0x08A34000, 0x3FB4E011,
/**/                   0xDF2C5AE5, 0x3D3AE5CF,
/**/                   0x00000000, 0x3FED7800,
/**/                   0xF4F31BA0, 0xBF026AD1,
/**/                   0x3F060000, 0x3FB51B07,
/**/                   0x278E686A, 0x3D383F69,
/**/                   0x00000000, 0x3FED7000,
/**/                   0xF26DF1BD, 0x3F1DE6B2,
/**/                   0xE40B4000, 0x3FB555EF,
/**/                   0x8C868E23, 0x3D30B497,
/**/                   0x00000000, 0x3FED6800,
/**/                   0x7BA23D96, 0x3F31599F,
/**/                   0xFDF00000, 0x3FB590CA,
/**/                   0x5722ABAA, 0x3D3C284F,
/**/                   0x00000000, 0x3FED6000,
/**/                   0xD425A760, 0x3F3B526C,
/**/                   0x92ED4000, 0x3FB5CB98,
/**/                   0xA64FC52F, 0x3D17BE44,
/**/                   0x00000000, 0x3FED6000,
/**/                   0x546A6FF1, 0xBF3A9BFC,
/**/                   0xA9374000, 0x3FB60658,
/**/                   0xDEE9C4F8, 0x3D30C3B1,
/**/                   0x00000000, 0x3FED5800,
/**/                   0x08F02FAC, 0xBF3071AD,
/**/                   0x46FE8000, 0x3FB6410B,
/**/                   0x3CBD8D14, 0xBD153F8F,
/**/                   0x00000000, 0x3FED5000,
/**/                   0x12C6C142, 0xBF18BAD9,
/**/                   0x726EC000, 0x3FB67BB0,
/**/                   0x69EF5912, 0x3CEF724B,
/**/                   0x00000000, 0x3FED4800,
/**/                   0x3254A5A2, 0x3F10B35C,
/**/                   0x31B00000, 0x3FB6B648,
/**/                   0x1377DE92, 0xBD3BF30A,
/**/                   0x00000000, 0x3FED4000,
/**/                   0x1D41D41D, 0x3F2D41D4,
/**/                   0x8AE58000, 0x3FB6F0D2,
/**/                   0x1B664613, 0xBD34B464,
/**/                   0x00000000, 0x3FED3800,
/**/                   0xF494E548, 0x3F392D71,
/**/                   0x842EC000, 0x3FB72B4F,
/**/                   0xC00C9DD3, 0xBD3704CC,
/**/                   0x00000000, 0x3FED3800,
/**/                   0xFF165C2E, 0xBF3C2DA1,
/**/                   0x23A6C000, 0x3FB765BF,
/**/                   0x35C4256A, 0xBCFECBC0,
/**/                   0x00000000, 0x3FED3000,
/**/                   0x7AA49674, 0xBF317062,
/**/                   0x6F648000, 0x3FB7A021,
/**/                   0xA18418FF, 0x3D3E124C,
/**/                   0x00000000, 0x3FED2800,
/**/                   0x749CB290, 0xBF1A6B80,
/**/                   0x6D7B0000, 0x3FB7DA76,
/**/                   0x4480C89B, 0x3D32CC84,
/**/                   0x00000000, 0x3FED2000,
/**/                   0x25C6336D, 0x3F114B52,
/**/                   0x23F8C000, 0x3FB814BE,
/**/                   0xDA82FDFD, 0x3CCB2381,
/**/                   0x00000000, 0x3FED1800,
/**/                   0xF08A3B1D, 0x3F2EB155,
/**/                   0x98E84000, 0x3FB84EF8,
/**/                   0x246977C9, 0xBD37D5CD,
/**/                   0x00000000, 0x3FED1000,
/**/                   0xBD71CD93, 0x3F3A7692,
/**/                   0xD24FC000, 0x3FB88925,
/**/                   0x44FBB806, 0xBD31D505,
/**/                   0x00000000, 0x3FED1000,
/**/                   0x89FC5E69, 0xBF3A5384,
/**/                   0xD6318000, 0x3FB8C345,
/**/                   0xACB42A66, 0x3D3B20F5,
/**/                   0x00000000, 0x3FED0800,
/**/                   0x6439240E, 0xBF2E0B56,
/**/                   0xAA8C4000, 0x3FB8FD58,
/**/                   0x1BCB725B, 0xBD3EEC90,
/**/                   0x00000000, 0x3FED0000,
/**/                   0x01CFF8C0, 0xBF0CFF8C,
/**/                   0x55594000, 0x3FB9375E,
/**/                   0x7380C364, 0x3D3EDDC3,
/**/                   0x00000000, 0x3FECF800,
/**/                   0x546D8D78, 0x3F1F7661,
/**/                   0xDC8F8000, 0x3FB97156,
/**/                   0x9AFDB97B, 0xBD3C1FC1,
/**/                   0x00000000, 0x3FECF000,
/**/                   0x25FE30D9, 0x3F3372E2,
/**/                   0x46204000, 0x3FB9AB42,
/**/                   0x26787061, 0xBD28A648,
/**/                   0x00000000, 0x3FECE800,
/**/                   0xD92305A6, 0x3F3F1FDB,
/**/                   0x97F9C000, 0x3FB9E520,
/**/                   0xB52DD050, 0x3D235FAC,
/**/                   0x00000000, 0x3FECE800,
/**/                   0x9C37FC63, 0xBF351B8A,
/**/                   0xD8060000, 0x3FBA1EF1,
/**/                   0x6DF97BCB, 0x3D3CD417,
/**/                   0x00000000, 0x3FECE000,
/**/                   0x6CB725AB, 0xBF227EC2,
/**/                   0x0C2B4000, 0x3FBA58B6,
/**/                   0x5C5C9F2A, 0xBD3CDC73,
/**/                   0x00000000, 0x3FECD800,
/**/                   0xE6C2B448, 0x3F05A240,
/**/                   0x3A4AC000, 0x3FBA926D,
/**/                   0x0BD22A9C, 0x3D356365,
/**/                   0x00000000, 0x3FECD000,
/**/                   0xFBB8D9F3, 0x3F2D7EC2,
/**/                   0x68434000, 0x3FBACC17,
/**/                   0xA0B7FA4C, 0xBD2AA783,
/**/                   0x00000000, 0x3FECC800,
/**/                   0x1B71D3E9, 0x3F3AE1DB,
/**/                   0x9BEE4000, 0x3FBB05B4,
/**/                   0x18F84A5E, 0x3D0FF22C,
/**/                   0x00000000, 0x3FECC800,
/**/                   0xCD6DE82D, 0xBF38E45A,
/**/                   0xDB220000, 0x3FBB3F44,
/**/                   0xD8DE09AF, 0x3D3FD153,
/**/                   0x00000000, 0x3FECC000,
/**/                   0xE341926A, 0xBF29269F,
/**/                   0x2BB10000, 0x3FBB78C8,
/**/                   0xBC3987E7, 0xBD325EF7,
/**/                   0x00000000, 0x3FECB800,
/**/                   0xF620C1DA, 0xBEC589FB,
/**/                   0x93690000, 0x3FBBB23E,
/**/                   0x3559DB8B, 0xBD368B18,
/**/                   0x00000000, 0x3FECB000,
/**/                   0x0DE5FF1A, 0x3F28A893,
/**/                   0x18148000, 0x3FBBEBA8,
/**/                   0xB6DF1F57, 0xBD389B78,
/**/                   0x00000000, 0x3FECA800,
/**/                   0x0039563B, 0x3F38EAB9,
/**/                   0xBF79C000, 0x3FBC2504,
/**/                   0xD0EF4ADC, 0x3D3717C4,
/**/                   0x00000000, 0x3FECA800,
/**/                   0x08F377F2, 0xBF3A67D5,
/**/                   0x8F5BC000, 0x3FBC5E54,
/**/                   0x585FBE06, 0x3D1D0C57,
/**/                   0x00000000, 0x3FECA000,
/**/                   0x072792E4, 0xBF2B46E0,
/**/                   0x8D790000, 0x3FBC9797,
/**/                   0x977D1884, 0xBD36E010,
/**/                   0x00000000, 0x3FEC9800,
/**/                   0x1BB327C3, 0xBEE904EA,
/**/                   0xBF8C0000, 0x3FBCD0CD,
/**/                   0xB50DD743, 0x3D33E14D,
/**/                   0x00000000, 0x3FEC9000,
/**/                   0x77683AEC, 0x3F2853EB,
/**/                   0x2B4C4000, 0x3FBD09F7,
/**/                   0x00354E33, 0x3D2048C0,
/**/                   0x00000000, 0x3FEC8800,
/**/                   0xDC52100E, 0x3F3932D7,
/**/                   0xD66CC000, 0x3FBD4313,
/**/                   0x79135713, 0xBD294543,
/**/                   0x00000000, 0x3FEC8800,
/**/                   0x2736962B, 0xBF39AD90,
/**/                   0xC69CC000, 0x3FBD7C23,
/**/                   0xDD328771, 0xBD297EE4,
/**/                   0x00000000, 0x3FEC8000,
/**/                   0xF316B4C2, 0xBF28EEA2,
/**/                   0x0187C000, 0x3FBDB527,
/**/                   0x56AE181F, 0x3D392778,
/**/                   0x00000000, 0x3FEC7800,
/**/                   0x058F7536, 0x3EEAB099,
/**/                   0x8CD60000, 0x3FBDEE1D,
/**/                   0x729EFF89, 0xBD328DA0,
/**/                   0x00000000, 0x3FEC7000,
/**/                   0x1C71C71C, 0x3F2C71C7,
/**/                   0x6E2B0000, 0x3FBE2707,
/**/                   0x2AF0003C, 0xBD2A342C,
/**/                   0x00000000, 0x3FEC6800,
/**/                   0xD6422A30, 0x3F3BB2BB,
/**/                   0xAB274000, 0x3FBE5FE4,
/**/                   0xF74FFE4D, 0xBD35FAE9,
/**/                   0x00000000, 0x3FEC6800,
/**/                   0x54BDE47E, 0xBF36BD01,
/**/                   0x49670000, 0x3FBE98B5,
/**/                   0x89C50E97, 0x3D346774,
/**/                   0x00000000, 0x3FEC6000,
/**/                   0xB5157FE4, 0xBF222CC5,
/**/                   0x4E838000, 0x3FBED179,
/**/                   0x749D0484, 0xBD1FD143,
/**/                   0x00000000, 0x3FEC5800,
/**/                   0xA930B840, 0x3F129A21,
/**/                   0xC0118000, 0x3FBF0A30,
/**/                   0x83368E91, 0xBD3D599E,
/**/                   0x00000000, 0x3FEC5000,
/**/                   0xAC5CEE14, 0x3F3279B1,
/**/                   0xA3A24000, 0x3FBF42DB,
/**/                   0x32DF6C0D, 0xBD3312B7,
/**/                   0x00000000, 0x3FEC5000,
/**/                   0xD4AB8D0B, 0xBF3F9CF5,
/**/                   0xFEC38000, 0x3FBF7B79,
/**/                   0xE897ED01, 0xBD010987,
/**/                   0x00000000, 0x3FEC4800,
/**/                   0xCC17DAE4, 0xBF319D7C,
/**/                   0xD6FF4000, 0x3FBFB40B,
/**/                   0xB7B53B5B, 0x3D2C0BEC,
/**/                   0x00000000, 0x3FEC4000,
/**/                   0x01C3F8F0, 0xBF0C3F8F,
/**/                   0x31DC0000, 0x3FBFEC91,
/**/                   0xD1AE6607, 0xBD354555,
/**/                   0x00000000, 0x3FEC3800,
/**/                   0xAB1B8FFC, 0x3F254738,
/**/                   0x0A6E0000, 0x3FC01285,
/**/                   0x4805BF94, 0xBD1A8619,
/**/                   0x00000000, 0x3FEC3000,
/**/                   0x48B3C5D7, 0x3F38E51F,
/**/                   0x42BF4000, 0x3FC02EBB,
/**/                   0x5CE00E5D, 0xBD15A8FA,
/**/                   0x00000000, 0x3FEC3000,
/**/                   0x867E595E, 0xBF38C377,
/**/                   0x449F6000, 0x3FC04AEB,
/**/                   0x65CCD35C, 0x3D2AFA90,
/**/                   0x00000000, 0x3FEC2800,
/**/                   0x15FE3D95, 0xBF24AC6D,
/**/                   0x12CA6000, 0x3FC06715,
/**/                   0x9CDC0A3D, 0xBD2A4757,
/**/                   0x00000000, 0x3FEC2000,
/**/                   0x53B8CDAE, 0x3F10B34F,
/**/                   0xAFFA2000, 0x3FC08338,
/**/                   0xAC823E27, 0x3D30533C,
/**/                   0x00000000, 0x3FEC1800,
/**/                   0x3FABB0F6, 0x3F32C599,
/**/                   0x1EE72000, 0x3FC09F56,
/**/                   0x7157D1A8, 0xBD28F305,
/**/                   0x00000000, 0x3FEC1800,
/**/                   0x97CD1B6C, 0xBF3E8BF4,
/**/                   0x6247A000, 0x3FC0BB6D,
/**/                   0x3CCD04B3, 0x3D35464F,
/**/                   0x00000000, 0x3FEC1000,
/**/                   0xE3F1F8FC, 0xBF2F8FC7,
/**/                   0x7CD08000, 0x3FC0D77E,
/**/                   0x2EE2F482, 0x3D3CB2CD,
/**/                   0x00000000, 0x3FEC0800,
/**/                   0x5B199F35, 0xBEEDC860,
/**/                   0x7134C000, 0x3FC0F389,
/**/                   0xE893D6C6, 0xBD3DA359,
/**/                   0x00000000, 0x3FEC0000,
/**/                   0x1C01C01C, 0x3F2C01C0,
/**/                   0x42254000, 0x3FC10F8E,
/**/                   0x43396307, 0xBD293B38,
/**/                   0x00000000, 0x3FEBF800,
/**/                   0x256228AA, 0x3F3D0577,
/**/                   0xF2518000, 0x3FC12B8C,
/**/                   0x13C0A0FC, 0x3D348A4A,
/**/                   0x00000000, 0x3FEBF800,
/**/                   0xCB93A8A1, 0xBF33E08B,
/**/                   0x84674000, 0x3FC14785,
/**/                   0x1027C750, 0x3D156345,
/**/                   0x00000000, 0x3FEBF000,
/**/                   0x1DE63F4A, 0xBF12C4DB,
/**/                   0xFB124000, 0x3FC16377,
/**/                   0xBF41763E, 0x3D091E1A,
/**/                   0x00000000, 0x3FEBE800,
/**/                   0x769F9E4F, 0x3F2526D0,
/**/                   0x58FCA000, 0x3FC17F64,
/**/                   0xD093C8DC, 0x3D2843FA,
/**/                   0x00000000, 0x3FEBE000,
/**/                   0x5292D891, 0x3F39ED43,
/**/                   0xA0CEE000, 0x3FC19B4A,
/**/                   0x9621338B, 0xBD3D8824,
/**/                   0x00000000, 0x3FEBE000,
/**/                   0x5FC845A9, 0xBF36A3B3,
/**/                   0xD52F6000, 0x3FC1B72A,
/**/                   0x1811A396, 0x3D2E80A4,
/**/                   0x00000000, 0x3FEBD800,
/**/                   0xB7230491, 0xBF1C7E26,
/**/                   0xF8C36000, 0x3FC1D304,
/**/                   0xDF451042, 0xBD3A6D44,
/**/                   0x00000000, 0x3FEBD000,
/**/                   0x451B61CB, 0x3F20F365,
/**/                   0x0E2DC000, 0x3FC1EED9,
/**/                   0x7097648F, 0x3D161563,
/**/                   0x00000000, 0x3FEBC800,
/**/                   0xD72DD0AA, 0x3F3827F3,
/**/                   0x18102000, 0x3FC20AA7,
/**/                   0x348552FE, 0x3D3F2C94,
/**/                   0x00000000, 0x3FEBC800,
/**/                   0xBE0C262F, 0xBF3814D3,
/**/                   0x190A6000, 0x3FC2266F,
/**/                   0xB840E7F6, 0xBD24D20A,
/**/                   0x00000000, 0x3FEBC000,
/**/                   0x7ECECB53, 0xBF207963,
/**/                   0x13BA6000, 0x3FC24231,
/**/                   0x78EE9D9C, 0xBD3E3A00,
/**/                   0x00000000, 0x3FEBB800,
/**/                   0xF29268D3, 0x3F1EC130,
/**/                   0x0ABC6000, 0x3FC25DED,
/**/                   0x4F176449, 0x3D35A385,
/**/                   0x00000000, 0x3FEBB000,
/**/                   0xAB6353BF, 0x3F37B218,
/**/                   0x00AB4000, 0x3FC279A3,
/**/                   0xB3235108, 0x3D3EF432,
/**/                   0x00000000, 0x3FEBB000,
/**/                   0xF2298376, 0xBF383759,
/**/                   0xF8200000, 0x3FC29552,
/**/                   0xF4471DFC, 0xBD35B967,
/**/                   0x00000000, 0x3FEBA800,
/**/                   0x1EAD4253, 0xBF201832,
/**/                   0xF3B1A000, 0x3FC2B0FC,
/**/                   0xE30A59EA, 0x3D177CA3,
/**/                   0x00000000, 0x3FEBA000,
/**/                   0xD84886B1, 0x3F20679B,
/**/                   0xF5F60000, 0x3FC2CCA0,
/**/                   0x91AFF120, 0xBD3B5EF1,
/**/                   0x00000000, 0x3FEB9800,
/**/                   0xA41FEB4C, 0x3F38884D,
/**/                   0x0180E000, 0x3FC2E83F,
/**/                   0xC284E1CE, 0xBD3F0C2A,
/**/                   0x00000000, 0x3FEB9800,
/**/                   0x3806E548, 0xBF370EA7,
/**/                   0x18E48000, 0x3FC303D7,
/**/                   0xCE3ECB05, 0xBCD680B5,
/**/                   0x00000000, 0x3FEB9000,
/**/                   0xB5EF34C0, 0xBF1A4477,
/**/                   0x3EB1A000, 0x3FC31F69,
/**/                   0xE5A396FB, 0xBD2A6726,
/**/                   0x00000000, 0x3FEB8800,
/**/                   0x9401B894, 0x3F2401B8,
/**/                   0x75770000, 0x3FC33AF5,
/**/                   0xA2FE72A5, 0x3D3C9ECC,
/**/                   0x00000000, 0x3FEB8000,
/**/                   0x400DC1AA, 0x3F3AA73A,
/**/                   0xBFC22000, 0x3FC3567B,
/**/                   0x53991A1F, 0x3D3250D2,
/**/                   0x00000000, 0x3FEB8000,
/**/                   0x2E63A6A8, 0xBF349E11,
/**/                   0x201E8000, 0x3FC371FC,
/**/                   0x9B2D8ABC, 0x3D3EE877,
/**/                   0x00000000, 0x3FEB7800,
/**/                   0xC8DA04B9, 0xBF0E7898,
/**/                   0x99164000, 0x3FC38D76,
/**/                   0x9E39BB70, 0x3D1844A5,
/**/                   0x00000000, 0x3FEB7000,
/**/                   0xE6B33E2D, 0x3F2A284E,
/**/                   0x2D31A000, 0x3FC3A8EB,
/**/                   0x7D5D503E, 0x3D1BAFB7,
/**/                   0x00000000, 0x3FEB6800,
/**/                   0x759C2BB4, 0x3F3E0B91,
/**/                   0xDEF76000, 0x3FC3C459,
/**/                   0xF6B70D33, 0x3D3EDC86,
/**/                   0x00000000, 0x3FEB6800,
/**/                   0x088FD6E7, 0xBF30E8E2,
/**/                   0xB0ECC000, 0x3FC3DFC2,
/**/                   0x62B8C13F, 0x3D28A72A,
/**/                   0x00000000, 0x3FEB6000,
/**/                   0xD801B600, 0x3ECB6006,
/**/                   0xA5952000, 0x3FC3FB25,
/**/                   0x6B358FF7, 0x3D3195BE,
/**/                   0x00000000, 0x3FEB5800,
/**/                   0xD840F62C, 0x3F316A6A,
/**/                   0xBF728000, 0x3FC41682,
/**/                   0x081F849D, 0xBD210047,
/**/                   0x00000000, 0x3FEB5800,
/**/                   0x7DF8BD99, 0xBF3D4DEE,
/**/                   0x01050000, 0x3FC431DA,
/**/                   0x836E0391, 0x3D304837,
/**/                   0x00000000, 0x3FEB5000,
/**/                   0x7E4B17E5, 0xBF27E4B1,
/**/                   0x6CCB8000, 0x3FC44D2B,
/**/                   0x6135783C, 0xBD170CC1,
/**/                   0x00000000, 0x3FEB4800,
/**/                   0x55E6D8FE, 0x3F15F47D,
/**/                   0x05430000, 0x3FC46877,
/**/                   0xF8D5087E, 0xBD3D8145,
/**/                   0x00000000, 0x3FEB4000,
/**/                   0x0B803686, 0x3F37006D,
/**/                   0xCCE6E000, 0x3FC483BC,
/**/                   0x723F6369, 0x3D1EEA52,
/**/                   0x00000000, 0x3FEB4000,
/**/                   0x46A66920, 0xBF37687C,
/**/                   0xC6314000, 0x3FC49EFC,
/**/                   0x9F55572B, 0xBD090F59,
/**/                   0x00000000, 0x3FEB3800,
/**/                   0xFF2645BE, 0xBF16F6A4,
/**/                   0xF39A6000, 0x3FC4BA36,
/**/                   0xB3F219E5, 0xBD34354B,
/**/                   0x00000000, 0x3FEB3000,
/**/                   0x1801B318, 0x3F2801B3,
/**/                   0x5798E000, 0x3FC4D56B,
/**/                   0x15A96555, 0x3D380580,
/**/                   0x00000000, 0x3FEB2800,
/**/                   0x93511680, 0x3F3DD2FF,
/**/                   0xF4A24000, 0x3FC4F099,
/**/                   0xFAFEAF27, 0xBD3E9BF2,
/**/                   0x00000000, 0x3FEB2800,
/**/                   0xA89DCCAC, 0xBF304743,
/**/                   0xCD29C000, 0x3FC50BC2,
/**/                   0x28DB8D4F, 0x3D1ADA57,
/**/                   0x00000000, 0x3FEB2000,
/**/                   0x406C80D9, 0x3EFB2036,
/**/                   0xE3A1C000, 0x3FC526E5,
/**/                   0x37FC5238, 0xBD3790BA,
/**/                   0x00000000, 0x3FEB1800,
/**/                   0x4F9DC00E, 0x3F33BEC8,
/**/                   0x3A7A8000, 0x3FC54203,
/**/                   0xED855F0E, 0x3D268D68,
/**/                   0x00000000, 0x3FEB1800,
/**/                   0x44F8CE7E, 0xBF3A2101,
/**/                   0xD4232000, 0x3FC55D1A,
/**/                   0xDDA647E8, 0x3D3ADD94,
/**/                   0x00000000, 0x3FEB1000,
/**/                   0xB99AF3F3, 0xBF1FB596,
/**/                   0xB3092000, 0x3FC5782C,
/**/                   0x51794442, 0xBD33A463,
/**/                   0x00000000, 0x3FEB0800,
/**/                   0x922A3E85, 0x3F24B31D,
/**/                   0xD9982000, 0x3FC59338,
/**/                   0xB7555D4A, 0x3CF0BA68,
/**/                   0x00000000, 0x3FEB0000,
/**/                   0xE19BF6B7, 0x3F3CB3CF,
/**/                   0x4A3AA000, 0x3FC5AE3F,
/**/                   0xF012A8B9, 0x3D21EA25,
/**/                   0x00000000, 0x3FEB0000,
/**/                   0x9A5BF0D1, 0xBF30DEAE,
/**/                   0x07598000, 0x3FC5C940,
/**/                   0x8CD23322, 0xBD3A8D94,
/**/                   0x00000000, 0x3FEAF800,
/**/                   0x9EDE13CE, 0x3EFA2072,
/**/                   0x135BE000, 0x3FC5E43B,
/**/                   0xCEED9C31, 0xBD343AB4,
/**/                   0x00000000, 0x3FEAF000,
/**/                   0x0D79435E, 0x3F3435E5,
/**/                   0x70A7A000, 0x3FC5FF30,
/**/                   0x183BEBF2, 0xBD38586F,
/**/                   0x00000000, 0x3FEAF000,
/**/                   0x06855D30, 0xBF392321,
/**/                   0x21A0E000, 0x3FC61A20,
/**/                   0x1BDF3CDD, 0x3D3DD9DD,
/**/                   0x00000000, 0x3FEAE800,
/**/                   0x7ABED811, 0xBF19A45C,
/**/                   0x28AAA000, 0x3FC6350A,
/**/                   0xAB8163AF, 0x3D2D5EC0,
/**/                   0x00000000, 0x3FEAE000,
/**/                   0x84EF68CB, 0x3F28C7ED,
/**/                   0x88260000, 0x3FC64FEE,
/**/                   0x759DDED6, 0xBD1DA40D,
/**/                   0x00000000, 0x3FEAD800,
/**/                   0xA482F00D, 0x3F3F43FC,
/**/                   0x4272A000, 0x3FC66ACD,
/**/                   0xBFC6C785, 0x3D3AA1BD,
/**/                   0x00000000, 0x3FEAD800,
/**/                   0xCDE3E7AE, 0xBF2B9222,
/**/                   0x59EF0000, 0x3FC685A6,
/**/                   0x6C103214, 0xBD21F2A9,
/**/                   0x00000000, 0x3FEAD000,
/**/                   0xEED254A3, 0x3F14F302,
/**/                   0xD0F7A000, 0x3FC6A079,
/**/                   0x448D14F5, 0x3D35A3F8,
/**/                   0x00000000, 0x3FEAC800,
/**/                   0x32071DEF, 0x3F385567,
/**/                   0xA9E80000, 0x3FC6BB47,
/**/                   0x23EA3296, 0x3D19F64D,
/**/                   0x00000000, 0x3FEAC800,
/**/                   0xD47F29D4, 0xBF347F29,
/**/                   0xE719E000, 0x3FC6D60F,
/**/                   0x57134767, 0xBD3BC6E5,
/**/                   0x00000000, 0x3FEAC000,
/**/                   0xE82D23BC, 0xBEF40FE1,
/**/                   0x8AE56000, 0x3FC6F0D2,
/**/                   0xC93373DA, 0x3D369737,
/**/                   0x00000000, 0x3FEAB800,
/**/                   0x972D8538, 0x3F320FDE,
/**/                   0x97A1A000, 0x3FC70B8F,
/**/                   0xF6A95BEF, 0x3D34EA64,
/**/                   0x00000000, 0x3FEAB800,
/**/                   0x66711513, 0xBF3A8C9F,
/**/                   0x0FA40000, 0x3FC72647,
/**/                   0x0E743A45, 0xBD3774DF,
/**/                   0x00000000, 0x3FEAB000,
/**/                   0x02806ABC, 0xBF1C5A0F,
/**/                   0xF5404000, 0x3FC740F8,
/**/                   0x99018AA1, 0xBD30B66C,
/**/                   0x00000000, 0x3FEAA800,
/**/                   0xD22C937A, 0x3F28E44B,
/**/                   0x4AC8E000, 0x3FC75BA5,
/**/                   0x8BC4A7C0, 0x3D3DDCA5,
/**/                   0x00000000, 0x3FEAA800,
/**/                   0xFF2ADFF3, 0xBF3FF2AD,
/**/                   0x128F2000, 0x3FC7764C,
/**/                   0x3479E3D1, 0x3D027490,
/**/                   0x00000000, 0x3FEAA000,
/**/                   0x0B3ADA5C, 0xBF288A16,
/**/                   0x4EE26000, 0x3FC790ED,
/**/                   0x4E7746F6, 0x3D199BBD,
/**/                   0x00000000, 0x3FEA9800,
/**/                   0x4C77B035, 0x3F1DEC0D,
/**/                   0x0210E000, 0x3FC7AB89,
/**/                   0x72534A58, 0xBD2BDB90,
/**/                   0x00000000, 0x3FEA9000,
/**/                   0x91F59E6B, 0x3F3B4D71,
/**/                   0x2E674000, 0x3FC7C61F,
/**/                   0xB31BE8E0, 0xBD32392D,
/**/                   0x00000000, 0x3FEA9000,
/**/                   0xB8A2A522, 0xBF30CDCB,
/**/                   0xD630C000, 0x3FC7E0AF,
/**/                   0x1D8F1034, 0x3D139E7C,
/**/                   0x00000000, 0x3FEA8800,
/**/                   0x6A2194A0, 0x3F094A00,
/**/                   0xFBB76000, 0x3FC7FB3A,
/**/                   0x24609D57, 0xBD37DBF5,
/**/                   0x00000000, 0x3FEA8000,
/**/                   0x870AC52E, 0x3F373289,
/**/                   0xA1436000, 0x3FC815C0,
/**/                   0xF9201CE8, 0xBD302A52,
/**/                   0x00000000, 0x3FEA8000,
/**/                   0x9E8684DD, 0xBF34B1FA,
/**/                   0xC91BC000, 0x3FC83040,
/**/                   0xC6E66F32, 0x3D3E5B71,
/**/                   0x00000000, 0x3FEA7800,
/**/                   0xA9267648, 0xBEE08AF5,
/**/                   0x75866000, 0x3FC84ABB,
/**/                   0xDF4E2BD2, 0xBD3D8DAA,
/**/                   0x00000000, 0x3FEA7000,
/**/                   0x1A3D927E, 0x3F33BB67,
/**/                   0xA8C70000, 0x3FC86530,
/**/                   0xCB4EA3E3, 0x3D398BB0,
/**/                   0x00000000, 0x3FEA7000,
/**/                   0x7F2C97F3, 0xBF37F2C9,
/**/                   0x6520C000, 0x3FC87FA0,
/**/                   0x401202FC, 0x3D322120,
/**/                   0x00000000, 0x3FEA6800,
/**/                   0x3C076D20, 0xBF0C77A5,
/**/                   0xACD4E000, 0x3FC89A0A,
/**/                   0xDA8F5A72, 0x3D2C0BFB,
/**/                   0x00000000, 0x3FEA6000,
/**/                   0x7C7EF82B, 0x3F30E6DA,
/**/                   0x82236000, 0x3FC8B46F,
/**/                   0x102DD7C9, 0x3D12D9F2,
/**/                   0x00000000, 0x3FEA6000,
/**/                   0x2EC05C44, 0xBF3A9167,
/**/                   0xE74AE000, 0x3FC8CECE,
/**/                   0xAA429BB5, 0xBD3A5BA0,
/**/                   0x00000000, 0x3FEA5800,
/**/                   0xEEB6BD53, 0xBF17DF12,
/**/                   0xDE886000, 0x3FC8E928,
/**/                   0xB13D72D5, 0x3D3A8154,
/**/                   0x00000000, 0x3FEA5000,
/**/                   0x98C70AE6, 0x3F2D676D,
/**/                   0x6A180000, 0x3FC9037D,
/**/                   0x57C1C8D9, 0x3D230DEA,
/**/                   0x00000000, 0x3FEA5000,
/**/                   0x96CE4780, 0xBF3C8EFF,
/**/                   0x8C340000, 0x3FC91DCC,
/**/                   0xBDDEFF46, 0x3D37BC6A,
/**/                   0x00000000, 0x3FEA4800,
/**/                   0x71EFFCB7, 0xBF1EFFCB,
/**/                   0x4715A000, 0x3FC93816,
/**/                   0x6A3A39D9, 0xBD34C63D,
/**/                   0x00000000, 0x3FEA4000,
/**/                   0x1A41A41A, 0x3F2A41A4,
/**/                   0x9CF46000, 0x3FC9525A,
/**/                   0x7D9F158F, 0xBD329713,
/**/                   0x00000000, 0x3FEA4000,
/**/                   0xBF3B3C0E, 0xBF3DECBB,
/**/                   0x9006A000, 0x3FC96C99,
/**/                   0x9CBB452C, 0x3D2A88D5,
/**/                   0x00000000, 0x3FEA3800,
/**/                   0x3BCD35A8, 0xBF21D14E,
/**/                   0x22818000, 0x3FC986D3,
/**/                   0x4DD44000, 0x3CF93B56,
/**/                   0x00000000, 0x3FEA3000,
/**/                   0x3B5832C0, 0x3F285A0A,
/**/                   0x56988000, 0x3FC9A107,
/**/                   0x242CD098, 0x3D264AA6,
/**/                   0x00000000, 0x3FEA3000,
/**/                   0xD71AFD8C, 0xBF3EABC1,
/**/                   0x2E7E0000, 0x3FC9BB36,
/**/                   0xA1CE0FFC, 0xBD21F2A8,
/**/                   0x00000000, 0x3FEA2800,
/**/                   0x7C041611, 0xBF22E60D,
/**/                   0xAC62E000, 0x3FC9D55F,
/**/                   0xFC3B5BC3, 0xBD3F4669,
/**/                   0x00000000, 0x3FEA2000,
/**/                   0x5FF2EF43, 0x3F27AE57,
/**/                   0xD276A000, 0x3FC9EF83,
/**/                   0xB3F9CE00, 0xBD2730B7,
/**/                   0x00000000, 0x3FEA2000,
/**/                   0x3D66322E, 0xBF3ECD35,
/**/                   0xA2E7A000, 0x3FCA09A2,
/**/                   0xCD411233, 0xBD2DD99D,
/**/                   0x00000000, 0x3FEA1800,
/**/                   0x5B4FE5E9, 0xBF22C068,
/**/                   0x1FE2C000, 0x3FCA23BC,
/**/                   0x91DC9F0B, 0xBD3539CD,
/**/                   0x00000000, 0x3FEA1000,
/**/                   0x80B67A9A, 0x3F283C48,
/**/                   0x4B938000, 0x3FCA3DD0,
/**/                   0x366E2C5A, 0x3D297DA1,
/**/                   0x00000000, 0x3FEA1000,
/**/                   0x89907BBA, 0xBF3E5236,
/**/                   0x28244000, 0x3FCA57DF,
/**/                   0xCA1D9ABB, 0x3D3B99C8,
/**/                   0x00000000, 0x3FEA0800,
/**/                   0x32054967, 0xBF21629E,
/**/                   0xB7BE0000, 0x3FCA71E8,
/**/                   0x6EF05323, 0xBD210ACA,
/**/                   0x00000000, 0x3FEA0000,
/**/                   0x1A01A01A, 0x3F2A01A0,
/**/                   0xFC882000, 0x3FCA8BEC,
/**/                   0xCF21B9CF, 0x3D3E3185,
/**/                   0x00000000, 0x3FEA0000,
/**/                   0x93FF301D, 0xBF3D3BE3,
/**/                   0xF8A94000, 0x3FCAA5EB,
/**/                   0x36951A8F, 0xBD32A0A9,
/**/                   0x00000000, 0x3FE9F800,
/**/                   0xBFE608ED, 0xBF1D9DD1,
/**/                   0xAE462000, 0x3FCABFE5,
/**/                   0x395F139D, 0xBD3B68F5,
/**/                   0x00000000, 0x3FE9F000,
/**/                   0x1B29257F, 0x3F2CFC26,
/**/                   0x1F828000, 0x3FCAD9DA,
/**/                   0xC803F050, 0xBD3882B7,
/**/                   0x00000000, 0x3FE9F000,
/**/                   0x7E613717, 0xBF3B8B57,
/**/                   0x4E80C000, 0x3FCAF3C9,
/**/                   0x3FCD9066, 0xBCBA4E63,
/**/                   0x00000000, 0x3FE9E800,
/**/                   0xB9FABD04, 0xBF160EF9,
/**/                   0x3D620000, 0x3FCB0DB3,
/**/                   0x38EAB906, 0x3D3FEE14,
/**/                   0x00000000, 0x3FE9E000,
/**/                   0xEAF850E2, 0x3F3094D3,
/**/                   0xEE464000, 0x3FCB2797,
/**/                   0x906D00A9, 0xBD3BE88A,
/**/                   0x00000000, 0x3FE9E000,
/**/                   0xBBE88FDC, 0xBF3941AA,
/**/                   0x634BA000, 0x3FCB4177,
/**/                   0x5666069F, 0x3D355D01,
/**/                   0x00000000, 0x3FE9D800,
/**/                   0x25F4B1AA, 0xBF083A25,
/**/                   0x9E8FC000, 0x3FCB5B51,
/**/                   0xEC011F31, 0xBD34B722,
/**/                   0x00000000, 0x3FE9D000,
/**/                   0xF71FAC14, 0x3F3343FB,
/**/                   0xA22E4000, 0x3FCB7526,
/**/                   0x2E785490, 0x3D2C0DBF,
/**/                   0x00000000, 0x3FE9D000,
/**/                   0x1965FF32, 0xBF365FF3,
/**/                   0x70420000, 0x3FCB8EF6,
/**/                   0x321788E0, 0x3D387533,
/**/                   0x00000000, 0x3FE9C800,
/**/                   0x9C8019C8, 0x3EA9C801,
/**/                   0x0AE46000, 0x3FCBA8C1,
/**/                   0x9EEE9D85, 0x3D3A32E2,
/**/                   0x00000000, 0x3FE9C000,
/**/                   0x25080CE1, 0x3F368A77,
/**/                   0x742D8000, 0x3FCBC286,
/**/                   0xF39D121C, 0x3D39AC53,
/**/                   0x00000000, 0x3FE9C000,
/**/                   0xC54763F2, 0xBF32E743,
/**/                   0xAE344000, 0x3FCBDC46,
/**/                   0x023D6505, 0x3D3625B4,
/**/                   0x00000000, 0x3FE9B800,
/**/                   0x8B7424F9, 0x3F0DBD49,
/**/                   0xBB0E4000, 0x3FCBF601,
/**/                   0x47C378B5, 0x3D2386A9,
/**/                   0x00000000, 0x3FE9B000,
/**/                   0x00CD9A67, 0x3F3A6734,
/**/                   0x9CCFE000, 0x3FCC0FB7,
/**/                   0x99E8A558, 0xBD346FFF,
/**/                   0x00000000, 0x3FE9B000,
/**/                   0xAEF25B7C, 0xBF2DB15A,
/**/                   0x558C2000, 0x3FCC2968,
/**/                   0xDEE38A40, 0xBD2CFD73,
/**/                   0x00000000, 0x3FE9A800,
/**/                   0xC140C073, 0x3F1FDFEC,
/**/                   0xE754E000, 0x3FCC4313,
/**/                   0x74CAD7D6, 0x3D3279BE,
/**/                   0x00000000, 0x3FE9A000,
/**/                   0xA7DCBEB3, 0x3F3ED923,
/**/                   0x543AE000, 0x3FCC5CBA,
/**/                   0xECB454FC, 0x3D20929D,
/**/                   0x00000000, 0x3FE9A000,
/**/                   0xB256DE2C, 0xBF246A7B,
/**/                   0x9E4D6000, 0x3FCC765B,
/**/                   0x36976F6C, 0x3D31AB6B,
/**/                   0x00000000, 0x3FE99800,
/**/                   0x9999999A, 0x3F299999,
/**/                   0xC79AA000, 0x3FCC8FF7,
/**/                   0x689F8434, 0xBD27794F,
/**/                   0x00000000, 0x3FE99800,
/**/                   0x3EC03FF3, 0xBF3C20C6,
/**/                   0xD22F6000, 0x3FCCA98E,
/**/                   0x8CA209C8, 0xBCF698C1,
/**/                   0x00000000, 0x3FE99000,
/**/                   0x31EC07FD, 0xBF13F803,
/**/                   0xC0176000, 0x3FCCC320,
/**/                   0x9A653794, 0x3D240903,
/**/                   0x00000000, 0x3FE98800,
/**/                   0x5AC98715, 0x3F323513,
/**/                   0x935D2000, 0x3FCCDCAD,
/**/                   0x34C9A447, 0xBD0A0FF0,
/**/                   0x00000000, 0x3FE98800,
/**/                   0x89F80661, 0xBF368793,
/**/                   0x4E09C000, 0x3FCCF635,
/**/                   0x9A07D55B, 0x3D277123,
/**/                   0x00000000, 0x3FE98000,
/**/                   0x8019801A, 0x3EE98019,
/**/                   0xF2256000, 0x3FCD0FB7,
/**/                   0x20633B29, 0xBD0AF52B,
/**/                   0x00000000, 0x3FE97800,
/**/                   0xAB329020, 0x3F382FC6,
/**/                   0x81B6C000, 0x3FCD2935,
/**/                   0x128AAA5F, 0xBD383270,
/**/                   0x00000000, 0x3FE97800,
/**/                   0x962DBFF3, 0xBF305C4B,
/**/                   0xFEC36000, 0x3FCD42AD,
/**/                   0xFD804272, 0xBD175C00,
/**/                   0x00000000, 0x3FE97000,
/**/                   0x970E4F81, 0x3F1C9F01,
/**/                   0x6B4FC000, 0x3FCD5C21,
/**/                   0xBBCA681B, 0xBD21BA91,
/**/                   0x00000000, 0x3FE96800,
/**/                   0x049160B8, 0x3F3EBBE1,
/**/                   0xC95F0000, 0x3FCD758F,
/**/                   0x8B4162AA, 0xBD15A10A,
/**/                   0x00000000, 0x3FE96800,
/**/                   0x9933FE6A, 0xBF233FE6,
/**/                   0x1AF32000, 0x3FCD8EF9,
/**/                   0xC364C784, 0xBD15105F,
/**/                   0x00000000, 0x3FE96000,
/**/                   0xCE078906, 0x3F2C2873,
/**/                   0x620CE000, 0x3FCDA85D,
/**/                   0xC16CC7EC, 0x3D240194,
/**/                   0x00000000, 0x3FE96000,
/**/                   0xE442936B, 0xBF3A27A0,
/**/                   0xA0ABE000, 0x3FCDC1BC,
/**/                   0xA628CCC6, 0x3D38FAC1,
/**/                   0x00000000, 0x3FE95800,
/**/                   0x548A97A9, 0xBF029C69,
/**/                   0xD8CEA000, 0x3FCDDB16,
/**/                   0x7104B8BC, 0xBD1EEF79,
/**/                   0x00000000, 0x3FE95000,
/**/                   0x9F74B92D, 0x3F35906B,
/**/                   0x0C722000, 0x3FCDF46C,
/**/                   0xB0B79039, 0x3D3A5E82,
/**/                   0x00000000, 0x3FE95000,
/**/                   0xF35927BC, 0xBF327BBF,
/**/                   0x3D92A000, 0x3FCE0DBC,
/**/                   0xF0529BF1, 0x3D359233,
/**/                   0x00000000, 0x3FE94800,
/**/                   0xDD3C0CA4, 0x3F161F9A,
/**/                   0x6E2B0000, 0x3FCE2707,
/**/                   0x2AF0003C, 0xBD3A342C,
/**/                   0x00000000, 0x3FE94000,
/**/                   0x41228A8F, 0x3F3D9B56,
/**/                   0xA034C000, 0x3FCE404D,
/**/                   0xE09A2799, 0xBD3187EE,
/**/                   0x00000000, 0x3FE94000,
/**/                   0x598A73F8, 0xBF2482F5,
/**/                   0xD5A88000, 0x3FCE598E,
/**/                   0xCF1E98A1, 0xBD0D134B,
/**/                   0x00000000, 0x3FE93800,
/**/                   0x3C1B9728, 0x3F2BE2D5,
/**/                   0x107DA000, 0x3FCE72CB,
/**/                   0xCDF5471C, 0x3D1DD48C,
/**/                   0x00000000, 0x3FE93800,
/**/                   0x2698CFF3, 0xBF39CC03,
/**/                   0x52AA6000, 0x3FCE8C02,
/**/                   0x80E8E6FF, 0xBD26805B,
/**/                   0x00000000, 0x3FE93000,
/**/                   0xB9F30358, 0xBEF79CD3,
/**/                   0x9E23A000, 0x3FCEA534,
/**/                   0x4C73CCB5, 0x3D381B93,
/**/                   0x00000000, 0x3FE92800,
/**/                   0x255BA00D, 0x3F36E803,
/**/                   0xF4DD8000, 0x3FCEBE61,
/**/                   0x30FDCA4D, 0xBD23D453,
/**/                   0x00000000, 0x3FE92800,
/**/                   0x36077742, 0xBF30A69B,
/**/                   0x58CA8000, 0x3FCED78A,
/**/                   0x3793387E, 0x3D16F1B5,
/**/                   0x00000000, 0x3FE92000,
/**/                   0x1C451AB3, 0x3F1F693A,
/**/                   0xCBDC6000, 0x3FCEF0AD,
/**/                   0x9C86AF24, 0xBD2B26B7,
/**/                   0x00000000, 0x3FE92000,
/**/                   0xC74EA9E2, 0xBF3F9548,
/**/                   0x50036000, 0x3FCF09CC,
/**/                   0x18D999DB, 0x3D3DA094,
/**/                   0x00000000, 0x3FE91800,
/**/                   0xF7C46911, 0xBF1BD5A8,
/**/                   0xE72F2000, 0x3FCF22E5,
/**/                   0x1417E41F, 0xBD3F454F,
/**/                   0x00000000, 0x3FE91000,
/**/                   0x0D83D1C6, 0x3F31B9E1,
/**/                   0x934D6000, 0x3FCF3BFA,
/**/                   0x937B903B, 0x3D2D9F2A,
/**/                   0x00000000, 0x3FE91000,
/**/                   0xF3795877, 0xBF35876F,
/**/                   0x564B8000, 0x3FCF550A,
/**/                   0xA09202FE, 0xBD2323E3,
/**/                   0x00000000, 0x3FE90800,
/**/                   0xBD1D87EC, 0x3F0A34CD,
/**/                   0x32154000, 0x3FCF6E15,
/**/                   0x7AC4EC74, 0xBD3C9A97,
/**/                   0x00000000, 0x3FE90000,
/**/                   0x0E760899, 0x3F3C23F5,
/**/                   0x28956000, 0x3FCF871B,
/**/                   0x6A526EFE, 0xBD3F75FD,
/**/                   0x00000000, 0x3FE90000,
/**/                   0xD0BE9594, 0xBF25DECD,
/**/                   0x3BB58000, 0x3FCFA01C,
/**/                   0xFAE1D786, 0xBD1A1F71,
/**/                   0x00000000, 0x3FE8F800,
/**/                   0xC18F9C19, 0x3F2C18F9,
/**/                   0x6D5E4000, 0x3FCFB918,
/**/                   0xAB993C87, 0xBD0D572A,
/**/                   0x00000000, 0x3FE8F800,
/**/                   0x8176594C, 0xBF38E868,
/**/                   0xBF770000, 0x3FCFD20F,
/**/                   0x72C6FE70, 0xBD11C55B,
/**/                   0x00000000, 0x3FE8F000,
/**/                   0x3C018F00, 0x3EC8F006,
/**/                   0x33E60000, 0x3FCFEB02,
/**/                   0x32D5E8C7, 0x3D2F316E,
/**/                   0x00000000, 0x3FE8E800,
/**/                   0xAD115384, 0x3F395B4D,
/**/                   0xE6484000, 0x3FD001F7,
/**/                   0x40C9ABBC, 0x3D38A957,
/**/                   0x00000000, 0x3FE8E800,
/**/                   0xEC8C0F90, 0xBF2AD850,
/**/                   0x45AD5000, 0x3FD00E6C,
/**/                   0x52E01203, 0x3CDCC68D,
/**/                   0x00000000, 0x3FE8E000,
/**/                   0xA56B1AA1, 0x3F27B6E9,
/**/                   0x3913A000, 0x3FD01ADE,
/**/                   0xCCDC1521, 0xBD108930,
/**/                   0x00000000, 0x3FE8E000,
/**/                   0x40DFC1D8, 0xBF3ACDE3,
/**/                   0xC16C2000, 0x3FD0274D,
/**/                   0x9CF835C2, 0x3D2979E8,
/**/                   0x00000000, 0x3FE8D800,
/**/                   0x317DF64C, 0xBEF68397,
/**/                   0xDFA74000, 0x3FD033BA,
/**/                   0x1485BDFF, 0x3D0C30BC,
/**/                   0x00000000, 0x3FE8D000,
/**/                   0x80C6980C, 0x3F380C69,
/**/                   0x94B4D000, 0x3FD04025,
/**/                   0x9EF42D7F, 0x3CF036B8,
/**/                   0x00000000, 0x3FE8D000,
/**/                   0x338C7FE7, 0xBF2CE006,
/**/                   0xE1842000, 0x3FD04C8D,
/**/                   0x512CEB86, 0xBD1FE6BA,
/**/                   0x00000000, 0x3FE8C800,
/**/                   0x1EFBBD63, 0x3F2644F0,
/**/                   0xC703F000, 0x3FD058F3,
/**/                   0xBCD236AD, 0xBD30E866,
/**/                   0x00000000, 0x3FE8C800,
/**/                   0xAA79217A, 0xBF3B3C2D,
/**/                   0x46227000, 0x3FD06557,
/**/                   0xB4868D6A, 0x3D0131DF,
/**/                   0x00000000, 0x3FE8C000,
/**/                   0x8062FF3A, 0xBEF8BFCE,
/**/                   0x5FCD6000, 0x3FD071B8,
/**/                   0xA3E01A11, 0xBD3BCB8B,
/**/                   0x00000000, 0x3FE8B800,
/**/                   0xBD2672C4, 0x3F383301,
/**/                   0x14F1D000, 0x3FD07E17,
/**/                   0x4F384BD5, 0xBD3EFCC6,
/**/                   0x00000000, 0x3FE8B800,
/**/                   0x9BFE749C, 0xBF2BFE74,
/**/                   0x667C5000, 0x3FD08A73,
/**/                   0x40C5A329, 0x3D3EBC1D,
/**/                   0x00000000, 0x3FE8B000,
/**/                   0xD4353EB3, 0x3F27BA8C,
/**/                   0x55591000, 0x3FD096CD,
/**/                   0x20550A31, 0x3D3F998D,
/**/                   0x00000000, 0x3FE8B000,
/**/                   0xA062B2E4, 0xBF3A3784,
/**/                   0xE2739000, 0x3FD0A324,
/**/                   0x7EF4030E, 0x3D0C6BEE,
/**/                   0x00000000, 0x3FE8A800,
/**/                   0x5E630281, 0xBECED1F6,
/**/                   0x0EB6C000, 0x3FD0AF7A,
/**/                   0x4945ADAD, 0x3D23CCF9,
/**/                   0x00000000, 0x3FE8A000,
/**/                   0x0C519CAE, 0x3F39CAE0,
/**/                   0xDB0D2000, 0x3FD0BBCC,
/**/                   0xCC5DCDFB, 0x3D32F32C,
/**/                   0x00000000, 0x3FE8A000,
/**/                   0x4EDBA5FD, 0xBF283C02,
/**/                   0x4860B000, 0x3FD0C81D,
/**/                   0x401D1731, 0xBD3E5BCF,
/**/                   0x00000000, 0x3FE89800,
/**/                   0x1899C0F6, 0x3F2C0F60,
/**/                   0x579AB000, 0x3FD0D46B,
/**/                   0xF640E1E6, 0x3D3D2C81,
/**/                   0x00000000, 0x3FE89800,
/**/                   0xBDBE51D0, 0xBF37C414,
/**/                   0x09A43000, 0x3FD0E0B7,
/**/                   0xA7862F2A, 0x3D32A038,
/**/                   0x00000000, 0x3FE89000,
/**/                   0xDD12CE7D, 0x3F03F540,
/**/                   0x5F658000, 0x3FD0ED00,
/**/                   0x285AA803, 0xBD22DC75,
/**/                   0x00000000, 0x3FE88800,
/**/                   0x400C45CD, 0x3F3CCFDE,
/**/                   0x59C67000, 0x3FD0F947,
/**/                   0x7F0818B6, 0xBD395261,
/**/                   0x00000000, 0x3FE88800,
/**/                   0x44FB66B5, 0xBF21A0F5,
/**/                   0xF9AE5000, 0x3FD1058B,
/**/                   0x817D52CD, 0xBD34AB9D,
/**/                   0x00000000, 0x3FE88000,
/**/                   0x2866A138, 0x3F319D95,
/**/                   0x4003F000, 0x3FD111CE,
/**/                   0x096B4B6B, 0xBD1B3237,
/**/                   0x00000000, 0x3FE88000,
/**/                   0xA48B49DA, 0xBF33E5FA,
/**/                   0x2DADA000, 0x3FD11E0E,
/**/                   0x8FCCE5BA, 0xBD2A47F8,
/**/                   0x00000000, 0x3FE87800,
/**/                   0xDEECB0A8, 0x3F1A9336,
/**/                   0xC3912000, 0x3FD12A4B,
/**/                   0x61473259, 0xBD35A750,
/**/                   0x00000000, 0x3FE87800,
/**/                   0xFB6A388D, 0xBF3EC219,
/**/                   0x0293B000, 0x3FD13687,
/**/                   0x99D67123, 0xBD3D3E84,
/**/                   0x00000000, 0x3FE87000,
/**/                   0xC1625090, 0xBF106AE7,
/**/                   0xEB9A0000, 0x3FD142BF,
/**/                   0x85B58A9E, 0x3D31CE61,
/**/                   0x00000000, 0x3FE86800,
/**/                   0xACD4200C, 0x3F369AE5,
/**/                   0x7F887000, 0x3FD14EF6,
/**/                   0x5DFC9794, 0xBD3E97A6,
/**/                   0x00000000, 0x3FE86800,
/**/                   0x9389D11C, 0xBF2D4286,
/**/                   0xBF429000, 0x3FD15B2A,
/**/                   0x49B629B2, 0xBD2D8E3B,
/**/                   0x00000000, 0x3FE86000,
/**/                   0x18618618, 0x3F286186,
/**/                   0xABABA000, 0x3FD1675C,
/**/                   0x731F55C4, 0x3D38380E,
/**/                   0x00000000, 0x3FE86000,
/**/                   0x6AC71708, 0xBF38EF0F,
/**/                   0x45A67000, 0x3FD1738C,
/**/                   0x0032C176, 0xBD39C6E9,
/**/                   0x00000000, 0x3FE85800,
/**/                   0xE00C2C20, 0x3EFFF3D3,
/**/                   0x8E151000, 0x3FD17FB9,
/**/                   0xA74A2684, 0xBD3A8A8B,
/**/                   0x00000000, 0x3FE85000,
/**/                   0xF9592266, 0x3F3CFBA0,
/**/                   0x85D93000, 0x3FD18BE4,
/**/                   0x6F3604AB, 0x3D3C167F,
/**/                   0x00000000, 0x3FE85000,
/**/                   0xFF3D87FA, 0xBF1FE7B0,
/**/                   0x2DD42000, 0x3FD1980D,
/**/                   0x7A361C9A, 0x3D2B7B3A,
/**/                   0x00000000, 0x3FE84800,
/**/                   0x918DC223, 0x3F331E8D,
/**/                   0x86E68000, 0x3FD1A433,
/**/                   0x634E0AAC, 0xBD07A850,
/**/                   0x00000000, 0x3FE84800,
/**/                   0x8D76B549, 0xBF31BAF9,
/**/                   0x91F08000, 0x3FD1B057,
/**/                   0x6DC55E2D, 0xBD32DD46,
/**/                   0x00000000, 0x3FE84000,
/**/                   0xDC90C512, 0x3F22F2EC,
/**/                   0x4FD1D000, 0x3FD1BC79,
/**/                   0x747BA7BE, 0xBD3CCF0C,
/**/                   0x00000000, 0x3FE84000,
/**/                   0x6A0916B9, 0xBF3B442A,
/**/                   0xC169A000, 0x3FD1C898,
/**/                   0xE5C62AFF, 0xBD381410,
/**/                   0x00000000, 0x3FE83800,
/**/                   0x83801838, 0x3EA83801,
/**/                   0xE796A000, 0x3FD1D4B5,
/**/                   0xD197BAC2, 0x3D222A5B,
/**/                   0x00000000, 0x3FE83000,
/**/                   0xCBD11C5C, 0x3F3B6A41,
/**/                   0xC3371000, 0x3FD1E0D0,
/**/                   0xA9B0D4A0, 0x3D3AF8F2,
/**/                   0x00000000, 0x3FE83000,
/**/                   0xCB7A3CD6, 0xBF225381,
/**/                   0x5528B000, 0x3FD1ECE9,
/**/                   0x09B4A3B8, 0xBD184E7B,
/**/                   0x00000000, 0x3FE82800,
/**/                   0x152500C1, 0x3F32500C,
/**/                   0x9E48A000, 0x3FD1F8FF,
/**/                   0x040CBE77, 0x3D27946C,
/**/                   0x00000000, 0x3FE82800,
/**/                   0x14902134, 0xBF32285F,
/**/                   0x9F73B000, 0x3FD20513,
/**/                   0x1609E0A4, 0x3CF6E15E,
/**/                   0x00000000, 0x3FE82000,
/**/                   0xA4018213, 0x3F22D9EB,
/**/                   0x59861000, 0x3FD21125,
/**/                   0xBA2950C4, 0x3D382E78,
/**/                   0x00000000, 0x3FE82000,
/**/                   0xFC6BBFF4, 0xBF3AEFFC,
/**/                   0xCD5B9000, 0x3FD21D34,
/**/                   0xB28BADAA, 0x3D3B552F,
/**/                   0x00000000, 0x3FE81800,
/**/                   0x18181818, 0x3EE81818,
/**/                   0xFBCF8000, 0x3FD22941,
/**/                   0xF5EB0963, 0xBD3A6976,
/**/                   0x00000000, 0x3FE81000,
/**/                   0x4FF0F3C6, 0x3F3C7F27,
/**/                   0xE5BC9000, 0x3FD2354C,
/**/                   0x0602A663, 0xBD3D78ED,
/**/                   0x00000000, 0x3FE81000,
/**/                   0x0A86941D, 0xBF1ED344,
/**/                   0x8BFD1000, 0x3FD24155,
/**/                   0x3228FCAD, 0x3D300FFF,
/**/                   0x00000000, 0x3FE80800,
/**/                   0x1B0BD52D, 0x3F3424D0,
/**/                   0xEF6AF000, 0x3FD24D5B,
/**/                   0xFC9FABDD, 0xBCBDD780,
/**/                   0x00000000, 0x3FE80800,
/**/                   0xFE7F9FE8, 0xBF2FE7F9,
/**/                   0x10DF7000, 0x3FD25960,
/**/                   0x224EA3E3, 0x3D38E7BC,
/**/                   0x00000000, 0x3FE80000,
/**/                   0x18018018, 0x3F280180,
/**/                   0xF1338000, 0x3FD26561,
/**/                   0x66FAA45F, 0x3D38B488,
/**/                   0x00000000, 0x3FE80000,
/**/                   0x5FF40180, 0xBF37FD00,
/**/                   0x913F8000, 0x3FD27161,
/**/                   0xF61564B4, 0x3D34F4F1,
/**/                   0x00000000, 0x3FE7F800,
/**/                   0x9750B6C7, 0x3F104AE8,
/**/                   0xF1DB6000, 0x3FD27D5E,
/**/                   0x78CAC9F4, 0xBD092374,
/**/                   0x00000000, 0x3FE7F800,
/**/                   0xF405FD01, 0xBF3FD017,
/**/                   0x13DE8000, 0x3FD2895A,
/**/                   0xD24C13F0, 0x3D3A8D7A,
/**/                   0x00000000, 0x3FE7F000,
/**/                   0xC9C5485E, 0xBF0D2BF1,
/**/                   0xF81FF000, 0x3FD29552,
/**/                   0x1771C408, 0x3D348D30,
/**/                   0x00000000, 0x3FE7E800,
/**/                   0xD029DB60, 0x3F38927F,
/**/                   0x9F763000, 0x3FD2A149,
/**/                   0x51F3AADC, 0xBD30DBBF,
/**/                   0x00000000, 0x3FE7E800,
/**/                   0xB0A45169, 0xBF26504A,
/**/                   0x0AB73000, 0x3FD2AD3E,
/**/                   0x488C359F, 0x3D2B972E,
/**/                   0x00000000, 0x3FE7E000,
/**/                   0xD278E8DD, 0x3F312A8A,
/**/                   0x3AB8A000, 0x3FD2B930,
/**/                   0xD6BFB0A5, 0xBD26DB12,
/**/                   0x00000000, 0x3FE7E000,
/**/                   0x24BB32E7, 0xBF327577,
/**/                   0x304F8000, 0x3FD2C520,
/**/                   0x8C342F39, 0x3D230852,
/**/                   0x00000000, 0x3FE7D800,
/**/                   0xA4B45AEC, 0x3F23EF9A,
/**/                   0xEC508000, 0x3FD2D10D,
/**/                   0xF7088353, 0x3D360C61,
/**/                   0x00000000, 0x3FE7D800,
/**/                   0x32748CC1, 0xBF398DAF,
/**/                   0x6F8FD000, 0x3FD2DCF9,
/**/                   0x8E33C9CE, 0x3D20B4A2,
/**/                   0x00000000, 0x3FE7D000,
/**/                   0x417D05F4, 0x3F07D05F,
/**/                   0xBAE12000, 0x3FD2E8E2,
/**/                   0x99B72BD8, 0xBD267B1E,
/**/                   0x00000000, 0x3FE7C800,
/**/                   0x431D3027, 0x3F3F8EF7,
/**/                   0xCF17A000, 0x3FD2F4C9,
/**/                   0x9374B87B, 0x3D371F04,
/**/                   0x00000000, 0x3FE7C800,
/**/                   0xDAD83E6C, 0xBF0E77A3,
/**/                   0xAD063000, 0x3FD300AE,
/**/                   0x8B75FCAC, 0x3D342F56,
/**/                   0x00000000, 0x3FE7C000,
/**/                   0x588D1676, 0x3F38E041,
/**/                   0x557F2000, 0x3FD30C91,
/**/                   0xA1451755, 0xBD142958,
/**/                   0x00000000, 0x3FE7C000,
/**/                   0x1FE8414C, 0xBF24C6DD,
/**/                   0xC9544000, 0x3FD31871,
/**/                   0x94CECFD9, 0x3D184FAB,
/**/                   0x00000000, 0x3FE7B800,
/**/                   0x81C2D3B2, 0x3F3265F4,
/**/                   0x09570000, 0x3FD32450,
/**/                   0x9BDAE59D, 0x3D3D271B,
/**/                   0x00000000, 0x3FE7B800,
/**/                   0xB6466407, 0xBF30C39C,
/**/                   0x16586000, 0x3FD3302C,
/**/                   0xC2A3E08B, 0x3D36217D,
/**/                   0x00000000, 0x3FE7B000,
/**/                   0x12B21224, 0x3F283FAD,
/**/                   0xF128E000, 0x3FD33C05,
/**/                   0x380E1A7D, 0xBD22B906,
/**/                   0x00000000, 0x3FE7B000,
/**/                   0xF899E55D, 0xBF36EFB8,
/**/                   0x9A988000, 0x3FD347DD,
/**/                   0xD4C58092, 0xBD25594D,
/**/                   0x00000000, 0x3FE7A800,
/**/                   0x3FF42B9F, 0x3F1836B6,
/**/                   0x1376E000, 0x3FD353B3,
/**/                   0xE6C26D9B, 0xBD1331AF,
/**/                   0x00000000, 0x3FE7A800,
/**/                   0x0B739FF4, 0xBF3CE7FD,
/**/                   0x5C933000, 0x3FD35F86,
/**/                   0x4EA1A54A, 0xBD3B07DE,
/**/                   0x00000000, 0x3FE7A000,
/**/                   0xE8017A00, 0x3EC7A005,
/**/                   0x76BC1000, 0x3FD36B57,
/**/                   0x5A9C223F, 0x3D116978,
/**/                   0x00000000, 0x3FE79800,
/**/                   0xB1CC5B7B, 0x3F3D535D,
/**/                   0x62BFE000, 0x3FD37726,
/**/                   0xAC53B023, 0xBD3E9436,
/**/                   0x00000000, 0x3FE79800,
/**/                   0xE0DA37A9, 0xBF15EEAC,
/**/                   0x216C5000, 0x3FD382F3,
/**/                   0x1D1A7F6D, 0xBD1061D2,
/**/                   0x00000000, 0x3FE79000,
/**/                   0x344E16D6, 0x3F37C21E,
/**/                   0xB38ED000, 0x3FD38EBD,
/**/                   0xE67D4CA0, 0x3D290582,
/**/                   0x00000000, 0x3FE79000,
/**/                   0x39C9E465, 0xBF25E69A,
/**/                   0x19F45000, 0x3FD39A86,
/**/                   0x937354F5, 0x3D18EE51,
/**/                   0x00000000, 0x3FE78800,
/**/                   0xC52640BC, 0x3F32640B,
/**/                   0x55694000, 0x3FD3A64C,
/**/                   0xBCD735D0, 0x3D37A71C,
/**/                   0x00000000, 0x3FE78800,
/**/                   0x2F6A09ED, 0xBF3037DE,
/**/                   0x66B9C000, 0x3FD3B210,
/**/                   0x9811560E, 0xBD33C1ED,
/**/                   0x00000000, 0x3FE78000,
/**/                   0x01781A72, 0x3F2A71DC,
/**/                   0x4EB15000, 0x3FD3BDD2,
/**/                   0x970E6ED9, 0xBD3257B4,
/**/                   0x00000000, 0x3FE78000,
/**/                   0xA9EEBFF4, 0xBF354996,
/**/                   0x0E1B2000, 0x3FD3C992,
/**/                   0xAA680B76, 0x3D141C28,
/**/                   0x00000000, 0x3FE77800,
/**/                   0xAC60D341, 0x3F208119,
/**/                   0xA5C1F000, 0x3FD3D54F,
/**/                   0xD9A395E3, 0x3D3C3E1C,
/**/                   0x00000000, 0x3FE77800,
/**/                   0x742E2DD0, 0xBF3A28AE,
/**/                   0x16701000, 0x3FD3E10B,
/**/                   0x145429C7, 0x3D3F3BCF,
/**/                   0x00000000, 0x3FE77000,
/**/                   0x36340177, 0x3F0BD584,
/**/                   0x60EF6000, 0x3FD3ECC4,
/**/                   0x27C1300F, 0xBD060286,
/**/                   0x00000000, 0x3FE77000,
/**/                   0x240C7174, 0xBF3ED55D,
/**/                   0x86094000, 0x3FD3F87B,
/**/                   0x54589889, 0xBD35DFD7,
/**/                   0x00000000, 0x3FE76800,
/**/                   0xAB277F45, 0xBEF18DE5,
/**/                   0x8686A000, 0x3FD40430,
/**/                   0x3049F7D3, 0x3D3F8EF4,
/**/                   0x00000000, 0x3FE76000,
/**/                   0x01D3C7B8, 0x3F3CB026,
/**/                   0x63303000, 0x3FD40FE3,
/**/                   0xE79F05C6, 0x3D3E5C5F,
/**/                   0x00000000, 0x3FE76000,
/**/                   0xA9D08664, 0xBF15E95B,
/**/                   0x1CCE1000, 0x3FD41B94,
/**/                   0x13E43FC9, 0xBD304690,
/**/                   0x00000000, 0x3FE75800,
/**/                   0x097CFD43, 0x3F3867A4,
/**/                   0xB427E000, 0x3FD42742,
/**/                   0x02B82675, 0xBD398727,
/**/                   0x00000000, 0x3FE75800,
/**/                   0xE8A9353E, 0xBF2353DF,
/**/                   0x2A04F000, 0x3FD432EF,
/**/                   0x931715AD, 0xBD3FB129,
/**/                   0x00000000, 0x3FE75000,
/**/                   0x4F13DC4A, 0x3F3450E6,
/**/                   0x7F2C1000, 0x3FD43E99,
/**/                   0x40C41A04, 0x3D1C3F72,
/**/                   0x00000000, 0x3FE75000,
/**/                   0xE8B1B4FC, 0xBF2B4FBF,
/**/                   0xB463C000, 0x3FD44A41,
/**/                   0xF37CF612, 0x3D31EE28,
/**/                   0x00000000, 0x3FE74800,
/**/                   0x7E458100, 0x3F306BB6,
/**/                   0xCA720000, 0x3FD455E7,
/**/                   0x36629AED, 0x3D1AD8C6,
/**/                   0x00000000, 0x3FE74800,
/**/                   0x1745D174, 0xBF31745D,
/**/                   0xC21C6000, 0x3FD4618B,
/**/                   0x484C84CC, 0xBD13D82F,
/**/                   0x00000000, 0x3FE74000,
/**/                   0x236DEC04, 0x3F296FBD,
/**/                   0x9C280000, 0x3FD46D2D,
/**/                   0x5F67F75A, 0x3D359B27,
/**/                   0x00000000, 0x3FE74000,
/**/                   0x3B304B87, 0xBF350F9D,
/**/                   0x5959B000, 0x3FD478CD,
/**/                   0xF0C8D098, 0x3D2EC89B,
/**/                   0x00000000, 0x3FE73800,
/**/                   0xA4EBDC70, 0x3F226A51,
/**/                   0xFA75C000, 0x3FD4846A,
/**/                   0xE3798DCE, 0xBD263EA2,
/**/                   0x00000000, 0x3FE73800,
/**/                   0xF00B9A78, 0xBF3879D5,
/**/                   0x80401000, 0x3FD49006,
/**/                   0xFE1A0F8C, 0xBD38BCCF,
/**/                   0x00000000, 0x3FE73000,
/**/                   0x5DAAD90C, 0x3F178D7F,
/**/                   0xEB7C1000, 0x3FD49B9F,
/**/                   0x58AB60D7, 0x3D3DAC1C,
/**/                   0x00000000, 0x3FE73000,
/**/                   0x783709C7, 0xBF3BB33C,
/**/                   0x3CED0000, 0x3FD4A737,
/**/                   0xEBF35449, 0xBD39A234,
/**/                   0x00000000, 0x3FE72800,
/**/                   0x265AD23A, 0x3F061274,
/**/                   0x75556000, 0x3FD4B2CC,
/**/                   0xC78BFA4B, 0xBD380FCB,
/**/                   0x00000000, 0x3FE72800,
/**/                   0xC90A1FD2, 0xBF3EBC05,
/**/                   0x95778000, 0x3FD4BE5F,
/**/                   0xCD9AD824, 0xBD3D7C92,
/**/                   0x00000000, 0x3FE72000,
/**/                   0x38017200, 0xBEC71FFA,
/**/                   0x9E153000, 0x3FD4C9F0,
/**/                   0x70E02DE0, 0xBD2E1DDE,
/**/                   0x00000000, 0x3FE71800,
/**/                   0x74A050E1, 0x3F3E6B99,
/**/                   0x8FEFE000, 0x3FD4D57F,
/**/                   0x7FD06868, 0x3D23F926,
/**/                   0x00000000, 0x3FE71800,
/**/                   0xB8BD1180, 0xBF077400,
/**/                   0x6BC8A000, 0x3FD4E10C,
/**/                   0x1636F061, 0x3CF8283F,
/**/                   0x00000000, 0x3FE71000,
/**/                   0xE3E0453A, 0x3F3BC36C,
/**/                   0x32600000, 0x3FD4EC97,
/**/                   0xAF04D104, 0x3D234D7A,
/**/                   0x00000000, 0x3FE71000,
/**/                   0x6935DDC5, 0xBF15FA98,
/**/                   0xE4764000, 0x3FD4F81F,
/**/                   0x434FF08D, 0xBD27FCF6,
/**/                   0x00000000, 0x3FE70800,
/**/                   0x7337CF08, 0x3F394B40,
/**/                   0x82CB2000, 0x3FD503A6,
/**/                   0xF16F9B5D, 0xBD2A68C8,
/**/                   0x00000000, 0x3FE70800,
/**/                   0xA835403A, 0xBF1F7B97,
/**/                   0x0E1E0000, 0x3FD50F2B,
/**/                   0x8C47B8D8, 0x3D3A0940,
/**/                   0x00000000, 0x3FE70000,
/**/                   0x5C0B8170, 0x3F3702E0,
/**/                   0x872E0000, 0x3FD51AAD,
/**/                   0xDB0A7CC1, 0xBD3F4BD8,
/**/                   0x00000000, 0x3FE70000,
/**/                   0x4F67A855, 0xBF241EE6,
/**/                   0xEEB99000, 0x3FD5262D,
/**/                   0x70894A01, 0xBD3E1B9F,
/**/                   0x00000000, 0x3FE6F800,
/**/                   0x221C0170, 0x3F34EA19,
/**/                   0x457EE000, 0x3FD531AC,
/**/                   0x7D931501, 0x3D3DF83B,
/**/                   0x00000000, 0x3FE6F800,
/**/                   0x5508CA5C, 0xBF282102,
/**/                   0x8C3BE000, 0x3FD53D28,
/**/                   0xEB6DFAC5, 0xBD111397,
/**/                   0x00000000, 0x3FE6F000,
/**/                   0x9300B793, 0x3F3300B7,
/**/                   0xC3ADD000, 0x3FD548A2,
/**/                   0x63081CF7, 0x3D23167E,
/**/                   0x00000000, 0x3FE6F000,
/**/                   0x005BB90F, 0xBF2BC486,
/**/                   0xEC91C000, 0x3FD5541A,
/**/                   0xDC72EEBA, 0xBCF816AA,
/**/                   0x00000000, 0x3FE6E800,
/**/                   0xC5A3A00B, 0x3F314688,
/**/                   0x07A44000, 0x3FD55F91,
/**/                   0x78DF4A62, 0xBD11E647,
/**/                   0x00000000, 0x3FE6E800,
/**/                   0xDA9C5AE1, 0xBF2F09D6,
/**/                   0x15A18000, 0x3FD56B05,
/**/                   0xBC4A23FC, 0x3D29247B,
/**/                   0x00000000, 0x3FE6E000,
/**/                   0x337C6CB1, 0x3F2F76B4,
/**/                   0x17456000, 0x3FD57677,
/**/                   0x9524D7CA, 0xBD364EAD,
/**/                   0x00000000, 0x3FE6E000,
/**/                   0xEDF4EC87, 0xBF30F8AC,
/**/                   0x0D4B3000, 0x3FD581E7,
/**/                   0xB12D8F1D, 0xBD1F31E1,
/**/                   0x00000000, 0x3FE6D800,
/**/                   0x6EAEF381, 0x3F2CBDF2,
/**/                   0xF86E0000, 0x3FD58D54,
/**/                   0x0A795215, 0x3D2791F3,
/**/                   0x00000000, 0x3FE6D800,
/**/                   0xB624BFF5, 0xBF323DB9,
/**/                   0xD9688000, 0x3FD598C0,
/**/                   0x70D96DA4, 0xBD385F49,
/**/                   0x00000000, 0x3FE6D000,
/**/                   0x1C860FB0, 0x3F2A6268,
/**/                   0xB0F4D000, 0x3FD5A42A,
/**/                   0x2DF7BA69, 0xBCDE63AF,
/**/                   0x00000000, 0x3FE6D000,
/**/                   0xB253BAE1, 0xBF335443,
/**/                   0x7FCCE000, 0x3FD5AF92,
/**/                   0xF5FFC77A, 0xBD1C032F,
/**/                   0x00000000, 0x3FE6C800,
/**/                   0xAB4294D4, 0x3F2863B1,
/**/                   0x46AA2000, 0x3FD5BAF8,
/**/                   0xF873FA41, 0xBD339AE8,
/**/                   0x00000000, 0x3FE6C800,
/**/                   0x87EAA6DF, 0xBF343C7C,
/**/                   0x0645A000, 0x3FD5C65C,
/**/                   0x0180EE65, 0xBD39FE06,
/**/                   0x00000000, 0x3FE6C000,
/**/                   0x16C16C17, 0x3F26C16C,
/**/                   0xBF581000, 0x3FD5D1BD,
/**/                   0xC9C7C238, 0xBD38D6BD,
/**/                   0x00000000, 0x3FE6C000,
/**/                   0x95C33E00, 0xBF34F695,
/**/                   0x7299C000, 0x3FD5DD1D,
/**/                   0x8815CE17, 0xBD38AF61,
/**/                   0x00000000, 0x3FE6B800,
/**/                   0xE7802D73, 0x3F257B34,
/**/                   0x20C29000, 0x3FD5E87B,
/**/                   0x8F7738FA, 0x3D3527D1,
/**/                   0x00000000, 0x3FE6B800,
/**/                   0xF4A5582C, 0xBF3582BF,
/**/                   0xCA8A2000, 0x3FD5F3D6,
/**/                   0x8E19CC75, 0x3D37AF84,
/**/                   0x00000000, 0x3FE6B000,
/**/                   0x31A3CFC7, 0x3F2490AA,
/**/                   0x70A79000, 0x3FD5FF30,
/**/                   0x9F105039, 0x3D2E9E43,
/**/                   0x00000000, 0x3FE6B000,
/**/                   0x77C30E5A, 0xBF35E12C,
/**/                   0x13D1A000, 0x3FD60A88,
/**/                   0xC879AF55, 0x3D36E9B9,
/**/                   0x00000000, 0x3FE6A800,
/**/                   0x94016A94, 0x3F24016A,
/**/                   0xB4BEC000, 0x3FD615DD,
/**/                   0x90BC04B2, 0x3D13C7CA,
/**/                   0x00000000, 0x3FE6A800,
/**/                   0xAD33D63F, 0xBF36120B,
/**/                   0x5424F000, 0x3FD62131,
/**/                   0x4AA68669, 0xBD3382FC,
/**/                   0x00000000, 0x3FE6A000,
/**/                   0x3729043E, 0x3F23CD15,
/**/                   0xF2B9C000, 0x3FD62C82,
/**/                   0xBD7C8A98, 0x3D3E54BD } };

static const union {int4 i[4350]; double x[2175]; } vj = { .i = {
/**/                   0x7D161C28, 0x3F46A400,
/**/                   0x20600000, 0xBF46A200,
/**/                   0xAA7623D9, 0x3D27DC4E,
/**/                   0xD596E639, 0x3F4693FA,
/**/                   0x4CE00000, 0xBF4691FD,
/**/                   0x29C3F0AD, 0x3D26B0CF,
/**/                   0x3219CE89, 0x3F4683F5,
/**/                   0x7B600000, 0xBF4681FA,
/**/                   0x95B9FDCC, 0x3D22B290,
/**/                   0x929ED397, 0x3F4673EF,
/**/                   0xABE00000, 0xBF4671F7,
/**/                   0xFA2F2D87, 0x3D17C727,
/**/                   0xF725F3E2, 0x3F4663E9,
/**/                   0xDE600000, 0xBF4661F4,
/**/                   0x6EDBFF1C, 0x3CF22ED3,
/**/                   0x5FAF2DE9, 0x3F4653E4,
/**/                   0x12E00000, 0xBF4651F2,
/**/                   0x157812BB, 0xBD144936,
/**/                   0xCC3A802B, 0x3F4643DE,
/**/                   0x49600000, 0xBF4641EF,
/**/                   0x60314E05, 0xBD2959CB,
/**/                   0x3CC7E927, 0x3F4633D9,
/**/                   0x81E00000, 0xBF4631EC,
/**/                   0xC3638E99, 0xBD35ABDA,
/**/                   0xB157675C, 0x3F4623D3,
/**/                   0xBC800000, 0xBF4621E9,
/**/                   0xC63F9A21, 0x3D3FF1D3,
/**/                   0x29E8F948, 0x3F4613CE,
/**/                   0xF9000000, 0xBF4611E6,
/**/                   0x71EEE611, 0x3D342D26,
/**/                   0xA67C9D6B, 0x3F4603C8,
/**/                   0x37800000, 0xBF4601E4,
/**/                   0x11A09689, 0x3D1C1C77,
/**/                   0x27125244, 0x3F45F3C3,
/**/                   0x78000000, 0xBF45F1E1,
/**/                   0xF7DC643C, 0xBD1DFD16,
/**/                   0xABAA1651, 0x3F45E3BD,
/**/                   0xBA800000, 0xBF45E1DE,
/**/                   0x91318A02, 0xBD376503,
/**/                   0x3443E812, 0x3F45D3B8,
/**/                   0xFF200000, 0xBF45D1DB,
/**/                   0xCE55DCDD, 0x3D3756E4,
/**/                   0xC0DFC606, 0x3F45C3B2,
/**/                   0x45A00000, 0xBF45C1D9,
/**/                   0x8F6F8FA0, 0x3D12D5CF,
/**/                   0x517DAEAB, 0x3F45B3AD,
/**/                   0x8E200000, 0xBF45B1D6,
/**/                   0x9B85DC2C, 0xBD2E90AB,
/**/                   0xE61DA081, 0x3F45A3A7,
/**/                   0xD8C00000, 0xBF45A1D3,
/**/                   0x3BF5AC54, 0x3D3B5E88,
/**/                   0x7EBF9A07, 0x3F4593A2,
/**/                   0x25400000, 0xBF4591D1,
/**/                   0x0C86DDB1, 0x3D12AC3A,
/**/                   0x1B6399BB, 0x3F45839D,
/**/                   0x73C00000, 0xBF4581CE,
/**/                   0x76830985, 0xBD3361C2,
/**/                   0xBC099E1C, 0x3F457397,
/**/                   0xC4600000, 0xBF4571CB,
/**/                   0xD062EBFF, 0x3D333915,
/**/                   0x60B1A5AA, 0x3F456392,
/**/                   0x16E00000, 0xBF4561C9,
/**/                   0x9CC4988F, 0xBD1E0DA0,
/**/                   0x095BAEE4, 0x3F45538D,
/**/                   0x6B800000, 0xBF4551C6,
/**/                   0x235BC18A, 0x3D3C69C4,
/**/                   0xB607B848, 0x3F454387,
/**/                   0xC2000000, 0xBF4541C3,
/**/                   0xF7737723, 0xBCEFCC99,
/**/                   0x66B5C056, 0x3F453382,
/**/                   0x1A800000, 0xBF4531C1,
/**/                   0x809CBCBB, 0xBD3FBAE2,
/**/                   0x1B65C58C, 0x3F45237D,
/**/                   0x75200000, 0xBF4521BE,
/**/                   0x194FEE63, 0x3CCAA5C8,
/**/                   0xD417C66A, 0x3F451377,
/**/                   0xD1C00000, 0xBF4511BB,
/**/                   0xE1CC7BBC, 0x3D3ED325,
/**/                   0x90CBC16E, 0x3F450372,
/**/                   0x30400000, 0xBF4501B9,
/**/                   0x68AB3742, 0xBD0F0298,
/**/                   0x5181B517, 0x3F44F36D,
/**/                   0x90E00000, 0xBF44F1B6,
/**/                   0x41E67AD9, 0x3D381BE1,
/**/                   0x16399FE6, 0x3F44E368,
/**/                   0xF3600000, 0xBF44E1B3,
/**/                   0x668D3662, 0xBD2A6E79,
/**/                   0xDEF38058, 0x3F44D362,
/**/                   0x58000000, 0xBF44D1B1,
/**/                   0x21F8B7C2, 0x3D284EA7,
/**/                   0xABAF54EC, 0x3F44C35D,
/**/                   0xBE800000, 0xBF44C1AE,
/**/                   0x7417D9C5, 0xBD3BC76D,
/**/                   0x7C6D1C22, 0x3F44B358,
/**/                   0x27200000, 0xBF44B1AC,
/**/                   0x16AAD1FC, 0xBD1409FD,
/**/                   0x512CD479, 0x3F44A353,
/**/                   0x91C00000, 0xBF44A1A9,
/**/                   0x98BC14FD, 0x3D30771E,
/**/                   0x29EE7C70, 0x3F44934E,
/**/                   0xFE400000, 0xBF4491A6,
/**/                   0x5CCB7232, 0xBD3B5993,
/**/                   0x06B21285, 0x3F448349,
/**/                   0x6CE00000, 0xBF4481A4,
/**/                   0x5512F9C2, 0xBD20E729,
/**/                   0xE7779538, 0x3F447343,
/**/                   0xDD800000, 0xBF4471A1,
/**/                   0x55B30899, 0x3D225436,
/**/                   0xCC3F0308, 0x3F44633E,
/**/                   0x50200000, 0xBF44619F,
/**/                   0x9E54E31F, 0x3D39807C,
/**/                   0xB5085A73, 0x3F445339,
/**/                   0xC4A00000, 0xBF44519C,
/**/                   0xD5804C0E, 0xBD376F6F,
/**/                   0xA1D399FA, 0x3F444334,
/**/                   0x3B400000, 0xBF44419A,
/**/                   0x6CDE6425, 0xBD234953,
/**/                   0x92A0C01A, 0x3F44332F,
/**/                   0xB3E00000, 0xBF443197,
/**/                   0xAAF6596F, 0x3D070E7B,
/**/                   0x876FCB54, 0x3F44232A,
/**/                   0x2E800000, 0xBF442195,
/**/                   0x4EC011F1, 0x3D2C49F8,
/**/                   0x8040BA25, 0x3F441325,
/**/                   0xAB200000, 0xBF441192,
/**/                   0xD8AAA7EB, 0x3D3825DC,
/**/                   0x7D138B0E, 0x3F440320,
/**/                   0x29A00000, 0xBF440190,
/**/                   0xFE0B73D6, 0xBD3F1A8D,
/**/                   0x7DE83C8C, 0x3F43F31B,
/**/                   0xAA400000, 0xBF43F18D,
/**/                   0xE46CA26B, 0xBD379B43,
/**/                   0x82BECD20, 0x3F43E316,
/**/                   0x2CE00000, 0xBF43E18B,
/**/                   0x6283780D, 0xBD315B44,
/**/                   0x8B973B49, 0x3F43D311,
/**/                   0xB1800000, 0xBF43D188,
/**/                   0x017589BE, 0xBD28B31E,
/**/                   0x98718584, 0x3F43C30C,
/**/                   0x38200000, 0xBF43C186,
/**/                   0x8FBB296E, 0xBD212A46,
/**/                   0xA94DAA52, 0x3F43B307,
/**/                   0xC0C00000, 0xBF43B183,
/**/                   0x045CBBD2, 0xBD183403,
/**/                   0xBE2BA832, 0x3F43A302,
/**/                   0x4B600000, 0xBF43A181,
/**/                   0xD7CC5936, 0xBD13009B,
/**/                   0xD70B7DA2, 0x3F4392FD,
/**/                   0xD8000000, 0xBF43917E,
/**/                   0xC1742279, 0xBD12B655,
/**/                   0xF3ED2921, 0x3F4382F8,
/**/                   0x66A00000, 0xBF43817C,
/**/                   0xEA83FAE8, 0xBD17512E,
/**/                   0x14D0A930, 0x3F4372F4,
/**/                   0xF7400000, 0xBF437179,
/**/                   0xBED65875, 0xBD206692,
/**/                   0x39B5FC4C, 0x3F4362EF,
/**/                   0x89E00000, 0xBF436177,
/**/                   0xD38FFE9E, 0xBD27931B,
/**/                   0x629D20F5, 0x3F4352EA,
/**/                   0x1E800000, 0xBF435175,
/**/                   0xE524208F, 0xBD309618,
/**/                   0x8F8615AA, 0x3F4342E5,
/**/                   0xB5200000, 0xBF434172,
/**/                   0xDD4C72C5, 0xBD3697E9,
/**/                   0xC070D8EB, 0x3F4332E0,
/**/                   0x4DC00000, 0xBF433170,
/**/                   0x5E6E12C3, 0xBD3DCE00,
/**/                   0xF55D6935, 0x3F4322DB,
/**/                   0xE8800000, 0xBF43216D,
/**/                   0x0AE9A8CE, 0x3D39C8A4,
/**/                   0x2E4BC509, 0x3F4312D7,
/**/                   0x85200000, 0xBF43116B,
/**/                   0xD1CD2FA1, 0x3D302D03,
/**/                   0x6B3BEAE5, 0x3F4302D2,
/**/                   0x23C00000, 0xBF430169,
/**/                   0xA3BADFD1, 0x3D15807D,
/**/                   0xAC2DD949, 0x3F42F2CD,
/**/                   0xC4600000, 0xBF42F166,
/**/                   0xF57F0504, 0xBD1A7422,
/**/                   0xF1218EB3, 0x3F42E2C8,
/**/                   0x67000000, 0xBF42E164,
/**/                   0x2F2C781C, 0xBD33C974,
/**/                   0x3A1709A3, 0x3F42D2C4,
/**/                   0x0BC00000, 0xBF42D162,
/**/                   0x851A1E61, 0x3D3DDBDD,
/**/                   0x870E4898, 0x3F42C2BF,
/**/                   0xB2600000, 0xBF42C15F,
/**/                   0xA14AA8FD, 0x3D2CA7D9,
/**/                   0xD8074A10, 0x3F42B2BA,
/**/                   0x5B000000, 0xBF42B15D,
/**/                   0xDDCDDFF5, 0xBD03022E,
/**/                   0x2D020C8C, 0x3F42A2B6,
/**/                   0x05A00000, 0xBF42A15B,
/**/                   0x0F9231A8, 0xBD343FBA,
/**/                   0x85FE8E8A, 0x3F4292B1,
/**/                   0xB2600000, 0xBF429158,
/**/                   0xA52C9CCF, 0x3D38B690,
/**/                   0xE2FCCE8A, 0x3F4282AC,
/**/                   0x61000000, 0xBF428156,
/**/                   0xC8CC82EB, 0x3D120E6A,
/**/                   0x43FCCB0A, 0x3F4272A8,
/**/                   0x11A00000, 0xBF427154,
/**/                   0x792E6C51, 0xBD30D79B,
/**/                   0xA8FE8289, 0x3F4262A3,
/**/                   0xC4600000, 0xBF426151,
/**/                   0x91F7F7AA, 0x3D38A5EE,
/**/                   0x1201F387, 0x3F42529F,
/**/                   0x79000000, 0xBF42514F,
/**/                   0x46C2E8BA, 0x3CEFA728,
/**/                   0x7F071C84, 0x3F42429A,
/**/                   0x2FA00000, 0xBF42414D,
/**/                   0xFA447A17, 0xBD37D0BA,
/**/                   0xF00DFBFD, 0x3F423295,
/**/                   0xE8600000, 0xBF42314A,
/**/                   0x94AF3FED, 0x3D2C7A24,
/**/                   0x65169072, 0x3F422291,
/**/                   0xA3000000, 0xBF422148,
/**/                   0x050CEA04, 0xBD29B0BD,
/**/                   0xDE20D863, 0x3F42128C,
/**/                   0x5FC00000, 0xBF421146,
/**/                   0x0C3035EB, 0x3D36EFF3,
/**/                   0x5B2CD24E, 0x3F420288,
/**/                   0x1E600000, 0xBF420144,
/**/                   0x73569B27, 0xBD19A3E2,
/**/                   0xDC3A7CB2, 0x3F41F283,
/**/                   0xDF200000, 0xBF41F141,
/**/                   0xEEB67715, 0x3D3B1DDE,
/**/                   0x6149D610, 0x3F41E27F,
/**/                   0xA1C00000, 0xBF41E13F,
/**/                   0x94F49154, 0xBD11EA17,
/**/                   0xEA5ADCE5, 0x3F41D27A,
/**/                   0x66800000, 0xBF41D13D,
/**/                   0x52DD9D37, 0x3D3ACED9,
/**/                   0x776D8FB1, 0x3F41C276,
/**/                   0x2D200000, 0xBF41C13B,
/**/                   0xF72D8EEB, 0xBD1C140B,
/**/                   0x0881ECF4, 0x3F41B272,
/**/                   0xF5E00000, 0xBF41B138,
/**/                   0x939583E1, 0x3D360AE5,
/**/                   0x9D97F32C, 0x3F41A26D,
/**/                   0xC0800000, 0xBF41A136,
/**/                   0x1D246C7C, 0xBD2C00D9,
/**/                   0x36AFA0D9, 0x3F419269,
/**/                   0x8D400000, 0xBF419134,
/**/                   0x0B955CFB, 0x3D29B40E,
/**/                   0xD3C8F479, 0x3F418264,
/**/                   0x5BE00000, 0xBF418132,
/**/                   0x45A6C249, 0xBD3964BF,
/**/                   0x74E3EC8D, 0x3F417260,
/**/                   0x2CA00000, 0xBF417130,
/**/                   0xF3363612, 0xBCE777E0,
/**/                   0x1A008792, 0x3F41625C,
/**/                   0xFF600000, 0xBF41612D,
/**/                   0x28DE8296, 0x3D36D608,
/**/                   0xC31EC409, 0x3F415257,
/**/                   0xD4000000, 0xBF41512B,
/**/                   0x4BB1B788, 0xBD32AE69,
/**/                   0x703EA071, 0x3F414253,
/**/                   0xAAC00000, 0xBF414129,
/**/                   0x170ECD8C, 0x3D05BF68,
/**/                   0x21601B48, 0x3F41324F,
/**/                   0x83800000, 0xBF413127,
/**/                   0x7C653BFC, 0x3D370A0B,
/**/                   0xD683330E, 0x3F41224A,
/**/                   0x5E200000, 0xBF412125,
/**/                   0x77BBBEBF, 0xBD35B70D,
/**/                   0x8FA7E642, 0x3F411246,
/**/                   0x3AE00000, 0xBF411123,
/**/                   0x93ABC1CD, 0xBD0C52EB,
/**/                   0x4CCE3363, 0x3F410242,
/**/                   0x19A00000, 0xBF410121,
/**/                   0xE5C6F4C7, 0x3D2B2237,
/**/                   0x0DF618F1, 0x3F40F23E,
/**/                   0xFA600000, 0xBF40F11E,
/**/                   0x1E9A50AD, 0x3D3D9C5F,
/**/                   0xD31F956A, 0x3F40E239,
/**/                   0xDD000000, 0xBF40E11C,
/**/                   0x8965F0DA, 0xBD336793,
/**/                   0x9C4AA74E, 0x3F40D235,
/**/                   0xC1C00000, 0xBF40D11A,
/**/                   0x7E49E231, 0xBD15E6EE,
/**/                   0x69774D1D, 0x3F40C231,
/**/                   0xA8800000, 0xBF40C118,
/**/                   0x04FD621C, 0x3D1D9B9D,
/**/                   0x3AA58554, 0x3F40B22D,
/**/                   0x91400000, 0xBF40B116,
/**/                   0x7DD9EED3, 0x3D333B55,
/**/                   0x0FD54E74, 0x3F40A229,
/**/                   0x7C000000, 0xBF40A114,
/**/                   0x7AA78478, 0x3D3E048F,
/**/                   0xE906A6FC, 0x3F409224,
/**/                   0x68A00000, 0xBF409112,
/**/                   0x644DDE88, 0xBD383C6A,
/**/                   0xC6398D6B, 0x3F408220,
/**/                   0x57600000, 0xBF408110,
/**/                   0x76B8C83A, 0xBD2F0D2F,
/**/                   0xA76E0040, 0x3F40721C,
/**/                   0x48200000, 0xBF40710E,
/**/                   0x9CE99FD3, 0xBD1F63E0,
/**/                   0x8CA3FDFB, 0x3F406218,
/**/                   0x3AE00000, 0xBF40610C,
/**/                   0x4FE774F2, 0xBCF328B4,
/**/                   0x75DB851A, 0x3F405214,
/**/                   0x2FA00000, 0xBF40510A,
/**/                   0x3782BCD4, 0x3D11B6BD,
/**/                   0x6314941D, 0x3F404210,
/**/                   0x26600000, 0xBF404108,
/**/                   0xE7183792, 0x3D22116F,
/**/                   0x544F2983, 0x3F40320C,
/**/                   0x1F200000, 0xBF403106,
/**/                   0x1B995B3D, 0x3D293F1E,
/**/                   0x498B43CB, 0x3F402208,
/**/                   0x19E00000, 0xBF402104,
/**/                   0xFC162630, 0x3D2E6669,
/**/                   0x42C8E175, 0x3F401204,
/**/                   0x16A00000, 0xBF401102,
/**/                   0x254FC9F8, 0x3D30C4AA,
/**/                   0x40080100, 0x3F400200,
/**/                   0x15600000, 0xBF400100,
/**/                   0xE4431F92, 0x3D3154EE,
/**/                   0x829141D6, 0x3F3FE3F8,
/**/                   0x2C400000, 0xBF3FE1FC,
/**/                   0x9B2D30FB, 0x3D30E503,
/**/                   0x8D157F6B, 0x3F3FC3F0,
/**/                   0x31C00000, 0xBF3FC1F8,
/**/                   0x53EBD670, 0x3D2EEBD1,
/**/                   0x9F9CB7BC, 0x3F3FA3E8,
/**/                   0x3B400000, 0xBF3FA1F4,
/**/                   0xE04A16E0, 0x3D2A113C,
/**/                   0xBA26E7CA, 0x3F3F83E0,
/**/                   0x48C00000, 0xBF3F81F0,
/**/                   0x99C43E34, 0x3D233C4A,
/**/                   0xDCB40C91, 0x3F3F63D8,
/**/                   0x5A400000, 0xBF3F61EC,
/**/                   0x7BD210C1, 0x3D14DDF6,
/**/                   0x07442311, 0x3F3F43D1,
/**/                   0x6FC00000, 0xBF3F41E8,
/**/                   0x9E4B51C8, 0xBCC52C1D,
/**/                   0x39D72849, 0x3F3F23C9,
/**/                   0x89400000, 0xBF3F21E4,
/**/                   0x8EA8C754, 0xBD1A196F,
/**/                   0x746D1936, 0x3F3F03C1,
/**/                   0xA6C00000, 0xBF3F01E0,
/**/                   0xF95AF98D, 0xBD2BB719,
/**/                   0xB705F2D8, 0x3F3EE3B9,
/**/                   0xC8400000, 0xBF3EE1DC,
/**/                   0x28FFD598, 0xBD3628EB,
/**/                   0x01A1B22C, 0x3F3EC3B2,
/**/                   0xEDC00000, 0xBF3EC1D8,
/**/                   0x0BBAC8F8, 0xBD3F6D76,
/**/                   0x54405432, 0x3F3EA3AA,
/**/                   0x17800000, 0xBF3EA1D5,
/**/                   0xB7A7EE0D, 0x3D3657D2,
/**/                   0xAEE1D5E8, 0x3F3E83A2,
/**/                   0x45000000, 0xBF3E81D1,
/**/                   0xFA9CCC78, 0x3D264FDE,
/**/                   0x1186344C, 0x3F3E639B,
/**/                   0x76800000, 0xBF3E61CD,
/**/                   0xE02EF455, 0xBCEF83EB,
/**/                   0x7C2D6C5E, 0x3F3E4393,
/**/                   0xAC000000, 0xBF3E41C9,
/**/                   0x03C3E129, 0xBD2C26B3,
/**/                   0xEED77B1B, 0x3F3E238B,
/**/                   0xE5800000, 0xBF3E21C5,
/**/                   0x904D773D, 0xBD3C1CBE,
/**/                   0x69845D83, 0x3F3E0384,
/**/                   0x23400000, 0xBF3E01C2,
/**/                   0xD0615454, 0x3D34E8B1,
/**/                   0xEC341093, 0x3F3DE37C,
/**/                   0x64C00000, 0xBF3DE1BE,
/**/                   0xE9BE933E, 0x3D13F7DF,
/**/                   0x76E6914B, 0x3F3DC375,
/**/                   0xAA400000, 0xBF3DC1BA,
/**/                   0x707B004A, 0xBD27B7D7,
/**/                   0x099BDCA9, 0x3F3DA36E,
/**/                   0xF3C00000, 0xBF3DA1B6,
/**/                   0xEE2141C3, 0xBD3DA3F8,
/**/                   0xA453EFAC, 0x3F3D8366,
/**/                   0x41800000, 0xBF3D81B3,
/**/                   0x63D21825, 0x3D2F4DA1,
/**/                   0x470EC752, 0x3F3D635F,
/**/                   0x93000000, 0xBF3D61AF,
/**/                   0xFAD0B844, 0xBD0FD473,
/**/                   0xF1CC609A, 0x3F3D4357,
/**/                   0xE8800000, 0xBF3D41AB,
/**/                   0x298657C2, 0xBD388716,
/**/                   0xA48CB882, 0x3F3D2350,
/**/                   0x42400000, 0xBF3D21A8,
/**/                   0x0B68711A, 0x3D32023A,
/**/                   0x5F4FCC0A, 0x3F3D0349,
/**/                   0x9FC00000, 0xBF3D01A4,
/**/                   0x23A704B0, 0xBD117676,
/**/                   0x22159830, 0x3F3CE342,
/**/                   0x01400000, 0xBF3CE1A1,
/**/                   0x8F391F09, 0xBD3BA59C,
/**/                   0xECDE19F1, 0x3F3CC33A,
/**/                   0x67000000, 0xBF3CC19D,
/**/                   0x9EBBF706, 0x3D28567A,
/**/                   0xBFA94E4E, 0x3F3CA333,
/**/                   0xD0800000, 0xBF3CA199,
/**/                   0x2D41F1CC, 0xBD29D41F,
/**/                   0x9A773245, 0x3F3C832C,
/**/                   0x3E400000, 0xBF3C8196,
/**/                   0x14ED5134, 0x3D391B7D,
/**/                   0x7D47C2D4, 0x3F3C6325,
/**/                   0xAFC00000, 0xBF3C6192,
/**/                   0x83403B5B, 0xBCFC31C5,
/**/                   0x681AFCFA, 0x3F3C431E,
/**/                   0x25400000, 0xBF3C418F,
/**/                   0x88A1FFF3, 0xBD3D84DB,
/**/                   0x5AF0DDB6, 0x3F3C2317,
/**/                   0x9F000000, 0xBF3C218B,
/**/                   0x6298A63B, 0x3D175CFF,
/**/                   0x55C96207, 0x3F3C0310,
/**/                   0x1C800000, 0xBF3C0188,
/**/                   0xDFB8E489, 0xBD37ADC9,
/**/                   0x58A486EA, 0x3F3BE309,
/**/                   0x9E400000, 0xBF3BE184,
/**/                   0x45069C64, 0x3D23DA0F,
/**/                   0x6382495F, 0x3F3BC302,
/**/                   0x23C00000, 0xBF3BC181,
/**/                   0x4CC2EFE0, 0xBD35574B,
/**/                   0x7662A665, 0x3F3BA2FB,
/**/                   0xAD800000, 0xBF3BA17D,
/**/                   0x4BED0B89, 0x3D250C7B,
/**/                   0x91459AFA, 0x3F3B82F4,
/**/                   0x3B000000, 0xBF3B817A,
/**/                   0x322E5605, 0xBD36795D,
/**/                   0xB42B241D, 0x3F3B62ED,
/**/                   0xCCC00000, 0xBF3B6176,
/**/                   0xF6413886, 0x3D1EAB91,
/**/                   0xDF133ECC, 0x3F3B42E6,
/**/                   0x62400000, 0xBF3B4173,
/**/                   0xF86BE5B5, 0xBD3B0BFC,
/**/                   0x11FDE807, 0x3F3B22E0,
/**/                   0xFC000000, 0xBF3B216F,
/**/                   0xDDE8D701, 0x3CF62FEB,
/**/                   0x4CEB1CCC, 0x3F3B02D9,
/**/                   0x99C00000, 0xBF3B016C,
/**/                   0xF210FD9E, 0x3D3CF8D7,
/**/                   0x8FDADA1A, 0x3F3AE2D2,
/**/                   0x3B400000, 0xBF3AE169,
/**/                   0x1526CFB0, 0xBD2092E2,
/**/                   0xDACD1CEF, 0x3F3AC2CB,
/**/                   0xE1000000, 0xBF3AC165,
/**/                   0x18D261D5, 0x3D319D24,
/**/                   0x2DC1E24A, 0x3F3AA2C5,
/**/                   0x8A800000, 0xBF3AA162,
/**/                   0x533CC8EC, 0xBD355268,
/**/                   0x88B9272B, 0x3F3A82BE,
/**/                   0x38400000, 0xBF3A815F,
/**/                   0x0AFE6139, 0x3D074750,
/**/                   0xEBB2E88F, 0x3F3A62B7,
/**/                   0xEA000000, 0xBF3A615B,
/**/                   0x6668AD57, 0x3D3A501B,
/**/                   0x56AF2375, 0x3F3A42B1,
/**/                   0x9F800000, 0xBF3A4158,
/**/                   0xA98381BD, 0xBD2E37A7,
/**/                   0xC9ADD4DD, 0x3F3A22AA,
/**/                   0x59400000, 0xBF3A2155,
/**/                   0x7B82F9AC, 0x3D1A9872,
/**/                   0x44AEF9C5, 0x3F3A02A4,
/**/                   0x17000000, 0xBF3A0152,
/**/                   0x0FF040AD, 0x3D3B96ED,
/**/                   0xC7B28F2C, 0x3F39E29D,
/**/                   0xD8800000, 0xBF39E14E,
/**/                   0x33534BD7, 0xBD304862,
/**/                   0x52B89211, 0x3F39C297,
/**/                   0x9E400000, 0xBF39C14B,
/**/                   0x17AF009B, 0x3D084979,
/**/                   0xE5C0FF72, 0x3F39A290,
/**/                   0x68000000, 0xBF39A148,
/**/                   0x604B64C9, 0x3D358CA1,
/**/                   0x80CBD44E, 0x3F39828A,
/**/                   0x35800000, 0xBF398145,
/**/                   0x2E334404, 0xBD38BD0B,
/**/                   0x23D90DA4, 0x3F396284,
/**/                   0x07400000, 0xBF396142,
/**/                   0xEF1B1C68, 0xBD1F4B58,
/**/                   0xCEE8A873, 0x3F39427D,
/**/                   0xDD000000, 0xBF39413E,
/**/                   0x07E010EC, 0x3D209881,
/**/                   0x81FAA1B9, 0x3F392277,
/**/                   0xB6C00000, 0xBF39213B,
/**/                   0x5CF03181, 0x3D37A139,
/**/                   0x3D0EF676, 0x3F390271,
/**/                   0x94400000, 0xBF390138,
/**/                   0x65276B0B, 0xBD39D2EB,
/**/                   0x0025A3A8, 0x3F38E26B,
/**/                   0x76000000, 0xBF38E135,
/**/                   0xEE3023F6, 0xBD281E5A,
/**/                   0xCB3EA64F, 0x3F38C264,
/**/                   0x5BC00000, 0xBF38C132,
/**/                   0x3F9A4B53, 0x3CEDAE6E,
/**/                   0x9E59FB68, 0x3F38A25E,
/**/                   0x45800000, 0xBF38A12F,
/**/                   0x412B648E, 0x3D2A47EF,
/**/                   0x79779FF3, 0x3F388258,
/**/                   0x33400000, 0xBF38812C,
/**/                   0x5ED0D8F2, 0x3D38955F,
/**/                   0x5C9790EE, 0x3F386252,
/**/                   0x24C00000, 0xBF386129,
/**/                   0x09939374, 0xBD3CBD55,
/**/                   0x47B9CB5A, 0x3F38424C,
/**/                   0x1A800000, 0xBF384126,
/**/                   0x4F399186, 0xBD32D325,
/**/                   0x3ADE4C33, 0x3F382246,
/**/                   0x14400000, 0xBF382123,
/**/                   0x524688EB, 0xBD235622,
/**/                   0x3605107A, 0x3F380240,
/**/                   0x12000000, 0xBF380120,
/**/                   0xEB2F3DDC, 0xBCF44184,
/**/                   0x392E152C, 0x3F37E23A,
/**/                   0x13C00000, 0xBF37E11D,
/**/                   0x2153D1B8, 0x3D198B16,
/**/                   0x4459574A, 0x3F37C234,
/**/                   0x19800000, 0xBF37C11A,
/**/                   0x47A3C923, 0x3D2A9511,
/**/                   0x5786D3D1, 0x3F37A22E,
/**/                   0x23400000, 0xBF37A117,
/**/                   0x4B4128D9, 0x3D337431,
/**/                   0x72B687C1, 0x3F378228,
/**/                   0x31000000, 0xBF378114,
/**/                   0xC5BFE9E8, 0x3D38E0BF,
/**/                   0x95E87019, 0x3F376222,
/**/                   0x42C00000, 0xBF376111,
/**/                   0x5A0B2CE9, 0x3D3D9134,
/**/                   0xC11C89D8, 0x3F37421C,
/**/                   0x58400000, 0xBF37410E,
/**/                   0xB1802C40, 0xBD3E7970,
/**/                   0xF452D1FB, 0x3F372216,
/**/                   0x72000000, 0xBF37210B,
/**/                   0x16E562C9, 0xBD3B3E2F,
/**/                   0x2F8B4583, 0x3F370211,
/**/                   0x8FC00000, 0xBF370108,
/**/                   0x9087DACD, 0xBD38BC06,
/**/                   0x72C5E16F, 0x3F36E20B,
/**/                   0xB1800000, 0xBF36E105,
/**/                   0xD92B1B21, 0xBD36F1F6,
/**/                   0xBE02A2BC, 0x3F36C205,
/**/                   0xD7400000, 0xBF36C102,
/**/                   0xABF2CD23, 0xBD35DEFF,
/**/                   0x1141866B, 0x3F36A200,
/**/                   0x01000000, 0xBF36A100,
/**/                   0xC462BC85, 0xBD358220,
/**/                   0x6C828979, 0x3F3681FA,
/**/                   0x2EC00000, 0xBF3680FD,
/**/                   0xDE5ED723, 0xBD35DA59,
/**/                   0xCFC5A8E7, 0x3F3661F4,
/**/                   0x60800000, 0xBF3660FA,
/**/                   0xB62B2CD1, 0xBD36E6AA,
/**/                   0x3B0AE1B2, 0x3F3641EF,
/**/                   0x96400000, 0xBF3640F7,
/**/                   0x086BEF29, 0xBD38A613,
/**/                   0xAE5230DA, 0x3F3621E9,
/**/                   0xD0000000, 0xBF3620F4,
/**/                   0x9225715D, 0xBD3B1792,
/**/                   0x299B935F, 0x3F3601E4,
/**/                   0x0DC00000, 0xBF3600F2,
/**/                   0x10BC2805, 0xBD3E3A29,
/**/                   0xACE7063E, 0x3F35E1DE,
/**/                   0x4FC00000, 0xBF35E0EF,
/**/                   0xBE0B570D, 0x3D3DF329,
/**/                   0x38348676, 0x3F35C1D9,
/**/                   0x95800000, 0xBF35C0EC,
/**/                   0x1C0C5502, 0x3D397166,
/**/                   0xCB841108, 0x3F35A1D3,
/**/                   0xDF400000, 0xBF35A0E9,
/**/                   0x4AC1FA2D, 0x3D34418C,
/**/                   0x66D5A2F1, 0x3F3581CE,
/**/                   0x2D000000, 0xBF3580E7,
/**/                   0x168E9C6E, 0x3D2CC939,
/**/                   0x0A293931, 0x3F3561C9,
/**/                   0x7EC00000, 0xBF3560E4,
/**/                   0x795CE154, 0x3D1F6E5C,
/**/                   0xB57ED0C7, 0x3F3541C3,
/**/                   0xD4800000, 0xBF3540E1,
/**/                   0x898FEE67, 0x3CE4EF88,
/**/                   0x68D666B1, 0x3F3521BE,
/**/                   0x2E400000, 0xBF3520DF,
/**/                   0x0B78D65E, 0xBD1CDACF,
/**/                   0x242FF7EF, 0x3F3501B9,
/**/                   0x8C000000, 0xBF3500DC,
/**/                   0x6F1CBFB8, 0xBD2F7BF1,
/**/                   0xE78B8180, 0x3F34E1B3,
/**/                   0xEDC00000, 0xBF34E0D9,
/**/                   0x5A899820, 0xBD38ED52,
/**/                   0xB2E90063, 0x3F34C1AE,
/**/                   0x53C00000, 0xBF34C0D7,
/**/                   0x930A694E, 0x3D3D3C3F,
/**/                   0x86487196, 0x3F34A1A9,
/**/                   0xBD800000, 0xBF34A0D4,
/**/                   0x4FA7CCCB, 0x3D32BFBD,
/**/                   0x61A9D219, 0x3F3481A4,
/**/                   0x2B400000, 0xBF3480D2,
/**/                   0x65A26E32, 0x3D1E789C,
/**/                   0x450D1EEB, 0x3F34619F,
/**/                   0x9D000000, 0xBF3460CF,
/**/                   0x47E500B5, 0xBD109E0B,
/**/                   0x3072550B, 0x3F34419A,
/**/                   0x12C00000, 0xBF3440CD,
/**/                   0x3523FAE9, 0xBD309040,
/**/                   0x23D97178, 0x3F342195,
/**/                   0x8C800000, 0xBF3420CA,
/**/                   0xD31DE7C2, 0xBD3D9B10,
/**/                   0x1F427131, 0x3F340190,
/**/                   0x0A800000, 0xBF3400C8,
/**/                   0x90B287C4, 0x3D34B90B,
/**/                   0x22AD5135, 0x3F33E18B,
/**/                   0x8C400000, 0xBF33E0C5,
/**/                   0xCA1B0FC2, 0x3D19B454,
/**/                   0x2E1A0E83, 0x3F33C186,
/**/                   0x12000000, 0xBF33C0C3,
/**/                   0x638FC1F4, 0xBD20FBE7,
/**/                   0x4188A61A, 0x3F33A181,
/**/                   0x9BC00000, 0xBF33A0C0,
/**/                   0xE0C03290, 0xBD38070E,
/**/                   0x5CF914F9, 0x3F33817C,
/**/                   0x29C00000, 0xBF3380BE,
/**/                   0xE0B6E5F5, 0x3D37D2C3,
/**/                   0x806B5820, 0x3F336177,
/**/                   0xBB800000, 0xBF3360BB,
/**/                   0x35598794, 0x3D1C4213,
/**/                   0xABDF6C8D, 0x3F334172,
/**/                   0x51400000, 0xBF3340B9,
/**/                   0xC111C569, 0xBD249997,
/**/                   0xDF554F40, 0x3F33216D,
/**/                   0xEB000000, 0xBF3320B6,
/**/                   0xEEEE28E2, 0xBD3C442D,
/**/                   0x1ACCFD37, 0x3F330169,
/**/                   0x89000000, 0xBF3300B4,
/**/                   0xDBBF316D, 0x3D312B5E,
/**/                   0x5E467372, 0x3F32E164,
/**/                   0x2AC00000, 0xBF32E0B2,
/**/                   0x7484E6E1, 0xBCFFD254,
/**/                   0xA9C1AEF0, 0x3F32C15F,
/**/                   0xD0800000, 0xBF32C0AF,
/**/                   0x1F2C3F9D, 0xBD35BCBA,
/**/                   0xFD3EACAF, 0x3F32A15A,
/**/                   0x7A800000, 0xBF32A0AD,
/**/                   0x8C8BAA61, 0x3D35EDA0,
/**/                   0x58BD69B0, 0x3F328156,
/**/                   0x28400000, 0xBF3280AB,
/**/                   0x3F79FE5E, 0x3CF02EAF,
/**/                   0xBC3DE2F1, 0x3F326151,
/**/                   0xDA000000, 0xBF3260A8,
/**/                   0xB1304AA8, 0xBD347BDA,
/**/                   0x27C01572, 0x3F32414D,
/**/                   0x90000000, 0xBF3240A6,
/**/                   0xD46BE359, 0x3D35724F,
/**/                   0x9B43FE30, 0x3F322148,
/**/                   0x49C00000, 0xBF3220A4,
/**/                   0x43BF90C9, 0xBCF31954,
/**/                   0x16C99A2D, 0x3F320144,
/**/                   0x07800000, 0xBF3200A2,
/**/                   0xC4901E30, 0xBD386689,
/**/                   0x9A50E666, 0x3F31E13F,
/**/                   0xC9800000, 0xBF31E09F,
/**/                   0x134E34BF, 0x3D2FA8E5,
/**/                   0x25D9DFDB, 0x3F31C13B,
/**/                   0x8F400000, 0xBF31C09D,
/**/                   0x477D87DF, 0xBD20FF40,
/**/                   0xB964838C, 0x3F31A136,
/**/                   0x59400000, 0xBF31A09B,
/**/                   0x68B5B77B, 0x3D3E9E3E,
/**/                   0x54F0CE76, 0x3F318132,
/**/                   0x27000000, 0xBF318099,
/**/                   0x906F8A53, 0x3D14BC39,
/**/                   0xF87EBD9A, 0x3F31612D,
/**/                   0xF8C00000, 0xBF316096,
/**/                   0xFCD50724, 0xBD34CC2F,
/**/                   0xA40E4DF7, 0x3F314129,
/**/                   0xCEC00000, 0xBF314094,
/**/                   0x7A3A1B8D, 0x3D30AD83,
/**/                   0x579F7C8B, 0x3F312125,
/**/                   0xA8800000, 0xBF312092,
/**/                   0x057F5C66, 0xBD24C5AE,
/**/                   0x13324657, 0x3F310121,
/**/                   0x86800000, 0xBF310090,
/**/                   0xBFD488E0, 0x3D3A03C0,
/**/                   0xD6C6A858, 0x3F30E11C,
/**/                   0x68400000, 0xBF30E08E,
/**/                   0x56935D63, 0xBD00EDA8,
/**/                   0xA25C9F8F, 0x3F30C118,
/**/                   0x4E000000, 0xBF30C08C,
/**/                   0x2FDDD1CE, 0xBD3EC638,
/**/                   0x75F428FB, 0x3F30A114,
/**/                   0x38000000, 0xBF30A08A,
/**/                   0x0CA3DCBE, 0x3D102CDE,
/**/                   0x518D419B, 0x3F308110,
/**/                   0x25C00000, 0xBF308088,
/**/                   0xBFA78921, 0xBD39A865,
/**/                   0x3527E66D, 0x3F30610C,
/**/                   0x17C00000, 0xBF306086,
/**/                   0x72CE37BD, 0x3D203FE0,
/**/                   0x20C41472, 0x3F304108,
/**/                   0x0D800000, 0xBF304084,
/**/                   0x6054C3FA, 0xBD369AC6,
/**/                   0x1461C8A9, 0x3F302104,
/**/                   0x07800000, 0xBF302082,
/**/                   0x4836293A, 0x3D2450ED,
/**/                   0x10010010, 0x3F300100,
/**/                   0x05400000, 0xBF300080,
/**/                   0x88B3357C, 0xBD359558,
/**/                   0x27436F4F, 0x3F2FC1F8,
/**/                   0x0E800000, 0xBF2FC0FC,
/**/                   0x92ECD4D1, 0x3D245998,
/**/                   0x3E87D8DC, 0x3F2F81F0,
/**/                   0x1A000000, 0xBF2F80F8,
/**/                   0xB592170A, 0xBD36901A,
/**/                   0x65CF36C6, 0x3F2F41E8,
/**/                   0x2E000000, 0xBF2F40F4,
/**/                   0x53524603, 0x3D2069E5,
/**/                   0x9D19830B, 0x3F2F01E0,
/**/                   0x49800000, 0xBF2F00F0,
/**/                   0x69C22240, 0xBD39830B,
/**/                   0xE466B7AB, 0x3F2EC1D8,
/**/                   0x6D800000, 0xBF2EC0EC,
/**/                   0xFB871BBA, 0x3D1123AC,
/**/                   0x3BB6CEA4, 0x3F2E81D1,
/**/                   0x99000000, 0xBF2E80E8,
/**/                   0x2E158AF6, 0xBD3E6629,
/**/                   0xA309C1F4, 0x3F2E41C9,
/**/                   0xCD000000, 0xBF2E40E4,
/**/                   0x2B29884E, 0xBCF8F488,
/**/                   0x1A5F8B99, 0x3F2E01C2,
/**/                   0x09000000, 0xBF2E00E1,
/**/                   0x6EA006C6, 0x3D3ACE8D,
/**/                   0xA1B82593, 0x3F2DC1BA,
/**/                   0x4C800000, 0xBF2DC0DD,
/**/                   0x59D0B687, 0xBD22974E,
/**/                   0x391389E0, 0x3F2D81B3,
/**/                   0x98800000, 0xBF2D80D9,
/**/                   0xD7897CAD, 0x3D322319,
/**/                   0xE071B27F, 0x3F2D41AB,
/**/                   0xEC000000, 0xBF2D40D5,
/**/                   0x57954C6E, 0xBD32E42F,
/**/                   0x97D2996E, 0x3F2D01A4,
/**/                   0x48000000, 0xBF2D00D2,
/**/                   0xC741610E, 0x3D1E7DF5,
/**/                   0x5F3638AB, 0x3F2CC19D,
/**/                   0xAB800000, 0xBF2CC0CE,
/**/                   0xA0909C5A, 0xBD3E50DF,
/**/                   0x369C8A37, 0x3F2C8196,
/**/                   0x17800000, 0xBF2C80CB,
/**/                   0x8D8D1C8F, 0xBD12D119,
/**/                   0x1E05880E, 0x3F2C418F,
/**/                   0x8B800000, 0xBF2C40C7,
/**/                   0x544D2574, 0x3D347649,
/**/                   0x15712C30, 0x3F2C0188,
/**/                   0x07000000, 0xBF2C00C4,
/**/                   0x4EEA9E68, 0xBD32D030,
/**/                   0x1CDF709C, 0x3F2BC181,
/**/                   0x8B000000, 0xBF2BC0C0,
/**/                   0x74A84109, 0x3D15E533,
/**/                   0x34504F50, 0x3F2B817A,
/**/                   0x17000000, 0xBF2B80BD,
/**/                   0x025FBF68, 0x3D3D53C1,
/**/                   0x5BC3C24B, 0x3F2B4173,
/**/                   0xAA800000, 0xBF2B40B9,
/**/                   0x6BAA2FA8, 0xBD267FA7,
/**/                   0x9339C38C, 0x3F2B016C,
/**/                   0x46800000, 0xBF2B00B6,
/**/                   0xBB3FDE1E, 0x3D277F1D,
/**/                   0xDAB24D11, 0x3F2AC165,
/**/                   0xEA000000, 0xBF2AC0B2,
/**/                   0x1A8CDBE2, 0xBD3DAD17,
/**/                   0x322D58D9, 0x3F2A815F,
/**/                   0x96000000, 0xBF2A80AF,
/**/                   0xD81CF36E, 0xBD1E1315,
/**/                   0x99AAE0E3, 0x3F2A4158,
/**/                   0x4A000000, 0xBF2A40AC,
/**/                   0xE649E7B4, 0x3D2C7307,
/**/                   0x112ADF2D, 0x3F2A0152,
/**/                   0x05800000, 0xBF2A00A9,
/**/                   0xB77435EC, 0xBD3C713A,
/**/                   0x98AD4DB7, 0x3F29C14B,
/**/                   0xC9800000, 0xBF29C0A5,
/**/                   0x3A7AE827, 0xBD1E1005,
/**/                   0x3032267F, 0x3F298145,
/**/                   0x95800000, 0xBF2980A2,
/**/                   0xA8F2A842, 0x3D2A0460,
/**/                   0xD7B96385, 0x3F29413E,
/**/                   0x69000000, 0xBF29409F,
/**/                   0xA7B8321E, 0xBD3EDDA5,
/**/                   0x8F42FEC5, 0x3F290138,
/**/                   0x45000000, 0xBF29009C,
/**/                   0x3A3F0D33, 0xBD264506,
/**/                   0x56CEF241, 0x3F28C132,
/**/                   0x29000000, 0xBF28C099,
/**/                   0x33EE13CD, 0x3D206930,
/**/                   0x2E5D37F6, 0x3F28812C,
/**/                   0x15000000, 0xBF288096,
/**/                   0x22DF1FDA, 0x3D3B28AC,
/**/                   0x15EDC9E3, 0x3F284126,
/**/                   0x08800000, 0xBF284093,
/**/                   0xDD73B6DB, 0xBD324546,
/**/                   0x0D80A208, 0x3F280120,
/**/                   0x04800000, 0xBF280090,
/**/                   0x6DFEB485, 0xBCB440C2,
/**/                   0x1515BA62, 0x3F27C11A,
/**/                   0x08800000, 0xBF27C08D,
/**/                   0x9823B19D, 0x3D31BCBE,
/**/                   0x2CAD0CF1, 0x3F278114,
/**/                   0x14000000, 0xBF27808A,
/**/                   0xA9EB4E97, 0xBD3CD148,
/**/                   0x544693B4, 0x3F27410E,
/**/                   0x28000000, 0xBF274087,
/**/                   0xCA4F73AA, 0xBD277AAC,
/**/                   0x8BE248AA, 0x3F270108,
/**/                   0x44000000, 0xBF270084,
/**/                   0x26068EF7, 0x3D13E656,
/**/                   0xD38025D2, 0x3F26C102,
/**/                   0x68000000, 0xBF26C081,
/**/                   0x44C3EC8A, 0x3D35547B,
/**/                   0x2B20252A, 0x3F2680FD,
/**/                   0x93800000, 0xBF26807E,
/**/                   0x110DCE4B, 0xBD3AABA5,
/**/                   0x92C240B1, 0x3F2640F7,
/**/                   0xC7800000, 0xBF26407B,
/**/                   0xAC011956, 0xBD260B96,
/**/                   0x0A667267, 0x3F2600F2,
/**/                   0x03800000, 0xBF260079,
/**/                   0x5DFA826E, 0x3D111C22,
/**/                   0x920CB44A, 0x3F25C0EC,
/**/                   0x47800000, 0xBF25C076,
/**/                   0xD8A2980A, 0x3D333BD6,
/**/                   0x29B5005A, 0x3F2580E7,
/**/                   0x93000000, 0xBF258073,
/**/                   0x71C1D861, 0xBD3E2660,
/**/                   0xD15F5095, 0x3F2540E1,
/**/                   0xE7000000, 0xBF254070,
/**/                   0x4E77E5EE, 0xBD2FBD3A,
/**/                   0x890B9EFA, 0x3F2500DC,
/**/                   0x43000000, 0xBF25006E,
/**/                   0x7B90A2D9, 0xBCFEBDF2,
/**/                   0x50B9E589, 0x3F24C0D7,
/**/                   0xA7000000, 0xBF24C06B,
/**/                   0x58F2FF2C, 0x3D2765B3,
/**/                   0x286A1E40, 0x3F2480D2,
/**/                   0x13000000, 0xBF248069,
/**/                   0x74AE382C, 0x3D38FE8D,
/**/                   0x101C431E, 0x3F2440CD,
/**/                   0x86800000, 0xBF244066,
/**/                   0xB0286224, 0xBD3A07C3,
/**/                   0x07D04E23, 0x3F2400C8,
/**/                   0x02800000, 0xBF240064,
/**/                   0x46EFC0EC, 0xBD2ABE33,
/**/                   0x0F86394D, 0x3F23C0C3,
/**/                   0x86800000, 0xBF23C061,
/**/                   0x70DE3151, 0xBCF06744,
/**/                   0x273DFE9C, 0x3F2380BE,
/**/                   0x12800000, 0xBF23805F,
/**/                   0x05CFCD61, 0x3D260659,
/**/                   0x4EF7980F, 0x3F2340B9,
/**/                   0xA6800000, 0xBF23405C,
/**/                   0xD7DBBEBC, 0x3D36BEC8,
/**/                   0x86B2FFA4, 0x3F2300B4,
/**/                   0x42000000, 0xBF23005A,
/**/                   0x2B2027B4, 0xBD3DD29F,
/**/                   0xCE702F5C, 0x3F22C0AF,
/**/                   0xE6000000, 0xBF22C057,
/**/                   0x6959A7D0, 0xBD32B00B,
/**/                   0x262F2134, 0x3F2280AB,
/**/                   0x92000000, 0xBF228055,
/**/                   0x19FAAC2D, 0xBD1F61EF,
/**/                   0x8DEFCF2C, 0x3F2240A6,
/**/                   0x46000000, 0xBF224053,
/**/                   0xCB16B8A8, 0x3D05A87E,
/**/                   0x05B23344, 0x3F2200A2,
/**/                   0x02000000, 0xBF220051,
/**/                   0x23B9B257, 0x3D29F32F,
/**/                   0x8D76477A, 0x3F21C09D,
/**/                   0xC6000000, 0xBF21C04E,
/**/                   0x7E214821, 0x3D36F61B,
/**/                   0x253C05CD, 0x3F218099,
/**/                   0x91800000, 0xBF21804C,
/**/                   0x46FDFCA2, 0xBD3F5464,
/**/                   0xCD03683D, 0x3F214094,
/**/                   0x65800000, 0xBF21404A,
/**/                   0xA30F2308, 0xBD35E4E7,
/**/                   0x84CC68C9, 0x3F210090,
/**/                   0x41800000, 0xBF210048,
/**/                   0xF800CC34, 0xBD2974DC,
/**/                   0x4C970171, 0x3F20C08C,
/**/                   0x25800000, 0xBF20C046,
/**/                   0xC1006E9D, 0xBD0E9FC5,
/**/                   0x24632C32, 0x3F208088,
/**/                   0x11800000, 0xBF208044,
/**/                   0x078E4438, 0x3D133DE7,
/**/                   0x0C30E30D, 0x3F204084,
/**/                   0x05800000, 0xBF204042,
/**/                   0x15F82A7B, 0x3D2A61D2,
/**/                   0x04002001, 0x3F200080,
/**/                   0x01800000, 0xBF200040,
/**/                   0x3BBB110C, 0x3D355155,
/**/                   0x17A1BA1A, 0x3F1F80F8,
/**/                   0x0B000000, 0xBF1F807C,
/**/                   0x6C520A9B, 0x3D3D31BE,
/**/                   0x47462860, 0x3F1F00F0,
/**/                   0x22000000, 0xBF1F0078,
/**/                   0x4B6D83F6, 0xBD3B2CDB,
/**/                   0x96ED7ED3, 0x3F1E80E8,
/**/                   0x4A000000, 0xBF1E8074,
/**/                   0xD4122C5A, 0xBD33C977,
/**/                   0x0697B172, 0x3F1E00E1,
/**/                   0x82000000, 0xBF1E0070,
/**/                   0x2D1517C4, 0xBD29462E,
/**/                   0x9644B43B, 0x3F1D80D9,
/**/                   0xCA000000, 0xBF1D806C,
/**/                   0xF0952D45, 0xBD16E2E3,
/**/                   0x45F47B2C, 0x3F1D00D2,
/**/                   0x22000000, 0xBF1D0069,
/**/                   0x2DDC2A8D, 0x3CEED452,
/**/                   0x15A6FA46, 0x3F1C80CB,
/**/                   0x8A000000, 0xBF1C8065,
/**/                   0xA08CEBE8, 0x3D1DAFEE,
/**/                   0x055C2585, 0x3F1C00C4,
/**/                   0x02000000, 0xBF1C0062,
/**/                   0xBB11EF55, 0x3D2B50A4,
/**/                   0x1513F0E9, 0x3F1B80BD,
/**/                   0x8A000000, 0xBF1B805E,
/**/                   0xC6D142BF, 0x3D33ACA6,
/**/                   0x44CE5071, 0x3F1B00B6,
/**/                   0x22000000, 0xBF1B005B,
/**/                   0xF8CD3D11, 0x3D3979F8,
/**/                   0x948B381A, 0x3F1A80AF,
/**/                   0xCA000000, 0xBF1A8057,
/**/                   0x07EDFD29, 0x3D3F1149,
/**/                   0x044A9BE5, 0x3F1A00A9,
/**/                   0x81000000, 0xBF1A0054,
/**/                   0xF7BB7092, 0xBD3B8C68,
/**/                   0x940C6FCF, 0x3F1980A2,
/**/                   0x49000000, 0xBF198051,
/**/                   0xF27E09A9, 0xBD365E1C,
/**/                   0x43D0A7D8, 0x3F19009C,
/**/                   0x21000000, 0xBF19004E,
/**/                   0xD508D564, 0xBD3162D2,
/**/                   0x139737FE, 0x3F188096,
/**/                   0x09000000, 0xBF18804B,
/**/                   0x18D5C93E, 0xBD293315,
/**/                   0x03601440, 0x3F180090,
/**/                   0x01000000, 0xBF180048,
/**/                   0x0C26A328, 0xBD200288,
/**/                   0x132B309E, 0x3F17808A,
/**/                   0x09000000, 0xBF178045,
/**/                   0x7E89FD6F, 0xBD0CC7F9,
/**/                   0x42F88115, 0x3F170084,
/**/                   0x21000000, 0xBF170042,
/**/                   0x058494DC, 0x3CE40881,
/**/                   0x92C7F9A5, 0x3F16807E,
/**/                   0x49000000, 0xBF16803F,
/**/                   0xCD5698B9, 0x3D12AE16,
/**/                   0x02998E4D, 0x3F160079,
/**/                   0x81000000, 0xBF16003C,
/**/                   0xC5780E17, 0x3D21138B,
/**/                   0x926D330B, 0x3F158073,
/**/                   0xC9000000, 0xBF158039,
/**/                   0x4E2001E2, 0x3D287809,
/**/                   0x4242DBDF, 0x3F15006E,
/**/                   0x21000000, 0xBF150037,
/**/                   0x21448AA2, 0x3D2F8684,
/**/                   0x121A7CC8, 0x3F148069,
/**/                   0x89000000, 0xBF148034,
/**/                   0x2F637D8E, 0x3D33207E,
/**/                   0x01F409C4, 0x3F140064,
/**/                   0x01000000, 0xBF140032,
/**/                   0x12E44B29, 0x3D3654B9,
/**/                   0x11CF76D3, 0x3F13805F,
/**/                   0x89000000, 0xBF13802F,
/**/                   0xCA5547F3, 0x3D3960F2,
/**/                   0x41ACB7F4, 0x3F13005A,
/**/                   0x21000000, 0xBF13002D,
/**/                   0x6487063D, 0x3D3C462B,
/**/                   0x918BC126, 0x3F128055,
/**/                   0xC9000000, 0xBF12802A,
/**/                   0xEFEA1107, 0x3D3F0562,
/**/                   0x016C8668, 0x3F120051,
/**/                   0x80000000, 0xBF120028,
/**/                   0x857113CE, 0xBD3E6066,
/**/                   0x914EFBBA, 0x3F11804C,
/**/                   0x48000000, 0xBF118026,
/**/                   0xEDD9EB54, 0xBD3BEA30,
/**/                   0x41331519, 0x3F110048,
/**/                   0x20000000, 0xBF110024,
/**/                   0x3BFFFF5A, 0xBD3996FC,
/**/                   0x1118C686, 0x3F108044,
/**/                   0x08000000, 0xBF108022,
/**/                   0x62F2E042, 0xBD3765C8,
/**/                   0x01000400, 0x3F100040,
/**/                   0x00000000, 0xBF100020,
/**/                   0x562224CD, 0xBD355595,
/**/                   0x21D1830C, 0x3F0F0078,
/**/                   0x10000000, 0xBF0F003C,
/**/                   0x095D69EB, 0xBD336563,
/**/                   0x81A5E62E, 0x3F0E0070,
/**/                   0x40000000, 0xBF0E0038,
/**/                   0x70D45290, 0xBD319431,
/**/                   0x217D1965, 0x3F0D0069,
/**/                   0x90000000, 0xBF0D0034,
/**/                   0x022D0EF6, 0xBD2FC201,
/**/                   0x015704B1, 0x3F0C0062,
/**/                   0x00000000, 0xBF0C0031,
/**/                   0x5E276E21, 0xBD2C95A0,
/**/                   0x2133900E, 0x3F0B005B,
/**/                   0x90000000, 0xBF0B002D,
/**/                   0xE0372A42, 0xBD29A140,
/**/                   0x8112A37D, 0x3F0A0054,
/**/                   0x40000000, 0xBF0A002A,
/**/                   0x73BBB580, 0xBD26E2E2,
/**/                   0x20F426FB, 0x3F09004E,
/**/                   0x10000000, 0xBF090027,
/**/                   0x04D48C20, 0xBD245885,
/**/                   0x00D80288, 0x3F080048,
/**/                   0x00000000, 0xBF080024,
/**/                   0x80613426, 0xBD220028,
/**/                   0x20BE1E23, 0x3F070042,
/**/                   0x10000000, 0xBF070021,
/**/                   0xA80279F3, 0xBD1FAF99,
/**/                   0x80A661CA, 0x3F06003C,
/**/                   0x40000000, 0xBF06001E,
/**/                   0xDC287DFE, 0xBD1BBAE3,
/**/                   0x2090B57C, 0x3F050037,
/**/                   0x90000000, 0xBF05001B,
/**/                   0x7B73B67C, 0xBD181E2F,
/**/                   0x007D0139, 0x3F040032,
/**/                   0x00000000, 0xBF040019,
/**/                   0x65A375F8, 0xBD14D57C,
/**/                   0x206B2CFF, 0x3F03002D,
/**/                   0x90000000, 0xBF030016,
/**/                   0x7BF71EC1, 0xBD11DCCA,
/**/                   0x805B20CD, 0x3F020028,
/**/                   0x40000000, 0xBF020014,
/**/                   0x425C4447, 0xBD0E6033,
/**/                   0x204CC4A3, 0x3F010024,
/**/                   0x10000000, 0xBF010012,
/**/                   0x730FFF5C, 0xBD0996D3,
/**/                   0x00400080, 0x3F000020,
/**/                   0x00000000, 0xBF000010,
/**/                   0x558888DE, 0xBD055575,
/**/                   0x406978C6, 0x3EFE0038,
/**/                   0x20000000, 0xBEFE001C,
/**/                   0xB845146A, 0xBD019418,
/**/                   0x0055C096, 0x3EFC0031,
/**/                   0x80000000, 0xBEFC0018,
/**/                   0xD989DB3C, 0xBCFC957A,
/**/                   0x4044A870, 0x3EFA002A,
/**/                   0x20000000, 0xBEFA0015,
/**/                   0x8F0EED2F, 0xBCF6E2C6,
/**/                   0x00360051, 0x3EF80024,
/**/                   0x00000000, 0xBEF80012,
/**/                   0x40184CEB, 0xBCF20014,
/**/                   0x40299839, 0x3EF6001E,
/**/                   0x20000000, 0xBEF6000F,
/**/                   0x434A1F5C, 0xBCEBBAC7,
/**/                   0x001F4027, 0x3EF40019,
/**/                   0x80000000, 0xBEF4000C,
/**/                   0xDD68DD6A, 0xBCE4D568,
/**/                   0x4016C81A, 0x3EF20014,
/**/                   0x20000000, 0xBEF2000A,
/**/                   0xA11710FC, 0xBCDE6019,
/**/                   0x00100010, 0x3EF00010,
/**/                   0x00000000, 0xBEF00008,
/**/                   0x5562222D, 0xBCD55565,
/**/                   0x80157013, 0x3EEC0018,
/**/                   0x40000000, 0xBEEC000C,
/**/                   0x176276C5, 0xBCCC9568,
/**/                   0x000D800A, 0x3EE80012,
/**/                   0x00000000, 0xBEE80009,
/**/                   0x20061337, 0xBCC2000A,
/**/                   0x8007D005, 0x3EE4000C,
/**/                   0x40000000, 0xBEE40006,
/**/                   0x195A3758, 0xBCB4D55F,
/**/                   0x00040002, 0x3EE00008,
/**/                   0x00000000, 0xBEE00004,
/**/                   0x5558888A, 0xBCA5555D,
/**/                   0x00036001, 0x3ED80009,
/**/                   0x80000000, 0xBED80004,
/**/                   0x100184CD, 0xBC920005,
/**/                   0x00010000, 0x3ED00004,
/**/                   0x00000000, 0xBED00002,
/**/                   0x55562222, 0xBC755559,
/**/                   0x00004000, 0x3EC00002,
/**/                   0x00000000, 0xBEC00001,
/**/                   0x55558889, 0xBC455557,
/**/                   0x00000000, 0x00000000,
/**/                   0x00000000, 0x00000000,
/**/                   0x00000000, 0x00000000,
/**/                   0x00008000, 0xBEBFFFFC,
/**/                   0x00000000, 0x3EBFFFFE,
/**/                   0x55558889, 0x3C455553,
/**/                   0x00020000, 0xBECFFFF8,
/**/                   0x00000000, 0x3ECFFFFC,
/**/                   0x55562222, 0x3C755551,
/**/                   0x00035FFF, 0xBED7FFF7,
/**/                   0x80000000, 0x3ED7FFFB,
/**/                   0xF00184CC, 0x3C91FFFA,
/**/                   0x0007FFFC, 0xBEDFFFF0,
/**/                   0x00000000, 0x3EDFFFF8,
/**/                   0x55588887, 0x3CA5554D,
/**/                   0x8007CFFB, 0xBEE3FFF3,
/**/                   0xC0000000, 0x3EE3FFF9,
/**/                   0x915A3753, 0x3CB4D54B,
/**/                   0x000D7FF6, 0xBEE7FFEE,
/**/                   0x00000000, 0x3EE7FFF7,
/**/                   0xE006132F, 0x3CC1FFF5,
/**/                   0x80156FED, 0xBEEBFFE7,
/**/                   0xC0000000, 0x3EEBFFF3,
/**/                   0x936276B2, 0x3CCC9542,
/**/                   0x001FFFE0, 0xBEEFFFE0,
/**/                   0x00000000, 0x3EEFFFF0,
/**/                   0x55622217, 0x3CD55545,
/**/                   0xC016C7E6, 0xBEF1FFEB,
/**/                   0xE0000000, 0x3EF1FFF5,
/**/                   0x5F1710D1, 0x3CDE5FE6,
/**/                   0x001F3FD9, 0xBEF3FFE7,
/**/                   0x80000000, 0x3EF3FFF3,
/**/                   0xCD68DD41, 0x3CE4D541,
/**/                   0xC02997C7, 0xBEF5FFE1,
/**/                   0xE0000000, 0x3EF5FFF0,
/**/                   0x124A1F13, 0x3CEBBA8E,
/**/                   0x0035FFAF, 0xBEF7FFDC,
/**/                   0x00000000, 0x3EF7FFEE,
/**/                   0xC0184CAE, 0x3CF1FFEB,
/**/                   0xC044A790, 0xBEF9FFD5,
/**/                   0xE0000000, 0x3EF9FFEA,
/**/                   0xC68EECCD, 0x3CF6E28E,
/**/                   0x0055BF6A, 0xBEFBFFCF,
/**/                   0x80000000, 0x3EFBFFE7,
/**/                   0xD189DAA2, 0x3CFC952F,
/**/                   0xC069773A, 0xBEFDFFC7,
/**/                   0xE0000000, 0x3EFDFFE3,
/**/                   0x480513F6, 0x3D0193E7,
/**/                   0x007FFF00, 0xBEFFFFC0,
/**/                   0x00000000, 0x3EFFFFE0,
/**/                   0x55888833, 0x3D055535,
/**/                   0xE04CC35D, 0xBF00FFDB,
/**/                   0xF0000000, 0x3F00FFED,
/**/                   0xE2CFFE66, 0x3D099681,
/**/                   0x805B1F33, 0xBF01FFD7,
/**/                   0xC0000000, 0x3F01FFEB,
/**/                   0xBE5C42ED, 0x3D0E5FCC,
/**/                   0xE06B2B01, 0xBF02FFD2,
/**/                   0x70000000, 0x3F02FFE9,
/**/                   0xD9D71DD1, 0x3D11DC8A,
/**/                   0x007CFEC8, 0xBF03FFCE,
/**/                   0x00000000, 0x3F03FFE7,
/**/                   0x45A374B3, 0x3D14D52E,
/**/                   0xE090B284, 0xBF04FFC8,
/**/                   0x70000000, 0x3F04FFE4,
/**/                   0x8553B4C7, 0x3D181DD0,
/**/                   0x80A65E36, 0xBF05FFC3,
/**/                   0xC0000000, 0x3F05FFE1,
/**/                   0x7A287BBE, 0x3D1BBA71,
/**/                   0xE0BE19DD, 0xBF06FFBD,
/**/                   0xF0000000, 0x3F06FFDE,
/**/                   0x03E27702, 0x3D1FAF11,
/**/                   0x00D7FD78, 0xBF07FFB8,
/**/                   0x00000000, 0x3F07FFDC,
/**/                   0x80613240, 0x3D21FFD7,
/**/                   0xE0F42105, 0xBF08FFB1,
/**/                   0xF0000000, 0x3F08FFD8,
/**/                   0xA6C489B3, 0x3D245825,
/**/                   0x81129C84, 0xBF09FFAB,
/**/                   0xC0000000, 0x3F09FFD5,
/**/                   0xE2BBB26F, 0x3D26E272,
/**/                   0xE13387F2, 0xBF0AFFA4,
/**/                   0x70000000, 0x3F0AFFD2,
/**/                   0x21272669, 0x3D29A0BF,
/**/                   0x0156FB50, 0xBF0BFF9E,
/**/                   0x00000000, 0x3F0BFFCF,
/**/                   0x4E276957, 0x3D2C950A,
/**/                   0xE17D0E9B, 0xBF0CFF96,
/**/                   0x70000000, 0x3F0CFFCB,
/**/                   0x551D090E, 0x3D2FC154,
/**/                   0x81A5D9D2, 0xBF0DFF8F,
/**/                   0xC0000000, 0x3F0DFFC7,
/**/                   0x90544EF1, 0x3D3193CE,
/**/                   0xE1D174F4, 0xBF0EFF87,
/**/                   0xF0000000, 0x3F0EFFC3,
/**/                   0x4D556583, 0x3D3364F2,
/**/                   0x01FFF800, 0xBF0FFF80,
/**/                   0x00000000, 0x3F0FFFC0,
/**/                   0x56221F78, 0x3D355515,
/**/                   0xF118BD7A, 0xBF107FBB,
/**/                   0xF8000000, 0x3F107FDD,
/**/                   0x9EEAD9D8, 0x3D376537,
/**/                   0xC1330AE7, 0xBF10FFB7,
/**/                   0xE0000000, 0x3F10FFDB,
/**/                   0x1B7FF7AE, 0x3D399659,
/**/                   0x714EF047, 0xBF117FB3,
/**/                   0xB8000000, 0x3F117FD9,
/**/                   0xBF51E233, 0x3D3BE979,
/**/                   0x016C7998, 0xBF11FFAF,
/**/                   0x80000000, 0x3F11FFD7,
/**/                   0x7D7108FF, 0x3D3E5F99,
/**/                   0x718BB2DA, 0xBF127FAA,
/**/                   0x39000000, 0x3F127FD5,
/**/                   0xB7721DC6, 0xBD3F0647,
/**/                   0xC1ACA80C, 0xBF12FFA5,
/**/                   0xE1000000, 0x3F12FFD2,
/**/                   0xED071532, 0xBD3C4729,
/**/                   0xF1CF652D, 0xBF137FA0,
/**/                   0x79000000, 0x3F137FD0,
/**/                   0x315D596D, 0xBD39620D,
/**/                   0x01F3F63C, 0xBF13FF9C,
/**/                   0x01000000, 0x3F13FFCE,
/**/                   0x92E45F81, 0xBD3655F1,
/**/                   0xF21A6739, 0xBF147F96,
/**/                   0x79000000, 0x3F147FCB,
/**/                   0x206B9526, 0xBD3321D7,
/**/                   0xC242C421, 0xBF14FF91,
/**/                   0xE1000000, 0x3F14FFC8,
/**/                   0xD244C12A, 0xBD2F897B,
/**/                   0x726D18F6, 0xBF157F8C,
/**/                   0x39000000, 0x3F157FC6,
/**/                   0xF93040AE, 0xBD287B4B,
/**/                   0x029971B4, 0xBF15FF87,
/**/                   0x81000000, 0x3F15FFC3,
/**/                   0xD578562C, 0xBD21171E,
/**/                   0x72C7DA5C, 0xBF167F81,
/**/                   0xB9000000, 0x3F167FC0,
/**/                   0x0F773DB4, 0xBD12B5E9,
/**/                   0xC2F85EEC, 0xBF16FF7B,
/**/                   0xE1000000, 0x3F16FFBD,
/**/                   0x158A76C2, 0xBCE44CD3,
/**/                   0xF32B0B63, 0xBF177F75,
/**/                   0xF9000000, 0x3F177FBA,
/**/                   0x2E48511B, 0x3D0CB55C,
/**/                   0x035FEBC0, 0xBF17FF70,
/**/                   0x01000000, 0x3F17FFB8,
/**/                   0x184C534F, 0x3D1FFAF0,
/**/                   0xF3970C03, 0xBF187F69,
/**/                   0xF9000000, 0x3F187FB4,
/**/                   0xACC53FBE, 0x3D292D95,
/**/                   0xC3D07829, 0xBF18FF63,
/**/                   0xE1000000, 0x3F18FFB1,
/**/                   0xE48887C8, 0x3D315FD7,
/**/                   0x740C3C32, 0xBF197F5D,
/**/                   0xB9000000, 0x3F197FAE,
/**/                   0x1DF5B242, 0x3D365AE3,
/**/                   0x044A641C, 0xBF19FF57,
/**/                   0x81000000, 0x3F19FFAB,
/**/                   0x6FBB0E5F, 0x3D3B88EC,
/**/                   0x748AFBE7, 0xBF1A7F50,
/**/                   0x3A000000, 0x3F1A7FA8,
/**/                   0x39766B40, 0xBD3F150C,
/**/                   0xC4CE0F91, 0xBF1AFF49,
/**/                   0xE2000000, 0x3F1AFFA4,
/**/                   0xF14DB839, 0xBD397E06,
/**/                   0xF513AB19, 0xBF1B7F42,
/**/                   0x7A000000, 0x3F1B7FA1,
/**/                   0xCBD9CC3D, 0xBD33B103,
/**/                   0x055BDA7D, 0xBF1BFF3C,
/**/                   0x02000000, 0x3F1BFF9E,
/**/                   0xBB1321B5, 0xBD2B5A05,
/**/                   0xF5A6A9BD, 0xBF1C7F34,
/**/                   0x7A000000, 0x3F1C7F9A,
/**/                   0xECAF9551, 0xBD1DC410,
/**/                   0xC5F424D6, 0xBF1CFF2D,
/**/                   0xE2000000, 0x3F1CFF96,
/**/                   0x3DF3CD68, 0xBCEF80FF,
/**/                   0x764457C8, 0xBF1D7F26,
/**/                   0x3A000000, 0x3F1D7F93,
/**/                   0x4271E737, 0x3D16CBC7,
/**/                   0x06974E91, 0xBF1DFF1F,
/**/                   0x82000000, 0x3F1DFF8F,
/**/                   0x1D134848, 0x3D2939D2,
/**/                   0x76ED1530, 0xBF1E7F17,
/**/                   0xBA000000, 0x3F1E7F8B,
/**/                   0xA9892C73, 0x3D33C2DD,
/**/                   0xC745B7A4, 0xBF1EFF0F,
/**/                   0xE2000000, 0x3F1EFF87,
/**/                   0x8AEC69D5, 0x3D3B25CF,
/**/                   0xF7A141EA, 0xBF1F7F07,
/**/                   0xFB000000, 0x3F1F7F83,
/**/                   0x645B412A, 0xBD3D3941,
/**/                   0x07FFC002, 0xBF1FFF00,
/**/                   0x03000000, 0x3F1FFF80,
/**/                   0x3BBC6662, 0xBD355955,
/**/                   0xFC309EF5, 0xBF203F7B,
/**/                   0xFD800000, 0x3F203FBD,
/**/                   0x260B17B3, 0xBD2A72D8,
/**/                   0xE462E3D0, 0xBF207F77,
/**/                   0xF1800000, 0x3F207FBB,
/**/                   0x0994AE68, 0xBD136218,
/**/                   0xBC96B492, 0xBF20BF73,
/**/                   0xDD800000, 0x3F20BFB9,
/**/                   0xECB2641F, 0x3D0E52E6,
/**/                   0x84CC1739, 0xBF20FF6F,
/**/                   0xC1800000, 0x3F20FFB7,
/**/                   0xE7FCF60B, 0x3D296078,
/**/                   0x3D0311C6, 0xBF213F6B,
/**/                   0x9D800000, 0x3F213FB5,
/**/                   0xA7850AFF, 0x3D35DA18,
/**/                   0xE53BAA36, 0xBF217F66,
/**/                   0x71800000, 0x3F217FB3,
/**/                   0x5E7BB444, 0x3D3F48F1,
/**/                   0x7D75E68A, 0xBF21BF62,
/**/                   0x3E000000, 0x3F21BFB1,
/**/                   0x812BC469, 0xBD370239,
/**/                   0x05B1CCC0, 0xBF21FF5E,
/**/                   0x02000000, 0x3F21FFAF,
/**/                   0x23BF1A4D, 0xBD2A0CD0,
/**/                   0x7DEF62D8, 0xBF223F59,
/**/                   0xBE000000, 0x3F223FAC,
/**/                   0x736E3623, 0xBD0614D3,
/**/                   0xE62EAED0, 0xBF227F54,
/**/                   0x72000000, 0x3F227FAA,
/**/                   0x37EDEDB0, 0x3D1F28BD,
/**/                   0x3E6FB6A9, 0xBF22BF50,
/**/                   0x1E000000, 0x3F22BFA8,
/**/                   0x07CE33C8, 0x3D32A0F5,
/**/                   0x86B28060, 0xBF22FF4B,
/**/                   0xC2000000, 0x3F22FFA5,
/**/                   0xA31C6A8D, 0x3D3DC2B6,
/**/                   0xBEF711F6, 0xBF233F46,
/**/                   0x5E800000, 0x3F233FA3,
/**/                   0xFC67C9FB, 0xBD36CF8B,
/**/                   0xE73D7169, 0xBF237F41,
/**/                   0xF2800000, 0x3F237FA0,
/**/                   0xE6D88A89, 0xBD2629A5,
/**/                   0xFF85A4B8, 0xBF23BF3C,
/**/                   0x7E800000, 0x3F23BF9E,
/**/                   0x202574EC, 0x3CEE7C34,
/**/                   0x07CFB1E3, 0xBF23FF38,
/**/                   0x02800000, 0x3F23FF9C,
/**/                   0x46E594C1, 0x3D2A9723,
/**/                   0x001B9EE8, 0xBF243F33,
/**/                   0x7E800000, 0x3F243F99,
/**/                   0xF61AE74C, 0x3D39F33C,
/**/                   0xE86971C7, 0xBF247F2D,
/**/                   0xF3000000, 0x3F247F96,
/**/                   0x85341E31, 0xBD39141C,
/**/                   0xC0B9307F, 0xBF24BF28,
/**/                   0x5F000000, 0x3F24BF94,
/**/                   0xDA0FAF09, 0xBD2792F5,
/**/                   0x890AE10E, 0xBF24FF23,
/**/                   0xC3000000, 0x3F24FF91,
/**/                   0xFB239430, 0x3CFD4219,
/**/                   0x415E8974, 0xBF253F1E,
/**/                   0x1F000000, 0x3F253F8F,
/**/                   0x0359434A, 0x3D2F8B72,
/**/                   0xE9B42FAF, 0xBF257F18,
/**/                   0x73000000, 0x3F257F8C,
/**/                   0x1939FEDF, 0x3D3E0C4B,
/**/                   0x820BD9BF, 0xBF25BF13,
/**/                   0xBF800000, 0x3F25BF89,
/**/                   0x39B301E2, 0xBD335728,
/**/                   0x0A658DA3, 0xBF25FF0E,
/**/                   0x03800000, 0x3F25FF87,
/**/                   0x5E1E8D4F, 0xBD118E84,
/**/                   0x82C15159, 0xBF263F08,
/**/                   0x3F800000, 0x3F263F84,
/**/                   0xBDDDD045, 0x3D25CFC0,
/**/                   0xEB1F2AE1, 0xBF267F02,
/**/                   0x73800000, 0x3F267F81,
/**/                   0x08837E99, 0x3D3A8C5C,
/**/                   0x437F203A, 0xBF26BEFD,
/**/                   0xA0000000, 0x3F26BF7E,
/**/                   0x3C56F12D, 0xBD35752E,
/**/                   0x8BE13762, 0xBF26FEF7,
/**/                   0xC4000000, 0x3F26FF7B,
/**/                   0x46359E28, 0xBD146EFA,
/**/                   0xC4457659, 0xBF273EF1,
/**/                   0xE0000000, 0x3F273F78,
/**/                   0xCD265865, 0x3D273355,
/**/                   0xECABE31C, 0xBF277EEB,
/**/                   0xF4000000, 0x3F277F75,
/**/                   0x095DEBF8, 0x3D3CAC0E,
/**/                   0x051483AC, 0xBF27BEE6,
/**/                   0x00800000, 0x3F27BF73,
/**/                   0x4C39F4DB, 0xBD31E395,
/**/                   0x0D7F5E08, 0xBF27FEE0,
/**/                   0x04800000, 0x3F27FF70,
/**/                   0xA1314B81, 0xBCB43F3D,
/**/                   0x05EC782D, 0xBF283EDA,
/**/                   0x00800000, 0x3F283F6D,
/**/                   0x115B8D70, 0x3D321B10,
/**/                   0xEE5BD81B, 0xBF287ED3,
/**/                   0xF5000000, 0x3F287F69,
/**/                   0x83704FE1, 0xBD3B54A7,
/**/                   0xC6CD83D1, 0xBF28BECD,
/**/                   0xE1000000, 0x3F28BF66,
/**/                   0x41229C91, 0xBD20C4CC,
/**/                   0x8F41814D, 0xBF28FEC7,
/**/                   0xC5000000, 0x3F28FF63,
/**/                   0x2A183F17, 0x3D25E5A8,
/**/                   0x47B7D68F, 0xBF293EC1,
/**/                   0xA1000000, 0x3F293F60,
/**/                   0xF81B997D, 0x3D3EAC06,
/**/                   0xF0308995, 0xBF297EBA,
/**/                   0x75800000, 0x3F297F5D,
/**/                   0x3A1E5BAD, 0xBD2A6B9B,
/**/                   0x88ABA05E, 0xBF29BEB4,
/**/                   0x41800000, 0x3F29BF5A,
/**/                   0xBDFE3C77, 0x3D1D3958,
/**/                   0x112920E9, 0xBF29FEAE,
/**/                   0x05800000, 0x3F29FF57,
/**/                   0x375BA904, 0x3D3C3972,
/**/                   0x89A91135, 0xBF2A3EA7,
/**/                   0xC2000000, 0x3F2A3F53,
/**/                   0x588DE85B, 0xBD2CE6F3,
/**/                   0xF22B7740, 0xBF2A7EA0,
/**/                   0x76000000, 0x3F2A7F50,
/**/                   0x75AEDBFD, 0x3D1D2249,
/**/                   0x4AB05909, 0xBF2ABE9A,
/**/                   0x22000000, 0x3F2ABF4D,
/**/                   0x2CE7BDAC, 0x3D3D6E96,
/**/                   0x9337BC90, 0xBF2AFE93,
/**/                   0xC6800000, 0x3F2AFF49,
/**/                   0xCB7D724C, 0xBD2800DC,
/**/                   0xCBC1A7D1, 0xBF2B3E8C,
/**/                   0x62800000, 0x3F2B3F46,
/**/                   0xFA591B29, 0x3D25F908,
/**/                   0xF44E20CE, 0xBF2B7E85,
/**/                   0xF7000000, 0x3F2B7F42,
/**/                   0x53021ED8, 0xBD3D9991,
/**/                   0x0CDD2D83, 0xBF2BBE7F,
/**/                   0x83000000, 0x3F2BBF3F,
/**/                   0xFD596AD6, 0xBD1706BF,
/**/                   0x156ED3F0, 0xBF2BFE78,
/**/                   0x07000000, 0x3F2BFF3C,
/**/                   0x4EC45253, 0x3D328528,
/**/                   0x0E031A14, 0xBF2C3E71,
/**/                   0x83800000, 0x3F2C3F38,
/**/                   0x927D8A9E, 0xBD34C408,
/**/                   0xF69A05ED, 0xBF2C7E69,
/**/                   0xF7800000, 0x3F2C7F34,
/**/                   0xCAE2C25F, 0x3D118EF4,
/**/                   0xCF339D7A, 0xBF2CBE62,
/**/                   0x63800000, 0x3F2CBF31,
/**/                   0x73DBBB41, 0x3D3DFD79,
/**/                   0x97CFE6B9, 0xBF2CFE5B,
/**/                   0xC8000000, 0x3F2CFF2D,
/**/                   0xE7FE77E6, 0xBD1FD74F,
/**/                   0x506EE7AA, 0xBF2D3E54,
/**/                   0x24000000, 0x3F2D3F2A,
/**/                   0xBDDB871F, 0x3D328AD4,
/**/                   0xF910A64A, 0xBF2D7E4C,
/**/                   0x78800000, 0x3F2D7F26,
/**/                   0x903DDD81, 0xBD327F8C,
/**/                   0x91B52899, 0xBF2DBE45,
/**/                   0xC4800000, 0x3F2DBF22,
/**/                   0xDF52840A, 0x3D21D80F,
/**/                   0x1A5C7495, 0xBF2DFE3E,
/**/                   0x09000000, 0x3F2DFF1F,
/**/                   0xEED9F651, 0xBD3B316D,
/**/                   0x9306903D, 0xBF2E3E36,
/**/                   0x45000000, 0x3F2E3F1B,
/**/                   0x76DB3C6B, 0x3CF2911A,
/**/                   0xFBB3818F, 0xBF2E7E2E,
/**/                   0x79000000, 0x3F2E7F17,
/**/                   0x85559113, 0x3D3DFC86,
/**/                   0x54634E89, 0xBF2EBE27,
/**/                   0xA5800000, 0x3F2EBF13,
/**/                   0x0AB3DBE7, 0xBD12D83E,
/**/                   0x9D15FD2B, 0xBF2EFE1F,
/**/                   0xC9800000, 0x3F2EFF0F,
/**/                   0x617B99F1, 0x3D39124F,
/**/                   0xD5CB9373, 0xBF2F3E17,
/**/                   0xE6000000, 0x3F2F3F0B,
/**/                   0xF8F64DA1, 0xBD2152B9,
/**/                   0xFE841760, 0xBF2F7E0F,
/**/                   0xFA000000, 0x3F2F7F07,
/**/                   0x34C4735B, 0x3D3617EB,
/**/                   0x173F8EEF, 0xBF2FBE08,
/**/                   0x06800000, 0x3F2FBF04,
/**/                   0x739FA712, 0xBD2551B0,
/**/                   0x1FFE0020, 0xBF2FFE00,
/**/                   0x0A800000, 0x3F2FFF00,
/**/                   0x885DE027, 0x3D351558,
/**/                   0x0C5FB879, 0xBF301EFC,
/**/                   0x03800000, 0x3F301F7E,
/**/                   0x68F8FC50, 0xBD255905,
/**/                   0x00C1F3B0, 0xBF303EF8,
/**/                   0xFD800000, 0x3F303F7B,
/**/                   0xDF771CF4, 0x3D361295,
/**/                   0xED25B4B7, 0xBF305EF3,
/**/                   0xF3C00000, 0x3F305F79,
/**/                   0xD8A255DB, 0xBD2158BB,
/**/                   0xD18AFE8B, 0xBF307EEF,
/**/                   0xE5C00000, 0x3F307F77,
/**/                   0xB740E625, 0x3D3917A1,
/**/                   0xADF1D42C, 0xBF309EEB,
/**/                   0xD4000000, 0x3F309F75,
/**/                   0x9C716D59, 0xBD1281AD,
/**/                   0x825A3899, 0xBF30BEE7,
/**/                   0xBE000000, 0x3F30BF73,
/**/                   0x86ED7DDC, 0x3D3E2C7A,
/**/                   0x4EC42ED1, 0xBF30DEE3,
/**/                   0xA4400000, 0x3F30DF71,
/**/                   0xF54F7E28, 0x3CF7F534,
/**/                   0x132FB9D5, 0xBF30FEDF,
/**/                   0x86800000, 0x3F30FF6F,
/**/                   0x404F4E01, 0xBD3AA6E1,
/**/                   0xCF9CDCA2, 0xBF311EDA,
/**/                   0x64800000, 0x3F311F6D,
/**/                   0x4A6EC981, 0x3D2375B9,
/**/                   0x840B9A38, 0xBF313ED6,
/**/                   0x3EC00000, 0x3F313F6B,
/**/                   0x33401DD0, 0xBD315A73,
/**/                   0x307BF596, 0xBF315ED2,
/**/                   0x14C00000, 0x3F315F69,
/**/                   0x02C11605, 0x3D341A2F,
/**/                   0xD4EDF1BC, 0xBF317ECD,
/**/                   0xE7000000, 0x3F317F66,
/**/                   0xB2B7E8C5, 0xBD1798F3,
/**/                   0x716191A8, 0xBF319EC9,
/**/                   0xB5400000, 0x3F319F64,
/**/                   0x35D62ED5, 0xBD3F5AB7,
/**/                   0x05D6D85A, 0xBF31BEC5,
/**/                   0x7F400000, 0x3F31BF62,
/**/                   0xCA7EC7CD, 0x3D1EF6FF,
/**/                   0x924DC8D2, 0xBF31DEC0,
/**/                   0x45800000, 0x3F31DF60,
/**/                   0xA8550396, 0xBD309BD7,
/**/                   0x16C6660D, 0xBF31FEBC,
/**/                   0x07800000, 0x3F31FF5E,
/**/                   0xC3E31F70, 0x3D379981,
/**/                   0x9340B30B, 0xBF321EB7,
/**/                   0xC5C00000, 0x3F321F5B,
/**/                   0x5FE92B94, 0x3CD7B300,
/**/                   0x07BCB2CC, 0xBF323EB3,
/**/                   0x80000000, 0x3F323F59,
/**/                   0x25A7CF34, 0xBD364AF9,
/**/                   0x743A684F, 0xBF325EAE,
/**/                   0x36000000, 0x3F325F57,
/**/                   0x17E48399, 0x3D339D32,
/**/                   0xD8B9D692, 0xBF327EA9,
/**/                   0xE8400000, 0x3F327F54,
/**/                   0xCC387BD1, 0xBCFE7B27,
/**/                   0x353B0095, 0xBF329EA5,
/**/                   0x96800000, 0x3F329F52,
/**/                   0x1AE7FA80, 0xBD36D8A7,
/**/                   0x89BDE957, 0xBF32BEA0,
/**/                   0x40800000, 0x3F32BF50,
/**/                   0x05CF3DC3, 0x3D34CB54,
/**/                   0xD64293D7, 0xBF32DE9B,
/**/                   0xE6C00000, 0x3F32DF4D,
/**/                   0xD5A4F691, 0x3CF053EA,
/**/                   0x1AC90315, 0xBF32FE97,
/**/                   0x89000000, 0x3F32FF4B,
/**/                   0x5CAE7B16, 0xBD3229E7,
/**/                   0x57513A0F, 0xBF331E92,
/**/                   0x27000000, 0x3F331F49,
/**/                   0xAEED4509, 0x3D3B3EE1,
/**/                   0x8BDB3BC4, 0xBF333E8D,
/**/                   0xC1400000, 0x3F333F46,
/**/                   0x2E0C2605, 0x3D228133,
/**/                   0xB8670B34, 0xBF335E88,
/**/                   0x57800000, 0x3F335F44,
/**/                   0xBBD6E280, 0xBD20477F,
/**/                   0xDCF4AB5D, 0xBF337E83,
/**/                   0xE9C00000, 0x3F337F41,
/**/                   0xE9CE8AFC, 0xBD38ED2A,
/**/                   0xF9841F3F, 0xBF339E7E,
/**/                   0x77C00000, 0x3F339F3F,
/**/                   0x39159F9B, 0x3D36E558,
/**/                   0x0E1569D9, 0xBF33BE7A,
/**/                   0x02000000, 0x3F33BF3D,
/**/                   0x40681634, 0x3D1D5325,
/**/                   0x1AA88E2A, 0xBF33DE75,
/**/                   0x88400000, 0x3F33DF3A,
/**/                   0x7F2112CE, 0xBD1E775F,
/**/                   0x1F3D8F31, 0xBF33FE70,
/**/                   0x0A800000, 0x3F33FF38,
/**/                   0x91F80D1B, 0xBD35F18B,
/**/                   0x1BD46FED, 0xBF341E6B,
/**/                   0x88800000, 0x3F341F35,
/**/                   0xFDC3FC2F, 0x3D3C5AAD,
/**/                   0x106D335D, 0xBF343E66,
/**/                   0x02C00000, 0x3F343F33,
/**/                   0x268A89F1, 0x3D2E8FA9,
/**/                   0xFD07DC80, 0xBF345E60,
/**/                   0x79000000, 0x3F345F30,
/**/                   0x902AC9EE, 0x3D06B73F,
/**/                   0xE1A46E55, 0xBF347E5B,
/**/                   0xEB400000, 0x3F347F2D,
/**/                   0x45C43959, 0xBD21EE30,
/**/                   0xBE42EBDC, 0xBF349E56,
/**/                   0x59800000, 0x3F349F2B,
/**/                   0xE8B753E8, 0xBD34212B,
/**/                   0x92E35813, 0xBF34BE51,
/**/                   0xC3C00000, 0x3F34BF28,
/**/                   0x9D2064DB, 0xBD3EA653,
/**/                   0x5F85B5F9, 0xBF34DE4C,
/**/                   0x29C00000, 0x3F34DF26,
/**/                   0x81DCB6FB, 0x3D377A70,
/**/                   0x242A088D, 0xBF34FE47,
/**/                   0x8C000000, 0x3F34FF23,
/**/                   0x6BB44A6D, 0x3D2C8440,
/**/                   0xE0D052CF, 0xBF351E41,
/**/                   0xEA400000, 0x3F351F20,
/**/                   0x0048AAF8, 0x3D16C6ED,
/**/                   0x957897BD, 0xBF353E3C,
/**/                   0x44800000, 0x3F353F1E,
/**/                   0xF506A07E, 0xBD01ADF4,
/**/                   0x4222DA57, 0xBF355E37,
/**/                   0x9AC00000, 0x3F355F1B,
/**/                   0x4B88A655, 0xBD22E69B,
/**/                   0xE6CF1D9B, 0xBF357E31,
/**/                   0xED000000, 0x3F357F18,
/**/                   0x153DAEB0, 0xBD3005F2,
/**/                   0x837D6488, 0xBF359E2C,
/**/                   0x3B400000, 0x3F359F16,
/**/                   0x2D5222B4, 0xBD35ECAC,
/**/                   0x182DB21E, 0xBF35BE27,
/**/                   0x85800000, 0x3F35BF13,
/**/                   0x2EA6CB14, 0xBD3B267C,
/**/                   0xA4E0095B, 0xBF35DE21,
/**/                   0xCBC00000, 0x3F35DF10,
/**/                   0x5A40A340, 0xBD3FB262,
/**/                   0x29946D3F, 0xBF35FE1C,
/**/                   0x0DC00000, 0x3F35FF0E,
/**/                   0x0E7B79ED, 0x3D3C70A1,
/**/                   0xA64AE0C7, 0xBF361E16,
/**/                   0x4C000000, 0x3F361F0B,
/**/                   0xC9C8D263, 0x3D39438D,
/**/                   0x1B0366F4, 0xBF363E11,
/**/                   0x86400000, 0x3F363F08,
/**/                   0x9582CD0C, 0x3D36C763,
/**/                   0x87BE02C5, 0xBF365E0B,
/**/                   0xBC800000, 0x3F365F05,
/**/                   0x2F24F1F9, 0x3D34FD22,
/**/                   0xEC7AB737, 0xBF367E05,
/**/                   0xEEC00000, 0x3F367F02,
/**/                   0x53CAEA94, 0x3D33E5C9,
/**/                   0x4939874A, 0xBF369E00,
/**/                   0x1D000000, 0x3F369F00,
/**/                   0xC03081D0, 0x3D338258,
/**/                   0x9DFA75FE, 0xBF36BDFA,
/**/                   0x47400000, 0x3F36BEFD,
/**/                   0x30B1A458, 0x3D33D3D0,
/**/                   0xEABD8651, 0xBF36DDF4,
/**/                   0x6D800000, 0x3F36DEFA,
/**/                   0x614A60C1, 0x3D34DB2F,
/**/                   0x2F82BB41, 0xBF36FDEF,
/**/                   0x8FC00000, 0x3F36FEF7,
/**/                   0x0D96E7B8, 0x3D369976,
/**/                   0x6C4A17CF, 0xBF371DE9,
/**/                   0xAE000000, 0x3F371EF4,
/**/                   0xF0D38C30, 0x3D390FA3,
/**/                   0xA1139EF8, 0xBF373DE3,
/**/                   0xC8400000, 0x3F373EF1,
/**/                   0xC5DCC397, 0x3D3C3EB8,
/**/                   0xCDDF53BC, 0xBF375DDD,
/**/                   0xDEC00000, 0x3F375EEE,
/**/                   0xB8D0D9FD, 0xBD3FD84B,
/**/                   0xF2AD3919, 0xBF377DD7,
/**/                   0xF1000000, 0x3F377EEB,
/**/                   0xD11891A0, 0xBD3B3469,
/**/                   0x0F7D520F, 0xBF379DD2,
/**/                   0xFF400000, 0x3F379EE8,
/**/                   0xC93D855B, 0xBD35D4A1,
/**/                   0x244FA19D, 0xBF37BDCC,
/**/                   0x09800000, 0x3F37BEE6,
/**/                   0xCFC56806, 0xBD2F6FE7,
/**/                   0x31242AC1, 0xBF37DDC6,
/**/                   0x0FC00000, 0x3F37DEE3,
/**/                   0xE815F202, 0xBD21BAC0,
/**/                   0x35FAF079, 0xBF37FDC0,
/**/                   0x12000000, 0x3F37FEE0,
/**/                   0x5190C28B, 0xBCF43E7B,
/**/                   0x32D3F5C6, 0xBF381DBA,
/**/                   0x10400000, 0x3F381EDD,
/**/                   0x34C1F9E9, 0x3D1C55D8,
/**/                   0x27AF3DA6, 0xBF383DB4,
/**/                   0x0A800000, 0x3F383EDA,
/**/                   0x8AAF36D4, 0x3D302FB8,
/**/                   0x148CCB18, 0xBF385DAE,
/**/                   0x00C00000, 0x3F385ED7,
/**/                   0x7AE0D0F8, 0x3D3A0BDF,
/**/                   0xF96CA11B, 0xBF387DA7,
/**/                   0xF3400000, 0x3F387ED3,
/**/                   0x6B1CDAAF, 0xBD3B5515,
/**/                   0xD64EC2AD, 0xBF389DA1,
/**/                   0xE1800000, 0x3F389ED0,
/**/                   0xE1179E5E, 0xBD2FE44C,
/**/                   0xAB3332CD, 0xBF38BD9B,
/**/                   0xCBC00000, 0x3F38BECD,
/**/                   0xF86F56EC, 0xBD0E529E,
/**/                   0x7819F47A, 0xBF38DD95,
/**/                   0xB2000000, 0x3F38DECA,
/**/                   0xFEB631AB, 0x3D2246C3,
/**/                   0x3D030AB4, 0xBF38FD8F,
/**/                   0x94400000, 0x3F38FEC7,
/**/                   0xE04DA791, 0x3D36D7FA,
/**/                   0xF9EE7878, 0xBF391D88,
/**/                   0x72C00000, 0x3F391EC4,
/**/                   0x86F7ADBB, 0xBD3AAB89,
/**/                   0xAEDC40C7, 0xBF393D82,
/**/                   0x4D000000, 0x3F393EC1,
/**/                   0x032C6155, 0xBD26CC57,
/**/                   0x5BCC669D, 0xBF395D7C,
/**/                   0x23400000, 0x3F395EBE,
/**/                   0x93C3EB3D, 0x3D12A452,
/**/                   0x00BEECFB, 0xBF397D76,
/**/                   0xF5800000, 0x3F397EBA,
/**/                   0xA0BCD695, 0x3D358336,
/**/                   0x9DB3D6E0, 0xBF399D6F,
/**/                   0xC4000000, 0x3F399EB7,
/**/                   0xDA737570, 0xBD38D6C5,
/**/                   0x32AB2749, 0xBF39BD69,
/**/                   0x8E400000, 0x3F39BEB4,
/**/                   0x65026C7D, 0xBD198F84,
/**/                   0xBFA4E136, 0xBF39DD62,
/**/                   0x54800000, 0x3F39DEB1,
/**/                   0x2EA9B41A, 0x3D29B9C9,
/**/                   0x44A107A5, 0xBF39FD5C,
/**/                   0x17000000, 0x3F39FEAE,
/**/                   0x16137ACF, 0xBD3F1375,
/**/                   0xC19F9D96, 0xBF3A1D55,
/**/                   0xD5400000, 0x3F3A1EAA,
/**/                   0xDE73AFA0, 0xBD2467DC,
/**/                   0x36A0A607, 0xBF3A3D4F,
/**/                   0x8F800000, 0x3F3A3EA7,
/**/                   0x7B8357C6, 0x3D26F8F0,
/**/                   0xA3A423F7, 0xBF3A5D48,
/**/                   0x46000000, 0x3F3A5EA4,
/**/                   0x5DA0DFB7, 0xBD3E0141,
/**/                   0x08AA1A64, 0xBF3A7D42,
/**/                   0xF8400000, 0x3F3A7EA0,
/**/                   0x41050D29, 0xBD1AB06E,
/**/                   0x65B28C4E, 0xBF3A9D3B,
/**/                   0xA6800000, 0x3F3A9E9D,
/**/                   0x56A0E005, 0x3D317CE9,
/**/                   0xBABD7CB3, 0xBF3ABD34,
/**/                   0x51000000, 0x3F3ABE9A,
/**/                   0xF899EF39, 0xBD358532,
/**/                   0x07CAEE92, 0xBF3ADD2E,
/**/                   0xF7400000, 0x3F3ADE96,
/**/                   0xC83BF5C2, 0x3D113A3C,
/**/                   0x4CDAE4EA, 0xBF3AFD27,
/**/                   0x99800000, 0x3F3AFE93,
/**/                   0x863C7C8E, 0x3D3EF92F,
/**/                   0x89ED62B9, 0xBF3B1D20,
/**/                   0x38000000, 0x3F3B1E90,
/**/                   0x3341CC3C, 0xBD161149,
/**/                   0xBF026AFE, 0xBF3B3D19,
/**/                   0xD2400000, 0x3F3B3E8C,
/**/                   0x67C955DF, 0x3D36D709,
/**/                   0xEC1A00B8, 0xBF3B5D12,
/**/                   0x68C00000, 0x3F3B5E89,
/**/                   0x5AE9B17A, 0xBD27E77B,
/**/                   0x113426E6, 0xBF3B7D0C,
/**/                   0xFB000000, 0x3F3B7E85,
/**/                   0x219679DE, 0x3D321C58,
/**/                   0x2E50E086, 0xBF3B9D05,
/**/                   0x89800000, 0x3F3B9E82,
/**/                   0xFAA62113, 0xBD2DEF6A,
/**/                   0x43703097, 0xBF3BBCFE,
/**/                   0x13C00000, 0x3F3BBE7F,
/**/                   0x23305306, 0x3D30D119,
/**/                   0x50921A17, 0xBF3BDCF7,
/**/                   0x9A400000, 0x3F3BDE7B,
/**/                   0x9FBACE27, 0xBD2D1078,
/**/                   0x55B6A006, 0xBF3BFCF0,
/**/                   0x1C800000, 0x3F3BFE78,
/**/                   0xD625DF1E, 0x3D32FD49,
/**/                   0x52DDC563, 0xBF3C1CE9,
/**/                   0x9B000000, 0x3F3C1E74,
/**/                   0x7D07255B, 0xBD253AA9,
/**/                   0x48078D2B, 0xBF3C3CE2,
/**/                   0x15400000, 0x3F3C3E71,
/**/                   0x9E08B538, 0x3D38A8E7,
/**/                   0x3533FA5D, 0xBF3C5CDB,
/**/                   0x8BC00000, 0x3F3C5E6D,
/**/                   0x45956AFC, 0xBD09780B,
/**/                   0x1A630FF9, 0xBF3C7CD4,
/**/                   0xFE400000, 0x3F3C7E69,
/**/                   0x2792F44E, 0xBD3E2410,
/**/                   0xF794D0FC, 0xBF3C9CCC,
/**/                   0x6C800000, 0x3F3C9E66,
/**/                   0x30AB4456, 0x3D1F2AEC,
/**/                   0xCCC94066, 0xBF3CBCC5,
/**/                   0xD7000000, 0x3F3CBE62,
/**/                   0x231641D5, 0xBD3161A0,
/**/                   0x9A006135, 0xBF3CDCBE,
/**/                   0x3D400000, 0x3F3CDE5F,
/**/                   0xF4AD1934, 0x3D3657DD,
/**/                   0x5F3A3668, 0xBF3CFCB7,
/**/                   0x9FC00000, 0x3F3CFE5B,
/**/                   0x2E7AC798, 0xBCF07CB0,
/**/                   0x1C76C2FD, 0xBF3D1CB0,
/**/                   0xFE400000, 0x3F3D1E57,
/**/                   0x6090F643, 0xBD377F9B,
/**/                   0xD1B609F3, 0xBF3D3CA8,
/**/                   0x58800000, 0x3F3D3E54,
/**/                   0x849503E6, 0x3D32F16C,
/**/                   0x7EF80E49, 0xBF3D5CA1,
/**/                   0xAF000000, 0x3F3D5E50,
/**/                   0xAF1CA4EA, 0xBCFB3B3A,
/**/                   0x243CD2FE, 0xBF3D7C9A,
/**/                   0x01800000, 0x3F3D7E4D,
/**/                   0x4701415B, 0xBD356DFC,
/**/                   0xC1845B0F, 0xBF3D9C92,
/**/                   0x4FC00000, 0x3F3D9E49,
/**/                   0x582AEA48, 0x3D37C392,
/**/                   0x56CEA97C, 0xBF3DBC8B,
/**/                   0x9A400000, 0x3F3DBE45,
/**/                   0x67DCC15E, 0x3D1787DF,
/**/                   0xE41BC143, 0xBF3DDC83,
/**/                   0xE0C00000, 0x3F3DDE41,
/**/                   0x352F961F, 0xBD262398,
/**/                   0x696BA563, 0xBF3DFC7C,
/**/                   0x23400000, 0x3F3DFE3E,
/**/                   0xDEDD373A, 0xBD3B16B9,
/**/                   0xE6BE58DA, 0xBF3E1C74,
/**/                   0x61800000, 0x3F3E1E3A,
/**/                   0x336BE94B, 0x3D35D42E,
/**/                   0x5C13DEA7, 0xBF3E3C6D,
/**/                   0x9C000000, 0x3F3E3E36,
/**/                   0x08A303A2, 0x3D1EBFAF,
/**/                   0xC96C39C9, 0xBF3E5C65,
/**/                   0xD2800000, 0x3F3E5E32,
/**/                   0x34856362, 0xBD160A06,
/**/                   0x2EC76D3D, 0xBF3E7C5E,
/**/                   0x05000000, 0x3F3E7E2F,
/**/                   0x154CDF1A, 0xBD31C21A,
/**/                   0x8C257C04, 0xBF3E9C56,
/**/                   0x33800000, 0x3F3E9E2B,
/**/                   0x31941F7F, 0xBD3D0DDE,
/**/                   0xE186691B, 0xBF3EBC4E,
/**/                   0x5DC00000, 0x3F3EBE27,
/**/                   0xC26EC60D, 0x3D389B31,
/**/                   0x2EEA3781, 0xBF3EDC47,
/**/                   0x84400000, 0x3F3EDE23,
/**/                   0xD583BEF8, 0x3D2E742A,
/**/                   0x7450EA34, 0xBF3EFC3F,
/**/                   0xA6C00000, 0x3F3EFE1F,
/**/                   0xAC2DA351, 0x3D1B3F31,
/**/                   0xB1BA8433, 0xBF3F1C37,
/**/                   0xC5400000, 0x3F3F1E1B,
/**/                   0x2DC67430, 0xBCE45533,
/**/                   0xE727087C, 0xBF3F3C2F,
/**/                   0xDFC00000, 0x3F3F3E17,
/**/                   0xFF1174AE, 0xBD1C7133,
/**/                   0x14967A0F, 0xBF3F5C28,
/**/                   0xF6400000, 0x3F3F5E13,
/**/                   0x4AE098DC, 0xBD29383C,
/**/                   0x3A08DBE9, 0xBF3F7C20,
/**/                   0x08C00000, 0x3F3F7E10,
/**/                   0x684B0B3B, 0xBD31211D,
/**/                   0x577E3109, 0xBF3F9C18,
/**/                   0x17400000, 0x3F3F9E0C,
/**/                   0x268D7464, 0xBD34AA4B,
/**/                   0x6CF67C6E, 0xBF3FBC10,
/**/                   0x21C00000, 0x3F3FBE08,
/**/                   0xBED03388, 0xBD3736A7,
/**/                   0x7A71C116, 0xBF3FDC08,
/**/                   0x28400000, 0x3F3FDE04,
/**/                   0x900BC4E5, 0xBD38C533,
/**/                   0x7FF00200, 0xBF3FFC00,
/**/                   0x2AC00000, 0x3F3FFE00,
/**/                   0xF9987527, 0xBD3954EE,
/**/                   0x3EB8A115, 0xBF400DFC,
/**/                   0x14A00000, 0x3F400EFE,
/**/                   0x5B2E613B, 0xBD38E4DA,
/**/                   0x397AC249, 0xBF401DF8,
/**/                   0x11E00000, 0x3F401EFC,
/**/                   0x14E5761B, 0xBD3773F6,
/**/                   0x303E661C, 0xBF402DF4,
/**/                   0x0D200000, 0x3F402EFA,
/**/                   0x873570A0, 0xBD350142,
/**/                   0x23038E0C, 0xBF403DF0,
/**/                   0x06600000, 0x3F403EF8,
/**/                   0x12F5DD53, 0xBD318BC0,
/**/                   0x11CA3B9A, 0xBF404DEC,
/**/                   0xFDA00000, 0x3F404EF5,
/**/                   0x32BC307C, 0xBD2A24DE,
/**/                   0xFC927044, 0xBF405DE7,
/**/                   0xF2E00000, 0x3F405EF3,
/**/                   0xF01532DA, 0xBD1E513F,
/**/                   0xE35C2D8A, 0xBF406DE3,
/**/                   0xE6200000, 0x3F406EF1,
/**/                   0xCE27534E, 0xBCF10631,
/**/                   0xC62774EA, 0xBF407DDF,
/**/                   0xD7600000, 0x3F407EEF,
/**/                   0x86CE9380, 0x3D19E95C,
/**/                   0xA4F447E4, 0xBF408DDB,
/**/                   0xC6A00000, 0x3F408EED,
/**/                   0xBA0CD2C3, 0x3D2E19BC,
/**/                   0x7FC2A7F8, 0xBF409DD7,
/**/                   0xB3E00000, 0x3F409EEB,
/**/                   0x31FF7199, 0x3D38A832,
/**/                   0x569296A4, 0xBF40ADD3,
/**/                   0x9F400000, 0x3F40AEE9,
/**/                   0xC2D77791, 0xBD3CB2AD,
/**/                   0x29641567, 0xBF40BDCF,
/**/                   0x88800000, 0x3F40BEE7,
/**/                   0xE5545563, 0xBD3102C1,
/**/                   0xF83725C2, 0xBF40CDCA,
/**/                   0x6FC00000, 0x3F40CEE5,
/**/                   0x66B3E48D, 0xBD111C2A,
/**/                   0xC30BC932, 0xBF40DDC6,
/**/                   0x55000000, 0x3F40DEE3,
/**/                   0x7711FC2A, 0x3D2302EF,
/**/                   0x89E20138, 0xBF40EDC2,
/**/                   0x38400000, 0x3F40EEE1,
/**/                   0xB558238E, 0x3D3857C4,
/**/                   0x4CB9CF52, 0xBF40FDBE,
/**/                   0x19A00000, 0x3F40FEDF,
/**/                   0x1194C2E1, 0xBD37C324,
/**/                   0x0B933501, 0xBF410DBA,
/**/                   0xF8E00000, 0x3F410EDC,
/**/                   0xFBCAF285, 0xBD1B390B,
/**/                   0xC66E33C2, 0xBF411DB5,
/**/                   0xD6200000, 0x3F411EDA,
/**/                   0x0E52C3A4, 0x3D266ECF,
/**/                   0x7D4ACD15, 0xBF412DB1,
/**/                   0xB1600000, 0x3F412ED8,
/**/                   0x1A4AF71D, 0x3D3E4EDB,
/**/                   0x30290279, 0xBF413DAD,
/**/                   0x8AC00000, 0x3F413ED6,
/**/                   0x58C4D599, 0xBD2B0DD1,
/**/                   0xDF08D56E, 0xBF414DA8,
/**/                   0x62000000, 0x3F414ED4,
/**/                   0x2FB4061D, 0x3D1EDC6F,
/**/                   0x89EA4773, 0xBF415DA4,
/**/                   0x37400000, 0x3F415ED2,
/**/                   0x1BA53538, 0x3D3E09E8,
/**/                   0x30CD5A06, 0xBF416DA0,
/**/                   0x0AA00000, 0x3F416ED0,
/**/                   0x4A5B4574, 0xBD251B08,
/**/                   0xD3B20EA8, 0xBF417D9B,
/**/                   0xDBE00000, 0x3F417ECD,
/**/                   0x4241B57B, 0x3D2BE3AD,
/**/                   0x729866D7, 0xBF418D97,
/**/                   0xAB400000, 0x3F418ECB,
/**/                   0xFA22BD16, 0xBD387707,
/**/                   0x0D806412, 0xBF419D93,
/**/                   0x78800000, 0x3F419EC9,
/**/                   0xFFA2FC2F, 0x3D01C6FC,
/**/                   0xA46A07D9, 0xBF41AD8E,
/**/                   0x43C00000, 0x3F41AEC7,
/**/                   0x05F32EE8, 0x3D3E028D,
/**/                   0x375553AB, 0xBF41BD8A,
/**/                   0x0D200000, 0x3F41BEC5,
/**/                   0xC7E46F2B, 0xBD146400,
/**/                   0xC6424907, 0xBF41CD85,
/**/                   0xD4600000, 0x3F41CEC2,
/**/                   0x8DFCE791, 0x3D38E737,
/**/                   0x5130E96B, 0xBF41DD81,
/**/                   0x99C00000, 0x3F41DEC0,
/**/                   0x92F4A6CE, 0xBD1FEF30,
/**/                   0xD8213659, 0xBF41ED7C,
/**/                   0x5D000000, 0x3F41EEBE,
/**/                   0x4AE68315, 0x3D383EF4,
/**/                   0x5B13314D, 0xBF41FD78,
/**/                   0x1E600000, 0x3F41FEBC,
/**/                   0x39A8276A, 0xBD199E1E,
/**/                   0xDA06DBC8, 0xBF420D73,
/**/                   0xDDA00000, 0x3F420EB9,
/**/                   0xE39F6D77, 0x3D3C11BF,
/**/                   0x54FC3749, 0xBF421D6F,
/**/                   0x9B000000, 0x3F421EB7,
/**/                   0xC3A8C440, 0xBCD50D72,
/**/                   0xCBF3454F, 0xBF422D6A,
/**/                   0x56600000, 0x3F422EB5,
/**/                   0x06E59170, 0xBD3B9869,
/**/                   0x3EEC0759, 0xBF423D66,
/**/                   0x0FA00000, 0x3F423EB3,
/**/                   0x86930551, 0x3D248C4B,
/**/                   0xADE67EE6, 0xBF424D61,
/**/                   0xC7000000, 0x3F424EB0,
/**/                   0xB3649FF7, 0xBD2D6F13,
/**/                   0x18E2AD76, 0xBF425D5D,
/**/                   0x7C400000, 0x3F425EAE,
/**/                   0xB496441D, 0x3D396F87,
/**/                   0x7FE09487, 0xBF426D58,
/**/                   0x2FA00000, 0x3F426EAC,
/**/                   0x01961A2F, 0x3D05E2D0,
/**/                   0xE2E03598, 0xBF427D53,
/**/                   0xE1000000, 0x3F427EA9,
/**/                   0x652D1720, 0xBD32D013,
/**/                   0x41E1922A, 0xBF428D4F,
/**/                   0x90400000, 0x3F428EA7,
/**/                   0x15C6A78A, 0x3D38CB3F,
/**/                   0x9CE4ABBA, 0xBF429D4A,
/**/                   0x3DA00000, 0x3F429EA5,
/**/                   0x07F8A52A, 0x3D163D44,
/**/                   0xF3E983C8, 0xBF42AD45,
/**/                   0xE9000000, 0x3F42AEA2,
/**/                   0x1FEC6070, 0xBD2905BC,
/**/                   0x46F01BD4, 0xBF42BD41,
/**/                   0x92600000, 0x3F42BEA0,
/**/                   0x8FE5CB8E, 0xBD3D6A4E,
/**/                   0x95F8755C, 0xBF42CD3C,
/**/                   0x39A00000, 0x3F42CE9E,
/**/                   0x120028B6, 0x3D32D9FF,
/**/                   0xE10291DF, 0xBF42DD37,
/**/                   0xDF000000, 0x3F42DE9B,
/**/                   0x94B2D8A6, 0x3D112C29,
/**/                   0x280E72DD, 0xBF42ED33,
/**/                   0x82600000, 0x3F42EE99,
/**/                   0x0E9DC27F, 0xBD222C5A,
/**/                   0x6B1C19D4, 0xBF42FD2E,
/**/                   0x23C00000, 0x3F42FE97,
/**/                   0xA4C12307, 0xBD3548A7,
/**/                   0xAA2B8844, 0xBF430D29,
/**/                   0xC3000000, 0x3F430E94,
/**/                   0x1B27A40C, 0x3D3FB49A,
/**/                   0xE53CBFAC, 0xBF431D24,
/**/                   0x60600000, 0x3F431E92,
/**/                   0xC65D601D, 0x3D35E297,
/**/                   0x1C4FC18B, 0xBF432D20,
/**/                   0xFBC00000, 0x3F432E8F,
/**/                   0xD4E46CD5, 0x3D2A84A1,
/**/                   0x4F648F60, 0xBF433D1B,
/**/                   0x95200000, 0x3F433E8D,
/**/                   0x526215F8, 0x3D175314,
/**/                   0x7E7B2AAB, 0xBF434D16,
/**/                   0x2C800000, 0x3F434E8B,
/**/                   0x9746A94C, 0xBCD9430B,
/**/                   0xA99394E9, 0xBF435D11,
/**/                   0xC1E00000, 0x3F435E88,
/**/                   0x47EF6144, 0xBD15A88D,
/**/                   0xD0ADCF9B, 0xBF436D0C,
/**/                   0x55400000, 0x3F436E86,
/**/                   0x94614FFB, 0xBD227301,
/**/                   0xF3C9DC3F, 0xBF437D07,
/**/                   0xE6A00000, 0x3F437E83,
/**/                   0x16908831, 0xBD27A44A,
/**/                   0x12E7BC55, 0xBF438D03,
/**/                   0x76000000, 0x3F438E81,
/**/                   0x13DE59AC, 0xBD2A6621,
/**/                   0x2E07715C, 0xBF439CFE,
/**/                   0x03600000, 0x3F439E7F,
/**/                   0x76635000, 0xBD2AB687,
/**/                   0x4528FCD2, 0xBF43ACF9,
/**/                   0x8EC00000, 0x3F43AE7C,
/**/                   0x28F7818F, 0xBD28937E,
/**/                   0x584C6037, 0xBF43BCF4,
/**/                   0x18200000, 0x3F43BE7A,
/**/                   0x17328F27, 0xBD23FB06,
/**/                   0x67719D0A, 0xBF43CCEF,
/**/                   0x9F800000, 0x3F43CE77,
/**/                   0x5AD74747, 0xBD19D640,
/**/                   0x7298B4CA, 0xBF43DCEA,
/**/                   0x24E00000, 0x3F43DE75,
/**/                   0xC5CB9C74, 0xBCFB0E6A,
/**/                   0x79C1A8F6, 0xBF43ECE5,
/**/                   0xA8400000, 0x3F43EE72,
/**/                   0xF21B8682, 0x3D1145E2,
/**/                   0x7CEC7B0D, 0xBF43FCE0,
/**/                   0x29A00000, 0x3F43FE70,
/**/                   0x59543A06, 0x3D27251B,
/**/                   0x7C192C8E, 0xBF440CDB,
/**/                   0xA9000000, 0x3F440E6D,
/**/                   0xAC6250B6, 0x3D341357,
/**/                   0x7747BEF8, 0xBF441CD6,
/**/                   0x26600000, 0x3F441E6B,
/**/                   0x43A510F7, 0x3D3DD4D6,
/**/                   0x6E7833CB, 0xBF442CD1,
/**/                   0xA1E00000, 0x3F442E68,
/**/                   0x05F7D1E1, 0xBD3727F7,
/**/                   0x61AA8C85, 0xBF443CCC,
/**/                   0x1B400000, 0x3F443E66,
/**/                   0x527C9668, 0xBD25C421,
/**/                   0x50DECAA5, 0xBF444CC7,
/**/                   0x92A00000, 0x3F444E63,
/**/                   0x053F70AC, 0x3D053C47,
/**/                   0x3C14EFAB, 0xBF445CC2,
/**/                   0x08000000, 0x3F445E61,
/**/                   0x1E315FBB, 0x3D3175D5,
/**/                   0x234CFD15, 0xBF446CBD,
/**/                   0x7B800000, 0x3F446E5E,
/**/                   0x6A8B33AC, 0xBD3E762C,
/**/                   0x0686F463, 0xBF447CB8,
/**/                   0xECE00000, 0x3F447E5B,
/**/                   0x67AD9900, 0xBD2A36F8,
/**/                   0xE5C2D713, 0xBF448CB2,
/**/                   0x5C400000, 0x3F448E59,
/**/                   0x1E974853, 0x3D161B95,
/**/                   0xC100A6A5, 0xBF449CAD,
/**/                   0xC9A00000, 0x3F449E56,
/**/                   0x8CE22250, 0x3D3971F7,
/**/                   0x98406498, 0xBF44ACA8,
/**/                   0x35200000, 0x3F44AE54,
/**/                   0xDF8A23F8, 0xBD315945,
/**/                   0x6B82126A, 0xBF44BCA3,
/**/                   0x9E800000, 0x3F44BE51,
/**/                   0x1A63D360, 0x3D1498B2,
/**/                   0x3AC5B19B, 0xBF44CC9E,
/**/                   0x05E00000, 0x3F44CE4F,
/**/                   0x4323A054, 0x3D3CF14E,
/**/                   0x060B43AA, 0xBF44DC99,
/**/                   0x6B600000, 0x3F44DE4C,
/**/                   0x4CE35F94, 0xBD23EDC2,
/**/                   0xCD52CA15, 0xBF44EC93,
/**/                   0xCEC00000, 0x3F44EE49,
/**/                   0xCCF1B48E, 0x3D306E9D,
/**/                   0x909C465C, 0xBF44FC8E,
/**/                   0x30400000, 0x3F44FE47,
/**/                   0x5FF9440B, 0xBD33DD35,
/**/                   0x4FE7B9FF, 0xBF450C89,
/**/                   0x8FA00000, 0x3F450E44,
/**/                   0xAA4D276D, 0x3D224D49,
/**/                   0x0B35267A, 0xBF451C84,
/**/                   0xED200000, 0x3F451E41,
/**/                   0x11B557F9, 0xBD3884D4,
/**/                   0xC2848D4F, 0xBF452C7E,
/**/                   0x48800000, 0x3F452E3F,
/**/                   0xB43290C4, 0x3D1C857D,
/**/                   0x75D5EFFC, 0xBF453C79,
/**/                   0xA2000000, 0x3F453E3C,
/**/                   0x2D598D3C, 0xBD37E5C1,
/**/                   0x25294FFF, 0xBF454C74,
/**/                   0xF9600000, 0x3F454E39,
/**/                   0x3FE47B89, 0x3D24CD93,
/**/                   0xD07EAED8, 0xBF455C6E,
/**/                   0x4EE00000, 0x3F455E37,
/**/                   0xAA959122, 0xBD31F800,
/**/                   0x77D60E06, 0xBF456C69,
/**/                   0xA2400000, 0x3F456E34,
/**/                   0x7329AF92, 0x3D32FEDF,
/**/                   0x1B2F6F08, 0xBF457C64,
/**/                   0xF3C00000, 0x3F457E31,
/**/                   0x1C545A6F, 0xBD1ACE5A,
/**/                   0xBA8AD35D, 0xBF458C5E,
/**/                   0x43400000, 0x3F458E2F,
/**/                   0x19F6B9EF, 0xBD3F0E63,
/**/                   0x55E83C84, 0xBF459C59,
/**/                   0x90A00000, 0x3F459E2C,
/**/                   0x73005F6F, 0x3D23DEF2,
/**/                   0xED47ABFB, 0xBF45AC53,
/**/                   0xDC200000, 0x3F45AE29,
/**/                   0x1C295DE7, 0xBD277204,
/**/                   0x80A92343, 0xBF45BC4E,
/**/                   0x25800000, 0x3F45BE27,
/**/                   0x8D869589, 0x3D3FF92A,
/**/                   0x100CA3D9, 0xBF45CC49,
/**/                   0x6D000000, 0x3F45CE24,
/**/                   0x145C5335, 0x3D2A0DFD,
/**/                   0x9B722F3C, 0xBF45DC43,
/**/                   0xB2800000, 0x3F45DE21,
/**/                   0x6A8614B3, 0xBD123A1A,
/**/                   0x22D9C6ED, 0xBF45EC3E,
/**/                   0xF6000000, 0x3F45EE1E,
/**/                   0x63CBC7E7, 0xBD34C665,
/**/                   0xA6436C69, 0xBF45FC38,
/**/                   0x37600000, 0x3F45FE1C,
/**/                   0xAB6C51D7, 0x3D3C6061,
/**/                   0x25AF2130, 0xBF460C33,
/**/                   0x76E00000, 0x3F460E19,
/**/                   0x1EC7F453, 0x3D2DCD9C,
/**/                   0xA11CE6C1, 0xBF461C2D,
/**/                   0xB4600000, 0x3F461E16,
/**/                   0x20C52899, 0x3D066EFA,
/**/                   0x188CBE9A, 0xBF462C28,
/**/                   0xEFE00000, 0x3F462E13,
/**/                   0xEB5FDD5C, 0xBD1FA5AC,
/**/                   0x8BFEAA3B, 0xBF463C22,
/**/                   0x29600000, 0x3F463E11,
/**/                   0xF22FE2BC, 0xBD313E11,
/**/                   0xFB72AB23, 0xBF464C1C,
/**/                   0x60E00000, 0x3F464E0E,
/**/                   0x6710E251, 0xBD392F15,
/**/                   0x66E8C2D0, 0xBF465C17,
/**/                   0x96600000, 0x3F465E0B,
/**/                   0x1EFC78A7, 0xBD3FBB76,
/**/                   0xCE60F2C1, 0xBF466C11,
/**/                   0xC9C00000, 0x3F466E08,
/**/                   0x602C1A84, 0x3D3B1DCB,
/**/                   0x31DB3C76, 0xBF467C0C,
/**/                   0xFB400000, 0x3F467E05,
/**/                   0x9027DA74, 0x3D375DAE,
/**/                   0x9157A16E, 0xBF468C06,
/**/                   0x2AC00000, 0x3F468E03,
/**/                   0xEA560DA0, 0x3D350532,
/**/                   0xECD62326, 0xBF469C00,
/**/                   0x58400000, 0x3F469E00,
/**/                   0xE7B63DE2, 0x3D341557 } };

#endif
#endif
